"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

function comparaRules(condition, data) {
  var identifier = condition.identifier,
      opType = condition.opType;
  var fieldValue = data[identifier];

  switch (opType) {
    case 'NOT_HAS':
      return (0, _lodash.isEmpty)(fieldValue);

    case 'HAS':
      return !(0, _lodash.isEmpty)(fieldValue);

    default:
      return false;
  }
}
/**
 * 
 * @param {*} condition 条件
 * @param {*} data 表单数据对象
 */


function NAMEINPUT(condition, data) {
  return comparaRules(condition, data);
}

var _default = NAMEINPUT;
exports.default = _default;