"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _mkNumberInput = _interopRequireDefault(require("../../Process/mkNumberInput"));

var _mkSelect = _interopRequireDefault(require("../../Process/mkSelect"));

var _TranslateHook = _interopRequireDefault(require("../../hooks/TranslateHook"));

var Amount = function Amount(props) {
  var t = (0, _TranslateHook.default)('MK_ConditionSetting');
  var selectedNode = props.selectedNode,
      handleOpChange = props.handleOpChange,
      handleValue1Change = props.handleValue1Change,
      fieldConfig = props.fieldConfig;

  var _ref = fieldConfig || {},
      opTypes = _ref.opTypes;

  return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_mkNumberInput.default, {
    label: t('amount'),
    onChange: handleValue1Change,
    value: selectedNode.value1
  }));
};

var _default = Amount;
exports.default = _default;