"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _mkSelect = _interopRequireDefault(require("../../Process/mkSelect"));

var C = _interopRequireWildcard(require("../constants"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var DropDown = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(DropDown, _Component);

  var _super = _createSuper(DropDown);

  function DropDown(props) {
    var _this;

    (0, _classCallCheck2.default)(this, DropDown);
    _this = _super.call(this, props);
    _this.t = _mkTranslate.default.getLocalNs('MK_ConditionSetting', (0, _assertThisInitialized2.default)(_this));
    return _this;
  }

  (0, _createClass2.default)(DropDown, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          handleOpChange = _this$props.handleOpChange,
          selectedNode = _this$props.selectedNode;

      if (!selectedNode.opType) {
        handleOpChange(C.IN);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          selectedNode = _this$props2.selectedNode,
          handleOpChange = _this$props2.handleOpChange,
          handleTempChange = _this$props2.handleTempChange,
          fieldConfig = _this$props2.fieldConfig;

      var _ref = fieldConfig || {},
          opTypes = _ref.opTypes,
          manualItems = _ref.manualItems,
          optionMode = _ref.optionMode;

      var formatManualItems = manualItems === null || manualItems === void 0 ? void 0 : manualItems.map(function (item) {
        return _objectSpread(_objectSpread({}, item), {}, {
          value: item.code
        });
      });
      return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_mkSelect.default, {
        label: this.t('amount'),
        onChange: function onChange(value) {
          /* handleTempChange(manualItems.filter((d) => {
              return d.value === value;
          }), 'value') */
          var temp = formatManualItems.filter(function (d) {
            return typeof value === 'string' ? value === d.value : value.indexOf(d.value) !== -1;
          });
          handleTempChange(temp, 'code', 'value1');
        },
        mode: optionMode === 'MULTI' ? 'multiple' : '',
        value: selectedNode.value1 ? selectedNode.value1.split(',') : [],
        options: formatManualItems
      }));
    }
  }]);
  return DropDown;
}(_react.Component);

var _default = DropDown;
exports.default = _default;