"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/row/style/css");

var _row = _interopRequireDefault(require("maycur-antd/lib/row"));

var _react = _interopRequireWildcard(require("react"));

var _utils = _interopRequireDefault(require("../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function WebFormPie(props) {
  var formFields = props.formFields,
      FormDish = props.FormDish,
      FormChef = props.FormChef,
      options = props.options,
      fieldMapsPlus = props.fieldMapsPlus,
      formInstance = props.formInstance;
  var publicProps = options.publicProps,
      privateProps = options.privateProps,
      customRule = options.customRule;
  var formRows = (0, _react.useMemo)(function () {
    return _utils.default.generateRows(formFields);
  }, [formFields]);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, formRows.map(function (item, index) {
    var fieldList = item.fieldList;
    var rowKey = fieldList && fieldList[0].identifier || index;
    return /*#__PURE__*/_react.default.createElement(_row.default, {
      key: rowKey,
      gutter: 24
    }, fieldList.map(function (field) {
      return /*#__PURE__*/_react.default.createElement(FormDish, {
        FormBuild: FormChef,
        key: field.identifier || index,
        form: formInstance,
        field: field,
        publicProps: publicProps,
        privateProps: privateProps,
        fieldMapsPlus: fieldMapsPlus,
        validateRule: customRule && customRule[field.identifier] || []
      });
    }));
  }));
}

var _default = WebFormPie;
exports.default = _default;