"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

require("maycur-antd/lib/modal/style/css");

var _modal = _interopRequireDefault(require("maycur-antd/lib/modal"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _reactI18next = require("react-i18next");

var _MkSelect = _interopRequireDefault(require("../../MkSelect"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Search = _input.default.Search;
var Option = _MkSelect.default.Option,
    OptGroup = _MkSelect.default.OptGroup;
var selectClzName = "".concat(_utils.default.prefixCls, "-entity");

var LegalEntityField = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(LegalEntityField, _Component);

  var _super = _createSuper(LegalEntityField);

  function LegalEntityField(props) {
    var _this;

    (0, _classCallCheck2.default)(this, LegalEntityField);
    _this = _super.call(this, props);

    _this.fetchLegalEntities = function () {
      var keyword = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

      _this.setState({
        loading: true
      });

      var fetchEntities = _this.props.fetchEntities;
      return new Promise(function (resolve, reject) {
        fetchEntities({
          start: 0,
          length: 50,
          invoiceTitleKeyWords: keyword,
          usable: true
        }).then(function (res) {
          if (res && res.code === 'ACK') {
            _this.setState({
              legalEntities: res.data.data,
              loading: false
            });

            resolve(res.data.data);
          } else {
            _this.setState({
              loading: false
            });

            reject();
          }
        }).catch(function () {
          _this.setState({
            loading: false
          });

          reject();
        });
      });
    };

    _this.search = function (value) {
      value = _lodash.default.trim(value);

      _this.fetchLegalEntities(value);
    };

    _this.handleClick = function () {
      _this.fetchLegalEntities();
    };

    _this.handleChange = function (option, isInit) {
      var fromInner = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var _this$props = _this.props,
          _this$props$extraProp = _this$props.extraProps,
          isAffectedCollectionDetails = _this$props$extraProp.isAffectedCollectionDetails,
          isAffectedReceiptCrossInput = _this$props$extraProp.isAffectedReceiptCrossInput,
          getFieldValue = _this$props.fieldForm.getFieldValue,
          onChange = _this$props.onChange,
          t = _this$props.t;
      var consumeApplications = getFieldValue('consumeApplications');
      var consumeApplicationsLength = consumeApplications ? consumeApplications.length : 0;

      if ((isAffectedCollectionDetails || isAffectedReceiptCrossInput && consumeApplicationsLength > 0) && !isInit) {
        //关联申请单和收款明细可受公司抬头影响，先加在这里后期看有方法优化没有
        var titleText;

        if (isAffectedCollectionDetails && isAffectedReceiptCrossInput && consumeApplicationsLength > 0) {
          titleText = "changeAll";
        } else if (!isAffectedCollectionDetails && isAffectedReceiptCrossInput) {
          titleText = "changeReceiptCross";
        } else {
          titleText = "changeCollection";
        }

        _this.isFrozen = true;

        _modal.default.confirm({
          title: t(titleText),
          maskClosable: false,
          okText: t('ok'),
          cancelText: t('cancel'),
          onOk: function onOk() {
            _this.isFrozen = false;

            _this.changeValue(option);
          },
          onCancel: function onCancel() {
            _this.isFrozen = false;
            if (!fromInner) onChange(_this.state.value);
            return null;
          }
        });
      } else {
        _this.changeValue(option);
      }
    };

    _this.changeValue = function (option) {
      var legalEntities = _this.state.legalEntities;
      var _this$props2 = _this.props,
          onChange = _this$props2.onChange,
          entCode = _this$props2.personalInfo.entCode,
          latestLegalEntities = _this$props2.latestLegalEntities,
          setLatestInLocal = _this$props2.setLatestInLocal;
      var baseCcyCode = null;

      if (Array.isArray(legalEntities) && legalEntities.length) {
        // 查询当前点击的公司抬头币种信息
        var _findValue = _lodash.default.find(legalEntities, {
          code: option.value || option.code
        });

        var _ref = _findValue || {},
            _ref$baseCcyDetail = _ref.baseCcyDetail,
            baseCcyDetail = _ref$baseCcyDetail === void 0 ? {} : _ref$baseCcyDetail;

        baseCcyCode = baseCcyDetail && baseCcyDetail.code;
      }

      if (option && (0, _typeof2.default)(option) === 'object' && (option.code || option.value)) {
        var value = {
          code: (option.code || option.value).replace('-MOCK', ''),
          name: option.name
        }; // 赋值币种code

        if (baseCcyCode) {
          value.baseCcy = baseCcyCode;
        }

        var selectedItemIndex = _lodash.default.findIndex(_this.latestLegalEntities, {
          code: value.code
        });

        if (selectedItemIndex > -1) {
          _this.latestLegalEntities.splice(selectedItemIndex, 1);
        }

        _this.latestLegalEntities.unshift(value);

        _this.latestLegalEntities.length > 2 && (_this.latestLegalEntities.length = 2);
        latestLegalEntities[entCode] = _this.latestLegalEntities;
        setLatestInLocal(latestLegalEntities);

        _this.setState({
          value: value
        });

        if (typeof onChange === 'function' && value.code !== option.code) onChange(value);
      } else if (typeof option === 'string' && option) {
        var _value = {
          code: option.replace('-MOCK', '')
        }; // 赋值币种code

        if (baseCcyCode) {
          _value.baseCcy = baseCcyCode;
        }

        _this.setState({
          value: _value
        });

        if (typeof onChange === 'function') onChange(_value);
      }
    };

    _this.state = {
      value: {
        code: '',
        name: '',
        baseCcy: ''
      },
      legalEntities: []
    };
    _this.search = _lodash.default.debounce(_this.search, 800);
    var _entCode = props.personalInfo.entCode,
        _latestLegalEntities = props.latestLegalEntities;
    _this.latestLegalEntities = _latestLegalEntities[_entCode] || [];
    _this.isFrozen = false;
    return _this;
  }

  (0, _createClass2.default)(LegalEntityField, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(preProps) {
      var value = this.props.value;
      var defCode = value ? value.code : '';

      if (!this.isFrozen && this.state.value.code !== defCode) {
        this.handleChange(this.props.value, false, false);
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.handleChange(this.props.value, true);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          placeholder = _this$props3.fieldProperties.placeholder,
          readOnly = _this$props3.readOnly,
          t = _this$props3.t,
          _this$props3$extraPro = _this$props3.extraProps,
          fieldStyleCategory = _this$props3$extraPro.fieldStyleCategory,
          tableRef = _this$props3$extraPro.tableRef,
          registerEvent = _this$props3$extraPro.registerEvent;
      var _this$state = this.state,
          legalEntities = _this$state.legalEntities,
          value = _this$state.value;
      return /*#__PURE__*/_react.default.createElement(_MkSelect.default, {
        tableRef: tableRef,
        registerEvent: registerEvent,
        placeholder: placeholder,
        className: selectClzName,
        value: value || {},
        style: {
          width: '100%'
        },
        onChange: this.handleChange,
        onClick: this.handleClick,
        disabled: readOnly,
        actionVisible: !readOnly,
        category: fieldStyleCategory
      }, /*#__PURE__*/_react.default.createElement(OptGroup, {
        label: /*#__PURE__*/_react.default.createElement("div", {
          className: "".concat(selectClzName, "-search")
        }, /*#__PURE__*/_react.default.createElement("p", null, t('select')), /*#__PURE__*/_react.default.createElement(Search, {
          type: "gray",
          placeholder: t('search'),
          onChange: function onChange(e) {
            _this2.search(e.target.value);
          }
        }))
      }), this.latestLegalEntities.length && legalEntities && legalEntities.length > 0 ? /*#__PURE__*/_react.default.createElement(OptGroup, {
        label: t('latest'),
        className: "".concat(selectClzName, "-latest")
      }, this.latestLegalEntities.map(function (legalEntity) {
        // legalEntities 最多只会查出50条数据，这样写会导致不在这50条数据里的无法显示
        var isMatched = _lodash.default.find(legalEntities, {
          code: legalEntity.code
        });

        if (isMatched) {
          return /*#__PURE__*/_react.default.createElement(Option, {
            key: legalEntity.code + '-MOCK',
            value: legalEntity.code + '-MOCK',
            name: legalEntity.name
          }, /*#__PURE__*/_react.default.createElement("span", {
            className: "fm fm-legal-entity"
          }), legalEntity.name);
        } else {
          return null;
        }
      })) : null, /*#__PURE__*/_react.default.createElement(OptGroup, {
        label: t('entity'),
        className: "".concat(selectClzName, "-option-list")
      }, legalEntities && legalEntities.length > 0 ? legalEntities.map(function (le) {
        return /*#__PURE__*/_react.default.createElement(Option, {
          key: le.code,
          value: le.code,
          name: le.invoiceTitle
        }, /*#__PURE__*/_react.default.createElement("span", {
          className: "fm fm-legal-entity"
        }), le.invoiceTitle);
      }) : /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(selectClzName, "-empty-text")
      }, /*#__PURE__*/_react.default.createElement("span", null, t('noData')))));
    }
  }]);
  return LegalEntityField;
}(_react.Component);

var _default = (0, _reactI18next.withTranslation)('MK_LegalEntityField')(LegalEntityField);

exports.default = _default;