"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _OptionFieldPicker = _interopRequireDefault(require("./OptionFieldPicker"));

var _FullPathPopover = _interopRequireDefault(require("../../FullPathPopover"));

var _ViewInput = _interopRequireDefault(require("../../ViewInput"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/*
 * @Author: yuxuan 
 * @Date: 2020-03-06 19:31:16 
 * @Last Modified by: Chao Tang
 * @Last Modified time: 2021-05-26 10:53:45
 */
function OptionField(props) {
  var showBizCode = props.extraProps.showBizCode,
      value = props.value,
      readOnly = props.readOnly,
      _props$extraProps = props.extraProps,
      extraProps = _props$extraProps === void 0 ? {} : _props$extraProps,
      fetchFullPath = props.fetchFullPath,
      isShowFullPath = props.isShowFullPath;
  var fullBorder = extraProps.fullBorder;

  var _ref = value || {},
      name = _ref.name,
      bizCode = _ref.bizCode;

  var val = (0, _react.useMemo)(function () {
    var _value$fullNames;

    return /*#__PURE__*/_react.default.createElement("span", null, (name || '') + (showBizCode && bizCode ? "(".concat(bizCode, ")") : ''), value && isShowFullPath && (!value.fullNames || (value === null || value === void 0 ? void 0 : (_value$fullNames = value.fullNames) === null || _value$fullNames === void 0 ? void 0 : _value$fullNames.length) > 1) && /*#__PURE__*/_react.default.createElement(_FullPathPopover.default, {
      fetchFullPath: fetchFullPath
    }));
  }, [name, showBizCode, bizCode]);
  return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_OptionFieldPicker.default, props));
}

var _default = OptionField;
exports.default = _default;