"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/list/style/css");

var _list = _interopRequireDefault(require("maycur-antd/lib/list"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _reactOnclickoutside = _interopRequireDefault(require("react-onclickoutside"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

var _Loader = _interopRequireDefault(require("../../Loader"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var prefix = _utils.default.prefixCls;
var cmName = "".concat(prefix, "-option-field");
var Search = _input.default.Search;

function OptionInputList(props) {
  var showDropDown = props.showDropDown,
      value = props.value,
      search = props.search,
      fetchTreeDetail = props.fetchTreeDetail,
      fetchTree = props.fetchTree,
      legalEntity = props.legalEntity,
      onChange = props.onChange,
      hideDropDown = props.hideDropDown,
      _props$extraProps = props.extraProps,
      isEntityInAllocation = _props$extraProps.isEntityInAllocation,
      hasLegalEntity = _props$extraProps.hasLegalEntity,
      formSubTypeCode = _props$extraProps.formSubTypeCode,
      showBizCode = _props$extraProps.showBizCode,
      _props$fieldForm = props.fieldForm,
      setWatch = _props$fieldForm.setWatch,
      getFieldValue = _props$fieldForm.getFieldValue,
      fieldProperties = props.fieldProperties;
  var placeholder = fieldProperties.placeholder,
      label = fieldProperties.label,
      dataSource = fieldProperties.dataSource,
      sourceMode = fieldProperties.sourceMode;

  var _useState = (0, _react.useState)({}),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      data = _useState2[0],
      setData = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      crumbs = _useState4[0],
      setCrumbs = _useState4[1];

  var _useState5 = (0, _react.useState)({}),
      _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
      originalData = _useState6[0],
      setOriginalData = _useState6[1];

  var _useState7 = (0, _react.useState)([]),
      _useState8 = (0, _slicedToArray2.default)(_useState7, 2),
      searchList = _useState8[0],
      setSearchList = _useState8[1];

  var _useState9 = (0, _react.useState)(),
      _useState10 = (0, _slicedToArray2.default)(_useState9, 2),
      legalEntityAuthzs = _useState10[0],
      setLegalEntityAuthzs = _useState10[1];

  var _useState11 = (0, _react.useState)({}),
      _useState12 = (0, _slicedToArray2.default)(_useState11, 2),
      _useState12$ = _useState12[0],
      isLoad = _useState12$ === void 0 ? true : _useState12$,
      setIsLoad = _useState12[1];

  var transRef = (0, _react.useRef)();
  transRef.current = _mkTranslate.default.noop();
  var hide = (0, _react.useCallback)(function () {
    if (typeof hideDropDown === 'function') {
      hideDropDown();
    }
  }, [hideDropDown]);

  OptionInputList.handleClickOutside = function () {
    hide();
  }; // 创建一个保存公司抬头code的“盒子”


  var legalEntityRef = (0, _react.useRef)(legalEntity ? legalEntity.code : null);
  var showDropDownClass = (0, _react.useMemo)(function () {
    return showDropDown ? 'in' : '';
  }, [showDropDown]);
  var details = (0, _react.useMemo)(function () {
    return data.details && _lodash.default.filter(data.details, {
      enabled: true
    }) || [];
  }, [data]);
  var filterDetail = (0, _react.useCallback)(function (data) {
    return data.filter(function (d) {
      return d.deleted === false && d.enabled === true;
    });
  }, []);
  var legalEntityAuthzsChange = (0, _react.useCallback)(function (legalEntityAuthzs) {
    setLegalEntityAuthzs(legalEntityAuthzs);
  }, []);
  var handleSelect = (0, _react.useCallback)(function (detail) {
    legalEntityAuthzsChange(detail.legalEntityAuthzs);

    if (typeof onChange === 'function') {
      onChange(detail.code ? {
        code: detail.code,
        name: detail.name,
        nameZh: detail.nameZh,
        nameEn: detail.nameEn,
        extraProperty: detail.extraProperty,
        bizCode: detail.bizCode,
        fullNames: detail.fullNames
      } : undefined);
      setCrumbs([]);
      setData(originalData);
      setSearchList([]);

      if (typeof hideDropDown === 'function') {
        hideDropDown();
      }
    }
  }, [onChange, originalData, hideDropDown, legalEntityAuthzsChange]);
  var fetchSearchList = (0, _react.useCallback)(function (keyword) {
    if (typeof search === 'function') {
      search({
        cipherKeyword: keyword,
        keyword: keyword,
        limit: 50,
        referenceDataCode: dataSource,
        legalEntityCode: legalEntityRef.current,
        formSubTypeCode: formSubTypeCode
      }).then(function (res) {
        setSearchList(filterDetail(res.result || []));
      }).catch(function () {});
    }
  }, [search, dataSource, formSubTypeCode, filterDetail]);
  var fetchMoreData = (0, _react.useCallback)(function (categoryCode) {
    return new Promise(function (resolve) {
      var _extra = {
        formSubTypeCode: formSubTypeCode
      };

      if (legalEntityRef.current) {
        _extra.legalEntityCode = legalEntityRef.current;
      }

      if (typeof fetchTree === 'function') {
        setIsLoad(true);
        fetchTree(_objectSpread({
          referenceDataCode: dataSource,
          categoryCode: categoryCode
        }, _extra)).then(function (res) {
          resolve(res);
        }).finally(function () {
          setIsLoad(false);
        });
      }
    });
  }, [dataSource, fetchTree, formSubTypeCode]);
  var fetchTreeData = (0, _react.useCallback)(function () {
    var _extra = {
      formSubTypeCode: formSubTypeCode
    };

    if (legalEntityRef.current) {
      _extra.legalEntityCode = legalEntityRef.current;
    }

    if (typeof fetchTree === 'function') {
      setIsLoad(true);
      fetchTree(_objectSpread({
        referenceDataCode: dataSource
      }, _extra)).then(function (res) {
        setData(res.data);
        setOriginalData(res.data);
      }).catch(function () {}).finally(function () {
        setIsLoad(false);
      });
    }
  }, [legalEntityRef, fetchTree, dataSource, formSubTypeCode]);
  var updateTreeData = (0, _react.useCallback)(function (val) {
    var code = val && val.code || null;
    if (legalEntityRef.current === code) return;
    legalEntityRef.current = code;
    fetchTreeData();

    if (legalEntityAuthzs && legalEntityAuthzs.length) {
      if (legalEntityAuthzs.every(function (_ref) {
        var authzCode = _ref.authzCode;
        return authzCode !== code;
      })) {
        handleSelect({});
      }
    }
  }, [fetchTreeData, handleSelect, legalEntityAuthzs]);
  var onSearch = (0, _react.useCallback)(function (value) {
    value = _lodash.default.trim(value);

    if (value) {
      fetchSearchList(value);
    } else {
      setSearchList([]);
    }
  }, [fetchSearchList]);
  var jump = (0, _react.useCallback)(function (crumb, index) {
    var detail = {};

    if (index >= 0) {
      crumbs.length = index + 1;
      detail = crumb;
    } else {
      crumbs.length = 0;
      detail = originalData;
    }

    setData(detail);
    setCrumbs(crumbs);
  }, [crumbs, originalData]);
  var openCategory = (0, _react.useCallback)(function (category) {
    fetchMoreData(category.code).then(function (resp) {
      var data = resp.data;
      category.details = data.details;
      category.categories = data.categories;
      crumbs.push({
        code: category.code,
        name: category.name,
        details: data.details,
        categories: data.categories
      });
      setData(category);
    });
  }, [fetchMoreData, crumbs]);
  var renderItem = (0, _react.useCallback)(function (item) {
    //删除本身
    var _fullNames = _lodash.default.cloneDeep(item.fullNames);

    _fullNames.pop();

    return /*#__PURE__*/_react.default.createElement(_list.default.Item, {
      key: item.code,
      onClick: function onClick() {
        handleSelect(item);
      }
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "item-name"
    }, /*#__PURE__*/_react.default.createElement("span", null, /*#__PURE__*/_react.default.createElement("span", {
      className: "fm fm-paper"
    }), item.name, showBizCode && /*#__PURE__*/_react.default.createElement("div", {
      className: "item-code"
    }, item.bizCode)), item.fullNames.length > 0 && /*#__PURE__*/_react.default.createElement("span", {
      className: "full-path"
    }, _fullNames.join('/'))));
  }, [handleSelect, showBizCode]);
  (0, _react.useEffect)(function () {
    if (sourceMode === 'DATA_SOURCE') {
      // if (isEntityInAllocation) {
      //     const _legalEntity = getFieldValue('legalEntity');
      //     legalEntityRef.current = _legalEntity && _legalEntity.code || (hasLegalEntity ? 'NONE' : null);
      //     if (setWatch) {
      //         setWatch('legalEntity', (value) => {
      //             updateTreeData(value);
      //         });
      //     }
      // } else {
      //     legalEntityRef.current = legalEntity ? legalEntity.code : null;
      // }
      var _legalEntity = getFieldValue && getFieldValue('legalEntity') ? getFieldValue('legalEntity') : legalEntity ? legalEntity : null;

      legalEntityRef.current = _legalEntity && _legalEntity.code || (hasLegalEntity ? 'NONE' : null); // if (setWatch) {
      //     setWatch('legalEntity', (value) => {
      //         updateTreeData(value);
      //     });
      // }
    }

    fetchTreeData(); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: cmName
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "dropdown ".concat(showDropDownClass)
  }, isLoad ? /*#__PURE__*/_react.default.createElement(_Loader.default, {
    active: true,
    mask: true
  }) : null, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(cmName, "_display-value-clone")
  }, value && value.name ? /*#__PURE__*/_react.default.createElement("div", null, value.name, showBizCode && value.bizCode ? "(".concat(value.bizCode, ")") : '') : /*#__PURE__*/_react.default.createElement("div", {
    className: "placeholder"
  }, placeholder)), /*#__PURE__*/_react.default.createElement("div", {
    className: "search"
  }, /*#__PURE__*/_react.default.createElement(Search, {
    placeholder: transRef.current('searchKeywords'),
    onSearch: onSearch
  })), searchList && searchList.length ? /*#__PURE__*/_react.default.createElement(_list.default, {
    dataSource: searchList,
    renderItem: renderItem
  }) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "crumbs"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "crumb-item",
    onClick: jump
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: "crumb-name"
  }, label)), crumbs.map(function (crumb, index) {
    return /*#__PURE__*/_react.default.createElement("div", {
      key: index,
      className: "crumb-item",
      onClick: function onClick() {
        return jump(crumb, index);
      }
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "split"
    }, "/"), /*#__PURE__*/_react.default.createElement("span", {
      className: "crumb-name"
    }, crumb.name));
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "panel"
  }, data.categories && data.categories.length ? /*#__PURE__*/_react.default.createElement("div", {
    className: "category"
  }, data.categories.map(function (category) {
    return /*#__PURE__*/_react.default.createElement("div", {
      className: "item",
      key: category.code,
      onClick: function onClick() {
        return openCategory(category);
      }
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "fm fm-folder-o"
    }), category.name);
  })) : null, details.length ? /*#__PURE__*/_react.default.createElement("div", {
    className: "detail"
  }, details.map(function (detail) {
    return /*#__PURE__*/_react.default.createElement("div", {
      className: "item",
      key: detail.code,
      onClick: function onClick() {
        return handleSelect(detail);
      }
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "fm fm-paper"
    }), detail.name, showBizCode && /*#__PURE__*/_react.default.createElement("div", {
      className: "item-code"
    }, detail.bizCode));
  })) : null, !isLoad && (!details || !details.length) && (!data.categories || !data.categories.length) ? /*#__PURE__*/_react.default.createElement("div", {
    className: "empty-text"
  }, transRef.current('noData')) : null))));
}

var clickOutsideConfig = {
  handleClickOutside: function handleClickOutside() {
    return OptionInputList.handleClickOutside;
  }
};

var _default = (0, _reactOnclickoutside.default)(OptionInputList, clickOutsideConfig);

exports.default = _default;