"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/select/style/css");

var _select = _interopRequireDefault(require("maycur-antd/lib/select"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

var _ViewInput = _interopRequireDefault(require("../../ViewInput/ViewInput"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;
var cmName = "".concat(prefix, "-mk-select-field");
var Option = _select.default.Option;

var SelectField = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(SelectField, _Component);

  var _super = _createSuper(SelectField);

  function SelectField(props) {
    var _this;

    (0, _classCallCheck2.default)(this, SelectField);
    _this = _super.call(this, props);

    _this.handleSelect = function (value) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          _this$props$extraProp = _this$props.extraProps.optionData,
          optionData = _this$props$extraProp === void 0 ? [] : _this$props$extraProp,
          fieldProperties = _this$props.fieldProperties;
      var optionMode = fieldProperties.optionMode;
      var data = _this.state.data;
      var selectItems = optionData && optionData.length > 0 ? optionData : data;

      if (optionMode === 'multiple') {
        var _value = _lodash.default.filter(selectItems, function (item) {
          return value.includes(item.code);
        });

        if (typeof onChange === 'function' && value) {
          onChange(_value);
        }
      } else {
        var item = _lodash.default.find(selectItems, {
          code: value
        });

        if (typeof onChange === 'function' && value) {
          onChange({
            code: value,
            name: item && item.name
          });
        }
      }
    };

    _this.onBlur = function () {
      var onBlur = _this.props.onBlur;

      if (typeof onBlur === 'function') {
        onBlur();
      }
    };

    _this.clearValue = function (e) {
      e.stopPropagation();
      var afterChange = _this.props.afterChange;

      if (typeof afterChange === 'function') {
        afterChange({
          value: {}
        });
      }
    };

    _this.getName = function () {
      var _this$props2 = _this.props,
          fieldProperties = _this$props2.fieldProperties,
          value = _this$props2.value;
      var optionMode = fieldProperties.optionMode;

      if (optionMode === 'multiple') {
        return _lodash.default.map(value, 'name').join(',');
      } else {
        return value && value.name;
      }
    };

    _this.getCode = function () {
      var _this$props3 = _this.props,
          fieldProperties = _this$props3.fieldProperties,
          value = _this$props3.value;
      var optionMode = fieldProperties.optionMode;

      if (optionMode === 'multiple') {
        return _lodash.default.map(value, 'code');
      } else {
        return value && value.code;
      }
    };

    _this.onDropdownVisibleChange = function (open) {
      return _this.setState({
        open: open
      });
    };

    _this.state = {
      data: [],
      open: false
    };
    _this.containerRef = /*#__PURE__*/(0, _react.createRef)();
    return _this;
  }

  (0, _createClass2.default)(SelectField, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var _this$props4 = this.props,
          _this$props4$extraPro = _this$props4.extraProps,
          setDefault = _this$props4$extraPro.setDefault,
          items = _this$props4$extraPro.items,
          registerEvent = _this$props4$extraPro.registerEvent,
          value = _this$props4.value,
          fieldProperties = _this$props4.fieldProperties;
      var data = fieldProperties.manualItems,
          optionMode = fieldProperties.optionMode;

      var _data = data || items; //选项数据如果不是对象数组，重新初始化成对象数组


      if (Array.isArray(data) && (0, _typeof2.default)(data[0]) !== 'object') {
        _data = data.map(function (d) {
          return {
            code: d,
            name: d
          };
        });
      }

      if (setDefault && !value) {
        var defaultData = data || items;

        if (optionMode !== 'multiple') {
          this.handleSelect(defaultData && defaultData[0] && defaultData[0].code);
        }
      }

      this.setState({
        data: _data
      });
      registerEvent && registerEvent(function () {
        return _this2.onDropdownVisibleChange(false);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props5 = this.props,
          readOnly = _this$props5.readOnly,
          fieldProperties = _this$props5.fieldProperties,
          _this$props5$extraPro = _this$props5.extraProps,
          _this$props5$extraPro2 = _this$props5$extraPro.optionData,
          optionData = _this$props5$extraPro2 === void 0 ? [] : _this$props5$extraPro2,
          fieldStyleCategory = _this$props5$extraPro.fieldStyleCategory,
          emptyText = _this$props5$extraPro.emptyText,
          defaultOpen = _this$props5$extraPro.defaultOpen,
          tableRef = _this$props5$extraPro.tableRef;
      var placeholder = fieldProperties.placeholder,
          optionMode = fieldProperties.optionMode,
          sourceMode = fieldProperties.sourceMode;
      var _this$state = this.state,
          data = _this$state.data,
          open = _this$state.open;

      var t = _mkTranslate.default.noop();

      var selectItems = optionData && optionData.length > 0 ? optionData : data;
      var cls = fieldStyleCategory === 'origin' ? "".concat(cmName, ".origin") : '';
      var clsName = "".concat(cmName, " ").concat(cls);
      var isAllowClear = sourceMode === 'MANUAL' ? true : false;
      return /*#__PURE__*/_react.default.createElement("div", {
        className: clsName,
        ref: this.containerRef
      }, readOnly ? /*#__PURE__*/_react.default.createElement(_ViewInput.default, {
        value: this.getName(),
        emptyText: emptyText
      }) : /*#__PURE__*/_react.default.createElement(_select.default, {
        open: open,
        ref: this.props.forwardedRef,
        defaultOpen: defaultOpen,
        notFoundContent: t('noData'),
        placeholder: placeholder,
        value: this.getCode(),
        mode: optionMode,
        disabled: readOnly,
        type: fieldStyleCategory === 'origin' ? 'normal' : '',
        onChange: this.handleSelect,
        onBlur: this.onBlur,
        allowClear: isAllowClear,
        clearIcon: /*#__PURE__*/_react.default.createElement("span", {
          style: {
            color: '#fff'
          },
          className: 'mk-select-clear',
          onClick: function onClick(event) {
            return _this3.clearValue(event);
          }
        }, /*#__PURE__*/_react.default.createElement("i", {
          className: 'fm fm-cross'
        })),
        getPopupContainer: function getPopupContainer() {
          return tableRef || _this3.containerRef.current;
        },
        onDropdownVisibleChange: this.onDropdownVisibleChange
      }, selectItems instanceof Array && selectItems.length > 0 ? selectItems.map(function (item, index) {
        return /*#__PURE__*/_react.default.createElement(Option, {
          value: item && item.code,
          key: index
        }, item && item.name);
      }) : null));
    }
  }]);
  return SelectField;
}(_react.Component);

SelectField.defaultProps = {
  extraProps: {}
};
var _default = SelectField;
exports.default = _default;