"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var TextArea = _input.default.TextArea;
var prefix = _utils.default.prefixCls;
var cmName = "".concat(prefix, "-textarea-field");

var TextAreaField = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(TextAreaField, _Component);

  var _super = _createSuper(TextAreaField);

  function TextAreaField(props) {
    var _this;

    (0, _classCallCheck2.default)(this, TextAreaField);
    _this = _super.call(this, props);

    _this.onChange = function (e) {
      _this.setState({
        value: e.target.value
      });
    };

    _this.onBlur = function (e) {
      var onChange = _this.props.onChange;
      onChange(_this.state.value, true);
    };

    _this.componentDidUpdate = function (prevProps) {
      if (_this.props.value !== prevProps.value) {
        _this.setState({
          value: _this.props.value
        });
      }
    };

    _this.state = {
      value: props.value || ''
    };
    _this.t = _mkTranslate.default.getLocalNs('MK_FormFields', (0, _assertThisInitialized2.default)(_this));
    return _this;
  }

  (0, _createClass2.default)(TextAreaField, [{
    key: "render",
    value: function render() {
      var value = this.state.value;
      var _this$props = this.props,
          fieldProperties = _this$props.fieldProperties,
          readOnly = _this$props.readOnly,
          _this$props$extraProp = _this$props.extraProps,
          fieldStyleCategory = _this$props$extraProp.fieldStyleCategory,
          isInTable = _this$props$extraProp.isInTable;
      var placeholder = fieldProperties.placeholder,
          maxLength = fieldProperties.maxLength;
      var displayPlaceholder = !value && readOnly ? this.t('empty') : placeholder;
      var clsName = (0, _classnames.default)(cmName, {
        intable: isInTable
      });
      return /*#__PURE__*/_react.default.createElement("div", {
        className: clsName
      }, /*#__PURE__*/_react.default.createElement(TextArea, {
        onChange: this.onChange,
        onBlur: this.onBlur,
        placeholder: displayPlaceholder,
        value: value && value + '' // TextArea 只接受字符串类型的 value，数据互联映射过来的值可能是数字，会导致校验出错
        ,
        autosize: true,
        category: fieldStyleCategory,
        disabled: readOnly
      }), !readOnly && /*#__PURE__*/_react.default.createElement("div", {
        className: "count"
      }, /*#__PURE__*/_react.default.createElement("span", null, value && value.length || 0, "/", /*#__PURE__*/_react.default.createElement("span", {
        className: "total-count"
      }, maxLength))));
    }
  }]);
  return TextAreaField;
}(_react.Component);

var _default = TextAreaField;
exports.default = _default;