"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/tag/style/css");

var _tag = _interopRequireDefault(require("maycur-antd/lib/tag"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _excluded = ["content", "children"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;

var StuffTag = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(StuffTag, _Component);

  var _super = _createSuper(StuffTag);

  function StuffTag(props) {
    var _this;

    (0, _classCallCheck2.default)(this, StuffTag);
    _this = _super.call(this, props);

    _this.renderIcon = function () {
      var content = _this.props.content;
      var icon = null;

      switch (content) {
        case '火车':
          icon = /*#__PURE__*/_react.default.createElement("span", {
            className: "fm fm-e-train"
          });
          break;

        case '打车':
          icon = /*#__PURE__*/_react.default.createElement("span", {
            className: "fm fm-e-taxi"
          });
          break;

        case '飞机':
          icon = /*#__PURE__*/_react.default.createElement("span", {
            className: "fm fm-e-flight"
          });
          break;

        default:
          break;
      }

      return icon;
    };

    _this.state = {};
    return _this;
  }

  (0, _createClass2.default)(StuffTag, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          content = _this$props.content,
          children = _this$props.children,
          restProps = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
      return /*#__PURE__*/_react.default.createElement(_tag.default, (0, _extends2.default)({
        style: {
          marginRight: 3,
          height: 26,
          lineHeight: '26px'
        },
        className: "".concat(prefix, "-new-tag")
      }, restProps), this.renderIcon() ? /*#__PURE__*/_react.default.createElement("span", {
        className: "tag-icon"
      }, this.renderIcon()) : null, children);
    }
  }]);
  return StuffTag;
}(_react.Component);

var _default = StuffTag;
exports.default = _default;