"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Tippy = _interopRequireDefault(require("../Tippy"));

var _utils = _interopRequireDefault(require("../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;
var Tooltip = _Tippy.default.Tooltip;

var MkDropdown = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(MkDropdown, _Component);

  var _super = _createSuper(MkDropdown);

  function MkDropdown(props) {
    var _this;

    (0, _classCallCheck2.default)(this, MkDropdown);
    _this = _super.call(this, props);

    _this.onUpdate = function (dataObject) {
      var _this$props = _this.props,
          overlay = _this$props.overlay,
          onUpdate = _this$props.onUpdate,
          getTextNode = _this$props.getTextNode,
          getDropTextNode = _this$props.getDropTextNode,
          _this$props$top = _this$props.top,
          top = _this$props$top === void 0 ? 0 : _this$props$top,
          _this$props$left = _this$props.left,
          left = _this$props$left === void 0 ? 0 : _this$props$left;
      var _dataObject$instance = dataObject.instance,
          popper = _dataObject$instance.popper,
          reference = _dataObject$instance.reference;

      var _popper$getBoundingCl = popper.getBoundingClientRect(),
          popper_top = _popper$getBoundingCl.top,
          popper_left = _popper$getBoundingCl.left;

      var placement = dataObject.placement;
      var children = []; // flip children

      if (placement === 'top') {
        var overlayChildren = overlay.props.children;
        var length = overlayChildren ? overlayChildren.length : 0;

        for (var i = 0; i <= length - 1; i++) {
          children[i] = overlayChildren[length - 1 - i];
        }
      }

      if ( /*#__PURE__*/_react.default.isValidElement(overlay)) {
        _this.setState({
          overlay: /*#__PURE__*/_react.default.cloneElement(overlay, _objectSpread(_objectSpread({}, overlay.props), placement === 'top' ? {
            children: children
          } : null))
        }, function () {
          var queryTextDom = getTextNode ? getTextNode(reference, popper) : _this.getLastChild(reference);
          var listDoms = popper.querySelectorAll('li') || [];
          var listDom = placement === 'top' ? listDoms[listDoms.length - 1] : listDoms[0];
          var queryDropTextDom = getDropTextNode ? getDropTextNode(reference, popper) : listDom ? _this.getLastChild(listDom) : null;

          var _this$getBoundingClie = _this.getBoundingClientRect(queryTextDom),
              queryText_top = _this$getBoundingClie.top,
              queryText_left = _this$getBoundingClie.left;

          var _this$getBoundingClie2 = _this.getBoundingClientRect(queryDropTextDom),
              queryDropText_top = _this$getBoundingClie2.top,
              queryDropText_left = _this$getBoundingClie2.left;

          var diffTop = queryDropText_top - popper_top;
          var diffLeft = queryDropText_left - popper_left;

          var _left = queryText_left - diffLeft + left;

          var _top = queryText_top - diffTop + top;

          popper.style.transform = "translate3d(".concat(_left, "px, ").concat(_top, "px, 0px)");
          onUpdate && onUpdate(dataObject);
        });
      }
    };

    _this.onClick = function (e) {
      var autoHide = _this.props.autoHide;
      e.stopPropagation();

      if (_this.tippyRef && autoHide) {
        _this.tippyRef.current.hideTooltip();
      }
    };

    _this.onCreate = function (dataObject) {
      var onCreate = _this.props.onCreate;
      onCreate && onCreate(dataObject);
    };

    _this.state = {
      overlay: props.overlay
    };
    _this.tippyRef = /*#__PURE__*/_react.default.createRef();
    return _this;
  }

  (0, _createClass2.default)(MkDropdown, [{
    key: "getLastChild",
    value: // getStyle = (dom, attr) => {
    //     return dom.currentStyle ? dom.currentStyle[attr] : getComputedStyle(dom, false)[attr];
    // }
    function getLastChild(node) {
      if (node.firstElementChild) {
        return this.getLastChild(node.firstElementChild);
      } else {
        return node;
      }
    }
  }, {
    key: "getBoundingClientRect",
    value: function getBoundingClientRect(dom) {
      var top = 0,
          left = 0,
          height = 0;

      if (dom && dom.getBoundingClientRect) {
        var _dom$getBoundingClien = dom.getBoundingClientRect(),
            x = _dom$getBoundingClien.x,
            y = _dom$getBoundingClien.y,
            _height = _dom$getBoundingClien.height; // top = y + parseInt(this.getStyle(dom, "paddingTop"));
        // left = x + parseInt(this.getStyle(dom, "paddingLeft"));


        top = y;
        left = x;
        height = _height;
      }

      return {
        top: top,
        left: left,
        height: height
      };
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      this.setState({
        overlay: nextProps.overlay
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props2 = this.props,
          disabled = _this$props2.disabled,
          open = _this$props2.open,
          position = _this$props2.position,
          trigger = _this$props2.trigger,
          delay = _this$props2.delay,
          hideDelay = _this$props2.hideDelay,
          animation = _this$props2.animation,
          duration = _this$props2.duration,
          distance = _this$props2.distance,
          offset = _this$props2.offset,
          followCursor = _this$props2.followCursor,
          inertia = _this$props2.inertia,
          stickyDuration = _this$props2.stickyDuration,
          test = _this$props2.test,
          onShow = _this$props2.onShow,
          onHide = _this$props2.onHide,
          onTrigger = _this$props2.onTrigger,
          className = _this$props2.className,
          style = _this$props2.style;
      var props = {
        disabled: disabled,
        position: position,
        trigger: trigger,
        delay: delay,
        hideDelay: hideDelay,
        animation: animation,
        duration: duration,
        distance: distance,
        offset: offset,
        followCursor: followCursor,
        inertia: inertia,
        stickyDuration: stickyDuration,
        onShow: onShow,
        onHide: onHide,
        onTrigger: onTrigger
      };
      var overlay = this.state.overlay;

      var _className = (0, _classnames.default)("".concat(prefix, "_dropdown"), (_classNames = {}, (0, _defineProperty2.default)(_classNames, className, className), (0, _defineProperty2.default)(_classNames, "".concat(prefix, "_dropdown_test"), test), _classNames));

      var html = /*#__PURE__*/_react.default.createElement("div", {
        className: _className,
        style: style,
        onClick: this.onClick
      }, overlay);

      return /*#__PURE__*/_react.default.createElement(Tooltip, (0, _extends2.default)({}, props, {
        open: open || test,
        html: html,
        onUpdate: this.onUpdate,
        onCreate: this.onCreate,
        interactive: true,
        animateFill: false,
        transitionFlip: true,
        unmountHTMLWhenHide: true,
        ref: this.tippyRef
      }), this.props.children);
    }
  }]);
  return MkDropdown;
}(_react.Component);

MkDropdown.defaultProps = {
  top: 0,
  left: 0,
  position: 'bottom',
  boundariesElement: 'window',
  deviation: true,
  autoHide: false
};
var _default = MkDropdown;
exports.default = _default;