"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/layout/style/css");

var _layout = _interopRequireDefault(require("maycur-antd/lib/layout"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _MkHeader = _interopRequireDefault(require("./MkHeader"));

var _MkSider = _interopRequireDefault(require("./MkSider"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = _interopRequireDefault(require("../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;

var MkLayout = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(MkLayout, _Component);

  var _super = _createSuper(MkLayout);

  function MkLayout(props) {
    var _this;

    (0, _classCallCheck2.default)(this, MkLayout);
    _this = _super.call(this, props);

    _this.renderContent = function () {
      var collapsed = _this.state.collapsed;
      var _renderContent = _this.props.renderContent;
      return _renderContent(collapsed);
    };

    _this.onToggleCollapsed = function (collapsed, type) {
      _this.setState({
        collapsed: collapsed === undefined ? !_this.state.collapsed : collapsed
      });
    };

    _this.componentDidMount = function () {
      _this.setState({
        collapsed: !(document.body.clientWidth > 1200)
      });
    };

    _this.state = {
      collapsed: props.collapsed || false
    };
    return _this;
  }

  (0, _createClass2.default)(MkLayout, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if ('collapsed' in this.props && !!prevProps.collapsed !== !!this.props.collapsed) {
        this.setState({
          collapsed: this.props.collapsed
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var collapsed = this.state.collapsed;
      var _this$props = this.props,
          pathArr = _this$props.pathArr,
          setMenus = _this$props.setMenus,
          setSiderMenus = _this$props.setSiderMenus,
          renderHeaderMenu = _this$props.renderHeaderMenu,
          renderSiderMenu = _this$props.renderSiderMenu,
          isShowMenuFn = _this$props.isShowMenuFn,
          getBadgeCount = _this$props.getBadgeCount,
          noSider = _this$props.noSider,
          logo = _this$props.logo,
          renderLoader = _this$props.renderLoader,
          onMenuClick = _this$props.onMenuClick,
          Link = _this$props.Link,
          renderMenuLabel = _this$props.renderMenuLabel,
          headerBgColor = _this$props.headerBgColor,
          isHistoryPush = _this$props.isHistoryPush;
      var menus = setMenus();
      var siderMenus = setSiderMenus();
      return /*#__PURE__*/_react.default.createElement(_layout.default, {
        className: "".concat(prefix, "-page-container")
      }, /*#__PURE__*/_react.default.createElement(_MkHeader.default, {
        logo: logo,
        collapsed: collapsed,
        onToggleCollapsed: this.onToggleCollapsed,
        pathArr: pathArr,
        leftMenus: menus.leftMenus,
        rightMenus: menus.rightMenus,
        renderHeaderMenu: renderHeaderMenu,
        onMenuClick: onMenuClick,
        Link: Link,
        renderMenuLabel: renderMenuLabel,
        isShowMenuFn: isShowMenuFn,
        headerBgColor: headerBgColor
      }), /*#__PURE__*/_react.default.createElement(_layout.default, {
        className: "".concat(prefix, "-section")
      }, noSider ? null : /*#__PURE__*/_react.default.createElement(_MkSider.default, {
        collapsed: collapsed,
        renderLoader: renderLoader,
        onToggleCollapsed: this.onToggleCollapsed,
        pathArr: pathArr,
        menus: siderMenus,
        Link: Link,
        renderSiderMenu: renderSiderMenu,
        getBadgeCount: getBadgeCount,
        isHistoryPush: isHistoryPush,
        isShowMenuFn: isShowMenuFn,
        renderMenuLabel: renderMenuLabel
      }), /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-content")
      }, this.renderContent())));
    }
  }]);
  return MkLayout;
}(_react.Component);

MkLayout.propTypes = {
  setMenus: _propTypes.default.func,
  renderMenu: _propTypes.default.func,
  setSiderMenus: _propTypes.default.func,
  renderSiderMenu: _propTypes.default.func,
  renderContent: _propTypes.default.func
};
var _default = MkLayout;
exports.default = _default;