"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var homeRoutes = [{
  path: '/home',
  code: 'home',
  name: '首页',
  icon: 'fm-home-o',
  permission: 'home.home'
}, {
  path: '/home/approval',
  code: 'approval',
  name: '审核',
  icon: 'fm-quill-o',
  permission: 'home.approval'
}];
var leftMenus = [{
  path: '/home',
  //菜单路由
  code: 'home',
  //唯一编码
  name: '首页',
  //显示名称
  redirect: true,
  subRoutes: homeRoutes,
  //子菜单
  permission: 'home'
}];
var rightMenus = [];
var _default = {
  setMenus: function setMenus() {
    return {
      leftMenus: leftMenus,
      rightMenus: rightMenus
    };
  },
  setSiderMenus: function setSiderMenus() {
    return homeRoutes;
  },
  pathArr: ['home', 'approval'],
  isShowMenuFn: function isShowMenuFn(menu, isHeader) {
    return true;
  }
};
exports.default = _default;