"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _reactDom = require("react-dom");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;

var OptionExpense = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(OptionExpense, _Component);

  var _super = _createSuper(OptionExpense);

  function OptionExpense(props) {
    var _this;

    (0, _classCallCheck2.default)(this, OptionExpense);
    _this = _super.call(this, props);

    _this.onClick = function () {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          disabled = _this$props.disabled;
      !disabled && onChange && onChange(_this.props);
    };

    return _this;
  }

  (0, _createClass2.default)(OptionExpense, [{
    key: "getTargetTop",
    value: function getTargetTop() {
      var _this$props2 = this.props,
          select__value = _this$props2.select__value,
          value = _this$props2.value,
          getTargetTop = _this$props2.getTargetTop;

      if (value && select__value && select__value.code === value) {
        getTargetTop && getTargetTop((0, _reactDom.findDOMNode)(this).offsetTop);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.getTargetTop();
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.getTargetTop();
    }
  }, {
    key: "render",
    value: function render() {
      var _classnames;

      var _this$props3 = this.props,
          select__value = _this$props3.select__value,
          value = _this$props3.value,
          disabled = _this$props3.disabled,
          className = _this$props3.className,
          style = _this$props3.style,
          iconcode = _this$props3.iconcode;
      var classNames = (0, _classnames2.default)("".concat(prefix, "-option-expense"), (_classnames = {}, (0, _defineProperty2.default)(_classnames, "".concat(prefix, "-option-expense-selected"), select__value && select__value.code === value), (0, _defineProperty2.default)(_classnames, "".concat(prefix, "-option-expense-disabled"), disabled), (0, _defineProperty2.default)(_classnames, className, className), _classnames));
      return /*#__PURE__*/_react.default.createElement("div", {
        className: classNames,
        style: style,
        onClick: this.onClick
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "expense-type fm fm-feetype-".concat(iconcode)
      }), this.props.children);
    }
  }]);
  return OptionExpense;
}(_react.Component);

var _default = OptionExpense;
exports.default = _default;