"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("maycur-antd/lib/icon/style/css");

var _icon = _interopRequireDefault(require("maycur-antd/lib/icon"));

require("maycur-antd/lib/spin/style/css");

var _spin = _interopRequireDefault(require("maycur-antd/lib/spin"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _i18next = _interopRequireDefault(require("i18next"));

var _utils = _interopRequireDefault(require("../../../utils/utils"));

var _Empty = _interopRequireDefault(require("../../../Empty"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var prefix = _utils.default.prefixCls;
var Search = _input.default.Search;

function CustomTagSelectFilter(props) {
  var filters = props.filters,
      filtersSync = props.filtersSync,
      filterWidth = props.filterWidth,
      selectedKeys = props.selectedKeys,
      setSelectedKeys = props.setSelectedKeys,
      _props$showSearch = props.showSearch,
      showSearch = _props$showSearch === void 0 ? true : _props$showSearch,
      _props$placeholder = props.placeholder,
      placeholder = _props$placeholder === void 0 ? '' : _props$placeholder,
      search = props.search,
      confirm = props.confirm;

  var _useState = (0, _react.useState)(filters || []),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      options = _useState2[0],
      setOptions = _useState2[1];

  var _useState3 = (0, _react.useState)(filters || []),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      filtersSource = _useState4[0],
      setFilterSource = _useState4[1];

  var _useState5 = (0, _react.useState)(selectedKeys || []),
      _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
      values = _useState6[0],
      setValues = _useState6[1];

  var _useState7 = (0, _react.useState)(null),
      _useState8 = (0, _slicedToArray2.default)(_useState7, 2),
      searchKey = _useState8[0],
      setSearchKey = _useState8[1];

  var _useState9 = (0, _react.useState)(false),
      _useState10 = (0, _slicedToArray2.default)(_useState9, 2),
      loading = _useState10[0],
      setLoading = _useState10[1];

  var generateStyle = function generateStyle() {
    var style = {
      position: 'static',
      width: '100%'
    };

    if (filterWidth) {
      style = _objectSpread(_objectSpread({}, style), {}, {
        width: filterWidth
      });
    }

    return style;
  };

  var memoStyle = (0, _react.useMemo)(generateStyle, []);
  var parseOptions = (0, _react.useCallback)(function (data) {
    var result = [];
    result = data.map(function (item) {
      return _objectSpread(_objectSpread({}, item), {}, {
        label: item.text
      });
    });
    return result;
  }, []);
  var fetchFilters = (0, _react.useCallback)( /*#__PURE__*/(0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee() {
    var data, result;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return filtersSync();

          case 3:
            data = _context.sent;
            result = parseOptions(data);
            setFilterSource(result);
            setOptions(result);
            _context.next = 12;
            break;

          case 9:
            _context.prev = 9;
            _context.t0 = _context["catch"](0);
            console.error(_context.t0);

          case 12:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 9]]);
  })), [filtersSync, parseOptions, setFilterSource, setOptions]);
  var onSearchKeyChange = (0, _react.useCallback)(function (e) {
    setSearchKey(e.target.value);
  }, [setSearchKey]);
  var addItem = (0, _react.useCallback)(function (option) {
    var result = (0, _toConsumableArray2.default)(values);
    result.push(option.value);
    setValues(result);
    setSelectedKeys(result); // onChange(result);
  }, [values, setValues, setSelectedKeys]);
  var removeItem = (0, _react.useCallback)(function (option) {
    var result = (0, _toConsumableArray2.default)(values);
    result.splice(values.findIndex(function (item) {
      return item === option.value;
    }), 1);
    setValues(result);
    setSelectedKeys(result); // onChange(result);
  }, [values, setValues, setSelectedKeys]);
  var handleOptionClick = (0, _react.useCallback)(function (e, option) {
    e.stopPropagation();
    values.includes(option.value) ? removeItem(option) : addItem(option);
  }, [values, removeItem, addItem]);
  var onSearch = (0, _react.useCallback)(function (value) {
    if (typeof search === 'function') {
      setLoading(true);
      search(value).then(function (res) {
        setFilterSource(parseOptions(res));
        setLoading(false);
      }, function () {
        setLoading(false);
      });
      return;
    }

    if (value) {
      var _options = filtersSource.filter(function (item) {
        return item.label.indexOf(value) > -1;
      });

      setOptions(_options);
    } else {
      setOptions(filtersSource);
    }
  }, [setLoading, search, setFilterSource, parseOptions, filtersSource, setOptions]); // 重置

  var reset = (0, _react.useCallback)(function () {
    setValues([]);
    setSearchKey(null);
    setSelectedKeys();
    onSearch(null);
  }, [setValues, setSearchKey, setSelectedKeys, onSearch]); // 确定

  var onConfirm = function onConfirm() {
    // if (typeof filtersSync === 'function') {
    //     setFiltersMap();
    // }
    confirm();
  };

  (0, _react.useEffect)(function () {
    fetchFilters(); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  (0, _react.useEffect)(function () {
    Array.isArray(selectedKeys) && !!selectedKeys.length && setValues(selectedKeys);
  }, [selectedKeys]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-tag-filter")
  }, showSearch ? /*#__PURE__*/_react.default.createElement("div", {
    className: 'pin-search'
  }, /*#__PURE__*/_react.default.createElement(Search, {
    value: searchKey,
    onSearch: onSearch,
    onChange: onSearchKeyChange,
    placeholder: placeholder
  })) : null, loading && /*#__PURE__*/_react.default.createElement(_spin.default, null), /*#__PURE__*/_react.default.createElement("div", {
    className: "ant-select-dropdown ant-select-dropdown--multiple ant-select-dropdown-placement-bottomLeft",
    style: memoStyle
  }, /*#__PURE__*/_react.default.createElement("ul", {
    role: "listbox",
    className: "ant-select-dropdown-menu  ant-select-dropdown-menu-root ant-select-dropdown-menu-vertical",
    tabIndex: "0"
  }, options && options.length ? options.map(function (option) {
    return /*#__PURE__*/_react.default.createElement("li", {
      key: option.value,
      className: (0, _classnames.default)({
        'ant-select-dropdown-menu-item': true,
        'ant-select-dropdown-menu-item-selected ': values.includes(option.value)
      }),
      title: option.label,
      onClick: function onClick(e) {
        handleOptionClick(e, option);
      }
    }, /*#__PURE__*/_react.default.createElement("i", {
      className: "primary-radius",
      style: {
        backgroundColor: option.color || 'transparent'
      }
    }), option.label, /*#__PURE__*/_react.default.createElement(_icon.default, {
      className: "ant-select-selected-icon",
      type: "check"
    }));
  }) : /*#__PURE__*/_react.default.createElement(_Empty.default, null))), /*#__PURE__*/_react.default.createElement("div", {
    className: 'pin-footer'
  }, /*#__PURE__*/_react.default.createElement("div", {
    onClick: reset,
    className: 'footer-item weaker-item'
  }, _i18next.default.t('MK_Global:reset')), /*#__PURE__*/_react.default.createElement("div", {
    onClick: onConfirm,
    className: 'footer-item'
  }, _i18next.default.t('MK_Global:ok'))));
}

var _default = /*#__PURE__*/(0, _react.memo)(CustomTagSelectFilter);

exports.default = _default;