"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/button/style/css");

var _button = _interopRequireDefault(require("maycur-antd/lib/button"));

require("maycur-antd/lib/input-number/style/css");

var _inputNumber = _interopRequireDefault(require("maycur-antd/lib/input-number"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

require("maycur-antd/lib/message/style/css");

var _message2 = _interopRequireDefault(require("maycur-antd/lib/message"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _utils = _interopRequireDefault(require("../../../utils/utils"));

var _i18next = _interopRequireDefault(require("i18next"));

var _mkTranslate = _interopRequireDefault(require("../../../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;
var InputGroup = _input.default.Group;

var InputRange = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(InputRange, _Component);

  var _super = _createSuper(InputRange);

  function InputRange(props) {
    var _this;

    (0, _classCallCheck2.default)(this, InputRange);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_Table').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.onBlurMinAmount = function (e) {
      var maxAmount = _this.state.maxAmount;
      var _this$props = _this.props,
          showNumberRangeOkBtn = _this$props.showNumberRangeOkBtn,
          setSelectedKeys = _this$props.setSelectedKeys,
          confirm = _this$props.confirm;
      var value = e.target.value;
      var nextMaxAmount = maxAmount;

      if ((nextMaxAmount === undefined || nextMaxAmount === null) && value && value >= 0) {
        nextMaxAmount = value;
      }

      _this.setState({
        maxAmount: nextMaxAmount
      }, function () {
        if (!showNumberRangeOkBtn) {
          setSelectedKeys("".concat(_this.state.minAmount || 0, "~").concat(_this.state.maxAmount || 0));
          confirm();
        }
      });
    };

    _this.onChangeMinAmount = function (value) {
      _this.setState({
        minAmount: value
      });
    };

    _this.onBlurMaxAmount = function (e) {
      var minAmount = _this.state.minAmount;
      var _this$props2 = _this.props,
          showNumberRangeOkBtn = _this$props2.showNumberRangeOkBtn,
          setSelectedKeys = _this$props2.setSelectedKeys,
          confirm = _this$props2.confirm;
      var value = e.target.value;
      var nextMinAmount = minAmount;

      if ((nextMinAmount === undefined || nextMinAmount === null) && value && value >= 0) {
        nextMinAmount = value;
      }

      _this.setState({
        minAmount: nextMinAmount
      }, function () {
        if (!showNumberRangeOkBtn) {
          setSelectedKeys("".concat(_this.state.minAmount || 0, "~").concat(_this.state.maxAmount || 0));
          confirm();
        }
      });
    };

    _this.onChangeMaxAmount = function (value) {
      _this.setState({
        maxAmount: value
      });
    };

    _this.atLastValue = function () {
      var _this$props3 = _this.props,
          confirm = _this$props3.confirm,
          setSelectedKeys = _this$props3.setSelectedKeys;
      var _this$state = _this.state,
          minAmount = _this$state.minAmount,
          maxAmount = _this$state.maxAmount,
          t = _this$state.t;

      if (!minAmount && minAmount !== 0 || !maxAmount && maxAmount !== 0 || Number(minAmount) > Number(maxAmount)) {
        _message2.default.warn(t('numberRangeFilter.warn'));

        return;
      }

      setSelectedKeys("".concat(minAmount, "~").concat(maxAmount));
      confirm();
    };

    _this.state = {
      minAmount: undefined,
      maxAmount: undefined,
      t: _mkTranslate.default.noop()
    };

    _this.localeProcess();

    return _this;
  }

  (0, _createClass2.default)(InputRange, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props4 = this.props,
          selectedKeys = _this$props4.selectedKeys,
          dataIndex = _this$props4.dataIndex;

      if (selectedKeys && !_lodash.default.isEmpty(selectedKeys)) {
        if (dataIndex && dataIndex === 'creditScore') {
          // 自定义筛选信用分单独处理
          this.setState({
            minAmount: !selectedKeys.minCreditScore && selectedKeys.minCreditScore !== 0 ? undefined : selectedKeys.minCreditScore,
            maxAmount: !selectedKeys.maxCreditScore && selectedKeys.maxCreditScore !== 0 ? undefined : selectedKeys.maxCreditScore
          });
        } else {
          this.setState({
            minAmount: !selectedKeys.minAmount && selectedKeys.minAmount !== 0 ? undefined : selectedKeys.minAmount,
            maxAmount: !selectedKeys.maxAmount && selectedKeys.maxAmount !== 0 ? undefined : selectedKeys.maxAmount
          });
        }
      }
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (this.props.selectedKeys !== nextProps.selectedKeys) {
        if (typeof nextProps.selectedKeys === 'string') {
          var selectedKeys = nextProps.selectedKeys;

          var _selectedKeys$split = selectedKeys.split('~'),
              _selectedKeys$split2 = (0, _slicedToArray2.default)(_selectedKeys$split, 2),
              minAmount = _selectedKeys$split2[0],
              maxAmount = _selectedKeys$split2[1];

          this.setState({
            minAmount: minAmount,
            maxAmount: maxAmount
          });
        } else {
          this.setState({
            minAmount: undefined,
            maxAmount: undefined
          });
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var t = this.state.t;
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-input-range-wraper")
      }, /*#__PURE__*/_react.default.createElement(InputGroup, {
        compact: true
      }, /*#__PURE__*/_react.default.createElement(_inputNumber.default, {
        style: {
          textAlign: 'left'
        },
        placeholder: t('numberRangeFilter.min'),
        value: this.state.minAmount,
        onChange: this.onChangeMinAmount,
        onBlur: this.onBlurMinAmount
      }), /*#__PURE__*/_react.default.createElement(_input.default, {
        style: {
          width: 30,
          borderLeft: 0,
          pointerEvents: 'none',
          backgroundColor: '#fff'
        },
        placeholder: "~",
        disabled: true
      }), /*#__PURE__*/_react.default.createElement(_inputNumber.default, {
        style: {
          textAlign: 'left',
          borderLeft: 0
        },
        placeholder: t('numberRangeFilter.max'),
        value: this.state.maxAmount,
        onChange: this.onChangeMaxAmount,
        onBlur: this.onBlurMaxAmount
      }), this.props.showNumberRangeOkBtn && /*#__PURE__*/_react.default.createElement(_button.default, {
        size: "small",
        type: "primary",
        style: {
          marginLeft: 5
        },
        onClick: this.atLastValue
      }, _i18next.default.t('MK_Global:ok'))));
    }
  }]);
  return InputRange;
}(_react.Component);

InputRange.defaultProps = {
  showNumberRangeOkBtn: true
};
var _default = InputRange;
exports.default = _default;