"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/date-picker/style/css");

var _datePicker = _interopRequireDefault(require("maycur-antd/lib/date-picker"));

var _react = _interopRequireWildcard(require("react"));

var _moment = _interopRequireDefault(require("moment"));

var _utils = _interopRequireDefault(require("../../../utils/utils"));

var _i18next = _interopRequireDefault(require("i18next"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var RangePicker = _datePicker.default.RangePicker;
var prefix = _utils.default.prefixCls;

var RangeCalendarFilter = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(RangeCalendarFilter, _Component);

  var _super = _createSuper(RangeCalendarFilter);

  function RangeCalendarFilter(props) {
    var _this;

    (0, _classCallCheck2.default)(this, RangeCalendarFilter);
    _this = _super.call(this, props);

    _this.onChange = function (nextValue) {
      var _this$props = _this.props,
          confirm = _this$props.confirm,
          setSelectedKeys = _this$props.setSelectedKeys;

      if (nextValue) {
        if (nextValue.length === 2) {
          nextValue[0] = (0, _moment.default)(nextValue[0]).startOf('day');
          nextValue[1] = (0, _moment.default)(nextValue[1]).endOf('day');
        }

        _this.setState({
          selectedValue: nextValue
        }, function () {
          setSelectedKeys(nextValue);
          confirm();
        });
      }
    };

    _this.renderExtraFooter = function () {
      var isNeedSideBar = _this.props.isNeedSideBar;
      var rangeOptions = [{
        value: 'recentOne',
        label: _i18next.default.t('MK_Table:rangeCalendar.recentOne')
      }, {
        value: 'recentThree',
        label: _i18next.default.t('MK_Table:rangeCalendar.recentThree')
      }];
      return isNeedSideBar && /*#__PURE__*/_react.default.createElement("div", {
        className: "tabs"
      }, rangeOptions.map(function (item, index) {
        return /*#__PURE__*/_react.default.createElement("span", {
          className: 'tab',
          onClick: _this.onChoose.bind((0, _assertThisInitialized2.default)(_this), item.value),
          key: index
        }, item.label);
      }));
    };

    _this.onChoose = function (value) {
      var now = new Date();
      var _this$props2 = _this.props,
          confirm = _this$props2.confirm,
          setSelectedKeys = _this$props2.setSelectedKeys;

      _this.setState({
        range: value
      }, function () {
        switch (value) {
          case 'recentThree':
            _this.setState({
              selectedValue: [(0, _moment.default)(now).subtract(3, 'months'), (0, _moment.default)()]
            }, function () {
              setSelectedKeys(_this.state.selectedValue);
              confirm();
            });

            break;

          case 'recentOne':
            _this.setState({
              selectedValue: [(0, _moment.default)(now).subtract(1, 'months'), (0, _moment.default)()]
            }, function () {
              setSelectedKeys(_this.state.selectedValue);
              confirm();
            });

            break;

          default:
            break;
        }
      });
    };

    _this.state = {
      selectedValue: [],
      range: ''
    };
    return _this;
  }

  (0, _createClass2.default)(RangeCalendarFilter, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props3 = this.props,
          selectedKeys = _this$props3.selectedKeys,
          _this$props3$filterOp = _this$props3.filterOption,
          _this$props3$filterOp2 = _this$props3$filterOp.startDateKey,
          startDateKey = _this$props3$filterOp2 === void 0 ? 'startDate' : _this$props3$filterOp2,
          _this$props3$filterOp3 = _this$props3$filterOp.endDateKey,
          endDateKey = _this$props3$filterOp3 === void 0 ? 'endDate' : _this$props3$filterOp3;

      if (selectedKeys && selectedKeys[startDateKey] && selectedKeys[endDateKey]) {
        this.setState({
          selectedValue: [(0, _moment.default)(selectedKeys[startDateKey]), (0, _moment.default)(selectedKeys[endDateKey])]
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react.default.createElement(RangePicker, {
        dropdownClassName: "".concat(prefix, "-range-calendar"),
        defaultValue: this.state.selectedValue,
        value: this.state.selectedValue,
        onChange: this.onChange,
        renderExtraFooter: this.renderExtraFooter
      });
    }
  }]);
  return RangeCalendarFilter;
}(_react.Component);

RangeCalendarFilter.defaultProps = {
  isNeedSideBar: true
};
var _default = RangeCalendarFilter;
exports.default = _default;