"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/list/style/css");

var _list = _interopRequireDefault(require("maycur-antd/lib/list"));

require("maycur-antd/lib/message/style/css");

var _message2 = _interopRequireDefault(require("maycur-antd/lib/message"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _utils = _interopRequireDefault(require("../../../../../utils/utils"));

var _classnames = _interopRequireDefault(require("classnames"));

var _constants = _interopRequireDefault(require("../../../../../utils/constants"));

var _mkTranslate = _interopRequireDefault(require("../../../../../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var OPTION_PICKER = _constants.default.OPTION_PICKER;

var OptionList = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(OptionList, _Component);

  var _super = _createSuper(OptionList);

  function OptionList(props) {
    var _this;

    (0, _classCallCheck2.default)(this, OptionList);
    _this = _super.call(this, props);
    _this.state = {
      sourceList: props.sourceList || [],
      selectList: props.selectList || [],
      allSelected: false,
      t: _mkTranslate.default.noop()
    };
    _this.toggleAll = _this.toggleAll.bind((0, _assertThisInitialized2.default)(_this));
    _this.toggleItem = _this.toggleItem.bind((0, _assertThisInitialized2.default)(_this));
    _this.drillDown = _this.drillDown.bind((0, _assertThisInitialized2.default)(_this));
    _this.output = _this.output.bind((0, _assertThisInitialized2.default)(_this));
    _this.checkAllFlag = _this.checkAllFlag.bind((0, _assertThisInitialized2.default)(_this));
    _this.t = _mkTranslate.default.getNameSpace('MK_OptionInput').then(function (t) {
      _this.setState({
        t: t
      });
    });
    return _this;
  }

  (0, _createClass2.default)(OptionList, [{
    key: "preventCheckAllCondition",
    value: function preventCheckAllCondition() {
      var _this$props = this.props,
          maxSelectLength = _this$props.maxSelectLength,
          isSelectCategory = _this$props.isSelectCategory;
      var _this$state = this.state,
          sourceList = _this$state.sourceList,
          selectList = _this$state.selectList;
      sourceList = isSelectCategory ? sourceList : _lodash.default.filter(sourceList, {
        type: OPTION_PICKER.ITEM
      });

      var common = _lodash.default.intersectionWith(sourceList, selectList, _utils.default.bizEquals);

      return sourceList.length > common.length + (maxSelectLength - selectList.length) && maxSelectLength > 0 || !sourceList.length;
    }
  }, {
    key: "toggleAll",
    value: function toggleAll() {
      var _this$state2 = this.state,
          sourceList = _this$state2.sourceList,
          allSelected = _this$state2.allSelected;
      var isSelectCategory = this.props.isSelectCategory;
      sourceList = isSelectCategory ? sourceList : _lodash.default.filter(sourceList, {
        type: OPTION_PICKER.ITEM
      });

      if (this.preventCheckAllCondition()) {
        return;
      }

      this.setState({
        selectList: sourceList,
        allSelected: !allSelected
      });
      this.output(sourceList, false);
    }
  }, {
    key: "toggleItem",
    value: function toggleItem(e, item) {
      var _this$props2 = this.props,
          maxSelectLength = _this$props2.maxSelectLength,
          isSelectCategory = _this$props2.isSelectCategory;
      var selectList = this.state.selectList;

      if (item.type === OPTION_PICKER.CATEGORY && !isSelectCategory) {
        e.stopPropagation();
        return;
      }
      /** 单选 */


      if (!maxSelectLength || maxSelectLength === 1) {
        selectList = [item];
      } else {
        var idx = _lodash.default.findIndex(selectList, {
          code: item.code
        });

        if (idx !== -1) {
          selectList.splice(idx, 1);
        } else {
          if (selectList.length < maxSelectLength || maxSelectLength <= 0) {
            selectList.push(item);
          } else {
            _message2.default.warning("超出限制，最多只能选择" + maxSelectLength + "项");
          }
        }
      }

      this.setState({
        selectList: selectList
      });
      this.output(selectList, true);
      setTimeout(this.checkAllFlag);
    }
  }, {
    key: "checkAllFlag",
    value: function checkAllFlag() {
      var _this$state3 = this.state,
          sourceList = _this$state3.sourceList,
          selectList = _this$state3.selectList;
      var isSelectCategory = this.props.isSelectCategory;
      var targetList = isSelectCategory ? sourceList : _lodash.default.filter(sourceList, {
        type: OPTION_PICKER.ITEM
      });
      var allSelected = targetList.length && !_lodash.default.find(targetList, function (dep) {
        return !_lodash.default.find(selectList, {
          code: dep.code
        });
      });
      this.setState({
        allSelected: allSelected
      });
    }
  }, {
    key: "drillDown",
    value: function drillDown(item) {
      var onDrillDown = this.props.onDrillDown;

      if (typeof onDrillDown === "function") {
        onDrillDown(item);
      }
    }
  }, {
    key: "output",
    value: function output(selectList, itemSelected) {
      var allSelected = this.state.allSelected;
      var onOutput = this.props.onOutput;
      var result = {
        added: selectList,
        allSelected: allSelected,
        itemSelected: itemSelected
      };

      if (typeof onOutput === "function") {
        onOutput(result);
      }
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var sourceList = nextProps.sourceList,
          selectList = nextProps.selectList;

      if (sourceList) {
        this.setState({
          sourceList: sourceList
        });
      }

      if (selectList) {
        this.setState({
          selectList: selectList
        });
      }

      setTimeout(this.checkAllFlag);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.checkAllFlag();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state4 = this.state,
          sourceList = _this$state4.sourceList,
          selectList = _this$state4.selectList,
          allSelected = _this$state4.allSelected,
          className = _this$state4.className;
      var _this$props3 = this.props,
          canDrillDown = _this$props3.canDrillDown,
          loading = _this$props3.loading,
          isSelectCategory = _this$props3.isSelectCategory;
      var containerClass = (0, _classnames.default)("option-list", className);
      var selectClass = (0, _classnames.default)("select-all-btn", {
        disabled: this.preventCheckAllCondition()
      });
      var allSelectedClass = (0, _classnames.default)({
        selected: allSelected
      });
      return /*#__PURE__*/_react.default.createElement("div", {
        className: containerClass
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "opt-bar"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: selectClass,
        onClick: this.toggleAll
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: allSelectedClass + " fm fm-check"
      }), /*#__PURE__*/_react.default.createElement("span", null, allSelected ? this.state.t("deselectAll") : this.state.t("selectAll")))), /*#__PURE__*/_react.default.createElement(_list.default, {
        size: "small",
        loading: loading,
        dataSource: sourceList,
        renderItem: function renderItem(item) {
          var selected = _lodash.default.findIndex(selectList, {
            code: item.code
          }) !== -1;
          var itemClass = (0, _classnames.default)({
            selected: selected,
            notick: item.type === OPTION_PICKER.CATEGORY && !isSelectCategory
          });
          return /*#__PURE__*/_react.default.createElement(_list.default.Item, {
            className: itemClass,
            key: item.code,
            onClick: function onClick(e) {
              _this2.toggleItem(e, item);
            }
          }, /*#__PURE__*/_react.default.createElement("div", {
            className: 'item-content'
          }, /*#__PURE__*/_react.default.createElement("span", {
            className: 'fm fm-check'
          }), /*#__PURE__*/_react.default.createElement("span", {
            className: 'option-item-name'
          }, item.type === OPTION_PICKER.CATEGORY ? /*#__PURE__*/_react.default.createElement("span", {
            className: 'fm fm-folde-open'
          }) : /*#__PURE__*/_react.default.createElement("span", {
            className: 'fm fm-paper'
          }), item.name)), item.type === OPTION_PICKER.CATEGORY && !selected && item.hasMore && canDrillDown ? /*#__PURE__*/_react.default.createElement("span", {
            className: 'fm fm-organization',
            onClick: function onClick(e) {
              e.stopPropagation();

              _this2.drillDown(item);
            }
          }, " \u4E0B\u7EA7") : null);
        }
      }));
    }
  }]);
  return OptionList;
}(_react.Component);

OptionList.defaultProps = {
  canDrillDown: true
};
var _default = OptionList;
exports.default = _default;