"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/skeleton/style/css");

var _skeleton = _interopRequireDefault(require("maycur-antd/lib/skeleton"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var NameCard = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(NameCard, _Component);

  var _super = _createSuper(NameCard);

  function NameCard(props) {
    var _this;

    (0, _classCallCheck2.default)(this, NameCard);
    _this = _super.call(this, props);
    _this.state = {
      userCode: props.userCode,
      cardDetails: {
        fieldValues: [{
          label: '姓名',
          value: '张三丰'
        }, {
          label: '姓名',
          value: '张三丰'
        }]
      },
      loading: true
    };
    return _this;
  }

  (0, _createClass2.default)(NameCard, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var userCode = this.state.userCode;
      var fetchUserInfo = this.props.fetchUserInfo;
      fetchUserInfo(userCode).then(function (res) {
        if (res.code && res.code === 'ACK') {
          var data = res.data;

          _this2.setState({
            loading: false,
            cardDetails: data
          });
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          loading = _this$state.loading,
          cardDetails = _this$state.cardDetails;
      var _this$props = this.props,
          bg1 = _this$props.bg1,
          bg2 = _this$props.bg2;
      var style1 = bg1 && {
        backgroundImage: "url(".concat(bg1, ")")
      };
      var style2 = bg2 && {
        backgroundImage: "url(".concat(bg2, ")")
      };
      return /*#__PURE__*/_react.default.createElement("div", {
        className: 'nameCardContent',
        style: style1
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'cardHeaderBg'
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'nameCardHeader',
        style: style2
      }, /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("p", {
        className: 'name'
      }, cardDetails.employeeName), /*#__PURE__*/_react.default.createElement("p", {
        className: 'corporation'
      }, cardDetails.legalEntityName)))), /*#__PURE__*/_react.default.createElement("div", {
        className: 'nameCardBody'
      }, cardDetails.fieldValues && cardDetails.fieldValues.map(function (v, k) {
        if (v.identifier === 'rtRoutes') {
          var departments = v.value && v.value.split('，') || [];
          return /*#__PURE__*/_react.default.createElement(_skeleton.default, {
            key: v.sortIndex,
            loading: loading,
            active: true
          }, /*#__PURE__*/_react.default.createElement("div", {
            className: 'listItem',
            key: v.sortIndex
          }, /*#__PURE__*/_react.default.createElement("div", {
            className: 'listItemLable'
          }, v.name), /*#__PURE__*/_react.default.createElement("div", {
            className: 'listItemValue'
          }, departments && departments.map(function (departmentName, idx) {
            return /*#__PURE__*/_react.default.createElement("p", {
              key: idx
            }, departmentName);
          }))));
        } else {
          return /*#__PURE__*/_react.default.createElement(_skeleton.default, {
            key: v.sortIndex,
            loading: loading,
            active: true
          }, /*#__PURE__*/_react.default.createElement("div", {
            className: 'listItem',
            key: v.sortIndex
          }, /*#__PURE__*/_react.default.createElement("div", {
            className: 'listItemLable'
          }, v.name), /*#__PURE__*/_react.default.createElement("div", {
            className: 'listItemValue'
          }, v.value || /*#__PURE__*/_react.default.createElement("div", {
            className: 'emptyTxt'
          }, /*#__PURE__*/_react.default.createElement("span", {
            className: 'empty'
          })))));
        }
      })));
    }
  }]);
  return NameCard;
}(_react.Component);

var _default = NameCard;
exports.default = _default;