"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _OptionInputPicker = _interopRequireDefault(require("./OptionInputPicker"));

var _ViewInput = _interopRequireDefault(require("../ViewInput"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/*
 * @Author: yuxuan 
 * @Date: 2020-03-06 19:31:16 
 * @Last Modified by:   yuxuan 
 * @Last Modified time: 2020-03-06 19:31:16 
 */
function OptionInput(props) {
  var showBizCode = props.showBizCode,
      value = props.value,
      readOnly = props.readOnly;

  var _ref = value || {},
      name = _ref.name,
      bizCode = _ref.bizCode;

  var val = (0, _react.useMemo)(function () {
    return (name || '') + (showBizCode && bizCode ? "(".concat(bizCode, ")") : '');
  }, [name, showBizCode, bizCode]);
  return /*#__PURE__*/_react.default.createElement("div", null, readOnly ? /*#__PURE__*/_react.default.createElement(_ViewInput.default, {
    value: val
  }) : /*#__PURE__*/_react.default.createElement(_OptionInputPicker.default, props));
}

var _default = OptionInput;
exports.default = _default;