"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/checkbox/style/css");

var _checkbox = _interopRequireDefault(require("maycur-antd/lib/checkbox"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var TreeItem = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(TreeItem, _Component);

  var _super = _createSuper(TreeItem);

  function TreeItem(props) {
    var _this;

    (0, _classCallCheck2.default)(this, TreeItem);
    _this = _super.call(this, props);

    _this.expandClick = function (e) {
      var _this$props = _this.props,
          node = _this$props.node,
          expandNodes = _this$props.expandNodes; //const targetNode = this.findNodeData(treeData, e.target.code);

      expandNodes(node[_this.code]);
      e.stopPropagation();
    };

    _this.onChange = function (e) {
      var _checkNodes;

      var _this$props2 = _this.props,
          node = _this$props2.node,
          checkNodes = _this$props2.checkNodes;
      checkNodes((_checkNodes = {}, (0, _defineProperty2.default)(_checkNodes, _this.code, node[_this.code]), (0, _defineProperty2.default)(_checkNodes, _this.name, node[_this.name]), _checkNodes));
      e.stopPropagation();
    };

    _this.onParentChange = function (e) {
      var _onCheckDownNodes;

      var _this$props3 = _this.props,
          node = _this$props3.node,
          onCheckDownNodes = _this$props3.onCheckDownNodes;
      onCheckDownNodes((_onCheckDownNodes = {}, (0, _defineProperty2.default)(_onCheckDownNodes, _this.code, node[_this.code]), (0, _defineProperty2.default)(_onCheckDownNodes, _this.name, node[_this.name]), _onCheckDownNodes), e.target.checked);
      e.stopPropagation();
    };

    _this.code = props.code;
    _this.name = props.name;
    return _this;
  }

  (0, _createClass2.default)(TreeItem, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      return true;
    }
  }, {
    key: "findNodeData",
    value: function findNodeData(treeData, code) {
      if (treeData) {
        for (var i = 0; i < treeData.length; i++) {
          if (treeData[i][this.code] === code) {
            return treeData[i];
          }

          var found = this.findNodeData(treeData[i].children, code);
          if (found) return found;
        }
      }
    }
  }, {
    key: "render",
    value:
    /**
     * 
     * <span className={styles['checkbox-wrap']}>
                                <Checkbox onChange={this.onParentChange} checked={isNodeChecked(node.code)}  onClick={e => { e.stopPropagation()} }/>
                            </span>
     */
    function render() {
      var _this$props4 = this.props,
          node = _this$props4.node,
          children = _this$props4.children,
          parentTemplate = _this$props4.parentTemplate,
          childrenTemplate = _this$props4.childrenTemplate,
          isNodeChecked = _this$props4.isNodeChecked,
          isNodeExpanded = _this$props4.isNodeExpanded;
      return /*#__PURE__*/_react.default.createElement("li", {
        key: node[this.code]
      }, node.children ? /*#__PURE__*/_react.default.createElement("div", {
        onClick: this.expandClick
      }, /*#__PURE__*/_react.default.createElement("div", {
        code: node[this.code],
        className: "parent-wrap"
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: "\"fm\" \"fm-angle-right\" ".concat(isNodeExpanded(node[this.code]) ? "expanded" : "")
      }), parentTemplate(node)), /*#__PURE__*/_react.default.createElement("div", null, children)) : /*#__PURE__*/_react.default.createElement("div", {
        className: "child-wrap",
        onClick: this.onChange
      }, childrenTemplate(node), /*#__PURE__*/_react.default.createElement("span", {
        className: "checkbox-wrap"
      }, /*#__PURE__*/_react.default.createElement(_checkbox.default, {
        checked: isNodeChecked(node[this.code])
      }))));
    }
  }]);
  return TreeItem;
}(_react.Component);

var _default = TreeItem;
exports.default = _default;