"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/list/style/css");

var _list = _interopRequireDefault(require("maycur-antd/lib/list"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var RegionList = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(RegionList, _Component);

  var _super = _createSuper(RegionList);

  function RegionList(props) {
    var _this;

    (0, _classCallCheck2.default)(this, RegionList);
    _this = _super.call(this, props);
    _this.state = {
      sourceList: props.sourceList || [],
      selectList: props.selectList || [],
      allSelected: false
    };
    _this.t = _mkTranslate.default.getLocalNs('MK_RegionSelection', (0, _assertThisInitialized2.default)(_this));
    _this.toggleAll = _this.toggleAll.bind((0, _assertThisInitialized2.default)(_this));
    _this.toggleItem = _this.toggleItem.bind((0, _assertThisInitialized2.default)(_this));
    _this.drillDown = _this.drillDown.bind((0, _assertThisInitialized2.default)(_this));
    _this.checkAllFlag = _this.checkAllFlag.bind((0, _assertThisInitialized2.default)(_this));
    _this.output = _this.output.bind((0, _assertThisInitialized2.default)(_this));
    return _this;
  }

  (0, _createClass2.default)(RegionList, [{
    key: "toggleAll",
    value: function toggleAll() {
      var _this$state = this.state,
          sourceList = _this$state.sourceList,
          allSelected = _this$state.allSelected;
      var selectList;

      if (allSelected) {
        selectList = [];
      } else {
        selectList = _lodash.default.clone(sourceList);
      }

      if (this.preCheck(selectList)) {
        this.setState({
          selectList: selectList,
          allSelected: !allSelected
        });
        this.output(selectList);
      }
    }
  }, {
    key: "toggleItem",
    value: function toggleItem(item) {
      var selectList = this.state.selectList; // if (item.children) {
      //     this.drillDown(item);
      //     return;
      // }

      var idx = _lodash.default.findIndex(selectList, {
        code: item.code
      });

      if (idx !== -1) {
        selectList.splice(idx, 1);
      } else {
        if (this.preCheck(selectList)) {
          selectList.push(item);
        }
      }

      this.setState({
        selectList: selectList
      });
      this.output(selectList);
      setTimeout(this.checkAllFlag);
    }
  }, {
    key: "checkAllFlag",
    value: function checkAllFlag() {
      var _this$state2 = this.state,
          sourceList = _this$state2.sourceList,
          selectList = _this$state2.selectList;
      var allSelected = sourceList.length && !_lodash.default.find(sourceList, function (lo) {
        return !_lodash.default.find(selectList, {
          code: lo.code
        });
      });
      this.setState({
        allSelected: allSelected
      });
    }
  }, {
    key: "drillDown",
    value: function drillDown(item) {
      var onDrillDown = this.props.onDrillDown;

      if (typeof onDrillDown === 'function') {
        onDrillDown(item);
      }
    }
  }, {
    key: "output",
    value: function output(selectList) {
      var sourceList = this.state.sourceList;
      var onOutput = this.props.onOutput;
      var result = {
        added: selectList,
        removed: _lodash.default.differenceWith(sourceList, selectList, function (o1, o2) {
          return o1.code === o2.code;
        })
      };

      if (typeof onOutput === 'function') {
        onOutput(result);
      }
    }
  }, {
    key: "preCheck",
    value: function preCheck(selectList) {
      var sourceList = this.state.sourceList;
      var onPreCheck = this.props.onPreCheck;
      var result = {
        added: selectList,
        removed: _lodash.default.differenceWith(sourceList, selectList, function (o1, o2) {
          return o1.code === o2.code;
        })
      };

      if (typeof onPreCheck === 'function') {
        return onPreCheck(result);
      } else {
        return true;
      }
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var sourceList = nextProps.sourceList,
          selectList = nextProps.selectList;

      if (sourceList) {
        this.setState({
          sourceList: sourceList
        });
      }

      if (selectList) {
        this.setState({
          selectList: selectList
        });
      }

      setTimeout(this.checkAllFlag);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.checkAllFlag();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state3 = this.state,
          sourceList = _this$state3.sourceList,
          selectList = _this$state3.selectList,
          allSelected = _this$state3.allSelected;
      var _this$props = this.props,
          canDrillDown = _this$props.canDrillDown,
          loading = _this$props.loading;
      var allSelectedClass = (0, _classnames.default)({
        selected: allSelected
      });
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "region-list-wrapper"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "opt-bar"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "select-all-btn",
        onClick: this.toggleAll
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: allSelectedClass + ' fm fm-check'
      }), /*#__PURE__*/_react.default.createElement("span", null, allSelected ? this.t('deselectAll') : this.t('selectAll')))), /*#__PURE__*/_react.default.createElement(_list.default, {
        size: "small",
        loading: loading,
        dataSource: sourceList,
        renderItem: function renderItem(item) {
          var selected = _lodash.default.findIndex(selectList, {
            code: item.code
          }) !== -1;
          var itemClass = (0, _classnames.default)({
            selected: selected
          });
          return /*#__PURE__*/_react.default.createElement(_list.default.Item, {
            className: itemClass,
            key: item.code,
            onClick: function onClick() {
              _this2.toggleItem(item);
            }
          }, /*#__PURE__*/_react.default.createElement("span", {
            className: 'fm fm-check'
          }), /*#__PURE__*/_react.default.createElement("span", {
            className: "item-name"
          }, item.name), !selected && item.children && canDrillDown ? /*#__PURE__*/_react.default.createElement("span", {
            className: 'fm fm-organization',
            onClick: function onClick(e) {
              e.stopPropagation();

              _this2.drillDown(item);
            }
          }, _this2.t('subordinate')) : null);
        }
      }));
    }
  }]);
  return RegionList;
}(_react.Component);

RegionList.defaultProps = {
  canDrillDown: true
};
var _default = RegionList;
exports.default = _default;