"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _windowOrGlobal = require("window-or-global");

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

var _this = void 0;

var useTranslate = function useTranslate(ns) {
  if (!ns) throw new _windowOrGlobal.Error('ns is not allowed');

  var t = _mkTranslate.default.getLocalNs(ns, _this);

  return t;
};

var _default = useTranslate;
exports.default = _default;