"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _reactPdf = require("react-pdf");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var LegacyNav = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(LegacyNav, _React$Component);

  var _super = _createSuper(LegacyNav);

  function LegacyNav() {
    var _this;

    (0, _classCallCheck2.default)(this, LegacyNav);
    _this = _super.call(this);

    _this.handleChangeImg = function (newIndex) {
      if (_this.props.activeIndex === newIndex) {
        return;
      }

      _this.props.onChangeImg(newIndex);
    };

    _this.state = {};
    return _this;
  }

  (0, _createClass2.default)(LegacyNav, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props$cMapUrl = this.props.cMapUrl,
          cMapUrl = _this$props$cMapUrl === void 0 ? 'cmaps/' : _this$props$cMapUrl;
      var releaseStyle = {
        width: "".concat(this.props.navbarWidth ? "".concat(this.props.navbarWidth, "px") : 'auto')
      }; // const listStyle = {
      //     transform: `translateX(${this.props.compareDistance}px)`,
      // };

      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(this.props.prefixCls, "-navbar")
      }, /*#__PURE__*/React.createElement("p", null, this.props.activeIndex + 1, " / ", this.props.files.length), /*#__PURE__*/React.createElement("div", {
        className: "".concat(this.props.prefixCls, "-navbar-switch")
      }, /*#__PURE__*/React.createElement("i", {
        className: "fm fm-angle-left",
        onClick: this.props.onPrev
      }), /*#__PURE__*/React.createElement("div", {
        className: "".concat(this.props.prefixCls, "-list-switch"),
        ref: this.props.refNavBar
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(this.props.prefixCls, "-list-release"),
        style: releaseStyle
      }, /*#__PURE__*/React.createElement("ul", {
        className: "".concat(this.props.prefixCls, "-list ").concat(this.props.prefixCls, "-list-transition")
      }, this.props.sourefiles.map(function (item, index) {
        var name = _this2.props.files[item].filename;
        return /*#__PURE__*/React.createElement("li", {
          key: item,
          className: "".concat(item === _this2.props.activeIndex ? 'active' : null, " ").concat(_this2.props.files[item].validateStatus === 'VALIDATED' ? 'proven-true' : null),
          onClick: function onClick() {
            _this2.handleChangeImg(item);
          }
        }, name && !name.slice(name.lastIndexOf('.') + 1).toLowerCase().includes('ofd') && _this2.props.files[item].src ? _this2.props.files[item].imageType.includes('pdf') ? /*#__PURE__*/React.createElement(_reactPdf.Document, {
          file: _this2.props.files[item].src,
          loading: null,
          options: {
            cMapUrl: cMapUrl,
            cMapPacked: true,
            fontFamily: 'Microsoft YaHei'
          }
        }, /*#__PURE__*/React.createElement(_reactPdf.Page, {
          pageNumber: _this2.props.files[item].pageNumber || 1,
          height: 40
        })) : /*#__PURE__*/React.createElement("img", {
          src: _this2.props.files[item].src,
          alt: _this2.props.files[item].alt
        }) : /*#__PURE__*/React.createElement("div", {
          className: "empty"
        }, /*#__PURE__*/React.createElement("i", {
          className: "fm fm-receipt1"
        })), _this2.props.files[item].validateStatus === 'VALIDATED' && /*#__PURE__*/React.createElement("i", {
          className: "fm fm-proven-true"
        }));
      })))), /*#__PURE__*/React.createElement("i", {
        className: "fm fm-angle-right",
        onClick: this.props.onNext
      })));
    }
  }]);
  return LegacyNav;
}(React.Component);

exports.default = LegacyNav;