"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _rcTrigger = _interopRequireDefault(require("rc-trigger"));

var _excluded = ["action", "popup", "hideDropDown", "children", "tableRef", "registerEvent", "getPopupContainer", "popupStyle", "destroyPopupOnHide"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function WrapperTrigger(props) {
  var _props$action = props.action,
      action = _props$action === void 0 ? ['click'] : _props$action,
      popup = props.popup,
      _props$hideDropDown = props.hideDropDown,
      hideDropDown = _props$hideDropDown === void 0 ? function () {} : _props$hideDropDown,
      children = props.children,
      tableRef = props.tableRef,
      registerEvent = props.registerEvent,
      getPopupContainer = props.getPopupContainer,
      popupStyle = props.popupStyle,
      _props$destroyPopupOn = props.destroyPopupOnHide,
      destroyPopupOnHide = _props$destroyPopupOn === void 0 ? true : _props$destroyPopupOn,
      restProps = (0, _objectWithoutProperties2.default)(props, _excluded);
  var containerRef = (0, _react.useRef)(null);
  var maxWidth = containerRef.current ? containerRef.current.clientWidth : 400;
  (0, _react.useEffect)(function () {
    registerEvent && registerEvent(hideDropDown);
  }, [registerEvent]);
  return /*#__PURE__*/_react.default.createElement("div", {
    ref: containerRef
  }, /*#__PURE__*/_react.default.createElement(_rcTrigger.default, (0, _extends2.default)({
    action: action,
    destroyPopupOnHide: destroyPopupOnHide,
    popupStyle: popupStyle || {
      maxWidth: maxWidth
    },
    popup: popup,
    getPopupContainer: getPopupContainer || function () {
      // 二级表单下拉框渲染到 table 节点，一级表单渲染到组件本身节点下
      return tableRef || containerRef.current;
    }
  }, restProps), children));
}

var _default = WrapperTrigger;
exports.default = _default;