"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = UseTranslate;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("react");

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

function UseTranslate() {
  var ns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'MK_Global';

  var _useState = (0, _react.useState)(function () {
    return _mkTranslate.default.noop();
  }),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      translate = _useState2[0],
      setTranslate = _useState2[1];

  (0, _react.useEffect)(function () {
    _mkTranslate.default.getNameSpace(ns).then(function (t) {
      setTranslate(function () {
        return t;
      });
    });
  }, [ns]);
  return translate;
}