"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/*
 * @Description: 
 * @Author: qmm
 * @Date: 2020-02-25 17:42:33
 * @LastEditors: Jiangang Lu
 * @LastEditTime: 2020-12-22 11:46:49
 */
var _default = {
  "bankBranchInput": {
    "searchPlaceholder": "Enter keyword search.",
    "label": "If no branch is found, please follow the example to add the branch name completely and then add it directly.",
    "example": "Example: Hangzhou Baima Sub-branch of Industrial and Commercial Bank of China Limited.",
    "noData": "No Data"
  },
  "cityInput": {
    "placeholder": "Enter keyword search.",
    "notFoundContent": "No Matching Results"
  },
  "editPaymentForm": {
    "bank": "Bank Account",
    "alipay": "Alipay",
    "cash": "Cash",
    "other": "Other",
    "errMsg": "Some problems were found during form verification. Please correct them before continuing.",
    "p1": "Some rural credit cooperatives, despite being reformed into rural commercial banks or rural cooperative banks, are still classified like before.",
    "p2": "If you cannot find the bank you want in the two new categories, you can try to find it under the category of “rural credit cooperatives”.",
    "bankLabel": "Bank",
    "paymentType": "Account Type",
    "paymentTypeMsg": "Account type cannot be empty.",
    "bankAcctName": "Bank Account Name",
    "bankAcctNameMsg": "Bank Accout Name cannot be empty.",
    "bankAcctNameMax": "Enter up to 50 characters.",
    "bankAcctNamePlaceholder": "Enter bank account name",
    "cashAcctName": "Cash Account Name",
    "cashAcctNamePlaceholder": "Enter cash account name",
    "bankCodeMsg": "Bank cannot be empty.",
    "bankCodePlaceholder": "Choose a bank",
    "bankAcctNumber": "Account No",
    "bankAcctNumberMsg": "Account No cannot be empty.",
    "bankAcctNumberPlaceholder": "Please enter account number",
    "abroadBankAddress": "Bank Address",
    "abroadBankAddressPlaceholder": "Please enter bank address",
    "abroadPayeeAddress": "Beneficiary Address",
    "abroadPayeeAddressPlaceholder": "Please enter beneficiary address",
    "swiftCode": "SWIFT Code",
    "swiftCodePlaceholder": "Please enter SWIFT code",
    "country": "Country & Region",
    "bankLocation": "Provinces and Cities",
    "bankLocationMsg": "Provinces and Cities cannot be empty.",
    "bankLocationPlaceholder": "Choose a location",
    "bankBranchBizCode": "Branch",
    "bankBranchBizCodeMsg": "Branch cannot be empty.",
    "bankBranchNoMsg": "Branch No cannot be empty.",
    "bankBranchBizCodePlaceholder": "Choose a branch",
    "bankQuery": "How do I get the information of the company number?",
    "bankMsg": "The company may need your bank number information when making inter-bank payment, please ask the bank customer service or use the bank number inquiry tool of the following website to inquire online.",
    "bank1": "河北银行",
    "bank2": "浙商银行",
    "bank3": "建设银行",
    "bank4": "中原银行",
    "bankBranchNo": "CNAPS CODE",
    "bankBranchNoPlaceholder": "If inter-bank transfer is required, please fill in this information.",
    "agencyBizCode": "Agency service number",
    "agencyBizCodePlaceholder": "Please enter the agency business number in the online banking format for private batch payment.",
    "certType": "Certificate Type",
    "certTypeMsg": "Certificate Type cannot be empty.",
    "certTypeMax": "Enter up to 40 characters.",
    "certTypePlaceholder": "Select certificate type.",
    "identification": "Identification Number",
    "identificationMsg": "Identification Number cannot be empty.",
    "identificationPlaceholder": "Enter identification number.",
    "bankAcctNameAli": "Alipay Name",
    "bankAcctNameAliMsg": "Alipay Name cannot be empty.",
    "bankAcctNameAliPlaceholder": "Enter Alipay name",
    "bankAcctNumberAli": "Alipay Account Number",
    "bankAcctNumberAliMsg": "Ali Number cannot be empty.",
    "bankAcctNumberAliPlaceholder": "Enter Alipay account number",
    "bankAcctNameOther": "Name",
    "bankAcctNameOtherMsg": "Name cannot be empty.",
    "bankAcctNameOtherPlaceholder": "Enter name",
    "bankAcctNumberOther": "Account Number",
    "bankAcctNumberOtherPlaceholder": "Enter account number",
    "accountBizCode": "Account Code",
    "accountBizCodePlaceholder": "Auto-generated if left blank",
    "description": "Remarks",
    "descriptionPlaceholder": "Please  this accout to let it different.",
    "active": "Status ",
    "bankAutomaticEnable": "Bank auto-deduction",
    "bankAutomaticEnableMsg": "This card will be used for 'Bank auto-deduction'.",
    "bankAutomaticEnableTip": "Companies may sign the agreement of 'automatic bank payments' with other organizations, such as unions. If ticked, this account can be used for 'automatic payments from the company's bank account'.",
    "accountScope": "Scope of Application",
    "shouldLimitEntity": "Applicable to the following legal entities",
    "currencyLabel": "Currency"
  },
  "warnMsg": "Some problems were found during the form verification. Please correct them before submitting them.",
  "alertMsg": "Please select the branch of your bank card for interbank transfers."
};
exports.default = _default;