"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = abs;

var _isnumber = _interopRequireDefault(require("./isnumber"));

var _error = require("./error");

// Copyright 2015-2018 FormBucket LLC
// ABS computes absolute value of a number
function abs(value) {
  // Return `#VALUE!` if not number
  if (!(0, _isnumber.default)(value)) {
    return _error.ERRORTYPES.value;
  } // Use built-in Math.abs


  return Math.abs(value);
}