"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = isempty;

var _isblank = _interopRequireDefault(require("./isblank"));

var _isarray = _interopRequireDefault(require("./isarray"));

var _istext = _interopRequireDefault(require("./istext"));

// Copyright 2015-2018 FormBucket LLC
// ISEMPTY returns true when the value is blank, is an empty array or when it
// is an empty string.
function isempty(value) {
  return (0, _isblank.default)(value) || (0, _isarray.default)(value) && value.length === 0 || (0, _istext.default)(value) && value === "";
}