"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/modal/style/css");

var _modal = _interopRequireDefault(require("maycur-antd/lib/modal"));

var _react = _interopRequireWildcard(require("react"));

var _service = require("../service");

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var prefix = _utils.default.prefixCls;

var MileChange = function MileChange(props) {
  var mileInfo = props.mileInfo,
      isOpen = props.isOpen,
      onClose = props.onClose,
      _onOk = props.onOk;
  var mileRef = (0, _react.useRef)();
  return /*#__PURE__*/_react.default.createElement(_modal.default, {
    visible: isOpen,
    onCancel: onClose,
    wrapClassName: "ngmk-modal-content",
    maskStyle: {
      position: "absolute"
    } // style={{ content: { width: "80%" } }}
    ,
    width: "90%",
    title: "\u8C03\u6574\u91CC\u7A0B",
    cancelText: "\u53D6\u6D88",
    getContainer: function getContainer() {
      return document.querySelector(".".concat(_service.milePrefix));
    },
    onOk: function onOk() {
      _onOk(parseFloat(mileRef.current.value));
    } // parentSelector={() => document.querySelector(`.${milePrefix}`)}
    // ariaHideApp={false}

  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(_service.milePrefix, "-change")
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "modal-content"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-ng-form-item")
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-ng-form-item-label")
  }, /*#__PURE__*/_react.default.createElement("label", null, "\u884C\u9A76\u91CC\u7A0B")), /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-ng-form-item-control")
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-ng-form-item-control-input")
  }, /*#__PURE__*/_react.default.createElement("input", {
    className: "".concat(prefix, "-ng-input"),
    placeholder: "\u8BF7\u8F93\u5165",
    ref: mileRef
  })))), /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-ng-form-item readonly")
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-ng-form-item-label")
  }, /*#__PURE__*/_react.default.createElement("label", null, "\u8865\u8D34\u5355\u4EF7")), /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-ng-form-item-control")
  }, /*#__PURE__*/_react.default.createElement("span", null, mileInfo.ccyCode + " " + mileInfo.unitAmount))), /*#__PURE__*/_react.default.createElement("textarea", {
    className: "".concat(prefix, "-ng-textarea"),
    placeholder: "\u8BF7\u586B\u5199\u8C03\u6574\u7406\u7531"
  }))));
};

var _default = MileChange;
exports.default = _default;