"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _MileIcon = _interopRequireDefault(require("./MileIcon"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _excluded = ["onClick", "loading", "className", "children"];
// import { milePrefix } from "../service";
var prefix = _utils.default.prefixCls;

var ProcessBtn = function ProcessBtn(props) {
  var onClick = props.onClick,
      loading = props.loading,
      className = props.className,
      children = props.children,
      others = (0, _objectWithoutProperties2.default)(props, _excluded);
  console.log(others);
  var processClass = (0, _classnames.default)(className, {
    disabled: loading
  });

  var handleOnClick = function handleOnClick(e) {
    if (loading) return;
    onClick(e);
  };

  return /*#__PURE__*/_react.default.createElement("button", {
    className: "".concat(processClass, " ").concat(prefix, "-process-btn"),
    onClick: handleOnClick
  }, loading ? /*#__PURE__*/_react.default.createElement("span", {
    className: "".concat(prefix, "-ng-icon")
  }, /*#__PURE__*/_react.default.createElement(_MileIcon.default, {
    name: "loading"
  })) : null, children);
};

var _default = ProcessBtn;
exports.default = _default;