"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _slimLodash = _interopRequireDefault(require("../utils/slimLodash"));

var _CityList = _interopRequireDefault(require("./CityList"));

var _rcTrigger = _interopRequireDefault(require("rc-trigger"));

var _utils = _interopRequireDefault(require("../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;

var CityPicker = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(CityPicker, _Component);

  var _super = _createSuper(CityPicker);

  function CityPicker(props) {
    var _this;

    (0, _classCallCheck2.default)(this, CityPicker);
    _this = _super.call(this, props);

    _this.open = function () {
      _this.setState({
        visible: true
      });
    };

    _this.close = function () {
      _this.setState({
        visible: false
      });
    };

    _this.switch = function (val) {
      _this.setState(function (_ref) {
        var visible = _ref.visible;
        if (visible !== val) return {
          visible: !!val
        };
      });
    };

    _this.state = {
      visible: false
    };
    return _this;
  }
  /* 打开popup */


  (0, _createClass2.default)(CityPicker, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var popWidth = this.props.popWidth;
      var visible = this.state.visible;

      var popupProps = _slimLodash.default.pick(this.props, ['bankPlaces', 'expensePlaces', 'placesHashMap', 'bankPlacesHashMap', 'afterChange', 'value']);

      return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_rcTrigger.default, {
        action: ['click'],
        popupVisible: visible,
        destroyPopupOnHide: true,
        onPopupVisibleChange: function onPopupVisibleChange(val) {
          _this2.switch(val);
        },
        popupAlign: {
          points: ['tl', 'bl'],
          offset: [0, -58]
        },
        popupClassName: "".concat(prefix, "-city-picker"),
        popupStyle: {
          width: popWidth
        },
        popup: /*#__PURE__*/_react.default.createElement(_CityList.default, (0, _extends2.default)({}, popupProps, {
          showDropDown: true,
          hideDropDown: this.close
        }))
      }, this.props.children));
    }
  }]);
  return CityPicker;
}(_react.Component);

CityPicker.propTypes = {
  /** popout出来的宽度  */
  popWidth: _propTypes.default.number
};
CityPicker.defaultProps = {
  popWidth: 500
};
var _default = CityPicker;
exports.default = _default;