"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WORD_MAP = exports.NOT_EMPTY = exports.IS_EMPTY = exports.NOT_CONTAIN = exports.CONTAIN = exports.OR = exports.AND = exports.NOT_IN = exports.IN = exports.NOT_LIKE = exports.LIKE = exports.NE = exports.EQ = exports.LT = exports.GT = exports.LTE = exports.GTE = exports.FORM_EXPRESSION = exports.FORM_RELATION = void 0;

var _i18next = _interopRequireDefault(require("i18next"));

var FORM_RELATION = 'RELATION';
exports.FORM_RELATION = FORM_RELATION;
var FORM_EXPRESSION = 'EXPRESSION';
exports.FORM_EXPRESSION = FORM_EXPRESSION;
var GTE = 'GTE';
exports.GTE = GTE;
var LTE = 'LTE';
exports.LTE = LTE;
var GT = 'GT';
exports.GT = GT;
var LT = 'LT';
exports.LT = LT;
var EQ = 'EQ';
exports.EQ = EQ;
var NE = 'NE';
exports.NE = NE;
var LIKE = 'LIKE';
exports.LIKE = LIKE;
var NOT_LIKE = 'NOT_LIKE';
exports.NOT_LIKE = NOT_LIKE;
var IN = 'IN';
exports.IN = IN;
var NOT_IN = 'NOT_IN';
exports.NOT_IN = NOT_IN;
var AND = 'AND';
exports.AND = AND;
var OR = 'OR';
exports.OR = OR;
var CONTAIN = 'CONTAIN';
exports.CONTAIN = CONTAIN;
var NOT_CONTAIN = 'NOT_CONTAIN';
exports.NOT_CONTAIN = NOT_CONTAIN;
var IS_EMPTY = 'IS_EMPTY';
exports.IS_EMPTY = IS_EMPTY;
var NOT_EMPTY = 'NOT_EMPTY';
exports.NOT_EMPTY = NOT_EMPTY;
var WORD_MAP = {
  'GTE': '>=',
  'LTE': '<=',
  'GT': '>',
  'LT': '<',
  'EQ': _i18next.default.t('equals'),
  'NE': _i18next.default.t('notEquals'),
  'IN': _i18next.default.t('IS'),
  'NOT_IN': _i18next.default.t('Isnot'),
  'LIKE': _i18next.default.t('IS'),
  'NOT_LIKE': _i18next.default.t('Isnot'),
  'AND': _i18next.default.t('meetAll'),
  'OR': _i18next.default.t('meetAny'),
  'NOT_CONTAIN': _i18next.default.t('notContain'),
  'CONTAIN': _i18next.default.t('contain'),
  'IS_EMPTY': "为空",
  'NOT_EMPTY': "非空"
};
exports.WORD_MAP = WORD_MAP;