"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/modal/style/css");

var _modal = _interopRequireDefault(require("maycur-antd/lib/modal"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

require("maycur-antd/lib/icon/style/css");

var _icon = _interopRequireDefault(require("maycur-antd/lib/icon"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _i18next = _interopRequireDefault(require("i18next"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var ConfirmModal = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(ConfirmModal, _Component);

  var _super = _createSuper(ConfirmModal);

  function ConfirmModal(props) {
    var _this;

    (0, _classCallCheck2.default)(this, ConfirmModal);
    _this = _super.call(this, props);

    _this.handleOk = function () {
      var _this$props = _this.props,
          promise = _this$props.promise,
          afterSubmit = _this$props.afterSubmit;

      if (afterSubmit) {
        afterSubmit(promise);
      } else if (promise && typeof promise.resolve === 'function') {
        promise.resolve();
      }
    };

    _this.state = {};
    return _this;
  }

  (0, _createClass2.default)(ConfirmModal, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          title = _this$props2.title,
          subTitle = _this$props2.subTitle,
          iconType = _this$props2.iconType,
          content = _this$props2.content,
          size = _this$props2.size,
          okText = _this$props2.okText,
          cancelText = _this$props2.cancelText,
          visible = _this$props2.visible;
      return /*#__PURE__*/_react.default.createElement(_modal.default, (0, _extends2.default)({
        visible: visible,
        title: title,
        onOk: this.handleOk,
        okText: okText,
        cancelText: cancelText,
        cancelButtonProps: {
          type: 'info'
        },
        wrapClassName: "ant-modal-".concat(size)
      }, this.props), subTitle ? /*#__PURE__*/_react.default.createElement("div", {
        className: "title"
      }, /*#__PURE__*/_react.default.createElement(_icon.default, {
        type: iconType
      }), /*#__PURE__*/_react.default.createElement("div", {
        className: "sub-title"
      }, subTitle)) : null, /*#__PURE__*/_react.default.createElement("div", {
        className: "content"
      }, content));
    }
  }]);
  return ConfirmModal;
}(_react.Component);

ConfirmModal.defaultProps = {
  visible: true,
  okText: _i18next.default.t('MK_Global:ok'),
  cancelText: _i18next.default.t('MK_Global:cancel')
};
var _default = ConfirmModal;
exports.default = _default;