"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/modal/style/css");

var _modal = _interopRequireDefault(require("maycur-antd/lib/modal"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

require("maycur-antd/lib/button/style/css");

var _button = _interopRequireDefault(require("maycur-antd/lib/button"));

require("maycur-antd/lib/checkbox/style/css");

var _checkbox = _interopRequireDefault(require("maycur-antd/lib/checkbox"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

require("maycur-antd/lib/popover/style/css");

var _popover = _interopRequireDefault(require("maycur-antd/lib/popover"));

require("maycur-antd/lib/switch/style/css");

var _switch = _interopRequireDefault(require("maycur-antd/lib/switch"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _DepartmentTransfer = _interopRequireDefault(require("../DepartmentTransfer"));

var _constants = _interopRequireDefault(require("../../utils/constants"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

var _lodash = _interopRequireDefault(require("lodash"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;
var DEPARTMENT_PICKER = _constants.default.DEPARTMENT_PICKER;

var DepartmentSelection = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(DepartmentSelection, _Component);

  var _super = _createSuper(DepartmentSelection);

  function DepartmentSelection(props) {
    var _this;

    (0, _classCallCheck2.default)(this, DepartmentSelection);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_DepartmentSelectionModal').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.onChange = function (selectList) {
      _this.setState({
        selectList: selectList
      });
    };

    _this.onOk = function () {
      var selectList = _this.state.selectList;
      var _this$props = _this.props,
          isModalManager = _this$props.isModalManager,
          promise = _this$props.promise,
          modalCallBack = _this$props.modalProps.modalCallBack;

      if (isModalManager && promise) {
        promise.resolve(selectList);
      } else if (typeof modalCallBack === 'function') {
        modalCallBack(selectList);
      }
    };

    _this.onCancel = function () {
      var _this$props2 = _this.props,
          isModalManager = _this$props2.isModalManager,
          modalProps = _this$props2.modalProps,
          promise = _this$props2.promise;
      var onCancel = modalProps.onCancel;

      if (isModalManager && promise) {
        promise.reject();
      } else if (typeof onCancel === 'function') {
        onCancel();
      }
    };

    _this.onSwitchChange = function (checked) {
      _this.setState({
        switchChecked: checked
      });
    };

    var pickerProps = props.pickerProps;
    _this.state = {
      selectList: pickerProps && pickerProps.selectList ? _lodash.default.cloneDeep(pickerProps.selectList) : [],
      switchChecked: pickerProps && pickerProps.switchChecked,
      t: _mkTranslate.default.noop()
    };

    _this.localeProcess();

    return _this;
  }

  (0, _createClass2.default)(DepartmentSelection, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var modalProps = this.props.modalProps;
      var selectList = this.state.selectList;
      var includeChildDept;

      if (_lodash.default.isEmpty(selectList) && modalProps.showIncludeChildConfig) {
        includeChildDept = true;
      } else {
        includeChildDept = selectList[0] && selectList[0].includeChildDept;
      }

      this.setState({
        includeChildDept: includeChildDept
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          modalProps = _this$props3.modalProps,
          pickerProps = _this$props3.pickerProps;
      var _this$state = this.state,
          switchChecked = _this$state.switchChecked,
          selectList = _this$state.selectList,
          includeChildDept = _this$state.includeChildDept,
          t = _this$state.t;
      var title;

      switch (pickerProps.scope) {
        case DEPARTMENT_PICKER.SCOPE_DEPARTMENT:
          title = /*#__PURE__*/_react.default.createElement("div", {
            className: "title"
          }, /*#__PURE__*/_react.default.createElement("div", null, t('departmentSelection.selectDepartment')), pickerProps.isSwitch && /*#__PURE__*/_react.default.createElement("div", {
            className: "switch"
          }, /*#__PURE__*/_react.default.createElement(_switch.default, {
            checked: switchChecked,
            disabled: pickerProps.switchDisabled,
            onChange: this.onSwitchChange
          }), /*#__PURE__*/_react.default.createElement("span", null, t('departmentSelection.departmentSpan')), /*#__PURE__*/_react.default.createElement(_popover.default, {
            placement: "right",
            content: /*#__PURE__*/_react.default.createElement("div", {
              className: "".concat(prefix, "-popover")
            }, t('departmentSelection.departmentPopover'))
          }, /*#__PURE__*/_react.default.createElement("span", {
            className: "fm fm-question"
          }))));
          break;

        case DEPARTMENT_PICKER.SCOPE_STAFF:
          title = t('departmentSelection.selectStaff');
          break;

        default:
          title = t('departmentSelection.selectAll');
          break;
      }

      title = pickerProps.isShowUserGroup ? "".concat(title).concat(t('departmentSelection.userGroup')) : title;
      var hideHelp = modalProps.hideHelp,
          modalTitle = modalProps.title,
          extra = modalProps.extra;

      var footer = /*#__PURE__*/_react.default.createElement("div", {
        className: "footer"
      }, pickerProps.scope !== DEPARTMENT_PICKER.SCOPE_STAFF && modalProps.showIncludeChildConfig && /*#__PURE__*/_react.default.createElement("div", {
        className: "include"
      }, /*#__PURE__*/_react.default.createElement(_checkbox.default, {
        disabled: modalProps.includeChildReadOnly,
        checked: includeChildDept,
        onChange: function onChange(e) {
          _this2.setState({
            includeChildDept: e.target.checked,
            selectList: _lodash.default.map(selectList, function (item) {
              return _objectSpread(_objectSpread({}, item), {}, {
                includeChildDept: e.target.checked
              });
            })
          });
        }
      }, t('departmentSelection.departmentSpan'), /*#__PURE__*/_react.default.createElement(_popover.default, {
        placement: "right",
        content: /*#__PURE__*/_react.default.createElement("div", {
          className: "".concat(prefix, "-popover")
        }, t('departmentSelection.departmentPopover'))
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "fm fm-question"
      })))), /*#__PURE__*/_react.default.createElement("div", {
        className: "btns-wrap"
      }, extra ? extra : !hideHelp ? /*#__PURE__*/_react.default.createElement("div", {
        className: "help"
      }, t('MK_Global:helpText'), /*#__PURE__*/_react.default.createElement("a", {
        href: "https://www.yuque.com/ruanruan-eydfh/yb01tu/adugpa",
        rel: "noopener noreferrer",
        target: "_blank"
      }, t('MK_Global:help'))) : /*#__PURE__*/_react.default.createElement("div", {
        className: "help"
      }), /*#__PURE__*/_react.default.createElement("div", {
        className: "btn"
      }, /*#__PURE__*/_react.default.createElement(_button.default, {
        key: "back",
        type: "info",
        size: "large",
        onClick: this.onCancel
      }, t('MK_Global:cancel')), /*#__PURE__*/_react.default.createElement(_button.default, {
        key: "submit",
        type: "primary",
        size: "large",
        onClick: this.onOk
      }, t('MK_Global:ok')))));

      return /*#__PURE__*/_react.default.createElement(_modal.default, (0, _extends2.default)({}, modalProps, {
        title: modalTitle ? modalTitle : title,
        footer: footer,
        onCancel: this.onCancel,
        destroyOnClose: true,
        maskClosable: false,
        keyboard: false,
        centered: true,
        className: "".concat(prefix, "-department-picker-select")
      }), /*#__PURE__*/_react.default.createElement(_DepartmentTransfer.default, (0, _extends2.default)({}, pickerProps, {
        fetchUserDepartment: pickerProps.fetchUserDepartment,
        fetchDepartmentChildren: pickerProps.fetch,
        fetchUserGroup: pickerProps.fetchUserGroup,
        searchDepartmentChildren: pickerProps.search,
        legalEntity: pickerProps.legalEntity,
        includeChildDept: includeChildDept,
        selectList: selectList,
        onChange: this.onChange
      })));
    }
  }]);
  return DepartmentSelection;
}(_react.Component);

DepartmentSelection.defaultProps = {
  isActionModal: false,
  modalProps: {},
  pickerProps: {}
};
var _default = DepartmentSelection;
exports.default = _default;