"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _configProvider = require("maycur-antd/lib/config-provider");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

// import i18n from 'i18next';
var prefix = _utils.default.prefixCls;

var Empty = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(Empty, _Component);

  var _super = _createSuper(Empty);

  function Empty(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Empty);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_Empty').then(function (t) {
        if (_this.componentMounted) _this.setState({
          t: t
        });
      });
    };

    _this.state = {
      t: _mkTranslate.default.noop()
    };
    _this.componentMounted = false;
    return _this;
  }

  (0, _createClass2.default)(Empty, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.componentMounted = true;
      this.localeProcess();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.componentMounted = false;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          text = _this$props.text,
          type = _this$props.type,
          className = _this$props.className,
          children = _this$props.children,
          notDefault = _this$props.notDefault,
          renderEmpty = _this$props.renderEmpty;
      var t = this.state.t;

      if (!notDefault && typeof renderEmpty === 'function' && renderEmpty.isCustom) {
        return renderEmpty('', text);
      }

      return /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _classnames.default)("".concat(prefix, "-empty"), className)
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-empty-content")
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-empty-circle")
      }, type && type === 'report' ? /*#__PURE__*/_react.default.createElement("span", {
        className: "fm fm-allocation"
      }) : /*#__PURE__*/_react.default.createElement("span", {
        className: "fm fm-default-page"
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-empty-text")
      }, text ? text : t('text')), children));
    }
  }]);
  return Empty;
}(_react.Component);

Empty.propTypes = {
  text: _propTypes.default.string,
  type: _propTypes.default.string
};

var _default = (0, _configProvider.withConfigConsumer)({
  prefixCls: prefix
})(Empty);

exports.default = _default;