"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _FormFields = _interopRequireDefault(require("../../FormFields"));

var _FormChef = _interopRequireDefault(require("../FormChef"));

var _FormFood = _interopRequireDefault(require("../../WebFormFood/FormFood"));

var _FormDish = _interopRequireDefault(require("../../FormDish/FormDish"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var InputField = _FormFields.default.InputField,
    MoneyField = _FormFields.default.MoneyField;
var fieldMaps = {
  SingleTextInput: InputField,
  AmountInput: MoneyField
};
var mockFormFields = [{
  identifier: 'name',
  type: 'SingleTextInput',
  editable: true,
  property: {
    label: '名称',
    isFieldHide: false,
    required: true,
    maxShowLength: 2,
    placeholder: '请输入名称',
    maxSelectLength: -1
  }
}, {
  identifier: 'schedules',
  type: 'AmountInput',
  editable: true,
  property: {
    label: '金额',
    required: true,
    isFieldHide: false,
    placeholder: '请输入金额'
  }
}];

function Demo1(props) {
  var form = props.form;
  (0, _react.useEffect)(function () {
    form.formInstantiate(mockFormFields).then(function () {
      form.initData({});
    });
  }, [form]);
  return /*#__PURE__*/_react.default.createElement("div", null, form.cookForm());
}

var DemoFormDish = (0, _FormDish.default)(_FormFood.default, {
  fieldMaps: fieldMaps
});

var _default = (0, _FormChef.default)({
  FormDish: DemoFormDish
})(Demo1);

exports.default = _default;