"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/checkbox/style/css");

var _checkbox = _interopRequireDefault(require("maycur-antd/lib/checkbox"));

var _react = _interopRequireDefault(require("react"));

function MkCheckbox(props) {
  var text = props.fieldProperties.text,
      value = props.value,
      readOnly = props.readOnly;

  var onChange = function onChange(e) {
    props.onChange && props.onChange(e.target.checked);
  };

  return /*#__PURE__*/_react.default.createElement(_checkbox.default, {
    checked: value,
    onChange: onChange,
    disabled: readOnly,
    style: {
      height: '32px',
      'lineHeight': '32px'
    }
  }, text);
}

var _default = MkCheckbox;
exports.default = _default;