"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/date-picker/style/css");

var _datePicker = _interopRequireDefault(require("maycur-antd/lib/date-picker"));

var _react = _interopRequireWildcard(require("react"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _moment = _interopRequireDefault(require("moment"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

var _lodash = require("lodash");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;
var cmName = "".concat(prefix, "-date-field");
var MonthPicker = _datePicker.default.MonthPicker;
/**
 * The only true button.
 *
 * @visibleName     🍳-DateField  
 */

var DateField = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(DateField, _Component);

  var _super = _createSuper(DateField);

  function DateField(props) {
    var _this;

    (0, _classCallCheck2.default)(this, DateField);
    _this = _super.call(this, props);

    _this.onChange = function (date) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          valueFormat = _this$props.fieldProperties.valueFormat;

      _this.setState({
        isClear: !date
      }, function () {
        var changedValue = {
          currentTime: valueFormat === 'YYYY-MM' ? date && date.startOf('month').valueOf() || null : date && date.valueOf() || null,
          timeRange: null
        };
        onChange && onChange(changedValue);
      });
    };

    _this.onOpenChange = function (open) {
      return _this.setState({
        open: open
      });
    };

    _this.UNSAFE_componentWillReceiveProps = function (nextProps) {
      var value = nextProps.value;

      if (!(0, _lodash.isEqual)(value, _this.props.value)) {
        _this.setDefaultValue(nextProps);
      }
    };

    _this.state = {
      defaultValue: props.value && props.value.currentTime && (0, _moment.default)(props.value.currentTime),
      isClear: false,
      open: false
    };
    _this.t = _mkTranslate.default.getLocalNs('MK_FormFields', (0, _assertThisInitialized2.default)(_this));
    _this.containerRef = /*#__PURE__*/(0, _react.createRef)();
    return _this;
  }

  (0, _createClass2.default)(DateField, [{
    key: "setDefaultValue",
    value: function setDefaultValue(props) {
      var valueFormat = props.fieldProperties.valueFormat,
          _props$extraProps = props.extraProps,
          travelTrip = _props$extraProps.travelTrip,
          shouldShowNow = _props$extraProps.shouldShowNow,
          value = props.value;
      var valueDefault = props.fieldProperties.valueDefault;
      var singleValue = value && value.currentTime;
      var defaultValue = value && value.currentTime;

      if (travelTrip) {
        var attendance = travelTrip.attendance || travelTrip.travelTimeRange || {};
        valueDefault = (attendance.startDate || {}).currentTime;
      }

      if (singleValue) {
        defaultValue = valueFormat === 'YYYY-MM' ? (0, _moment.default)(singleValue).startOf('month') : (0, _moment.default)(singleValue);
        this.onChange(defaultValue);
      } else if (valueDefault === 'NOW' && shouldShowNow && !this.state.isClear) {
        // 修复日期清空不掉的bug
        defaultValue = valueFormat === 'YYYY-MM' ? (0, _moment.default)().startOf('month') : (0, _moment.default)();
        this.onChange(defaultValue);
      }

      this.setState({
        defaultValue: defaultValue
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var _this$props2 = this.props,
          valueDefault = _this$props2.fieldProperties.valueDefault,
          _this$props2$extraPro = _this$props2.extraProps,
          shouldShowNow = _this$props2$extraPro.shouldShowNow,
          registerEvent = _this$props2$extraPro.registerEvent; // 新建的费用，且用户选择默认空值

      if (valueDefault === 'NA' && shouldShowNow) {// defaultValue = null;
      } else {
        this.setDefaultValue(this.props);
      }

      registerEvent && registerEvent(function () {
        return _this2.onOpenChange(false);
      });
    } // eslint-disable-next-line camelcase

  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props3 = this.props,
          fieldProperties = _this$props3.fieldProperties,
          readOnly = _this$props3.readOnly,
          extraProps = _this$props3.extraProps;
      var placeholder = fieldProperties.placeholder,
          required = fieldProperties.required,
          _fieldProperties$valu = fieldProperties.valueFormat,
          valueFormat = _fieldProperties$valu === void 0 ? 'YYYY-MM-DD' : _fieldProperties$valu,
          Ismodify = fieldProperties.Ismodify;
      var fieldStyleCategory = extraProps.fieldStyleCategory,
          disabledDate = extraProps.disabledDate,
          tableRef = extraProps.tableRef;
      var _this$state = this.state,
          defaultValue = _this$state.defaultValue,
          open = _this$state.open;
      var showTime = false;
      var dateFormat = valueFormat || 'YYYY-MM-DD';

      if (valueFormat.includes('HH:mm') || valueFormat.includes('A')) {
        showTime = true;

        if (valueFormat.search(/HH:mm$/ig) > 0) {
          showTime = {
            format: 'HH:mm'
          };
        }
      }

      var Picker = valueFormat === 'YYYY-MM' ? MonthPicker : _datePicker.default;
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
        className: cmName,
        ref: this.containerRef
      }, /*#__PURE__*/_react.default.createElement(Picker, {
        open: open,
        defaultValue: defaultValue,
        value: defaultValue,
        format: dateFormat,
        disabledDate: disabledDate,
        placeholder: readOnly ? this.t('empty') : placeholder,
        showTime: showTime,
        allowClear: !required,
        onChange: this.onChange,
        className: fieldStyleCategory === 'origin' ? "".concat(cmName, "_table-cell") : "".concat(cmName, "_normal"),
        disabled: readOnly,
        getCalendarContainer: function getCalendarContainer() {
          return tableRef || _this3.containerRef.current;
        },
        onOpenChange: this.onOpenChange
      })), Ismodify ? /*#__PURE__*/_react.default.createElement("span", {
        className: "fm fm-revised"
      }) : null);
    }
  }]);
  return DateField;
}(_react.Component);

var _default = DateField;
exports.default = _default;