"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _MoneyField = _interopRequireDefault(require("./MoneyField"));

var _CityField = _interopRequireDefault(require("./CityField"));

var _TextAreaField = _interopRequireDefault(require("./TextAreaField"));

var _NumberField = _interopRequireDefault(require("./NumberField"));

var _DateField = _interopRequireDefault(require("./DateField"));

var _DateRangeField = _interopRequireDefault(require("./DateRangeField"));

var _OptionField = _interopRequireDefault(require("./OptionField"));

var _InputField = _interopRequireDefault(require("./InputField"));

var _SplitSpace = _interopRequireDefault(require("./SplitSpace"));

var _StaffField = _interopRequireDefault(require("./StaffField"));

var _CityPairField = _interopRequireDefault(require("./CityPairField"));

var _DescTextField = _interopRequireDefault(require("./DescTextField"));

var _RadioField = _interopRequireDefault(require("./RadioField"));

var _TableField = _interopRequireDefault(require("./TableField"));

var _SwitchField = _interopRequireDefault(require("./SwitchField"));

var _CheckboxField = _interopRequireDefault(require("./CheckboxField"));

var _LegalEntityField = _interopRequireDefault(require("./LegalEntityField"));

var _SelectField = _interopRequireDefault(require("./SelectField"));

var _CurrencyField = _interopRequireDefault(require("./CurrencyField"));

/*
 * @Description: file content
 * @Author: RongWei
 * @Date: 2020-03-19 15:13:49
 * @LastEditors: RongWei
 * @LastEditTime: 2020-09-27 16:35:38
 */
var _default = {
  MoneyField: _MoneyField.default,
  CityField: _CityField.default,
  TextAreaField: _TextAreaField.default,
  NumberField: _NumberField.default,
  DateField: _DateField.default,
  DaterangeField: _DateRangeField.default,
  OptionField: _OptionField.default,
  InputField: _InputField.default,
  SplitSpace: _SplitSpace.default,
  StaffField: _StaffField.default.StaffField,
  CityPairField: _CityPairField.default,
  DescTextField: _DescTextField.default,
  RadioField: _RadioField.default,
  TableField: _TableField.default,
  TableInput: _TableField.default,
  SwitchField: _SwitchField.default,
  CheckboxField: _CheckboxField.default,
  LegalEntityField: _LegalEntityField.default,
  SelectField: _SelectField.default,
  CurrencyField: _CurrencyField.default
};
exports.default = _default;