"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/button/style/css");

var _button = _interopRequireDefault(require("maycur-antd/lib/button"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _Loader = _interopRequireDefault(require("../Loader"));

var _EditableList = _interopRequireDefault(require("./EditableList"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _excluded = ["onSave", "containerStyle", "formLoading", "currentNode", "contentTitle", "saveLoading", "leftExtra", "children", "forwardedRef", "showSave"];
var prefix = _utils.default.prefixCls;

function ListEditor(props) {
  var onSave = props.onSave,
      containerStyle = props.containerStyle,
      formLoading = props.formLoading,
      currentNode = props.currentNode,
      contentTitle = props.contentTitle,
      saveLoading = props.saveLoading,
      leftExtra = props.leftExtra,
      children = props.children,
      forwardedRef = props.forwardedRef,
      showSave = props.showSave,
      listProps = (0, _objectWithoutProperties2.default)(props, _excluded);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-list-editor-container"),
    style: containerStyle
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "left-block"
  }, /*#__PURE__*/_react.default.createElement(_EditableList.default, (0, _extends2.default)({}, listProps, {
    ref: forwardedRef
  })), leftExtra || null), /*#__PURE__*/_react.default.createElement("div", {
    className: "right-block"
  }, contentTitle ? /*#__PURE__*/_react.default.createElement("div", {
    className: "edit-content-title"
  }, /*#__PURE__*/_react.default.createElement("span", {
    style: {
      marginLeft: 24
    }
  }, contentTitle)) : null, /*#__PURE__*/_react.default.createElement("div", {
    className: "content"
  }, /*#__PURE__*/_react.default.createElement(_Loader.default, {
    active: formLoading,
    mask: true
  }), children), currentNode && showSave && /*#__PURE__*/_react.default.createElement("div", {
    className: "operator-bottom-bar"
  }, /*#__PURE__*/_react.default.createElement(_button.default, {
    type: "primary",
    size: "large",
    onClick: onSave ? onSave : null,
    loading: saveLoading
  }, "\u4FDD\u5B58"))));
}

;
var _default = ListEditor;
exports.default = _default;