"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/tag/style/css");

var _tag = _interopRequireDefault(require("maycur-antd/lib/tag"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _ManageSelectionModal = _interopRequireDefault(require("./ManageSelectionModal"));

var _constants = _interopRequireDefault(require("../utils/constants"));

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;
var MANAGE_PICKER = _constants.default.MANAGE_PICKER;

var ManagePicker = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(ManagePicker, _Component);

  var _super = _createSuper(ManagePicker);

  function ManagePicker(props) {
    var _this;

    (0, _classCallCheck2.default)(this, ManagePicker);
    _this = _super.call(this, props);
    _this.state = {
      // rc-form组件契约：接受value属性成为受控组件
      value: props.value || []
    };
    _this.onChange = _this.onChange.bind((0, _assertThisInitialized2.default)(_this));
    _this.openModal = _this.openModal.bind((0, _assertThisInitialized2.default)(_this));
    _this.convertFromValue = _this.convertFromValue.bind((0, _assertThisInitialized2.default)(_this));
    _this.convertToValue = _this.convertToValue.bind((0, _assertThisInitialized2.default)(_this));
    _this.t = _mkTranslate.default.getLocalNs('MK_ManagePicker', (0, _assertThisInitialized2.default)(_this));
    return _this;
  } // rc-form组件契约：注册onChange事件为form提供值变化感知


  (0, _createClass2.default)(ManagePicker, [{
    key: "onChange",
    value: function onChange(value) {
      var onChange = this.props.onChange;

      if (typeof onChange === 'function') {
        onChange(value);
      }
    } // rc-form组件契约：接受value属性成为受控组件

  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (_lodash.default.isEqual(nextProps.value, this.props.value)) {
        return;
      } else {
        var value = nextProps.value;
        this.setState({
          value: value
        });
      }
    }
  }, {
    key: "convertFromValue",
    value: function convertFromValue(value) {
      value = value || [];
      return _lodash.default.map(value, function (item) {
        return {
          code: item.code,
          name: item.name,
          type: item.type,
          userEmployeeId: item.userEmployeeId
        };
      });
    }
  }, {
    key: "convertToValue",
    value: function convertToValue(selectList) {
      selectList = selectList || [];
      return _lodash.default.map(selectList, function (item) {
        return {
          code: item.code,
          name: item.name,
          type: item.type,
          userEmployeeId: item.userEmployeeId
        };
      });
    }
  }, {
    key: "openModal",
    value: function openModal(e) {
      var _this2 = this;

      var value = this.state.value;
      var _this$props = this.props,
          scope = _this$props.scope,
          title = _this$props.title,
          isShowUserGroup = _this$props.isShowUserGroup,
          maxSelectLength = _this$props.maxSelectLength,
          disabled = _this$props.disabled,
          fetchSourceList = _this$props.fetchSourceList,
          fetchSearchList = _this$props.fetchSearchList,
          nameAlias = _this$props.nameAlias,
          codeAlias = _this$props.codeAlias,
          isSwitch = _this$props.isSwitch,
          switchChecked = _this$props.switchChecked,
          switchDisabled = _this$props.switchDisabled,
          paging = _this$props.paging,
          pageSize = _this$props.pageSize,
          ModalManager = _this$props.ModalManager,
          convertValue = _this$props.convertValue,
          selectCategory = _this$props.selectCategory;
      e.stopPropagation();

      if (disabled) {
        return;
      }

      ModalManager.open({
        component: _ManageSelectionModal.default,
        componentProps: {
          selectList: convertValue && this.convertFromValue(value) || value,
          scope: scope,
          title: title,
          isShowUserGroup: isShowUserGroup,
          maxSelectLength: maxSelectLength,
          fetchSourceList: fetchSourceList,
          fetchSearchList: fetchSearchList,
          paging: paging,
          pageSize: pageSize,
          nameAlias: nameAlias,
          codeAlias: codeAlias,
          isSwitch: isSwitch,
          switchChecked: switchChecked,
          switchDisabled: switchDisabled,
          selectCategory: selectCategory
        }
      }).then(function (selectList) {
        var value = convertValue && _this2.convertToValue(selectList) || selectList;

        _this2.setState({
          value: value
        });

        _this2.onChange(value);
      }, _utils.default.noop);
    }
  }, {
    key: "renderCheckedValues",
    value: function renderCheckedValues() {
      var value = this.state.value;
      var _this$props2 = this.props,
          scope = _this$props2.scope,
          maxShowLength = _this$props2.maxShowLength,
          nameAlias = _this$props2.nameAlias,
          emptyText = _this$props2.emptyText,
          title = _this$props2.title,
          isEasy = _this$props2.isEasy,
          inForm = _this$props2.inForm;
      var defaultEmptyText;

      if (!emptyText) {
        switch (scope) {
          case MANAGE_PICKER.SCOPE_CATEGORY:
            defaultEmptyText = "未选择分类";
            break;

          case MANAGE_PICKER.SCOPE_ITEM:
            defaultEmptyText = this.t('ManagePicker.select', {
              title: title
            });
            break;

          default:
            defaultEmptyText = this.t('ManagePicker.select', {
              title: title
            });
            break;
        }
      }

      if (value && value.length) {
        if (isEasy) {
          var joinNames = value.map(function (item) {
            return item[nameAlias];
          }).join('、');
          return /*#__PURE__*/_react.default.createElement("span", {
            className: "joinNames"
          }, joinNames);
        }

        return _lodash.default.take(value, maxShowLength).map(function (item) {
          return /*#__PURE__*/_react.default.createElement(_tag.default, {
            className: "name",
            key: item.code
          }, /*#__PURE__*/_react.default.createElement("span", {
            className: item.icon
          }), item[nameAlias]);
        });
      } else {
        return /*#__PURE__*/_react.default.createElement("span", {
          className: "empty ".concat(inForm ? 'form-empty' : '')
        }, emptyText || defaultEmptyText);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var value = this.state.value;
      var _this$props3 = this.props,
          className = _this$props3.className,
          maxShowLength = _this$props3.maxShowLength,
          disabled = _this$props3.disabled,
          isInTable = _this$props3.isInTable,
          isEasy = _this$props3.isEasy;
      var containerClass = (0, _classnames.default)("".concat(prefix, "-manage-picker"), className, {
        disabled: disabled
      });
      return /*#__PURE__*/_react.default.createElement("div", {
        className: containerClass,
        onClick: this.openModal,
        style: {
          marginTop: isInTable ? 0 : 5
        }
      }, this.renderCheckedValues(), value && value.length > maxShowLength && !isEasy ? /*#__PURE__*/_react.default.createElement("span", {
        className: 'stats'
      }, "\u5171", /*#__PURE__*/_react.default.createElement("span", {
        className: 'strong'
      }, value.length), "\u9879") : null);
    }
  }]);
  return ManagePicker;
}(_react.Component);

ManagePicker.defaultProps = {
  maxShowLength: 6,
  maxSelectLength: -1,
  scope: MANAGE_PICKER.SCOPE_ALL,
  nameAlias: 'name',
  codeAlias: 'code'
};
var _default = ManagePicker;
exports.default = _default;