"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/popover/style/css");

var _popover = _interopRequireDefault(require("maycur-antd/lib/popover"));

var _react = _interopRequireDefault(require("react"));

/*
 * @Description: file content
 * @Author: RongWei
 * @Date: 2021-02-01 17:28:18
 * @LastEditors: RongWei
 * @LastEditTime: 2021-02-02 10:23:42
 */
var clsPrefix = 'message-popover';

var MessagePopover = function MessagePopover(props) {
  var _props$width = props.width,
      width = _props$width === void 0 ? 300 : _props$width,
      _props$placement = props.placement,
      placement = _props$placement === void 0 ? 'right' : _props$placement;
  return /*#__PURE__*/_react.default.createElement(_popover.default, {
    placement: placement,
    content: /*#__PURE__*/_react.default.createElement("div", {
      style: {
        width: width,
        whiteSpace: 'pre-wrap'
      }
    }, Array.isArray(props.content) ? props.content.map(function (item, index) {
      return /*#__PURE__*/_react.default.createElement("p", {
        key: index
      }, item);
    }) : props.content),
    overlayClassName: clsPrefix
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: "".concat(clsPrefix, "-icon fm fm-question"),
    onClick: function onClick(e) {
      e.preventDefault();
      e.stopPropagation();
    }
  }));
};

var _default = MessagePopover;
exports.default = _default;