"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/icon/style/css");

var _icon = _interopRequireDefault(require("maycur-antd/lib/icon"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

require("rc-trigger/assets/index.css");

var _utils = _interopRequireDefault(require("../utils/utils"));

var _WrapperTrigger = _interopRequireDefault(require("../WrapperTrigger"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;

var MkSelect = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(MkSelect, _Component);

  var _super = _createSuper(MkSelect);

  function MkSelect(props) {
    var _this;

    (0, _classCallCheck2.default)(this, MkSelect);
    _this = _super.call(this, props);

    _this.onFocus = function (e) {
      var onFocus = _this.props.onFocus;
      onFocus && onFocus();
    };

    _this.onChange = function (option) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          popupVisible = _this$props.popupVisible;
      onChange && onChange(option);

      if (!popupVisible) {
        _this.setState({
          popupVisible: false
        });
      }
    };

    _this.onPopupVisibleChange = function (open) {
      var _this$props2 = _this.props,
          onPopupVisibleChange = _this$props2.onPopupVisibleChange,
          popupVisible = _this$props2.popupVisible,
          disabled = _this$props2.disabled;

      if (popupVisible) {
        return;
      }

      if (open && !disabled) {
        _this.setState({
          popupVisible: true
        });
      } else {
        _this.setState({
          popupVisible: false
        });
      }

      onPopupVisibleChange && onPopupVisibleChange();
    };

    _this.getTargetTop = function (targetTop) {
      _this.targetTop = targetTop || 0;
    };

    _this.clearValue = function (e) {
      e.preventDefault();
      e.stopPropagation();
      var onChange = _this.props.onChange;
      onChange && onChange(null);
    };

    _this.state = {
      popupVisible: false
    };
    return _this;
  }

  (0, _createClass2.default)(MkSelect, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props3 = this.props,
          popupVisible = _this$props3.popupVisible,
          defaultPopupVisible = _this$props3.defaultPopupVisible;

      if (popupVisible || defaultPopupVisible) {
        this.setState({
          popupVisible: true
        });
      }

      if (this.$innerRef) {
        this.dropdown_width = this.$innerRef.clientWidth;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames2,
          _classNames3,
          _classNames4,
          _this2 = this;

      var _this$props4 = this.props,
          children = _this$props4.children,
          placeholder = _this$props4.placeholder,
          disabled = _this$props4.disabled,
          style = _this$props4.style,
          dropdownStyle = _this$props4.dropdownStyle,
          actionVisible = _this$props4.actionVisible,
          iconClass = _this$props4.iconClass,
          onBlur = _this$props4.onBlur,
          onClick = _this$props4.onClick,
          onMouseEnter = _this$props4.onMouseEnter,
          onMouseLeave = _this$props4.onMouseLeave,
          popupClassName = _this$props4.popupClassName,
          destroyPopupOnHide = _this$props4.destroyPopupOnHide,
          getPopupClassNameFromAlign = _this$props4.getPopupClassNameFromAlign,
          action = _this$props4.action,
          mouseEnterDelay = _this$props4.mouseEnterDelay,
          mouseLeaveDelay = _this$props4.mouseLeaveDelay,
          popupStyle = _this$props4.popupStyle,
          prefixCls = _this$props4.prefixCls,
          popupTransitionName = _this$props4.popupTransitionName,
          defaultPopupVisible = _this$props4.defaultPopupVisible,
          popupAlign = _this$props4.popupAlign,
          popupPlacement = _this$props4.popupPlacement,
          getPopupContainer = _this$props4.getPopupContainer,
          className = _this$props4.className,
          value = _this$props4.value,
          category = _this$props4.category,
          allowClear = _this$props4.allowClear,
          getCustomNode = _this$props4.getCustomNode,
          tableRef = _this$props4.tableRef,
          registerEvent = _this$props4.registerEvent;
      var popupVisible = this.state.popupVisible;
      var customNode = getCustomNode && getCustomNode(value);
      var selectClass = (0, _classnames.default)("".concat(prefix, "-select-dropdown"), (0, _defineProperty2.default)({}, className, className));
      var inputClass = (0, _classnames.default)("".concat(prefix, "-select-field"), (_classNames2 = {}, (0, _defineProperty2.default)(_classNames2, "".concat(prefix, "-select-focus"), popupVisible), (0, _defineProperty2.default)(_classNames2, "".concat(prefix, "-select-extra"), iconClass), _classNames2));
      var extraClass = (0, _classnames.default)("".concat(prefix, "-extra-icon"), (_classNames3 = {}, (0, _defineProperty2.default)(_classNames3, iconClass, iconClass), (0, _defineProperty2.default)(_classNames3, "".concat(prefix, "-extra-disabled"), disabled), _classNames3));
      var actionClass = (0, _classnames.default)('fm fm-angle-down', "".concat(prefix, "-action"), (_classNames4 = {}, (0, _defineProperty2.default)(_classNames4, "".concat(prefix, "-action-open"), popupVisible), (0, _defineProperty2.default)(_classNames4, "".concat(prefix, "-action-close"), !popupVisible), (0, _defineProperty2.default)(_classNames4, "".concat(prefix, "-with-right"), category), (0, _defineProperty2.default)(_classNames4, "is-hide", allowClear && value.name), _classNames4));
      var builtinPlacements = {
        left: {
          points: ['cr', 'cl']
        },
        right: {
          points: ['cl', 'cr']
        },
        top: {
          points: ['bc', 'tc']
        },
        bottom: {
          points: ['tc', 'bc']
        },
        topLeft: {
          points: ['bl', 'tl']
        },
        topRight: {
          points: ['br', 'tr']
        },
        bottomRight: {
          points: ['tr', 'br']
        },
        bottomLeft: {
          points: ['tl', 'bl']
        }
      };

      var innerTrigger = /*#__PURE__*/_react.default.createElement("div", {
        className: selectClass,
        style: _objectSpread({
          width: this.dropdown_width
        }, dropdownStyle),
        ref: function ref(_ref) {
          if (_ref) {
            _this2.target = _ref;
            _ref.scrollTop = _this2.targetTop - 10;
          }
        }
      }, _react.default.Children.map(children, function (o) {
        if (o && o.type) {
          if (typeof o.type === 'function') {
            if ( /*#__PURE__*/_react.default.isValidElement(o)) {
              return /*#__PURE__*/_react.default.cloneElement(o, {
                select__value: value,
                onChange: _this2.onChange,
                getTargetTop: _this2.getTargetTop
              });
            } else {
              return null;
            }
          } else {
            console.warn("please use OptGroup or Option instead of ".concat(o.type, ", otherwise, option would not be able to work normally."));
          }
        }

        return o;
      }));

      return /*#__PURE__*/_react.default.createElement(_WrapperTrigger.default, {
        tableRef: tableRef,
        registerEvent: registerEvent,
        popup: innerTrigger,
        popupVisible: popupVisible,
        popupClassName: popupClassName,
        hideDropDown: this.onPopupVisibleChange,
        builtinPlacements: builtinPlacements,
        onPopupVisibleChange: this.onPopupVisibleChange,
        destroyPopupOnHide: destroyPopupOnHide,
        getPopupClassNameFromAlign: getPopupClassNameFromAlign,
        action: action,
        mouseEnterDelay: mouseEnterDelay,
        mouseLeaveDelay: mouseLeaveDelay,
        popupStyle: popupStyle,
        prefixCls: prefixCls,
        popupTransitionName: popupTransitionName,
        defaultPopupVisible: defaultPopupVisible,
        popupAlign: popupAlign,
        popupPlacement: popupPlacement,
        getPopupContainer: getPopupContainer
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-select"),
        style: style,
        onClick: onClick,
        onMouseEnter: onMouseEnter,
        onMouseLeave: onMouseLeave,
        ref: function ref(_ref2) {
          return _this2.$innerRef = _ref2;
        }
      }, iconClass && /*#__PURE__*/_react.default.createElement("i", {
        className: extraClass,
        onClick: this.onFocus
      }), customNode ? /*#__PURE__*/_react.default.createElement("div", {
        className: inputClass
      }, value ? value.name : '', customNode) : /*#__PURE__*/_react.default.createElement(_input.default, {
        className: inputClass,
        placeholder: placeholder,
        disabled: disabled,
        value: value ? value.name : '',
        onFocus: this.onFocus,
        onChange: this.onChange,
        onBlur: onBlur,
        readOnly: true,
        category: category
      }), actionVisible && /*#__PURE__*/_react.default.createElement(_icon.default, {
        type: "down",
        className: actionClass,
        onClick: this.onFocus
      }), value && value.name && allowClear && !disabled && /*#__PURE__*/_react.default.createElement("span", {
        className: 'mk-select-clear',
        onClick: function onClick(event) {
          return _this2.clearValue(event);
        }
      }, /*#__PURE__*/_react.default.createElement(_icon.default, {
        type: "close"
      }))));
    }
  }]);
  return MkSelect;
}(_react.Component);

MkSelect.defaultProps = {
  action: ['click'],
  popupPlacement: 'bottomLeft',
  actionVisible: true,
  destroyPopupOnHide: true,
  value: {},
  allowClear: false
};
MkSelect.propTypes = {
  placeholder: _propTypes.default.string,
  iconClass: _propTypes.default.string,
  action: _propTypes.default.array,
  popupPlacement: _propTypes.default.string
};
var _default = MkSelect;
exports.default = _default;