"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/modal/style/css");

var _modal = _interopRequireDefault(require("maycur-antd/lib/modal"));

require("maycur-antd/lib/list/style/css");

var _list = _interopRequireDefault(require("maycur-antd/lib/list"));

require("maycur-antd/lib/alert/style/css");

var _alert = _interopRequireDefault(require("maycur-antd/lib/alert"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/tabs/style/css");

var _tabs = _interopRequireDefault(require("maycur-antd/lib/tabs"));

require("maycur-antd/lib/breadcrumb/style/css");

var _breadcrumb = _interopRequireDefault(require("maycur-antd/lib/breadcrumb"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _lodash = _interopRequireDefault(require("lodash"));

var _OptionList = _interopRequireDefault(require("./OptionList"));

var _utils = _interopRequireDefault(require("../../../../../utils/utils"));

var _constants = _interopRequireDefault(require("../../../../../utils/constants"));

var _i18next = _interopRequireDefault(require("i18next"));

var _mkTranslate = _interopRequireDefault(require("../../../../../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var OPTION_PICKER = _constants.default.OPTION_PICKER;
var Search = _input.default.Search;
var BreadItem = _breadcrumb.default.Item;
var TabPane = _tabs.default.TabPane;

var OptionSelectionModal = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(OptionSelectionModal, _Component);

  var _super = _createSuper(OptionSelectionModal);

  function OptionSelectionModal(props) {
    var _this;

    (0, _classCallCheck2.default)(this, OptionSelectionModal);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_OptionInput').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.state = {
      sourceList: [],
      searchList: [],
      breads: [{
        name: props.title || _i18next.default.t('MK_Global:Custom Archive'),
        code: null
      }],
      selectList: props.selectList || [],
      allSelected: false,
      searchKeyword: null,
      t: _mkTranslate.default.noop()
    };
    _this.onSearch = _this.onSearch.bind((0, _assertThisInitialized2.default)(_this));
    _this.clearSearch = _this.clearSearch.bind((0, _assertThisInitialized2.default)(_this));
    _this.closeSelf = _this.closeSelf.bind((0, _assertThisInitialized2.default)(_this));
    _this.unSelectItem = _this.unSelectItem.bind((0, _assertThisInitialized2.default)(_this));
    _this.clearAll = _this.clearAll.bind((0, _assertThisInitialized2.default)(_this));
    _this.onOutput = _this.onOutput.bind((0, _assertThisInitialized2.default)(_this));
    _this.fetchSourceList = _this.fetchSourceList.bind((0, _assertThisInitialized2.default)(_this));
    _this.fetchSearchList = _this.fetchSearchList.bind((0, _assertThisInitialized2.default)(_this));
    _this.onDrillDown = _this.onDrillDown.bind((0, _assertThisInitialized2.default)(_this));
    _this.goToBread = _this.goToBread.bind((0, _assertThisInitialized2.default)(_this));
    _this.onOk = _this.onOk.bind((0, _assertThisInitialized2.default)(_this));
    _this.scrollBottom = _this.scrollBottom.bind((0, _assertThisInitialized2.default)(_this));

    _this.localeProcess();

    return _this;
  }

  (0, _createClass2.default)(OptionSelectionModal, [{
    key: "onSearch",
    value: function onSearch(value) {
      value = _lodash.default.trim(value);
      this.setState({
        searchKeyword: value
      });

      if (value) {
        this.fetchSearchList(value);
      } else {
        this.setState({
          searchList: []
        });
      }
    }
  }, {
    key: "clearSearch",
    value: function clearSearch() {
      if (this.searchRef) {
        var dom = _reactDom.default.findDOMNode(this.searchRef);

        var input = dom.getElementsByTagName("input")[0];
        input.value = "";
      }

      this.setState({
        searchKeyword: null,
        searchList: []
      });
    }
  }, {
    key: "goToBread",
    value: function goToBread(bread) {
      var breads = this.state.breads;
      breads = _lodash.default.dropRightWhile(breads, function (item) {
        return item.code !== bread.code;
      });
      this.setState({
        breads: breads
      });
      this.fetchSourceList(bread.code);
    }
  }, {
    key: "unSelectItem",
    value: function unSelectItem(item) {
      var selectList = this.state.selectList;

      var idx = _lodash.default.findIndex(selectList, {
        code: item.code
      });

      if (idx !== -1) {
        selectList.splice(idx, 1);
      }

      this.setState({
        selectList: selectList
      });
    }
  }, {
    key: "clearAll",
    value: function clearAll() {
      this.setState({
        selectList: []
      });
    }
  }, {
    key: "closeSelf",
    value: function closeSelf() {
      var onCancel = this.props.onCancel;

      if (typeof onCancel === "function") {
        onCancel();
      }
    }
  }, {
    key: "onOutput",
    value: function onOutput(result) {
      var added = result.added,
          allSelected = result.allSelected,
          itemSelected = result.itemSelected;
      var selectList = this.state.selectList;
      var maxSelectLength = this.props.maxSelectLength;
      /** 单选 */

      if (!maxSelectLength || maxSelectLength === 1) {
        this.setState({
          selectList: added
        });
        setTimeout(this.scrollBottom);
        return;
      }

      if (!allSelected || itemSelected) {
        selectList = _lodash.default.unionWith(selectList, added, _utils.default.bizEquals);
      } else {
        selectList = _lodash.default.filter(selectList, function (o) {
          return added.every(function (i) {
            return i.code !== o.code;
          });
        });
      }

      this.setState({
        selectList: selectList
      });
      setTimeout(this.scrollBottom);
    }
  }, {
    key: "onDrillDown",
    value: function onDrillDown(item) {
      var breads = this.state.breads;
      breads.push(item);
      this.setState({
        breads: breads
      });
      this.fetchSourceList(item.code);
    }
  }, {
    key: "onOk",
    value: function onOk() {
      var selectList = this.state.selectList;
      var promise = this.props.promise;

      if (promise && typeof promise.resolve === "function") {
        promise.resolve(selectList);
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.fetchSourceList();
    }
  }, {
    key: "fetchSourceList",
    value: function fetchSourceList(categoryCode) {
      var _this2 = this;

      var _this$props = this.props,
          code = _this$props.code,
          dataSourceSync = _this$props.dataSourceSync;
      dataSourceSync({
        categoryCode: categoryCode,
        referenceDataCode: code
      }, {
        pageId: OPTION_PICKER.SOURCE_LIST
      }).then(function (data) {
        if (_utils.default.apiOK(data)) {
          var categories = data.data.categories;
          var details = data.data.details || [];

          _lodash.default.forEach(categories, function (item) {
            item.type = OPTION_PICKER.CATEGORY;
          });

          _lodash.default.forEach(details, function (item) {
            item.type = OPTION_PICKER.ITEM;
          });

          _this2.setState({
            sourceList: _lodash.default.unionWith(categories, details, _lodash.default.isEqual),
            optionCode: data.data.code
          });
        }
      });
    }
  }, {
    key: "fetchSearchList",
    value: function fetchSearchList(keyword) {
      var _this3 = this;

      var _this$props2 = this.props,
          code = _this$props2.code,
          fetchSearchList = _this$props2.fetchSearchList;
      fetchSearchList({
        cipherKeyword: keyword,
        keyword: keyword,
        limit: 50,
        referenceDataCode: code
      }, {
        pageId: OPTION_PICKER.SEARCH_LIST
      }).then(function (data) {
        var searchList = data.data.result;

        _lodash.default.forEach(searchList, function (item) {
          item.type = OPTION_PICKER.ITEM;
        });

        _this3.setState({
          searchList: searchList
        });
      });
    }
  }, {
    key: "scrollBottom",
    value: function scrollBottom() {
      if (this.selectListRef) {
        var dom = _reactDom.default.findDOMNode(this.selectListRef);

        dom.scrollTop = dom.scrollHeight;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$state = this.state,
          sourceList = _this$state.sourceList,
          searchList = _this$state.searchList,
          selectList = _this$state.selectList,
          breads = _this$state.breads,
          searchKeyword = _this$state.searchKeyword,
          t = _this$state.t;
      var _this$props3 = this.props,
          scope = _this$props3.scope,
          maxSelectLength = _this$props3.maxSelectLength,
          sourceListLoading = _this$props3.sourceListLoading,
          searchListLoading = _this$props3.searchListLoading,
          isSelectCategory = _this$props3.isSelectCategory,
          title = _this$props3.title;
      var modalTitle = title || t('modalTitle');

      var _title = title || t('modalTitle');

      var placeholder = t('placeholder');
      return /*#__PURE__*/_react.default.createElement(_modal.default, (0, _extends2.default)({
        title: modalTitle
      }, this.props, {
        onOk: this.onOk,
        destroyOnClose: true,
        maskClosable: false,
        keyboard: false,
        className: 'option-select',
        visible: true
      }), /*#__PURE__*/_react.default.createElement("div", {
        className: 'content'
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'left'
      }, /*#__PURE__*/_react.default.createElement(_tabs.default, {
        defaultActiveKey: "DEPT"
      }, /*#__PURE__*/_react.default.createElement(TabPane, {
        tab: _title,
        key: "DEPT"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'search-box'
      }, /*#__PURE__*/_react.default.createElement(Search, {
        placeholder: placeholder,
        ref: function ref(_ref) {
          _this4.searchRef = _ref;
        },
        onSearch: this.onSearch
      }), searchKeyword ? /*#__PURE__*/_react.default.createElement("span", {
        className: 'fm fm-cross',
        onClick: this.clearSearch
      }) : null), searchKeyword ? /*#__PURE__*/_react.default.createElement("div", {
        className: 'search-list'
      }, /*#__PURE__*/_react.default.createElement(_OptionList.default, (0, _extends2.default)({
        loading: searchListLoading
      }, this.props, {
        scope: scope,
        canDrillDown: false,
        sourceList: searchList,
        selectList: selectList,
        onOutput: this.onOutput,
        isSelectCategory: isSelectCategory
      }))) : /*#__PURE__*/_react.default.createElement("div", {
        className: 'source-list'
      }, /*#__PURE__*/_react.default.createElement(_breadcrumb.default, null, breads.map(function (bread, idx) {
        return /*#__PURE__*/_react.default.createElement(BreadItem, {
          key: bread.code
        }, idx !== breads.length - 1 ? /*#__PURE__*/_react.default.createElement("a", {
          href: "javascript:void(0)",
          onClick: function onClick() {
            _this4.goToBread(bread);
          }
        }, bread.name) : /*#__PURE__*/_react.default.createElement("span", null, bread.name));
      })), /*#__PURE__*/_react.default.createElement(_OptionList.default, (0, _extends2.default)({}, this.props, {
        loading: sourceListLoading,
        scope: scope,
        sourceList: sourceList,
        selectList: selectList,
        onOutput: this.onOutput,
        onDrillDown: this.onDrillDown,
        isSelectCategory: isSelectCategory
      })))))), /*#__PURE__*/_react.default.createElement("div", {
        className: 'middle'
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "fm fm-angle-right"
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: 'right'
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'status-bar'
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: 'bar-label'
      }, this.state.t("selected")), /*#__PURE__*/_react.default.createElement("span", {
        className: 'dep-count'
      }, this.state.t("options"), /*#__PURE__*/_react.default.createElement("span", {
        className: 'strong'
      }, selectList.length)), /*#__PURE__*/_react.default.createElement("span", {
        className: 'clear-all'
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: 'btn',
        onClick: this.clearAll
      }, this.state.t("clear")))), maxSelectLength > 0 ? /*#__PURE__*/_react.default.createElement(_alert.default, {
        message: /*#__PURE__*/_react.default.createElement("span", null, "\u6700\u591A\u53EA\u80FD\u9009\u62E9", /*#__PURE__*/_react.default.createElement("span", {
          className: "strong"
        }, maxSelectLength), "\u9879"),
        type: "warning"
      }) : null, /*#__PURE__*/_react.default.createElement(_list.default, {
        size: "small",
        dataSource: selectList,
        ref: function ref(_ref2) {
          _this4.selectListRef = _ref2;
        },
        renderItem: function renderItem(item) {
          return /*#__PURE__*/_react.default.createElement(_list.default.Item, {
            key: item.code
          }, /*#__PURE__*/_react.default.createElement("span", {
            className: 'item-name'
          }, item.type === OPTION_PICKER.CATEGORY ? /*#__PURE__*/_react.default.createElement("span", {
            className: 'fm fm-folde-open'
          }) : /*#__PURE__*/_react.default.createElement("span", {
            className: 'fm fm-paper'
          }), item.name), /*#__PURE__*/_react.default.createElement("span", {
            className: 'fm fm-trash',
            onClick: function onClick(e) {
              e.stopPropagation();

              _this4.unSelectItem(item);
            }
          }));
        }
      }))));
    }
  }]);
  return OptionSelectionModal;
}(_react.Component); // function stateMapProp({ app }) {
//     return {
//         sourceListLoading: app.loading[OPTION_PICKER.SOURCE_LIST] && app.loading[OPTION_PICKER.SOURCE_LIST].active,
//         searchListLoading: app.loading[OPTION_PICKER.SEARCH_LIST] && app.loading[OPTION_PICKER.SEARCH_LIST].active
//     };
// }


var _default = OptionSelectionModal;
exports.default = _default;