"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

require("maycur-antd/lib/button/style/css");

var _button = _interopRequireDefault(require("maycur-antd/lib/button"));

require("maycur-antd/lib/select/style/css");

var _select = _interopRequireDefault(require("maycur-antd/lib/select"));

require("maycur-antd/lib/form/style/css");

var _form = _interopRequireDefault(require("maycur-antd/lib/form"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _IncludeContent = _interopRequireDefault(require("../IncludeContent"));

var _utils = _interopRequireDefault(require("../../../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../../../utils/mkTranslate"));

var _lodash = _interopRequireDefault(require("lodash"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;

var FilterSettingPanel = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(FilterSettingPanel, _Component);

  var _super = _createSuper(FilterSettingPanel);

  function FilterSettingPanel(props) {
    var _this;

    (0, _classCallCheck2.default)(this, FilterSettingPanel);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_Table').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.validateIncludeContent = function (rule, value, callback, field) {
      var t = _this.state.t;

      if (!value) {
        callback(t('filterSettingPanel.content'));
        return;
      }

      if (field.filterOption.type === 'numberRange') {
        var minAmount, maxAmount;

        if (value[field.key]) {
          var _value$field$key$spli = value[field.key].split('~');

          var _value$field$key$spli2 = (0, _slicedToArray2.default)(_value$field$key$spli, 2);

          minAmount = _value$field$key$spli2[0];
          maxAmount = _value$field$key$spli2[1];
        } else {
          minAmount = value.minAmount;
          maxAmount = value.maxAmount;
        }

        if (Number(minAmount) >= Number(maxAmount)) {
          callback(t('filterSettingPanel.range'));
          return;
        } else {
          callback();
        }
      }

      if (Array.isArray(value) && !value.length) {
        callback(t('filterSettingPanel.content'));
        return;
      }

      if (_lodash.default.isObject(value)) {
        if (_lodash.default.isEmpty(value)) {
          callback(t('filterSettingPanel.content'));
          return;
        }

        var validateData = value[field.filterKey] || value[field.dataIndex];

        if (Array.isArray(validateData) && !(validateData !== null && validateData !== void 0 && validateData.length)) {
          callback(t('filterSettingPanel.content'));
          return;
        }

        if (_lodash.default.isObject(validateData) && _lodash.default.isEmpty(validateData)) {
          callback(t('filterSettingPanel.content'));
          return;
        }
      }

      callback();
    };

    _this.state = {
      t: _mkTranslate.default.noop()
    };

    _this.localeProcess();

    return _this;
  }

  (0, _createClass2.default)(FilterSettingPanel, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          getFieldDecorator = _this$props.form.getFieldDecorator,
          data = _this$props.data,
          addFilterCondition = _this$props.addFilterCondition,
          deleteFilterCondition = _this$props.deleteFilterCondition,
          ModalManager = _this$props.ModalManager,
          columns = _this$props.columns,
          _this$props$filterCol = _this$props.filterColumns,
          filterColumns = _this$props$filterCol === void 0 ? [] : _this$props$filterCol;
      var t = this.state.t;

      var _columns = _lodash.default.filter(columns, function (item) {
        return !['batchNum', 'voucherWord'].includes(item.key);
      });

      return /*#__PURE__*/_react.default.createElement(_form.default, {
        className: "".concat(prefix, "-filter-setting-form-wrapper")
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "filter-name-field"
      }, /*#__PURE__*/_react.default.createElement(_form.default.Item, {
        label: t('filterSettingPanel.label')
      }, getFieldDecorator('filterName', {
        rules: [{
          required: true,
          message: t('filterSettingPanel.rule')
        }, {
          max: 10,
          message: t('filterSettingPanel.message')
        }]
      })( /*#__PURE__*/_react.default.createElement(_input.default, null))), /*#__PURE__*/_react.default.createElement("div", {
        className: "line"
      })), data.customFilterItemList.map(function (item, index) {
        var field = _lodash.default.find(_columns, {
          key: data.customFilterItemList[index].key
        });

        return /*#__PURE__*/_react.default.createElement("div", {
          key: item.key
        }, /*#__PURE__*/_react.default.createElement("div", {
          className: "filter-item-title"
        }, /*#__PURE__*/_react.default.createElement("span", null, t('filterSettingPanel.title', {
          n: index + 1
        })), /*#__PURE__*/_react.default.createElement("span", {
          className: "fm fm-trash",
          onClick: function onClick() {
            return deleteFilterCondition(index);
          }
        })), /*#__PURE__*/_react.default.createElement("div", {
          className: "filter-item-form"
        }, /*#__PURE__*/_react.default.createElement(_form.default.Item, {
          label: t('filterSettingPanel.itemLabel')
        }, getFieldDecorator("customFilterItemList[".concat(index, "].key"), {
          rules: [{
            required: true,
            message: t('filterSettingPanel.itemMessage')
          }]
        })( /*#__PURE__*/_react.default.createElement(_select.default, null, _columns.map(function (column) {
          var disabled = !_lodash.default.find(filterColumns, function (filterColumn) {
            return column.key === filterColumn.key;
          });
          return /*#__PURE__*/_react.default.createElement(_select.default.Option, {
            key: column.key,
            value: column.key,
            disabled: disabled
          }, column.title);
        })))), data.customFilterItemList[index].key && /*#__PURE__*/_react.default.createElement(_form.default.Item, {
          label: t('filterSettingPanel.customLabel')
        }, getFieldDecorator("customFilterItemList[".concat(index, "].customFilterItemDto"), {
          rules: [{
            required: true,
            message: t('filterSettingPanel.customMessage')
          }, {
            validator: function validator(rule, value, callback) {
              return _this2.validateIncludeContent(rule, value, callback, field);
            }
          }]
        })( /*#__PURE__*/_react.default.createElement(_IncludeContent.default, {
          columns: _columns,
          ModalManager: ModalManager,
          field: field
        })))));
      }), /*#__PURE__*/_react.default.createElement(_button.default, {
        className: "add-condition-btn",
        onClick: addFilterCondition
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "fm fm-plus"
      }), t('filterSettingPanel.addBtn')));
    }
  }]);
  return FilterSettingPanel;
}(_react.Component);

var _default = _form.default.create({
  mapPropsToFields: function mapPropsToFields(props) {
    var data = props.data,
        fields = props.fields;

    var customFilterItemList = _lodash.default.map(data.customFilterItemList, function (item, index) {
      var field = {};

      _lodash.default.each(['key', 'customFilterItemDto'], function (key) {
        fields.customFilterItemList = fields.customFilterItemList || [];
        fields.customFilterItemList[index] = fields.customFilterItemList[index] || {};
        field[key] = _form.default.createFormField(_objectSpread(_objectSpread({}, fields.customFilterItemList[index][key]), {}, {
          value: data.customFilterItemList[index][key]
        }));
      });

      return field;
    });

    return {
      filterName: _form.default.createFormField(_objectSpread(_objectSpread({}, fields.filterName), {}, {
        value: data.filterName
      })),
      customFilterItemList: customFilterItemList
    };
  },
  onFieldsChange: function onFieldsChange(props, changedFields) {
    props.onChange(changedFields);
  }
})(FilterSettingPanel);

exports.default = _default;