"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/tag/style/css");

var _tag = _interopRequireDefault(require("maycur-antd/lib/tag"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _DepartmentSelectionModal = _interopRequireDefault(require("../../DepartmentSelectionModal"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _constants = _interopRequireDefault(require("../../utils/constants"));

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var DEPARTMENT_PICKER = _constants.default.DEPARTMENT_PICKER;
var prefix = _utils.default.prefixCls;

var DepartmentPicker = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(DepartmentPicker, _Component);

  var _super = _createSuper(DepartmentPicker);

  function DepartmentPicker(props) {
    var _this;

    (0, _classCallCheck2.default)(this, DepartmentPicker);
    _this = _super.call(this, props);
    _this.state = {
      // rc-form组件契约：接受value属性成为受控组件
      value: props.value || []
    };
    _this.onChange = _this.onChange.bind((0, _assertThisInitialized2.default)(_this));
    _this.openModal = _this.openModal.bind((0, _assertThisInitialized2.default)(_this));
    _this.convertFromValue = _this.convertFromValue.bind((0, _assertThisInitialized2.default)(_this));
    _this.convertToValue = _this.convertToValue.bind((0, _assertThisInitialized2.default)(_this));
    _this.t = _mkTranslate.default.getLocalNs('MK_DepartmentSelectionModal', (0, _assertThisInitialized2.default)(_this));
    return _this;
  } // rc-form组件契约：注册onChange事件为form提供值变化感知


  (0, _createClass2.default)(DepartmentPicker, [{
    key: "onChange",
    value: function onChange(value) {
      var onChange = this.props.onChange;

      if (typeof onChange === 'function') {
        onChange(value);
      }
    } // rc-form组件契约：接受value属性成为受控组件

  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (_lodash.default.isEqual(nextProps.value, this.props.value)) {
        return;
      } else {
        var value = nextProps.value;
        this.setState({
          value: value
        });
      }
    }
    /*     convertFromValue(value) {
            value = value || [];
            return _.map(value, (item) => {
                return { code: item.code, name: item.name, type: item.type, userEmployeeId: item.userEmployeeId };
            });
        }
    
        convertToValue(selectList) {
            selectList = selectList || [];
            return _.map(selectList, (item) => {
                return { code: item.code, name: item.name, type: item.type, userEmployeeId: item.userEmployeeId };
            });
        }
     */

  }, {
    key: "convertFromValue",
    value: function convertFromValue(value) {
      var _this$props = this.props,
          codeAlias = _this$props.codeAlias,
          nameAlias = _this$props.nameAlias,
          typeAlias = _this$props.typeAlias;
      value = value || [];
      return _lodash.default.map(value, function (item) {
        return {
          code: item[codeAlias],
          name: item[nameAlias],
          type: item[typeAlias],
          userEmployeeId: item.userEmployeeId
        };
      });
    }
  }, {
    key: "convertToValue",
    value: function convertToValue(selectList) {
      var _this$props2 = this.props,
          codeAlias = _this$props2.codeAlias,
          nameAlias = _this$props2.nameAlias,
          typeAlias = _this$props2.typeAlias;
      selectList = selectList || [];
      return _lodash.default.map(selectList, function (item) {
        var _ref;

        return _ref = {}, (0, _defineProperty2.default)(_ref, codeAlias, item.code), (0, _defineProperty2.default)(_ref, nameAlias, item.name), (0, _defineProperty2.default)(_ref, typeAlias, item.type), (0, _defineProperty2.default)(_ref, "userEmployeeId", item.userEmployeeId), _ref;
      });
    }
  }, {
    key: "openModal",
    value: function openModal(e) {
      var _this2 = this;

      var _this$props3 = this.props,
          scope = _this$props3.scope,
          maxSelectLength = _this$props3.maxSelectLength,
          disabled = _this$props3.disabled,
          isShowUserGroup = _this$props3.isShowUserGroup,
          fetchService = _this$props3.fetchService,
          searchService = _this$props3.searchService,
          apis = _this$props3.apis,
          ModalManager = _this$props3.ModalManager,
          initData = _this$props3.initData;
      var value = this.state.value;
      e.stopPropagation();

      if (disabled) {
        return;
      }

      var modalProps = {
        visible: true,
        hideHelp: (initData === null || initData === void 0 ? void 0 : initData.systemConfig.version) === 'maycur'
      };
      var pickerProps = {
        selectList: this.convertFromValue(value),
        scope: scope,
        maxSelectLength: maxSelectLength,
        isShowUserGroup: isShowUserGroup,
        fetch: fetchService || apis.fetchDepartmentChildren,
        search: searchService || apis.searchDepartmentChildren,
        fetchUserGroup: apis.fetchUserGroup
      };
      ModalManager.open({
        component: _DepartmentSelectionModal.default,
        componentProps: {
          modalProps: modalProps,
          pickerProps: pickerProps
        }
      }).then(function (selectList) {
        var value = _this2.convertToValue(selectList);

        _this2.setState({
          value: value
        });

        _this2.onChange(value);
      }, _utils.default.noop);
    }
  }, {
    key: "render",
    value: function render() {
      var value = this.state.value;
      var _this$props4 = this.props,
          className = _this$props4.className,
          maxShowLength = _this$props4.maxShowLength,
          scope = _this$props4.scope,
          emptyText = _this$props4.emptyText,
          disabled = _this$props4.disabled,
          codeAlias = _this$props4.codeAlias,
          nameAlias = _this$props4.nameAlias,
          typeAlias = _this$props4.typeAlias,
          t = _this$props4.t;
      var containerClass = (0, _classnames.default)("".concat(prefix, "-department-picker-container"), className, {
        "disabled": disabled
      });
      var defaultEmptyText;

      if (!emptyText) {
        switch (scope) {
          case DEPARTMENT_PICKER.SCOPE_DEPARTMENT:
            defaultEmptyText = this.t('departmentSelection.selectDepartment');
            break;

          case DEPARTMENT_PICKER.SCOPE_STAFF:
            defaultEmptyText = this.t('departmentSelection.selectStaff');
            break;

          default:
            defaultEmptyText = "未选择部门或人员";
            break;
        }
      }

      return /*#__PURE__*/_react.default.createElement("div", {
        className: containerClass,
        onClick: this.openModal
      }, value && value.length ? _lodash.default.take(value, maxShowLength).map(function (item) {
        return /*#__PURE__*/_react.default.createElement(_tag.default, {
          className: "name",
          key: item[codeAlias]
        }, item[typeAlias] === DEPARTMENT_PICKER.DEPARTMENT ? /*#__PURE__*/_react.default.createElement("span", {
          className: 'fm fm-cube'
        }) : item[typeAlias] === DEPARTMENT_PICKER.STAFF ? /*#__PURE__*/_react.default.createElement("span", {
          className: 'fm fm-employee'
        }) : /*#__PURE__*/_react.default.createElement("span", {
          className: 'fm fm-user-group'
        }), item[nameAlias]);
      }) : /*#__PURE__*/_react.default.createElement("span", {
        className: "empty"
      }, emptyText || defaultEmptyText), value && value.length > maxShowLength ? /*#__PURE__*/_react.default.createElement("span", {
        className: "stats"
      }, "\u5171", /*#__PURE__*/_react.default.createElement("span", {
        className: 'strong'
      }, value.length), "\u9879") : null, /*#__PURE__*/_react.default.createElement("span", {
        className: 'fm fm-more2'
      }));
    }
  }]);
  return DepartmentPicker;
}(_react.Component);

DepartmentPicker.defaultProps = {
  codeAlias: 'code',
  nameAlias: 'name',
  typeAlias: 'type',
  maxShowLength: 999999,
  maxSelectLength: -1,
  scope: DEPARTMENT_PICKER.SCOPE_ALL
};
var _default = DepartmentPicker;
exports.default = _default;