"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/modal/style/css");

var _modal = _interopRequireDefault(require("maycur-antd/lib/modal"));

require("maycur-antd/lib/form/style/css");

var _form = _interopRequireDefault(require("maycur-antd/lib/form"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireDefault(require("react"));

var _hooks = require("../../hooks");

var _utils = require("../../utils");

var _this = void 0;

var TextArea = _input.default.TextArea;

var FieldLangSettingModal = function FieldLangSettingModal(props) {
  var identifier = props.identifier;

  var _useLangModal = (0, _hooks.useLangModal)(props),
      _useLangModal2 = (0, _slicedToArray2.default)(_useLangModal, 2),
      property = _useLangModal2[0],
      _useLangModal2$ = _useLangModal2[1],
      onChange = _useLangModal2$.onChange,
      onOk = _useLangModal2$.onOk;

  var initialProps = (0, _hooks.useInitialProps)(props);
  var t = (0, _hooks.useTranslate)('MK_TransInput');
  return /*#__PURE__*/_react.default.createElement(_modal.default, (0, _extends2.default)({}, props, {
    title: t('Language Settings'),
    visible: true,
    destroyOnClose: true,
    maskClosable: false,
    keyboard: false,
    okText: t('confirm'),
    cancelText: t('cancel'),
    onOk: onOk
  }), /*#__PURE__*/_react.default.createElement(_form.default, {
    layout: "vertical"
  }, _utils.LANGS_CONFIG.map(function (_ref) {
    var key = _ref.key,
        label = _ref.label,
        placeholder = _ref.placeholder;
    var propertyKey = "".concat(identifier).concat(key);
    return /*#__PURE__*/_react.default.createElement(_form.default.Item, {
      key: key,
      label: label
    }, /*#__PURE__*/_react.default.createElement(TextArea, (0, _extends2.default)({}, initialProps, {
      autosize: {
        minRows: 2,
        maxRows: 6
      },
      value: property[propertyKey],
      placeholder: placeholder,
      onChange: onChange.bind(_this, propertyKey)
    })));
  })));
};

var _default = FieldLangSettingModal;
exports.default = _default;