"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _useLocalStorageState3 = _interopRequireDefault(require("../../hooks/useLocalStorageState"));

/*
 * @Author: Jiangang LU
 * @Date: 2021-01-18 17:15:49
 * @LastEditors: Jiangang Lu
 * @LastEditTime: 2021-01-18 17:28:42
 * @Description: 处理缓存中存储的国际化语言，zh-CN、zh都处理成zh
 */
var formatLang = function formatLang() {
  var lang = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'zh';
  return lang.startsWith('zh') ? 'zh' : 'en';
};

var useLang = function useLang(props) {
  var _useLocalStorageState = (0, _useLocalStorageState3.default)('lang'),
      _useLocalStorageState2 = (0, _slicedToArray2.default)(_useLocalStorageState, 1),
      lang = _useLocalStorageState2[0];

  return formatLang(lang);
};

var _default = useLang;
exports.default = _default;