"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

/*
 * @Author: Jiangang LU
 * @Date: 2021-05-21 10:50:02
 * @LastEditors: Jiangang Lu
 * @LastEditTime: 2021-05-21 10:53:04
 * @Description: useTransInput
 */
var useTransInput = function useTransInput(_ref) {
  var i18n = _ref.i18n,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled;
  var showI18n = (0, _react.useMemo)(function () {
    return i18n && !disabled;
  }, [i18n, disabled]);
  return [showI18n];
};

var _default = useTransInput;
exports.default = _default;