"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/popover/style/css");

var _popover = _interopRequireDefault(require("maycur-antd/lib/popover"));

var _react = _interopRequireWildcard(require("react"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

var _utils = _interopRequireDefault(require("../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/*
 * @Author: yuxuan 
 * @Date: 2020-03-05 21:15:49 
 * @Last Modified by: yuxuan
 * @Last Modified time: 2020-03-06 17:31:50
 */
var prefix = _utils.default.prefixCls;

function ViewInput(props) {
  var value = props.value,
      fullNames = props.fullNames,
      emptyText = props.emptyText,
      fullBorder = props.fullBorder;
  var transRef = (0, _react.useRef)();
  transRef.current = _mkTranslate.default.noop();

  var renderValue = function renderValue() {
    return /*#__PURE__*/_react.default.createElement("span", {
      className: "full-name-popover"
    }, value, fullNames && fullNames instanceof Array ? fullNames.map(function (fullName, index) {
      var _rootName = fullName && fullName.slice(-(fullName.length - 1));

      return /*#__PURE__*/_react.default.createElement(_popover.default, {
        placement: "bottom",
        content: _rootName && _rootName.join('/'),
        key: index
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'icon-circle'
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "fm fm-more-o"
      })));
    }) : null);
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-ant-view-input ").concat(fullBorder ? 'full-border' : '')
  }, value || value === 0 ? renderValue() : /*#__PURE__*/_react.default.createElement("span", {
    className: "empty-text"
  }, emptyText || transRef.current('empty')));
}

var _default = ViewInput;
exports.default = _default;