"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.ActionType = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefixCls = "".concat(_utils.default.prefixCls, "-viewer-icon"); // ActionType = {
//     zoomIn: 1,
//     zoomOut: 2,
//     prev: 3,
//     next: 4,
//     rotateLeft: 5,
//     rotateRight: 6,
//     reset: 7,
//     close: 8,
//     scaleX: 9,
//     scaleY: 10,
//     download: 11,
// }
// ActionType = {
//     1: 'zoomIn',
//     2: 'zoomOut',
//     3: 'prev',
//     4: 'next',
//     5: 'rotateLeft',
//     6: 'rotateRight',
//     7: 'reset',
//     8: 'close',
//     9: 'scaleX',
//     10: 'scaleY',
//     11: 'download'
// }

var ActionType = {
  zoomIn: 1,
  zoomOut: 2,
  prev: 3,
  next: 4,
  rotateLeft: 5,
  rotateRight: 6,
  reset: 7,
  close: 8,
  scaleX: 9,
  scaleY: 10,
  download: 11,
  fullscreen: 12
}; // export interface IconProps {
//   type: ActionType;
// }

exports.ActionType = ActionType;

var Icon = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Icon, _React$Component);

  var _super = _createSuper(Icon);

  function Icon() {
    (0, _classCallCheck2.default)(this, Icon);
    return _super.apply(this, arguments);
  }

  (0, _createClass2.default)(Icon, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement("i", {
        className: "".concat(prefixCls, " ").concat(prefixCls, "-").concat(this.props.type)
      });
    }
  }]);
  return Icon;
}(React.Component);

exports.default = Icon;