"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _reactPdf = require("react-pdf");

var _classnames2 = _interopRequireDefault(require("classnames"));

var _Loading = _interopRequireDefault(require("./Loading"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

if (typeof window !== 'undefined' && 'Worker' in window) {
  _reactPdf.pdfjs.GlobalWorkerOptions.workerSrc = "//cmimg.maycur.com/dt/static/pdf.worker.min2.js";
}

var LegacyCanvas = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(LegacyCanvas, _React$Component);

  var _super = _createSuper(LegacyCanvas);

  function LegacyCanvas() {
    var _this;

    (0, _classCallCheck2.default)(this, LegacyCanvas);
    _this = _super.call(this);

    _this.handleResize = function (e) {
      _this.props.onResize();
    };

    _this.handleCanvasMouseDown = function (e) {
      _this.props.onCanvasMouseDown(e);

      _this.handleMouseDown(e);
    };

    _this.handleMouseDown = function (e) {
      if (!_this.props.visible || !_this.props.drag) {
        return;
      }

      e.preventDefault();
      e.stopPropagation();

      _this.setState({
        isMouseDown: true,
        mouseX: e.nativeEvent.clientX,
        mouseY: e.nativeEvent.clientY
      });
    };

    _this.handleMouseMove = function (e) {
      if (_this.state.isMouseDown) {
        var diffX = e.clientX - _this.state.mouseX;
        var diffY = e.clientY - _this.state.mouseY;

        _this.setState({
          mouseX: e.clientX,
          mouseY: e.clientY
        });

        _this.props.onChangeImgState(_this.props.width, _this.props.height, _this.props.top + diffY, _this.props.left + diffX);
      }
    };

    _this.handleMouseUp = function (e) {
      _this.setState({
        isMouseDown: false
      });
    };

    _this.bindEvent = function (remove) {
      var funcName = 'addEventListener';

      if (remove) {
        funcName = 'removeEventListener';
      }

      document[funcName]('click', _this.handleMouseUp, false);
      document[funcName]('mousemove', _this.handleMouseMove, false);
      window[funcName]('resize', _this.handleResize, false);
    };

    _this.refPage = function (ref) {
      _this.page = ref;
    };

    _this.state = {
      isMouseDown: false,
      mouseX: 0,
      mouseY: 0
    };
    return _this;
  }

  (0, _createClass2.default)(LegacyCanvas, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.drag) {
        this.bindEvent();
      }
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (!this.props.visible && nextProps.visible) {
        if (nextProps.drag) {
          return this.bindEvent();
        }
      }

      if (this.props.visible && !nextProps.visible) {
        this.handleMouseUp({});

        if (nextProps.drag) {
          return this.bindEvent(true);
        }
      }

      if (this.props.drag && !nextProps.drag) {
        return this.bindEvent(true);
      }

      if (!this.props.drag && nextProps.drag) {
        if (nextProps.visible) {
          return this.bindEvent(true);
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.bindEvent(true);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props$activeFil = this.props.activeFile,
          src = _this$props$activeFil.src,
          pageNumber = _this$props$activeFil.pageNumber;
      var _this$props = this.props,
          _this$props$cMapUrl = _this$props.cMapUrl,
          cMapUrl = _this$props$cMapUrl === void 0 ? 'cmaps/' : _this$props$cMapUrl,
          type = _this$props.type;
      var imgStyle = {
        width: "".concat(this.props.width, "px"),
        height: "".concat(this.props.height, "px"),
        transform: "translateX(".concat(this.props.left !== null ? this.props.left + 'px' : 'aoto', ") translateY(").concat(this.props.top + 44, "px)\n      rotate(").concat(this.props.rotate, "deg) scaleX(").concat(this.props.scaleX, ") scaleY(").concat(this.props.scaleY, ")"),
        visibility: this.props.loading && !this.page ? 'hidden' : 'visible'
      };
      var imgClass = (0, _classnames2.default)("".concat(this.props.prefixCls, "-image"), (0, _defineProperty2.default)({
        drag: this.props.drag
      }, "".concat(this.props.prefixCls, "-image-transition"), !this.state.isMouseDown));
      var style = {
        zIndex: this.props.zIndex
      };
      var fileNode = /*#__PURE__*/React.createElement("div", {
        className: imgClass,
        style: imgStyle,
        onMouseDown: this.handleMouseDown
      }, type === 'img' ? /*#__PURE__*/React.createElement("img", {
        src: src,
        ref: this.refPage,
        alt: ""
      }) : // ofd格式发票预览展示
      type === 'ofd' ? 'OFD文件暂无图片，请点击预览查看' : /*#__PURE__*/React.createElement(_reactPdf.Document, {
        file: src,
        noData: "\u626B\u7801\u8BC6\u522B\uFF0C\u65E0\u53D1\u7968\u5F71\u50CF",
        options: {
          cMapUrl: cMapUrl,
          cMapPacked: true,
          fontFamily: 'Microsoft YaHei'
        }
      }, /*#__PURE__*/React.createElement(_reactPdf.Page, {
        pageNumber: pageNumber || 1,
        width: this.props.width,
        inputRef: this.refPage,
        onRenderSuccess: function onRenderSuccess() {
          _this2.props.onRenderSuccess();
        }
      })));
      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(this.props.prefixCls, "-canvas"),
        onMouseDown: this.handleCanvasMouseDown,
        style: style
      }, this.props.loading && /*#__PURE__*/React.createElement(_Loading.default, {
        prefixCls: this.props.prefixCls
      }), fileNode);
    }
  }]);
  return LegacyCanvas;
}(React.Component);

exports.default = LegacyCanvas;