"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/*
 * @Author: your name
 * @Date: 2020-09-21 20:42:56
 * @LastEditTime: 2021-08-09 11:22:26
 * @LastEditors: Jiangang Lu
 * @Description: In User Settings Edit
 * @FilePath: \maycur-business\components\lang\zh\MK_Table.js
 */
var _default = {
  "budgetmentFilter": {
    "placeholder": "请输入预算组织名称"
  },
  "budgetSubjectFilter": {
    "placeholder": "请输入预算科目名称"
  },
  "budgetUnitFilter": {
    "placeholder": "请输入预算组织名称"
  },
  "tradingPartnerFilter": {
    "placeholder": "输入关键字，按回车搜索"
  },
  "optionFilter": {
    "placeholder": "输入关键字，按回车搜索"
  },
  "dateFilter": {
    "all": "全部",
    "recentOne": "最近一个月",
    "recentThree": "最近三个月",
    "startDate": "开始",
    "endDate": "结束"
  },
  "numberRangeFilter": {
    "warn": "请输入有效的数值范围",
    "min": "最小值",
    "max": "最大值"
  },
  "departmentPicker": {
    "empty": "未选择部门",
    "stats": "共<1>{{n}}</1>项"
  },
  "rangeCalendar": {
    "recentOne": "最近一个月",
    "recentThree": "最近三个月"
  },
  "filterListPanel": {
    "add": "新建自定义筛选",
    "empty": "暂无自定义筛选",
    "设为默认": "设为默认",
    "取消默认": "取消默认",
    "默认筛选项": "默认筛选项",
    "编辑": "编辑",
    "删除": "删除"
  },
  "filterSettingPanel": {
    "content": "请选择包含内容",
    "range": "请输入有效的数值范围",
    "label": "条件名称",
    "rule": "请输入条件名称",
    "message": "条件名称不能超过10个字符",
    "title": "筛选条件（{{n}}）",
    "itemLabel": "筛选项：",
    "itemMessage": "请选择筛选项",
    "customLabel": "包含内容：",
    "customMessage": "请选择包含内容",
    "addBtn": "添加筛选条件"
  },
  "filterSettingModal": {
    "subTitle": "确定要删除此自定义筛选吗？删除后无法恢复。",
    "popover": "将个人经常使用的筛选条件保存在每刻系统中，可以在手机端和电脑端点击保存的筛选条件进行快速筛选",
    "edit": "编辑自定义筛选",
    "add": "新建自定义筛选",
    "manage": "管理自定义筛选"
  },
  "filterStateBar": {
    "empty": "无标题",
    "title": "筛选条件：",
    "filterLabel": "自定义筛选：",
    "setBtn": "配置",
    "totalCount": "共<1>{{n}}</1>条记录",
    "up": "收起",
    "down": "展开"
  },
  "mkTable": {
    "btn": "字段显示",
    "columnVisible": "列表显示",
    "tip": "按住【Shift】滚动鼠标滑轮，可以快速滑动横向滚动条"
  }
};
exports.default = _default;