"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

function Column() {}

Column.propTypes = {
  className: _propTypes.default.string,
  style: _propTypes.default.object,
  colSpan: _propTypes.default.number,
  title: _propTypes.default.node,
  dataIndex: _propTypes.default.string,
  width: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  fixed: _propTypes.default.oneOf([true, 'left', 'right']),
  render: _propTypes.default.func,
  onCellClick: _propTypes.default.func,
  onCell: _propTypes.default.func,
  onHeaderCell: _propTypes.default.func
};
var _default = Column;
exports.default = _default;