"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _default = (0, _defineProperty2.default)({
  FormTypeMap: {
    'REIMBURSE': '报销单',
    'PRECONSUME': '申请单'
  },
  OPTION_PICKER: {
    SCOPE_ALL: 'ALL',
    SCOPE_ITEM: 'ITEM',
    SCOPE_CATEGORY: 'CATEGORY',
    CATEGORY: 'CATEGORY',
    ITEM: 'ITEM',
    USER_GROUP: 'USER_GROUP',
    SOURCE_LIST: 'ITEM_PICKER_SOURCE_LIST',
    SEARCH_LIST: 'ITEMP_ICKER_SEARCH_LIST',
    USER_GROUP_SOURCE_LIST: 'USER_GROUP_SOURCE_LIST'
  },
  MANAGE_PICKER: {
    SCOPE_ALL: 'ALL',
    SCOPE_ITEM: 'ITEM',
    SCOPE_CATEGORY: 'CATEGORY',
    CATEGORY: 'CATEGORY',
    ITEM: 'ITEM',
    USER_GROUP: 'USER_GROUP',
    SOURCE_LIST: 'ITEM_PICKER_SOURCE_LIST',
    SEARCH_LIST: 'ITEMP_ICKER_SEARCH_LIST',
    USER_GROUP_SOURCE_LIST: 'USER_GROUP_SOURCE_LIST'
  },
  OPTION_INDEX: {
    FETCH_ALL: 'OPTION_INDEX_FETCH_ALL'
  },
  OPTION_EDIT_MODAL: {
    SAVE: 'OPTION_EDIT_MODAL_SAVE'
  },
  OPTION_EDIT: {
    SAVE: 'OPTION_EDIT_SAVE',
    GET: 'OPTION_EDIT_GET',
    SEARCH: 'OPTION_EDIT_SEARCH',
    DELETE: 'OPTION_EDIT_DELETE',
    FETCH_NODES: 'OPTION_EDIT_FETCH_NODES'
  },
  OPTION_TREE: {
    LOAD: 'OPTION_TREE_LOAD',
    MOVE: 'OPTION_TREE_MOVE',
    FETCH_NODES: 'OPTION_TREE_FETCH_NODES'
  },
  RECEIPT_INDEX: {
    FETCH_ALL: 'RECEIPT_INDEX_FETCH_ALL'
  },
  RECEIPT_EDIT: {
    GET_DETAIL: 'RECEIPT_EDIT_GET_DETAIL',
    SAVE: 'RECEIPT_EDIT_SAVE'
  },
  DEPARTMENT_PICKER: {
    SCOPE_ALL: 'ALL',
    SCOPE_DEPARTMENT: 'DEPARTMENT',
    SCOPE_STAFF: 'STAFF',
    DEPARTMENT: 'DEPARTMENT',
    STAFF: 'STAFF',
    USER_GROUP: 'USER_GROUP',
    SOURCE_LIST: 'DEPARTMENT_PICKER_SOURCE_LIST',
    SEARCH_LIST: 'DEPARTMENT_PICKER_SEARCH_LIST',
    USER_GROUP_SOURCE_LIST: 'USER_GROUP_SOURCE_LIST'
  },
  EXPENSE_TYPE_PICKER: {
    SCOPE_ALL: 'ALL',
    SCOPE_ENABLED: 'ENABLED',
    SCOPE_DISABLED: 'DISABLED',
    SOURCE_LIST: 'EXPENSE_TYPE_PICKER_SOURCE_LIST',
    SEARCH_LIST: 'EXPENSE_TYPE_PICKER_SEARCH_LIST'
  },
  APPLICATION_EXPENSE: {
    CONSUME_SUMMARY: 'CONSUME_SUMMARY',
    CONSUME_DETAIL: 'CONSUME_DETAIL'
  },
  INPUT_EMPTY_TEXT: '无',
  BANK_BLOCK_EDIT_MODAL: 'BANK_BLOCK_EDIT_MODAL',
  FORMTYPE: {
    REIMBURSE: "REIMBURSE",
    LOAN: "LOAN",
    PRECONSUME: 'PRECONSUME'
  },
  DRAWER_WIDTH: {
    EXPENSE: 700,
    REIMBURSE: 920 + 16 * 2 + 15,
    //两边各16px的margin，15为滚动条宽度
    LOAN: 1380,
    INVOICE: 690
  },
  DRAWER: {
    EXPENSE_EDIT_DRAWER: 'EXPENSE_EDIT_DRAWER',
    EXPENSE_VIEW_DRAWER: 'EXPENSE_VIEW_DRAWER',
    REIMBURSE_EDIT_DRAWER: 'REIMBURSE_EDIT_DRAWER',
    REIMBURSE_VIEW_DRAWER: 'REIMBURSE_VIEW_DRAWER',
    APPLICATION_EDIT_DRAWER: 'APPLICATION_EDIT_DRAWER',
    APPLICATION_VIEW_DRAWER: 'APPLICATION_VIEW_DRAWER',
    LOAN_VIEW_DRAWER: 'LOAN_VIEW_DRAWER'
  },
  REIMBURSE: {
    EDIT_DETAIL: 'EDIT_DETAIL',
    VIEW_DETAIL: 'VIEW_DETAIL'
  },
  LOAN: {
    EDIT_DETAIL: 'EDIT_DETAIL',
    VIEW_DETAIL: 'VIEW_DETAIL',
    LIST: 'LIST'
  },
  APPLICATION: {
    EDIT_DETAIL: 'EDIT_DETAIL',
    VIEW_DETAIL: 'VIEW_DETAIL'
  }
}, "OPTION_PICKER", {
  SCOPE_ALL: 'ALL',
  SCOPE_ITEM: 'ITEM',
  SCOPE_CATEGORY: 'CATEGORY',
  CATEGORY: 'CATEGORY',
  ITEM: 'ITEM',
  USER_GROUP: 'USER_GROUP',
  SOURCE_LIST: 'ITEM_PICKER_SOURCE_LIST',
  SEARCH_LIST: 'ITEMP_ICKER_SEARCH_LIST',
  USER_GROUP_SOURCE_LIST: 'USER_GROUP_SOURCE_LIST',
  MOCK_OPTION_INPUT_CATEGORY: 'MOCK_OPTION_INPUT_CATEGORY',
  MOCK_OPTION_INPUT_ITEM: 'MOCK_OPTION_INPUT_ITEM'
});

exports.default = _default;