"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = unique;

var _reduce = _interopRequireDefault(require("./reduce"));

// Copyright 2015-2018 FormBucket LLC
// UNIQUE reduces an `array` into an array without duplicate values.
function unique(array) {
  return (0, _reduce.default)(array, function (p, c) {
    if (p.indexOf(c) < 0) p.push(c);
    return p;
  }, []);
}