"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/select/style/css");

var _select = _interopRequireDefault(require("maycur-antd/lib/select"));

var _react = _interopRequireWildcard(require("react"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

var _MonthCell = _interopRequireDefault(require("./MonthCell"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;
var cmName = "".concat(prefix, "-calendar-china");
var Option = _select.default.Option;

var monthChineseMap = function monthChineseMap(t) {
  return {
    m1: t('month1'),
    m2: t('month2'),
    m3: t('month3'),
    m4: t('month4'),
    m5: t('month5'),
    m6: t('month6'),
    m7: t('month7'),
    m8: t('month8'),
    m9: t('month9'),
    m10: t('month10'),
    m11: t('month11'),
    m12: t('month12')
  };
};

function genYearList(year) {
  var r = [];

  for (var y = year - 10; y <= year + 10; y++) {
    r.push(y);
  }

  return r;
}

; // function dateConvert(dates = []) {
//     let r = [];
//     dates.forEach(d => {
//         if (d) {
//             r.push(d instanceof Date ? d : new Date(d));
//         }
//     })
//     return r;
// }

/** 
 * @author  🍺刀马
 */

var CalendarChina = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(CalendarChina, _Component);

  var _super = _createSuper(CalendarChina);

  function CalendarChina(props) {
    var _this;

    (0, _classCallCheck2.default)(this, CalendarChina);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_CalendarChina').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.yearChange = function (year) {
      _this.setState({
        selectedYear: year,
        yearList: genYearList(year)
      });
    };

    _this.daySelect = function (d) {
      var selectedDates = _this.state.selectedDates;
      var cloneSelectedDates = (0, _toConsumableArray2.default)(selectedDates);
      var matchedIndex = selectedDates.findIndex(function (sd) {
        return sd.getTime() === d.getTime();
      });

      if (matchedIndex === -1) {
        _this.setState({
          selectedDates: [].concat((0, _toConsumableArray2.default)(cloneSelectedDates), [d])
        });
      } else {
        cloneSelectedDates.splice(matchedIndex, 1);

        _this.setState({
          selectedDates: cloneSelectedDates
        });
      }
    };

    _this.getSelectedData = function () {
      return (0, _toConsumableArray2.default)(_this.state.selectedDates);
    };

    _this.setSelectedData = function (v) {
      _this.setState({
        selectedDates: v
      });
    };

    var _props$initialData = props.initialData,
        initialData = _props$initialData === void 0 ? {} : _props$initialData;
    _this.state = {
      yearList: genYearList(new Date().getFullYear()),
      selectedYear: initialData.selectedYear ? initialData.selectedYear : new Date().getFullYear(),
      selectedDates: [],
      t: _mkTranslate.default.noop()
    };

    _this.localeProcess();

    return _this;
  }

  (0, _createClass2.default)(CalendarChina, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state = this.state,
          selectedYear = _this$state.selectedYear,
          yearList = _this$state.yearList,
          selectedDates = _this$state.selectedDates,
          t = _this$state.t;
      var extraLabel = this.props.extraLabel;
      return /*#__PURE__*/_react.default.createElement("div", {
        className: cmName
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(cmName, "-header")
      }, /*#__PURE__*/_react.default.createElement(_select.default, {
        value: selectedYear,
        style: {
          width: 120
        },
        onChange: this.yearChange,
        dropdownStyle: {
          color: '#000'
        }
      }, yearList.map(function (y) {
        return /*#__PURE__*/_react.default.createElement(Option, {
          value: y,
          key: y
        }, y, t('year'));
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(cmName, "-header_custom-area")
      }, extraLabel ? extraLabel : null)), /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(cmName, "-body")
      }, Array.from(Array(12).keys()).map(function (v) {
        var m = v + 1;
        return /*#__PURE__*/_react.default.createElement("div", {
          className: 'month-wrapper',
          key: "".concat(selectedYear, "-").concat(m)
        }, /*#__PURE__*/_react.default.createElement("div", {
          className: 'month-label'
        }, monthChineseMap(t)["m".concat(m)]), /*#__PURE__*/_react.default.createElement(_MonthCell.default, {
          month: m,
          year: selectedYear,
          onChange: _this2.daySelect,
          selectedDates: selectedDates
        }));
      })));
    }
  }]);
  return CalendarChina;
}(_react.Component);

var _default = CalendarChina;
exports.default = _default;