"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

/*
 * @Description: file content
 * @Author: RongWei
 * @Date: 2020-06-15 19:29:04
 * @LastEditors: Jiangang Lu
 * @LastEditTime: 2021-07-23 16:28:58
 */
//这里暂时只处理金额的比较
function comparaRules(condition, data) {
  var identifier = condition.identifier,
      opType = condition.opType,
      value = condition.value;
  var fieldValue = data[identifier];

  if (typeof fieldValue === 'undefined') {
    return false;
  }

  var _value = value || 0;

  var _fieldValue = (0, _lodash.isObject)(fieldValue) ? fieldValue && fieldValue.amount : fieldValue || 0; //当值为空的时候，属于条件返回false，不属于返回true


  switch (opType) {
    case 'GT':
      return _fieldValue > _value;

    case 'LT':
      return _fieldValue < _value;
      ;

    case 'LTE':
      return _fieldValue <= _value;

    case 'GTE':
      return _fieldValue >= _value;

    default:
      return false;
  }
}
/**
 * 
 * @param {*} condition 条件
 * @param {*} data 表单数据对象
 */


function AMOUNT(condition, data) {
  return comparaRules(condition, data);
}

var _default = AMOUNT;
exports.default = _default;