"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/tree-select/style/css");

var _treeSelect = _interopRequireDefault(require("maycur-antd/lib/tree-select"));

require("maycur-antd/lib/select/style/css");

var _select = _interopRequireDefault(require("maycur-antd/lib/select"));

require("maycur-antd/lib/form/style/css");

var _form = _interopRequireDefault(require("maycur-antd/lib/form"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _mkSelect = _interopRequireDefault(require("../Process/mkSelect"));

var C = _interopRequireWildcard(require("./constants"));

var _formMap2 = _interopRequireDefault(require("./formMap"));

var _lodash = _interopRequireDefault(require("lodash"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var ConditionForm = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(ConditionForm, _Component);

  var _super = _createSuper(ConditionForm);

  function ConditionForm(props) {
    var _this;

    (0, _classCallCheck2.default)(this, ConditionForm);
    _this = _super.call(this, props);

    _this.onVisibleChange = function (b) {
      if (!b) {
        _this.refs.filterInput.value = '';

        _this.setState({
          filter: ''
        });
      }
    };

    _this.renderAdvanceFrom = function () {
      var _this$props = _this.props,
          selectedNode = _this$props.selectedNode,
          handleTempChange = _this$props.handleTempChange,
          ModalManager = _this$props.ModalManager,
          apis = _this$props.apis,
          initData = _this$props.initData;
      var temp = selectedNode.temp;
      console.log('selectedNode:', selectedNode);

      if (!temp) {
        return;
      }

      var fieldConfig = temp.fieldConfig;
      var FormIns = _formMap2.default[fieldConfig.type];
      var formProps = {
        selectedNode: selectedNode,
        handleOpChange: _this.handleOpChange,
        handleValue1Change: _this.handleValue1Change,
        handleValueFromChange: _this.handleValueFromChange,
        handleTempChange: handleTempChange,
        ModalManager: ModalManager,
        apis: apis,
        initData: initData,
        fieldConfig: fieldConfig
      };
      return /*#__PURE__*/_react.default.createElement(FormIns, formProps);
    };

    _this.handleFormChange = function (value, option, extra) {
      var _extra$triggerNode;

      _this.props.onFormTypeChange(value, extra === null || extra === void 0 ? void 0 : (_extra$triggerNode = extra.triggerNode) === null || _extra$triggerNode === void 0 ? void 0 : _extra$triggerNode.props);
    };

    _this.handleOpChange = function (value) {
      var _this$props2 = _this.props,
          handleTempChange = _this$props2.handleTempChange,
          selectedNode = _this$props2.selectedNode;
      var temp = selectedNode.temp;

      if (value === 'IS_EMPTY') {
        setTimeout(function () {
          if (temp.value1) {
            handleTempChange([]);
          }

          _this.handleValue1Change();
        }, 100);
      }

      _this.props.onFieldChange(value, 'opType');
    };

    _this.handleValueFromChange = function (value) {
      var handleTempChange = _this.props.handleTempChange;
      setTimeout(function () {
        handleTempChange([]);

        _this.handleValue1Change();
      }, 100);

      _this.props.onFieldChange(value, 'valueFrom');
    };

    _this.handleValue1Change = function (value) {
      _this.props.onFieldChange(value, 'value1');
    };

    _this.isAdvanceCondtion = function () {
      var selectedNode = _this.props.selectedNode;
      return selectedNode.conditionSource === 'CUSTOM';
    };

    _this.filterTreeDataBytype = function (data, type) {
      return _lodash.default.filter(_lodash.default.map(data, function (d) {
        return _objectSpread(_objectSpread({}, d), {}, {
          children: _lodash.default.filter(d.children, {
            type: type
          })
        });
      }), function (c) {
        return !_lodash.default.isEmpty(c.children);
      });
    };

    _this.FormItem = _form.default.Item;
    _this.Option = _select.default.Option;
    _this.state = {
      filter: '',
      visible: false
    };
    _this.t = _mkTranslate.default.getLocalNs('MK_ConditionSetting', (0, _assertThisInitialized2.default)(_this));
    return _this;
  }

  (0, _createClass2.default)(ConditionForm, [{
    key: "renderRelationForm",
    value: function renderRelationForm() {
      var selectedNode = this.props.selectedNode,
          options = [{
        name: C.WORD_MAP[C.AND],
        value: C.AND
      }, {
        name: C.WORD_MAP[C.OR],
        value: C.OR
      }];
      return /*#__PURE__*/_react.default.createElement(_mkSelect.default, {
        label: this.t('typeOfConditionSet'),
        placeholder: this.t('typeOfConditionSet'),
        options: options,
        onChange: this.handleOpChange,
        value: selectedNode.opType
      });
    }
  }, {
    key: "renderFrom",
    value: function renderFrom() {
      var _this$props3 = this.props,
          selectedNode = _this$props3.selectedNode,
          handleTempChange = _this$props3.handleTempChange,
          extraFormMap = _this$props3.extraFormMap;

      var _formMap = _objectSpread(_objectSpread({}, _formMap2.default), extraFormMap);

      if (!selectedNode.field) {
        return;
      }

      var formProps = {
        selectedNode: selectedNode,
        handleOpChange: this.handleOpChange,
        handleValue1Change: this.handleValue1Change,
        handleTempChange: handleTempChange
      };
      var FormIns = _formMap[selectedNode.field];
      return /*#__PURE__*/_react.default.createElement(FormIns, formProps);
      /* switch (selectedNode.field) {
          case 'APPROVED_AMOUNT':
              return <forms.ApprovedAmount
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange}
                  handleValue1Change={this.handleValue1Change} />
          case 'PAYMENT_AMOUNT':
          case 'INS_PAYMENT_AMOUNT':
              return <forms.PaymentAmount
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange}
                  handleValue1Change={this.handleValue1Change} />
          case 'COVER_DEPARTMENT_CODE':
          case 'COVER_DEPARTMENT_CODE_WITH_OUT_CHILD':
              return <forms.CoverDepartment
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange}
                  togglePopover={this.togglePopover}
                  handleTempChange={handleTempChange} />
          case 'REQUEST_USER_DEPARTMENT_CODE':
          case 'REQUEST_USER_DEPARTMENT_CODE_EXCLUDED_CHILD':
              return <forms.RequestUserDepartment
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange}
                  togglePopover={this.togglePopover}
                  handleTempChange={handleTempChange} />
          case 'COVER_USER_CODE':
          case 'COVER_USER_CODE_INCLUDE_ALLOCATIONS':
          case 'LOAN_USER_CODE':
              return <forms.CoverUser
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange}
                  togglePopover={this.togglePopover}
                  handleTempChange={handleTempChange} />
          case 'SINGLE_EXPENSE_TYPE_MAX_AMOUNT':
              return <forms.SingleExpenseTypeAmount
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange}
                  handleValue1Change={this.handleValue1Change}
                  handleTempChange={handleTempChange} />
          case 'AGGREGATED_EXPENSE_TYPE_AMOUNT':
          case 'VICE_EXPENSE_TYPE_AMOUNT':
          case 'EXPENSE_TYPE_AMOUNT_INCLUDE_DEDUCTION':
              return <forms.AggregatedExpenseTypeAmount
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange}
                  handleValue1Change={this.handleValue1Change}
                  handleTempChange={handleTempChange} />
          case 'EXPENSE_REGULATE':
              return <forms.ExpenseRegular
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange}
                  handleValue1Change={this.handleValue1Change} />
          case 'REFERENCE_DATA_DETAIL':
          case 'REQUEST_USER_REF_DETAIL':
              return <forms.ReferenceDateDetail
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange}
                  handleValue1Change={this.handleValue1Change}
                  handleTempChange={handleTempChange} />
          case 'ASSOCIATION_APPLICATION':
              return <forms.AssociationApplication
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange}
                  handleValue1Change={this.handleValue1Change} />
          case 'LEGAL_ENTITY':
              return <forms.LegalEntity
                  visible={this.state.visible}
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange}
                  togglePopover={this.togglePopover}
                  handleTempChange={handleTempChange} />
          case 'APPROVED_AMOUNT_COMPARE_APPLY_AMOUNT':
              return <forms.ApprovedAmountCompareApplyAmount
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange} />
          case 'BUDGET_OCCUPY_PERCENT':
              return <forms.BudgetOccupyPercent
                  visible={this.state.visible}
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange}
                  handleValue1Change={this.handleValue1Change}
                  handleTempChange={handleTempChange} />
          case 'TRAVEL_ROUTE_DAYS':
              return <forms.TravelRouteDays
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange}
                  handleValue1Change={this.handleValue1Change} />
          case 'EXISTED_EXTERNAL_VALIDATION_RESULT':
          case 'APPLICATION_QUOTA':
              return <forms.ExistedExternalValidationResult
                  visible={this.state.visible}
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange}
                  handleValue1Change={this.handleValue1Change} />
          case 'REQUEST_USER_CREDIT_SCORE':
              return <forms.RequestUserCreditScore
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange}
                  handleValue1Change={this.handleValue1Change} />
          case 'INTERNAL_PEOPLE_NUM':
              return <forms.InternalPeopleNum
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange}
                  handleValue1Change={this.handleValue1Change} />
          case 'IS_COVER_DEPARTMENT_PRINCIPLE':
              return <forms.IsCoverDepartmentPrinciple
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange}
                  handleValue1Change={this.handleValue1Change} />
          case 'EXPENSE_BUSINESS_SCENE':
              return <forms.ExpenseBusinessScene
                  selectedNode={selectedNode}
                  handleOpChange={this.handleOpChange}
                  handleTempChange={handleTempChange}  />
          default:
              return '';
       } */
      // return map[selected.field];
    }
  }, {
    key: "render",
    value: function render() {
      var _temp$fieldConfig, _temp$fieldConfig2, _selectedNode$temp, _selectedNode$temp$fi;

      var _this$props4 = this.props,
          selectedNode = _this$props4.selectedNode,
          entrance = _this$props4.entrance,
          initData = _this$props4.initData,
          conditionOptions = _this$props4.conditionOptions,
          handleTempChange = _this$props4.handleTempChange,
          conditionBuilder = _this$props4.conditionBuilder;
      var temp = selectedNode.temp;
      var options = conditionBuilder && conditionBuilder.getConditionOptions(initData === null || initData === void 0 ? void 0 : initData.processType, entrance, initData && initData.functionList);

      if (selectedNode && selectedNode.conditionType === C.FORM_RELATION) {
        return this.renderRelationForm();
      }

      return /*#__PURE__*/_react.default.createElement(_form.default, null, this.isAdvanceCondtion() ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_form.default.Item, {
        label: this.t('subject'),
        className: "mk-form-control"
      }, /*#__PURE__*/_react.default.createElement(_treeSelect.default, {
        treeData: conditionOptions,
        value: selectedNode.key,
        onChange: this.handleFormChange,
        showSearch: true,
        style: {
          width: '100%'
        },
        dropdownStyle: {
          maxHeight: '292px'
        },
        placeholder: this.t('pleaseSelect'),
        filterTreeNode: function filterTreeNode(searchValue, node) {
          return node.props.name.toLowerCase().indexOf(searchValue.toLowerCase()) >= 0;
        }
      })), /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_mkSelect.default, {
        label: this.t('relation'),
        onChange: this.handleOpChange,
        value: selectedNode.opType,
        options: temp === null || temp === void 0 ? void 0 : (_temp$fieldConfig = temp.fieldConfig) === null || _temp$fieldConfig === void 0 ? void 0 : _temp$fieldConfig.opTypes
      })), selectedNode.opType !== 'IS_EMPTY' && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, //现在只有人员选择支持
      ['StaffInput'].indexOf(temp === null || temp === void 0 ? void 0 : (_temp$fieldConfig2 = temp.fieldConfig) === null || _temp$fieldConfig2 === void 0 ? void 0 : _temp$fieldConfig2.type) !== -1 && /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_mkSelect.default, {
        label: "",
        onChange: this.handleValueFromChange,
        value: selectedNode.valueFrom,
        options: [{
          name: "指定值",
          value: "CUSTOM"
        }, {
          name: "来自单据",
          value: "FORM"
        }]
      })), this.renderAdvanceFrom(), /*#__PURE__*/_react.default.createElement("div", null, selectedNode.valueFrom === 'FORM' && /*#__PURE__*/_react.default.createElement(_form.default.Item, {
        label: "\u5BF9\u8C61",
        className: "mk-form-control"
      }, /*#__PURE__*/_react.default.createElement(_treeSelect.default, {
        treeData: this.filterTreeDataBytype(conditionOptions, selectedNode === null || selectedNode === void 0 ? void 0 : (_selectedNode$temp = selectedNode.temp) === null || _selectedNode$temp === void 0 ? void 0 : (_selectedNode$temp$fi = _selectedNode$temp.fieldConfig) === null || _selectedNode$temp$fi === void 0 ? void 0 : _selectedNode$temp$fi.type),
        value: selectedNode.value1,
        onChange: function onChange(value, option, extra) {
          var _extra$triggerNode2;

          handleTempChange([extra === null || extra === void 0 ? void 0 : (_extra$triggerNode2 = extra.triggerNode) === null || _extra$triggerNode2 === void 0 ? void 0 : _extra$triggerNode2.props], 'code');
        },
        showSearch: true,
        style: {
          width: '100%'
        },
        dropdownStyle: {
          maxHeight: '292px'
        },
        placeholder: this.t('pleaseSelect'),
        filterTreeNode: function filterTreeNode(searchValue, node) {
          return node.props.name.toLowerCase().indexOf(searchValue.toLowerCase()) >= 0;
        }
      }))))) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_mkSelect.default, {
        label: this.t('subject'),
        placeholder: this.t('pleaseSelect'),
        dropdownClassName: "condition-form-select",
        options: options,
        onChange: this.handleFormChange,
        value: selectedNode.field
      }), this.renderFrom()));
    }
  }]);
  return ConditionForm;
}(_react.Component);
/* const mapStateToProps = (state) => {
    return {
        initData: state.commonData.init,
        process: state.commonData.process
    }
} */


var _default = ConditionForm;
exports.default = _default;