"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _mkInput = _interopRequireDefault(require("../../Process/mkInput"));

var _sensitiveWordsSetting = _interopRequireDefault(require("../../Process/sensitiveWordsSetting"));

var _TranslateHook = _interopRequireDefault(require("../../hooks/TranslateHook"));

var Text = function Text(props) {
  var t = (0, _TranslateHook.default)('MK_ConditionSetting');
  var selectedNode = props.selectedNode,
      handleValue1Change = props.handleValue1Change;
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "popover-selected-item-wrap"
  }, /*#__PURE__*/_react.default.createElement(_sensitiveWordsSetting.default, {
    onChange: function onChange(value) {
      handleValue1Change(value.join(','));
    },
    value: selectedNode.value1 && selectedNode.value1.split(',')
  }));
};

var _default = Text;
exports.default = _default;