"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/list/style/css");

var _list = _interopRequireDefault(require("maycur-antd/lib/list"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/select/style/css");

var _select = _interopRequireDefault(require("maycur-antd/lib/select"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _constants = _interopRequireDefault(require("../../utils/constants"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

var _i18next = _interopRequireDefault(require("i18next"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Search = _input.default.Search;
var Option = _select.default.Option;
var prefix = _utils.default.prefixCls;
var DEPARTMENT_PICKER = _constants.default.DEPARTMENT_PICKER;

var UserGroupList = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(UserGroupList, _Component);

  var _super = _createSuper(UserGroupList);

  function UserGroupList(props) {
    var _this;

    (0, _classCallCheck2.default)(this, UserGroupList);
    _this = _super.call(this, props);

    _this.onSearchSelectChange = function (accurate) {
      return _this.setState({
        accurate: accurate
      });
    };

    _this.localeProcess = function (ns, key) {
      _mkTranslate.default.getNameSpace(ns).then(function (t) {
        _this.setState((0, _defineProperty2.default)({}, key, t));
      });
    };

    _this.onSearch = function (value) {
      var _this$state = _this.state,
          accurate = _this$state.accurate,
          cachedSourceList = _this$state.cachedSourceList;
      value = _lodash.default.trim(value);

      _this.setState({
        isSearching: true,
        searchKeyword: value
      });

      if (value) {
        var newSourceList = _lodash.default.filter(cachedSourceList, function (item) {
          if (accurate === 'true') {
            return item.name === value;
          }

          return item.name.indexOf(value) !== -1;
        });

        _this.setState({
          sourceList: newSourceList
        });
      } else {
        _this.setState({
          sourceList: cachedSourceList,
          isSearching: false
        });
      }
    };

    _this.clearSearch = function () {
      var cachedSourceList = _this.state.cachedSourceList;

      _this.setState({
        searchKeyword: null,
        sourceList: cachedSourceList,
        isSearching: false
      });
    };

    _this.state = {
      searchKeyword: null,
      sourceList: [],
      cachedSourceList: [],
      selectList: props.selectList || [],
      allSelected: false,
      accurate: 'false',
      t: _mkTranslate.default.noop(),
      gt: _mkTranslate.default.noop()
    };
    _this.toggleAll = _this.toggleAll.bind((0, _assertThisInitialized2.default)(_this));
    _this.toggleItem = _this.toggleItem.bind((0, _assertThisInitialized2.default)(_this));
    _this.checkAllFlag = _this.checkAllFlag.bind((0, _assertThisInitialized2.default)(_this));
    _this.output = _this.output.bind((0, _assertThisInitialized2.default)(_this));

    _this.localeProcess('MK_DepartmentSelectionModal', 't');

    _this.localeProcess('MK_Global', 'gt');

    _this.selectBefore = /*#__PURE__*/_react.default.createElement(_select.default, {
      defaultValue: 'false',
      onChange: _this.onSearchSelectChange,
      dropdownClassName: 'ant-dept-search-dropdown',
      dropdownMatchSelectWidth: true
    }, /*#__PURE__*/_react.default.createElement(Option, {
      value: 'false'
    }, _this.state.gt('FuzzySearch')), /*#__PURE__*/_react.default.createElement(Option, {
      value: 'true'
    }, _this.state.gt('AccurateSearch')));
    return _this;
  }

  (0, _createClass2.default)(UserGroupList, [{
    key: "toggleAll",
    value: function toggleAll() {
      var _this$state2 = this.state,
          sourceList = _this$state2.sourceList,
          allSelected = _this$state2.allSelected;
      this.setState({
        selectList: sourceList,
        allSelected: !allSelected
      });
      this.output(sourceList, false);
    }
  }, {
    key: "toggleItem",
    value: function toggleItem(item) {
      var selectList = this.state.selectList;

      var idx = _lodash.default.findIndex(selectList, {
        code: item.code
      });

      if (idx !== -1) {
        selectList.splice(idx, 1);
      } else {
        selectList.push(item);
      }

      this.setState({
        selectList: selectList
      });
      this.output(selectList, true);
      setTimeout(this.checkAllFlag);
    }
  }, {
    key: "checkAllFlag",
    value: function checkAllFlag() {
      var _this$state3 = this.state,
          sourceList = _this$state3.sourceList,
          selectList = _this$state3.selectList;
      var targetList = sourceList;
      var allSelected = targetList.length && !_lodash.default.find(targetList, function (dep) {
        return !_lodash.default.find(selectList, {
          code: dep.code
        });
      });
      this.setState({
        allSelected: allSelected
      });
    }
  }, {
    key: "output",
    value: function output(selectList, itemSelected) {
      var _this$state4 = this.state,
          sourceList = _this$state4.sourceList,
          allSelected = _this$state4.allSelected;
      var onOutput = this.props.onOutput;
      var result = {
        added: selectList,
        removed: _lodash.default.differenceWith(sourceList, selectList, function (o1, o2) {
          return o1.code === o2.code;
        }),
        allSelected: allSelected,
        itemSelected: itemSelected
      };

      if (typeof onOutput === "function") {
        onOutput(result);
      }
    }
  }, {
    key: "fetchUserGroup",
    value: function fetchUserGroup() {
      var _this2 = this;

      var fetchUserGroup = this.props.fetchUserGroup;
      fetchUserGroup({
        pageId: DEPARTMENT_PICKER.USER_GROUP_SOURCE_LIST
      }).then(function (data) {
        if (_utils.default.apiOK(data)) {
          var _data$data = data.data,
              userGroups = _data$data.userGroups,
              userGroupCategorys = _data$data.userGroupCategorys;

          var sourceList = _lodash.default.flatten(userGroups.concat(_lodash.default.map(userGroupCategorys, function (ugt) {
            return ugt.userGroups;
          })));

          _lodash.default.forEach(sourceList, function (item) {
            item.type = DEPARTMENT_PICKER.USER_GROUP;
          });

          _this2.setState({
            sourceList: sourceList,
            cachedSourceList: sourceList
          }, function () {
            _this2.checkAllFlag();
          });
        }
      });
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var selectList = nextProps.selectList;
      this.setState({
        selectList: selectList
      });
      setTimeout(this.checkAllFlag);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.fetchUserGroup();
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props = this.props,
          loading = _this$props.loading,
          maxSelectLength = _this$props.maxSelectLength,
          hideAccurateSearch = _this$props.hideAccurateSearch;
      var _this$state5 = this.state,
          sourceList = _this$state5.sourceList,
          selectList = _this$state5.selectList,
          allSelected = _this$state5.allSelected,
          className = _this$state5.className,
          searchKeyword = _this$state5.searchKeyword,
          t = _this$state5.t,
          accurate = _this$state5.accurate;
      var containerClass = (0, _classnames.default)("".concat(prefix, "-user-group-list"), className);
      var allSelectedClass = (0, _classnames.default)({
        selected: allSelected
      });
      return /*#__PURE__*/_react.default.createElement("div", {
        className: containerClass
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "search-box".concat(searchKeyword ? ' searching' : '')
      }, /*#__PURE__*/_react.default.createElement(Search, {
        addonBefore: hideAccurateSearch ? '' : this.selectBefore,
        value: searchKeyword,
        placeholder: accurate === 'true' ? t('departmentTransfer.userGroupSearch') : t('departmentTransfer.userGroupPlaceholder'),
        onChange: function onChange(e) {
          return _this3.setState({
            searchKeyword: e.target.value
          });
        },
        onSearch: this.onSearch
      }), searchKeyword ? /*#__PURE__*/_react.default.createElement("span", {
        className: 'fm fm-cross',
        onClick: this.clearSearch
      }) : null), maxSelectLength > 1 ? /*#__PURE__*/_react.default.createElement("div", {
        className: 'opt-bar'
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'select-all-btn',
        onClick: this.toggleAll
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: allSelectedClass + ' fm fm-check'
      }), /*#__PURE__*/_react.default.createElement("span", null, allSelected ? _i18next.default.t('MK_Global:selectInvert') : _i18next.default.t('MK_Global:selectAll')))) : null, /*#__PURE__*/_react.default.createElement(_list.default, {
        size: "small",
        loading: loading,
        dataSource: sourceList,
        renderItem: function renderItem(item) {
          var selected = _lodash.default.findIndex(selectList, {
            code: item.code
          }) !== -1;
          var itemClass = (0, _classnames.default)({
            selected: selected
          });
          return /*#__PURE__*/_react.default.createElement(_list.default.Item, {
            className: itemClass,
            key: item.code,
            onClick: function onClick() {
              _this3.toggleItem(item);
            }
          }, /*#__PURE__*/_react.default.createElement("span", {
            className: 'fm fm-check'
          }), /*#__PURE__*/_react.default.createElement("span", {
            className: 'item-name'
          }, /*#__PURE__*/_react.default.createElement("span", {
            className: 'fm fm-user-group'
          }), item.name));
        }
      }));
    }
  }]);
  return UserGroupList;
}(_react.Component);

var _default = UserGroupList;
exports.default = _default;