"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/popover/style/css");

var _popover = _interopRequireDefault(require("maycur-antd/lib/popover"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function PopoverContent(props) {
  var fetchFullPath = props.fetchFullPath;

  var _useState = (0, _react.useState)('加载中...'),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      content = _useState2[0],
      setContent = _useState2[1];

  (0, _react.useEffect)(function () {
    fetchFullPath && fetchFullPath().then(function (data) {
      setContent(data && data.join(' / '));
    });
  }, []);
  return /*#__PURE__*/_react.default.createElement("div", null, content);
}

function FullPathPopover(props) {
  return /*#__PURE__*/_react.default.createElement(_popover.default, {
    overlayClassName: "fullpath-popover-overlay",
    placement: "bottom",
    content: /*#__PURE__*/_react.default.createElement(PopoverContent, {
      fetchFullPath: props.fetchFullPath
    }),
    destroyTooltipOnHide: true
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: "icon-circle"
  }, /*#__PURE__*/_react.default.createElement("i", {
    className: "fm fm-more-o"
  })));
}

var _default = FullPathPopover;
exports.default = _default;