"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/spin/style/css");

var _spin = _interopRequireDefault(require("maycur-antd/lib/spin"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _StuffSelectionModal = _interopRequireDefault(require("./StuffSelectionModal"));

var _StuffTag = _interopRequireDefault(require("./StuffTag"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;

var ListPicker = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(ListPicker, _Component);

  var _super = _createSuper(ListPicker);

  function ListPicker(props) {
    var _this;

    (0, _classCallCheck2.default)(this, ListPicker);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_LegalEntityPicker').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.onChange = function (value) {
      var onChange = _this.props.onChange;

      if (typeof onChange === 'function') {
        onChange(value);
      }
    };

    _this.openModal = function (e) {
      e.stopPropagation();
      var _this$props = _this.props,
          title = _this$props.title,
          tabname = _this$props.tabname,
          dataSource = _this$props.dataSource,
          dataSourceSync = _this$props.dataSourceSync,
          dataIndex = _this$props.dataIndex,
          value = _this$props.value,
          isShowSearch = _this$props.isShowSearch,
          loadMore = _this$props.loadMore,
          pageSize = _this$props.pageSize,
          onSearch = _this$props.onSearch,
          multiply = _this$props.multiply,
          renderLeftListItem = _this$props.renderLeftListItem,
          renderRightListItem = _this$props.renderRightListItem,
          onRef = _this$props.onRef,
          loading = _this$props.loading,
          searchPlaceholder = _this$props.searchPlaceholder,
          selectedDesc = _this$props.selectedDesc,
          onCancel = _this$props.onCancel,
          modalManager = _this$props.modalManager;

      if (loading) {
        return;
      }

      modalManager.open({
        component: _StuffSelectionModal.default,
        componentProps: {
          title: title ? title : '标题',
          tabname: tabname,
          dataSource: dataSource,
          dataSourceSync: dataSourceSync,
          dataIndex: dataIndex ? dataIndex : 'name',
          value: value,
          isShowSearch: isShowSearch,
          loadMore: loadMore,
          pageSize: pageSize,
          onSearch: onSearch,
          multiply: multiply,
          renderLeftListItem: renderLeftListItem,
          renderRightListItem: renderRightListItem,
          onRef: onRef,
          searchPlaceholder: searchPlaceholder,
          selectedDesc: selectedDesc
        }
      }).then(function (_value) {
        _this.onChange(_value);
      }).catch(function (error) {
        // eslint-disable-next-line no-console
        console.log('error', error);

        if (typeof onCancel === 'function') {
          onCancel();
        }
      });
    };

    _this.renderTags = function (value, account, maxTagLength) {
      var _this$props2 = _this.props,
          emptyText = _this$props2.emptyText,
          dataIndex = _this$props2.dataIndex,
          renderTagItem = _this$props2.renderTagItem;
      var t = _this.state.t;
      return _lodash.default.isArray(value) && value.length > 0 ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
        style: {
          display: 'inline-flex',
          alignItems: 'center',
          flexWrap: 'wrap',
          maxWidth: '100%'
        }
      }, value.map(function (item, index) {
        return /*#__PURE__*/_react.default.createElement(_StuffTag.default, {
          key: index
        }, renderTagItem ? renderTagItem(item, index) : item.name || item[dataIndex]);
      }), account > maxTagLength ? /*#__PURE__*/_react.default.createElement("span", {
        className: "more-stuff"
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "more-stuff-symbol"
      }, "..."), /*#__PURE__*/_react.default.createElement("span", {
        style: {
          marginLeft: 2
        }
      }, t("MK_LegalEntityPicker:Total"), value ? /*#__PURE__*/_react.default.createElement("span", {
        className: "number"
      }, account) : null, t("MK_LegalEntityPicker:Items"))) : null)) : /*#__PURE__*/_react.default.createElement("div", {
        className: "empty"
      }, emptyText ? emptyText : '未设置');
    };

    _this.state = {
      t: _mkTranslate.default.noop()
    };

    _this.localeProcess();

    return _this;
  }

  (0, _createClass2.default)(ListPicker, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          value = _this$props3.value,
          maxTagLength = _this$props3.maxTagLength,
          loading = _this$props3.loading,
          disabled = _this$props3.disabled;
      var splicedValue;
      var account = value ? value.length : 3;

      if (maxTagLength && value && value.length > 0) {
        var _value = _lodash.default.cloneDeep(value);

        splicedValue = _value.slice(0, maxTagLength);
      }

      var containerClass = (0, _classnames.default)("".concat(prefix, "-list-picker-container"), {
        'disabled': disabled
      });
      return /*#__PURE__*/_react.default.createElement("div", {
        className: containerClass,
        onClick: this.openModal
      }, maxTagLength ? this.renderTags(splicedValue, account, maxTagLength) : this.renderTags(value, account, maxTagLength), loading ? /*#__PURE__*/_react.default.createElement(_spin.default, {
        size: "small"
      }) : null);
    }
  }]);
  return ListPicker;
}(_react.Component);

ListPicker.defaultProps = {
  multiply: true
};
ListPicker.StuffSelectionModal = _StuffSelectionModal.default;
var _default = ListPicker;
exports.default = _default;