"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _reactSpinners = require("react-spinners");

var _classnames2 = _interopRequireDefault(require("classnames"));

var _utils = _interopRequireDefault(require("../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;

var Loader = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(Loader, _Component);

  var _super = _createSuper(Loader);

  function Loader(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Loader);
    _this = _super.call(this, props);
    _this.state = {};
    return _this;
  }

  (0, _createClass2.default)(Loader, [{
    key: "render",
    value: function render() {
      var _classnames;

      var _this$props = this.props,
          active = _this$props.active,
          className = _this$props.className,
          size = _this$props.size,
          embed = _this$props.embed,
          mask = _this$props.mask;
      var loaderStyle = (0, _classnames2.default)("".concat(prefix, "-mk-loader"), className || "", (_classnames = {}, (0, _defineProperty2.default)(_classnames, "".concat(prefix, "-mk-loader-active"), active), (0, _defineProperty2.default)(_classnames, "".concat(prefix, "-mk-loader-embed"), embed), (0, _defineProperty2.default)(_classnames, "".concat(prefix, "-mk-loader-mask"), mask), _classnames));
      return /*#__PURE__*/_react.default.createElement("div", {
        className: loaderStyle
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "loader-body"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "loader-wrapper"
      }, /*#__PURE__*/_react.default.createElement(_reactSpinners.ClipLoader, {
        loading: active,
        size: size || 30
      }))));
    }
  }]);
  return Loader;
}(_react.Component);

var _default = Loader;
exports.default = _default;