"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _RangeCalendar = _interopRequireDefault(require("rc-calendar/lib/RangeCalendar"));

var _Panel = _interopRequireDefault(require("rc-time-picker/lib/Panel"));

require("rc-calendar/assets/index.css");

require("rc-time-picker/assets/index.css");

var _zh_CN = _interopRequireDefault(require("rc-calendar/lib/locale/zh_CN"));

var _en_US = _interopRequireDefault(require("rc-calendar/lib/locale/en_US"));

var _lodash = _interopRequireDefault(require("lodash"));

var _moment = _interopRequireDefault(require("moment"));

var _utils = _interopRequireDefault(require("../../../utils/utils"));

var _i18next = _interopRequireDefault(require("i18next"));

var _mkTranslate = _interopRequireDefault(require("../../../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;

var timePickerElement = /*#__PURE__*/_react.default.createElement(_Panel.default, {
  defaultValue: [(0, _moment.default)('00:00:00', 'HH:mm:ss'), (0, _moment.default)('23:59:59', 'HH:mm:ss')],
  showSecond: false
});
/**
 * @param {boolean} showTime:显示时间
 */


var DateFilter = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(DateFilter, _Component);

  var _super = _createSuper(DateFilter);

  function DateFilter(props) {
    var _this;

    (0, _classCallCheck2.default)(this, DateFilter);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_Table').then(function (t) {
        _this.setState({
          t: t,
          rangeOptions: [{
            value: 'all',
            label: t('dateFilter.all')
          }, {
            value: 'recentOne',
            label: t('dateFilter.recentOne')
          }, {
            value: 'recentThree',
            label: t('dateFilter.recentThree')
          }]
        });
      });
    };

    _this.dateChange = function (nextValue) {
      var _this$props = _this.props,
          confirm = _this$props.confirm,
          setSelectedKeys = _this$props.setSelectedKeys,
          showTime = _this$props.showTime;

      if (nextValue && nextValue.length === 2) {
        if (nextValue[0]) {
          nextValue[0] = showTime ? (0, _moment.default)(nextValue[0]) : (0, _moment.default)(nextValue[0]).startOf('day');
        }

        if (nextValue[1]) {
          nextValue[1] = showTime ? (0, _moment.default)(nextValue[1]) : (0, _moment.default)(nextValue[1]).endOf('day');
        }

        _this.setState({
          selectedValue: nextValue
        }, function () {
          setSelectedKeys(nextValue);

          if (!showTime && nextValue.length > 1) {
            confirm();
          }
        });
      }
    };

    _this.onChoose = function (value) {
      var now = new Date();
      var _this$props2 = _this.props,
          confirm = _this$props2.confirm,
          setSelectedKeys = _this$props2.setSelectedKeys;

      _this.setState({
        range: value
      }, function () {
        switch (value) {
          case 'recentThree':
            _this.setState({
              selectedValue: [(0, _moment.default)(now).subtract(3, 'months'), (0, _moment.default)()]
            }, function () {
              setSelectedKeys(_this.state.selectedValue);
              confirm();
            });

            break;

          case 'recentOne':
            _this.setState({
              selectedValue: [(0, _moment.default)(now).subtract(1, 'months'), (0, _moment.default)()]
            }, function () {
              setSelectedKeys(_this.state.selectedValue);
              confirm();
            });

            break;

          case 'all':
            _this.setState({
              selectedValue: []
            }, function () {
              setSelectedKeys(_this.state.selectedValue);
              confirm();
            });

            break;

          case 'customize':
            _this.setState({
              selectedValue: []
            });

            break;

          default:
            break;
        }
      });
    };

    _this.adapterValue = function (value) {
      if (Array.isArray(value) && value.length > 0) {
        return value.map(function (item) {
          return item && typeof item.isValid === 'function' && item.isValid() ? item : (0, _moment.default)(item);
        });
      } else {
        return null;
      }
    };

    _this.handleOK = function () {
      var confirm = _this.props.confirm;
      if (typeof confirm === 'function') confirm();
    };

    _this.state = {
      selectedValue: props.selectedKeys || [],
      t: _mkTranslate.default.noop(),
      rangeOptions: [],
      range: 'all',
      showOk: _this.props.showTime
    };

    _this.localeProcess();

    return _this;
  }

  (0, _createClass2.default)(DateFilter, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var prevSelectedKeys = prevProps.selectedKeys;
      var selectedKeys = this.props.selectedKeys;

      if (!_lodash.default.isEqual(prevSelectedKeys, selectedKeys)) {
        this.setState({
          selectedValue: selectedKeys
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          isNeedSideBar = _this$props3.isNeedSideBar,
          showTime = _this$props3.showTime,
          visible = _this$props3.visible;
      var _this$state = this.state,
          selectedValue = _this$state.selectedValue,
          range = _this$state.range,
          rangeOptions = _this$state.rangeOptions,
          t = _this$state.t,
          showOk = _this$state.showOk;

      var _selectedValue = this.adapterValue(selectedValue);

      return /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-date-filter")
      }, visible ? /*#__PURE__*/_react.default.createElement(_RangeCalendar.default, {
        renderFooter: function renderFooter() {
          if (isNeedSideBar) {
            return /*#__PURE__*/_react.default.createElement("div", {
              className: "tabs"
            }, rangeOptions.map(function (item, index) {
              return /*#__PURE__*/_react.default.createElement("div", {
                className: 'tab' + (range === item.value ? ' active' : ''),
                onClick: _this2.onChoose.bind(_this2, item.value),
                key: index
              }, item.label);
            }));
          } else {
            return null;
          }
        },
        locale: _i18next.default.language === 'en' ? _en_US.default : _zh_CN.default,
        selectedValue: _selectedValue ? _selectedValue : [],
        dateInputPlaceholder: [t('dateFilter.startDate'), t('dateFilter.endDate')],
        showToday: false,
        onChange: this.dateChange,
        onOk: this.handleOK,
        showOk: showOk,
        timePicker: showTime ? timePickerElement : undefined
      }) : null);
    }
  }]);
  return DateFilter;
}(_react.Component);

DateFilter.defaultProps = {
  isNeedSideBar: true,
  showTime: false
};
var _default = DateFilter;
exports.default = _default;