"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/button/style/css");

var _button = _interopRequireDefault(require("maycur-antd/lib/button"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _utils = _interopRequireDefault(require("../../../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../../../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;

var FilterListPanel = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(FilterListPanel, _Component);

  var _super = _createSuper(FilterListPanel);

  function FilterListPanel(props) {
    var _this;

    (0, _classCallCheck2.default)(this, FilterListPanel);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_Table').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.state = {
      t: _mkTranslate.default.noop()
    };

    _this.localeProcess();

    return _this;
  }

  (0, _createClass2.default)(FilterListPanel, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          list = _this$props.list,
          addItem = _this$props.addItem,
          editItem = _this$props.editItem,
          deleteItem = _this$props.deleteItem,
          emptyImg = _this$props.emptyImg,
          setDefaultFilter = _this$props.setDefaultFilter;
      var t = this.state.t;
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-filter-setting-list-wrapper")
      }, !!list.length && /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-filter-setting-list")
      }, _utils.default.sortList(list).map(function (item) {
        return /*#__PURE__*/_react.default.createElement("div", {
          className: "".concat(prefix, "-filter-list-item"),
          key: item.code
        }, /*#__PURE__*/_react.default.createElement("div", {
          className: "".concat(prefix, "-filter-list-item-name")
        }, item.filterName, item.isDefault && /*#__PURE__*/_react.default.createElement("span", {
          className: "defalut"
        }, t('filterListPanel.默认筛选项'))), /*#__PURE__*/_react.default.createElement("div", {
          className: "".concat(prefix, "-filter-list-item-actions")
        }, item.isDefault ? /*#__PURE__*/_react.default.createElement("span", {
          onClick: function onClick() {
            return setDefaultFilter(item, true);
          }
        }, t('filterListPanel.取消默认')) : /*#__PURE__*/_react.default.createElement("span", {
          onClick: function onClick() {
            return setDefaultFilter(item);
          }
        }, t('filterListPanel.设为默认')), /*#__PURE__*/_react.default.createElement("span", {
          style: {
            margin: '0 8px'
          },
          onClick: function onClick() {
            return editItem(item);
          }
        }, t('filterListPanel.编辑')), /*#__PURE__*/_react.default.createElement("span", {
          className: "delete",
          onClick: function onClick() {
            return deleteItem(item);
          }
        }, t('filterListPanel.删除'))));
      })), /*#__PURE__*/_react.default.createElement(_button.default, {
        onClick: addItem,
        className: "add-btn"
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "fm fm-plus"
      }), t('filterListPanel.add')), !list.length && /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-filter-empty")
      }, /*#__PURE__*/_react.default.createElement("img", {
        src: emptyImg,
        alt: t('filterListPanel.empty'),
        style: {
          width: '80px'
        }
      }), /*#__PURE__*/_react.default.createElement("p", {
        style: {
          marginTop: '10px',
          color: '#757575'
        }
      }, t('filterListPanel.empty'))));
    }
  }]);
  return FilterListPanel;
}(_react.Component);

FilterListPanel.defaultProps = {
  list: []
};
var _default = FilterListPanel;
exports.default = _default;