"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/list/style/css");

var _list = _interopRequireDefault(require("maycur-antd/lib/list"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = require("lodash");

var _reactOnclickoutside = _interopRequireDefault(require("react-onclickoutside"));

var _Loader = _interopRequireDefault(require("../../Loader"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var prefix = _utils.default.prefixCls;
var Search = _input.default.Search;

function OptionInputList(props) {
  var label = props.label,
      showDropDown = props.showDropDown,
      value = props.value,
      placeholder = props.placeholder,
      showBizCode = props.showBizCode,
      search = props.search,
      fetchTreeDetail = props.fetchTreeDetail,
      fetchTree = props.fetchTree,
      dataSource = props.dataSource,
      legalEntity = props.legalEntity,
      formSubTypeCode = props.formSubTypeCode,
      afterChange = props.afterChange,
      hideDropDown = props.hideDropDown,
      sourceMode = props.sourceMode,
      privateProps = props.privateProps,
      setWatch = props.setWatch,
      legalEntityAuthzs = props.legalEntityAuthzs,
      onSetLegalEntityAuthz = props.onSetLegalEntityAuthz;

  var _useState = (0, _react.useState)({}),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      data = _useState2[0],
      setData = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      crumbs = _useState4[0],
      setCrumbs = _useState4[1];

  var _useState5 = (0, _react.useState)({}),
      _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
      originalData = _useState6[0],
      setOriginalData = _useState6[1];

  var _useState7 = (0, _react.useState)([]),
      _useState8 = (0, _slicedToArray2.default)(_useState7, 2),
      searchList = _useState8[0],
      setSearchList = _useState8[1];

  var _useState9 = (0, _react.useState)(false),
      _useState10 = (0, _slicedToArray2.default)(_useState9, 2),
      loading = _useState10[0],
      setLoading = _useState10[1];

  var _useState11 = (0, _react.useState)(false),
      _useState12 = (0, _slicedToArray2.default)(_useState11, 2),
      searching = _useState12[0],
      setSearching = _useState12[1];

  var _useState13 = (0, _react.useState)(false),
      _useState14 = (0, _slicedToArray2.default)(_useState13, 2),
      watched = _useState14[0],
      setWatched = _useState14[1];

  var _useState15 = (0, _react.useState)(''),
      _useState16 = (0, _slicedToArray2.default)(_useState15, 2),
      searchValue = _useState16[0],
      setSearchValue = _useState16[1];

  var transRef = (0, _react.useRef)();
  transRef.current = _mkTranslate.default.noop();
  var hide = (0, _react.useCallback)(function () {
    if (typeof hideDropDown === 'function') {
      hideDropDown();
    }
  }, [hideDropDown]);

  OptionInputList.handleClickOutside = function () {
    hide();
  }; // 创建一个保存公司抬头code的“盒子”


  var legalEntityRef = (0, _react.useRef)(legalEntity ? legalEntity.code : null);
  var showDropDownClass = (0, _react.useMemo)(function () {
    return showDropDown ? 'in' : '';
  }, [showDropDown]);
  var details = (0, _react.useMemo)(function () {
    return data.details && (0, _lodash.filter)(data.details, {
      enabled: true
    }) || [];
  }, [data]);
  var outerFormLegalEntity = (0, _react.useMemo)(function () {
    return privateProps.form && privateProps.form.getFieldValue('legalEntity');
  }, [privateProps]);
  var filterDetail = (0, _react.useCallback)(function (data) {
    return data.filter(function (d) {
      return d.deleted === false && d.enabled === true;
    });
  }, []);
  var legalEntityAuthzsChange = (0, _react.useCallback)(function (legalEntityAuthzs) {
    onSetLegalEntityAuthz(legalEntityAuthzs);
  }, [onSetLegalEntityAuthz]);
  var handleSelect = (0, _react.useCallback)(function (detail) {
    legalEntityAuthzsChange(detail.legalEntityAuthzs);

    if (typeof afterChange === 'function') {
      if (detail.code) {
        afterChange({
          value: {
            code: detail.code,
            name: detail.name,
            extraProperty: detail.extraProperty,
            bizCode: detail.bizCode
          }
        });
      }

      setCrumbs([]);
      setData(originalData);
      setSearchList([]);

      if (typeof hideDropDown === 'function' && detail.code) {
        hideDropDown();
      }
    }
  }, [afterChange, originalData, hideDropDown, legalEntityAuthzsChange]);
  var fetchSearchList = (0, _react.useCallback)(function (keyword) {
    if (typeof search === 'function') {
      setLoading(true);
      search({
        cipherKeyword: keyword,
        keyword: keyword,
        limit: 50,
        referenceDataCode: dataSource,
        legalEntityCode: legalEntityRef.current,
        formSubTypeCode: formSubTypeCode
      }).then(function (res) {
        setSearchList(filterDetail(res.result || []));
        setLoading(false);
      }).catch(function () {
        setLoading(false);
      });
    }
  }, [search, dataSource, filterDetail, formSubTypeCode]);
  var fetchMoreData = (0, _react.useCallback)(function (categoryCode) {
    return new Promise(function (resolve) {
      var _extra = {
        formSubTypeCode: formSubTypeCode
      };

      if (legalEntityRef.current) {
        _extra.legalEntityCode = legalEntityRef.current;
      }

      if (typeof fetchTreeDetail === 'function') {
        setLoading(true);
        fetchTreeDetail(_objectSpread({
          referenceDataCode: dataSource,
          categoryCode: categoryCode
        }, _extra)).then(function (res) {
          resolve(res);
          setLoading(false);
        }).catch(function () {
          setLoading(false);
        });
      }
    });
  }, [dataSource, fetchTreeDetail, formSubTypeCode]);
  var fetchTreeData = (0, _react.useCallback)(function () {
    var _extra = {
      formSubTypeCode: formSubTypeCode
    };

    if (legalEntityRef.current && legalEntityRef.current !== 'NONE') {
      _extra.legalEntityCode = legalEntityRef.current;
    }

    if (typeof fetchTree === 'function') {
      setLoading(true);
      fetchTree(_objectSpread({
        referenceDataCode: dataSource
      }, _extra)).then(function (res) {
        setData(res.data);
        setOriginalData(res.data);
        setLoading(false);
      }).catch(function () {
        setLoading(false);
      });
    }
  }, [fetchTree, dataSource, formSubTypeCode]);
  var updateTreeData = (0, _react.useCallback)(function (val) {
    var code = val && val.code || undefined;
    if (!code || legalEntityRef.current === code) return;
    legalEntityRef.current = code;
    fetchTreeData();

    if (legalEntityAuthzs && legalEntityAuthzs.length) {
      if (legalEntityAuthzs.every(function (_ref) {
        var authzCode = _ref.authzCode;
        return authzCode !== code;
      })) {
        handleSelect({});
      }
    }
  }, [fetchTreeData, handleSelect, legalEntityAuthzs]);
  var onSearch = (0, _react.useCallback)(function (value) {
    value = (0, _lodash.trim)(value);

    if (value) {
      setSearching(true);
      fetchSearchList(value);
      setSearchValue(value);
    } else {
      setSearching(false);
      setSearchList([]);
    }
  }, [fetchSearchList]);
  var jump = (0, _react.useCallback)(function (crumb, index) {
    var detail = {};

    if (index >= 0) {
      crumbs.length = index + 1;
      detail = crumb;
    } else {
      crumbs.length = 0;
      detail = originalData;
    }

    setData(detail);
    setCrumbs(crumbs);
  }, [crumbs, originalData]);
  var openCategory = (0, _react.useCallback)(function (category) {
    fetchMoreData(category.code).then(function (data) {
      category.details = data.result;
      crumbs.push({
        code: category.code,
        name: category.name,
        details: category.details,
        categories: category.categories
      });
      setData(category);
    });
  }, [fetchMoreData, crumbs]);
  var renderItem = (0, _react.useCallback)(function (item) {
    return /*#__PURE__*/_react.default.createElement(_list.default.Item, {
      key: item.code,
      onClick: function onClick() {
        handleSelect(item);
      }
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "item-name"
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "fm fm-paper"
    }), item.name, showBizCode && /*#__PURE__*/_react.default.createElement("div", {
      className: "item-code"
    }, item.bizCode)));
  }, [handleSelect, showBizCode]);
  (0, _react.useEffect)(function () {
    if (sourceMode === 'DATA_SOURCE') {
      if (privateProps.isEntityInAllocation) {
        legalEntityRef.current = outerFormLegalEntity && outerFormLegalEntity.code || (legalEntity ? legalEntity.code : 'NONE');
      } else {
        // 分摊中的选项受外部表单中的抬头过滤
        updateTreeData(legalEntity);
        legalEntityRef.current = legalEntity ? legalEntity.code : null;
      }
    }
  }, [privateProps.isEntityInAllocation, outerFormLegalEntity, legalEntity, sourceMode, updateTreeData]);
  (0, _react.useEffect)(function () {
    if (typeof setWatch === 'function' && !watched) {
      setWatched(true);
      setWatch('legalEntity', function (value) {
        updateTreeData(value);
      });
    }
  }, [setWatch, updateTreeData, watched]);
  (0, _react.useEffect)(function () {
    fetchTreeData();
  }, [fetchTreeData]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-option-input")
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "dropdown ".concat(showDropDownClass)
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "city-picker-display-value-clone"
  }, value && value.name ? /*#__PURE__*/_react.default.createElement("div", null, value.name, showBizCode && value.bizCode ? "(".concat(value.bizCode, ")") : '') : /*#__PURE__*/_react.default.createElement("div", {
    className: "placeholder"
  }, placeholder)), /*#__PURE__*/_react.default.createElement("div", {
    className: "search"
  }, /*#__PURE__*/_react.default.createElement(Search, {
    placeholder: transRef.current('searchKeywords'),
    onSearch: onSearch
  })), searchValue && searchList.length === 0 && searching ? /*#__PURE__*/_react.default.createElement("div", {
    className: "empty-text"
  }, transRef.current('noData')) : null, searchList && searchList.length ? /*#__PURE__*/_react.default.createElement(_list.default, {
    dataSource: searchList,
    renderItem: renderItem,
    loading: loading
  }) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "crumbs"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "crumb-item",
    onClick: jump
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: "crumb-name"
  }, label)), crumbs.map(function (crumb, index) {
    return /*#__PURE__*/_react.default.createElement("div", {
      key: index,
      className: "crumb-item",
      onClick: function onClick() {
        return jump(crumb, index);
      }
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "split"
    }, "/"), /*#__PURE__*/_react.default.createElement("span", {
      className: "crumb-name"
    }, crumb.name));
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "panel"
  }, data.categories && data.categories.length ? /*#__PURE__*/_react.default.createElement("div", {
    className: "category"
  }, data.categories.map(function (category) {
    return /*#__PURE__*/_react.default.createElement("div", {
      className: "item",
      key: category.code,
      onClick: function onClick() {
        return openCategory(category);
      }
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "fm fm-folder-o"
    }), category.name);
  })) : null, details.length ? /*#__PURE__*/_react.default.createElement("div", {
    className: "detail"
  }, details.map(function (detail) {
    return /*#__PURE__*/_react.default.createElement("div", {
      className: "item",
      key: detail.code,
      onClick: function onClick() {
        return handleSelect(detail);
      }
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "fm fm-paper"
    }), detail.name, showBizCode && /*#__PURE__*/_react.default.createElement("div", {
      className: "item-code"
    }, detail.bizCode));
  })) : null, (!details || !details.length) && (!data.categories || !data.categories.length) ? /*#__PURE__*/_react.default.createElement("div", {
    className: "empty-text"
  }, transRef.current('noData')) : null, /*#__PURE__*/_react.default.createElement(_Loader.default, {
    active: loading,
    mask: true
  })))));
}

var clickOutsideConfig = {
  handleClickOutside: function handleClickOutside() {
    return OptionInputList.handleClickOutside;
  }
};
OptionInputList.defaultProps = {
  privateProps: {}
};

var _default = (0, _reactOnclickoutside.default)(OptionInputList, clickOutsideConfig);

exports.default = _default;