"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _debounce = _interopRequireDefault(require("lodash/debounce"));

var _MkSelect = _interopRequireDefault(require("../MkSelect"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

var _lodash = _interopRequireDefault(require("lodash"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Search = _input.default.Search;
var Option = _MkSelect.default.Option,
    OptGroup = _MkSelect.default.OptGroup;

var BankBranchInput = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(BankBranchInput, _Component);

  var _super = _createSuper(BankBranchInput);

  function BankBranchInput(props) {
    var _this;

    (0, _classCallCheck2.default)(this, BankBranchInput);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_PaymentAccountModal').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.onChange = function (value) {
      var onChange = _this.props.onChange;

      if (typeof onChange === 'function') {
        var showBranchNo = false;
        var item;

        if (value) {
          item = _this.state.branches.find(function (item) {
            return item.code === value.code;
          });
          if (item) showBranchNo = !!item.showBranchNo;
        }

        onChange(value, {
          props: {
            showBranchNo: showBranchNo,
            data: item
          }
        });
      }
    };

    _this.onMkChange = function (options) {
      _this.onChange(options.data);
    };

    _this.searchBranches = function (value) {
      var branches = value ? _this.branches.filter(function (item) {
        return item.name.indexOf(value) > -1;
      }) : (0, _toConsumableArray2.default)(_this.branches);
      if (value && branches.every(function (_ref) {
        var name = _ref.name;
        return name !== value;
      }) && _this.props.canAddBranch) branches.unshift({
        showBranchNo: true,
        code: value,
        name: "".concat(value)
      });

      _this.setState({
        branches: branches
      });
    };

    _this.state = {
      branches: [],
      // rc-form组件契约：接受value属性成为受控组件
      value: {
        code: props.value || '',
        name: props.bankBranchName || ''
      },
      t: _mkTranslate.default.noop()
    };
    _this.branches = [];
    _this.searchBranches = (0, _debounce.default)(_this.searchBranches, 800);
    _this.fetchBankBranches = _this.fetchBankBranches.bind((0, _assertThisInitialized2.default)(_this));

    _this.localeProcess();

    return _this;
  }

  (0, _createClass2.default)(BankBranchInput, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.fetchBankBranches();
    } // rc-form组件契约：接受value属性成为受控组件

  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var _this$props = this.props,
          cityCode = _this$props.cityCode,
          bankCode = _this$props.bankCode,
          value = _this$props.value;

      if (nextProps.value !== value) {
        var _value = nextProps.value;
        this.setState({
          value: _value
        });
      }

      if (cityCode !== nextProps.cityCode || bankCode !== nextProps.bankCode) {
        this.fetchBankBranches(_objectSpread(_objectSpread({}, nextProps), {}, {
          value: undefined
        }));
        this.setState({
          value: undefined
        });
        this.onChange();
      }
    }
  }, {
    key: "fetchBankBranches",
    value: function fetchBankBranches(params) {
      var _this2 = this;

      var _ref2 = params || this.props,
          cityCode = _ref2.cityCode,
          bankCode = _ref2.bankCode,
          value = _ref2.value,
          bankBranchName = _ref2.bankBranchName;

      var _this$props2 = this.props,
          fetchBankBranches = _this$props2.fetchBankBranches,
          showBranchNoChange = _this$props2.showBranchNoChange;

      if (!cityCode || !bankCode || typeof fetchBankBranches !== 'function') {
        this.branches = [];
        this.setState({
          branches: []
        });
        showBranchNoChange(!!value);
      } else {
        fetchBankBranches({
          cityCode: cityCode,
          bankCode: bankCode
        }).then(function (branches) {
          _this2.branches = (0, _toConsumableArray2.default)(branches); // 判断外部导入的支行是否在 branches 中，不存在要加进去，否则无法在 Select 中显示

          var isExist = _lodash.default.find(branches, {
            code: value
          });

          if (value && !isExist) {
            _this2.branches.unshift({
              code: value,
              name: bankBranchName
            });
          }

          _this2.setState({
            branches: _this2.branches
          }); // 判断所选分支行是否为自定义输入


          showBranchNoChange(value && !isExist);
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$state = this.state,
          branches = _this$state.branches,
          value = _this$state.value,
          t = _this$state.t;
      var _this$props3 = this.props,
          disabled = _this$props3.disabled,
          canAddBranch = _this$props3.canAddBranch,
          placeholder = _this$props3.placeholder;
      return /*#__PURE__*/_react.default.createElement(_MkSelect.default, {
        placeholder: placeholder,
        value: value || {},
        disabled: disabled,
        actionVisible: !disabled,
        onChange: this.onMkChange
      }, /*#__PURE__*/_react.default.createElement(OptGroup, {
        label: /*#__PURE__*/_react.default.createElement(Search, {
          type: "gray",
          placeholder: t('bankBranchInput.searchPlaceholder'),
          onChange: function onChange(e) {
            _this3.searchBranches(e.target.value);
          }
        })
      }), branches.map(function (city) {
        return /*#__PURE__*/_react.default.createElement(Option, {
          key: city.code,
          value: city.code,
          title: city.name,
          data: city
        }, city.name);
      }), !canAddBranch && branches && !branches.length && /*#__PURE__*/_react.default.createElement("div", {
        style: {
          height: '100px',
          display: 'flex',
          'align-items': 'center',
          'justify-content': 'center',
          color: '#999'
        }
      }, /*#__PURE__*/_react.default.createElement("span", null, t('bankBranchInput.noData'))), canAddBranch && /*#__PURE__*/_react.default.createElement("div", {
        key: "label",
        style: {
          textAlign: 'center',
          paddingBottom: 20
        }
      }, /*#__PURE__*/_react.default.createElement("p", {
        style: {
          color: '#999'
        }
      }, t('bankBranchInput.label')), /*#__PURE__*/_react.default.createElement("p", {
        className: 'branch-example'
      }, t('bankBranchInput.example'))));
    }
  }]);
  return BankBranchInput;
}(_react.Component);

var _default = BankBranchInput;
exports.default = _default;