"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/select/style/css");

var _select = _interopRequireDefault(require("maycur-antd/lib/select"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Option = _select.default.Option;

var BankInput = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(BankInput, _Component);

  var _super = _createSuper(BankInput);

  function BankInput(props) {
    var _this;

    (0, _classCallCheck2.default)(this, BankInput);
    _this = _super.call(this, props);

    _this.filterOption = function (inputValue, option) {
      console.log('j');
      var title = option.props.title;
      return (title.toLowerCase() || '').indexOf(inputValue.toLowerCase()) !== -1;
    };

    _this.state = {
      banks: props.banks || [],
      bankList: []
    };
    return _this;
  }

  (0, _createClass2.default)(BankInput, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var _this$props = this.props,
          banks = _this$props.banks,
          fetchBanks = _this$props.fetchBanks,
          area = _this$props.area;
      var bankList = this.state.bankList;

      if (_lodash.default.isEmpty(banks) && typeof fetchBanks === 'function') {
        fetchBanks().then(function (banks) {
          bankList = banks[area];

          _this2.setState({
            banks: banks,
            bankList: bankList
          });
        });
      } else {
        bankList = banks[area];
        this.setState({
          bankList: bankList
        });
      }
    }
  }, {
    key: "UNSAFE_componentWillUpdate",
    value: function UNSAFE_componentWillUpdate(nextProps) {
      var area = this.props.area;
      var bankList = this.state.bankList;

      if (nextProps.area !== area) {
        var _area = nextProps.area;
        var banks = this.state.banks;
        bankList = banks[_area];
        this.setState({
          bankList: bankList
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          disabled = _this$props2.disabled,
          value = _this$props2.value,
          needCountry = _this$props2.needCountry;
      var _this$state = this.state,
          bankList = _this$state.bankList,
          banks = _this$state.banks;

      var _banks = needCountry ? bankList : banks;

      if (!_lodash.default.find(_banks, {
        code: value
      })) {
        value = undefined;
      } // 未知类型的开户银行不可选择，只可通过接口生成


      return /*#__PURE__*/_react.default.createElement(_select.default, (0, _extends2.default)({}, this.props, {
        value: value,
        disabled: disabled,
        filterOption: this.filterOption,
        showSearch: true
      }), (_banks || []).map(function (bank) {
        return /*#__PURE__*/_react.default.createElement(Option, {
          key: bank.code,
          value: bank.code,
          title: bank.name,
          data: bank,
          disabled: bank.code === 'unknown'
        }, bank.name);
      }));
    }
  }]);
  return BankInput;
}(_react.Component);

var _default = BankInput;
exports.default = _default;