"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/select/style/css");

var _select2 = _interopRequireDefault(require("maycur-antd/lib/select"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Option = _select2.default.Option;

var CountryInput = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(CountryInput, _Component);

  var _super = _createSuper(CountryInput);

  function CountryInput(props) {
    var _this;

    (0, _classCallCheck2.default)(this, CountryInput);
    _this = _super.call(this, props);

    _this.filterOption = function (inputValue, option) {
      var title = option.props.title;
      return (title || '').indexOf(inputValue) !== -1;
    };

    _this.state = {
      countryList: props.countryList || []
    };
    _this.lang = localStorage.getItem('lang');
    return _this;
  }

  (0, _createClass2.default)(CountryInput, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var _this$props = this.props,
          countryList = _this$props.countryList,
          fetchCountryList = _this$props.fetchCountryList;

      if (_lodash.default.isEmpty(countryList) && typeof fetchCountryList === 'function') {
        fetchCountryList().then(function (countryList) {
          _this2.setState({
            countryList: countryList
          });
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var countryList = this.state.countryList;
      var _this$props2 = this.props,
          disabled = _this$props2.disabled,
          value = _this$props2.value;
      return /*#__PURE__*/_react.default.createElement(_select2.default, (0, _extends2.default)({}, this.props, {
        disabled: disabled,
        value: value,
        filterOption: this.filterOption,
        showSearch: true
      }), (countryList || []).map(function (country) {
        return /*#__PURE__*/_react.default.createElement(Option, {
          key: country.country,
          value: country.country,
          title: _this3.lang === 'zh' ? country.name : country.nameEn,
          data: country
        }, _this3.lang === 'zh' ? country.name : country.nameEn);
      }));
    }
  }]);
  return CountryInput;
}(_react.Component);

var _default = CountryInput;
exports.default = _default;