"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/input-number/style/css");

var _inputNumber = _interopRequireDefault(require("maycur-antd/lib/input-number"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

require("maycur-antd/lib/form/style/css");

var _form = _interopRequireDefault(require("maycur-antd/lib/form"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var MkNumberInput = function MkNumberInput(props) {
  var vertical = props.vertical,
      required = props.required,
      _onChange = props.onChange;
  var itemClass = (0, _classnames.default)({
    'mk-form-control': true,
    'mk-form-control-vertical': vertical,
    'mk-required': required
  });
  var FormItem = _form.default.Item;
  return /*#__PURE__*/_react.default.createElement(FormItem, {
    label: props.label,
    className: itemClass
  }, /*#__PURE__*/_react.default.createElement(_inputNumber.default, (0, _extends2.default)({}, props, {
    onChange: function onChange(value) {
      var reg = /^-?(0|[1-9][0-9]*)(\.[0-9]*)?$/;

      if (!isNaN(value) && reg.test(value) || value === '' || value === '-') {
        //value1统一为字符串
        _onChange(value + '');
      }
    },
    precision: props.precision
  })));
};

MkNumberInput.defaultProps = {
  precision: 2
};
var _default = MkNumberInput;
exports.default = _default;