"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

require("maycur-antd/lib/select/style/css");

var _select = _interopRequireDefault(require("maycur-antd/lib/select"));

require("maycur-antd/lib/form/style/css");

var _form = _interopRequireDefault(require("maycur-antd/lib/form"));

var _react = _interopRequireDefault(require("react"));

var _excluded = ["label", "options", "value", "onChange"];

var MkSelect = function MkSelect(props) {
  var FormItem = _form.default.Item,
      Option = _select.default.Option;
  var label = props.label,
      options = props.options,
      value = props.value,
      onChange = props.onChange,
      restProps = (0, _objectWithoutProperties2.default)(props, _excluded);
  /* if (value && !_.find(options, { value: value })) {
      onChange('');
  } */

  return /*#__PURE__*/_react.default.createElement(FormItem, {
    label: label,
    className: "mk-form-control"
  }, /*#__PURE__*/_react.default.createElement(_select.default, (0, _extends2.default)({
    showSearch: true,
    optionFilterProp: "children",
    filterOption: function filterOption(input, option) {
      return option.props.children.toLowerCase().indexOf(input.toLowerCase()) >= 0;
    },
    value: value,
    onChange: onChange
  }, restProps), options && options.map(function (option) {
    return /*#__PURE__*/_react.default.createElement(Option, {
      value: option.value,
      key: option.value
    }, option.name);
  })));
};

var _default = MkSelect;
exports.default = _default;