"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _TranslateHook = _interopRequireDefault(require("./TranslateHook"));

var _usePrevious = _interopRequireDefault(require("./usePrevious"));

var _useCrossPage = _interopRequireDefault(require("./useCrossPage"));

var _useLocalStorageState = _interopRequireDefault(require("./useLocalStorageState"));

/*
 * @Description: file content
 * @Author: RongWei
 * @Date: 2020-06-23 09:39:29
 * @LastEditors: Jiangang Lu
 * @LastEditTime: 2021-01-15 16:59:20
 */
var _default = {
  TranslateHook: _TranslateHook.default,
  usePrevious: _usePrevious.default,
  useCrossPage: _useCrossPage.default,
  useLocalStorageState: _useLocalStorageState.default
};
exports.default = _default;