"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/*
 * @Description: 
 * @Author: qmm
 * @Date: 2020-02-25 17:42:33
 * @LastEditors: Jiangang Lu
 * @LastEditTime: 2020-12-22 11:47:13
 */
var _default = {
  "bankBranchInput": {
    "searchPlaceholder": "请输入关键字搜索",
    "label": "如果未找到分支行，请按示例将分支行名称补充完整后，直接添加",
    "example": "示例：中国工商银行股份有限公司杭州白马支行 ",
    "noData": "暂无相关数据"
  },
  "cityInput": {
    "placeholder": "请输入关键字搜索",
    "notFoundContent": "无匹配结果"
  },
  "editPaymentForm": {
    "bank": "银行账户",
    "alipay": "支付宝",
    "cash": "现金",
    "other": "其他",
    "errMsg": "表单验证时发现一些问题，请先修正再继续操作",
    "p1": "部分农村信用社股份制改革为农村商业银行、农村合作银行后，仍归类在“农村信用社”下；",
    "p2": "在农村商业银行、农村合作银行中找不到所需银行时，可尝试在“农村信用社”下查找。",
    "bankLabel": "开户银行",
    "paymentType": "账户类型",
    "paymentTypeMsg": "账户类型不能为空",
    "bankAcctName": "户名",
    "bankAcctNameMsg": "名称不能为空",
    "bankAcctNameMax": "最多输入150个字符",
    "bankAcctNamePlaceholder": "请输入姓名",
    "cashAcctName": "户名",
    "cashAcctNamePlaceholder": "现金账户使用名称",
    "bankCodeMsg": "开户银行不能为空",
    "bankCodePlaceholder": "选择开户银行",
    "bankAcctNumber": "账号",
    "bankAcctNumberMsg": "账号不能为空",
    "bankAcctNumberPlaceholder": "输入账号",
    "abroadBankAddress": "开户银行地址",
    "abroadBankAddressPlaceholder": "输入开户银行地址",
    "abroadPayeeAddress": "收款人地址",
    "abroadPayeeAddressPlaceholder": "输入收款人地址",
    "swiftCode": "SWIFT Code",
    "swiftCodePlaceholder": "输入SWIFT Code",
    "country": "国家和地区",
    "bankLocation": "开户省市",
    "bankLocationMsg": "开户省市不能为空",
    "bankLocationPlaceholder": "选择开户省市",
    "bankBranchBizCode": "分支行",
    "bankBranchBizCodeMsg": "分支行不能为空",
    "bankBranchNoMsg": "支付联行号不能为空",
    "bankBranchBizCodePlaceholder": "选择分支行",
    "bankQuery": "如何获取联行号信息？",
    "bankMsg": "公司在跨行支付时可能需要您的联行号信息，请询问银行客服，或使用以下网站的联行号查询工具在线查询：",
    "bank1": "河北银行",
    "bank2": "浙商银行",
    "bank3": "建设银行",
    "bank4": "中原银行",
    "bankBranchNo": "支付联行号",
    "bankBranchNoPlaceholder": "如需跨行转账，请填写该信息",
    "agencyBizCode": "代理业务号",
    "agencyBizCodePlaceholder": "请输入对私批量支付网银格式中的代理业务号",
    "certType": "证件类型",
    "certTypeMsg": "证件类型不能为空",
    "certTypeMax": "最多输入40个字符",
    "certTypePlaceholder": "选择证件类型",
    "identification": "证件号",
    "identificationMsg": "证件号不能为空",
    "identificationPlaceholder": "输入证件号",
    "bankAcctNameAli": "户名",
    "bankAcctNameAliMsg": "姓名不能为空",
    "bankAcctNameAliPlaceholder": "输入支付宝账户名称",
    "bankAcctNumberAli": "账号",
    "bankAcctNumberAliMsg": "账号不能为空",
    "bankAcctNumberAliPlaceholder": "输入支付宝账号",
    "bankAcctNameOther": "户名",
    "bankAcctNameOtherMsg": "户名不能为空",
    "bankAcctNameOtherPlaceholder": "输入其他账户名称",
    "bankAcctNumberOther": "账号",
    "bankAcctNumberOtherPlaceholder": "输入账号",
    "accountBizCode": "账户编码",
    "accountBizCodePlaceholder": "请输入账户编码（留空自动生成）",
    "description": "备注",
    "descriptionPlaceholder": "备注该账户，以示区分",
    "active": "启用",
    "bankAutomaticEnable": "银行自动扣款",
    "bankAutomaticEnableMsg": "此银行卡会进行银行自动扣款业务",
    "bankAutomaticEnableTip": "银行自动扣款通常发生于公司和一些机构签署的自动扣款协议，如工会经费等；勾选后，此账户可以用于支付场景中“从公司银行账户自动扣款”的支付执行方式",
    "accountScope": "账户适用范围",
    "shouldLimitEntity": "限定以下公司抬头可用",
    "currencyLabel": "收款币种"
  },
  "warnMsg": "表单验证时发现一些问题，请修正后再提交",
  "alertMsg": "如需跨行转账，请维护好银行卡分支行信息。"
};
exports.default = _default;