"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _jsCookie = _interopRequireDefault(require("js-cookie"));

var defaultExpireDays = 7;
var cookieService = {
  set: function set(key, value, config) {
    var cookieOptions = config ? config : {
      expires: defaultExpireDays
    };

    _jsCookie.default.set(key, JSON.stringify(value), cookieOptions);
  },
  get: function get(key) {
    return _jsCookie.default.getJSON(key);
  },
  remove: function remove(key) {
    _jsCookie.default.remove(key);
  }
};
var _default = cookieService;
exports.default = _default;