"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = acos;

var _isnumber = _interopRequireDefault(require("./isnumber"));

var _error = require("./error");

// Copyright 2015-2018 FormBucket LLC
// ACOS computes the inverse cosine of a number
function acos(value) {
  // Return `#VALUE!` if not number
  if (!(0, _isnumber.default)(value)) {
    return _error.ERRORTYPES.value;
  } // Use built-in Math.acos


  return Math.acos(value);
}