"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = interpolate;

var _interpolator = _interopRequireDefault(require("./interpolator"));

// Compute a number a percentage distance between a and b.
// Usage: interpolate(0, 100, 0.5) == 50
// Credit: https://github.com/sveltejs/svelte/blob/master/src/motion/tweened.ts
function interpolate(a, b, percentage) {
  return (0, _interpolator.default)(a, b)(percentage);
}