"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = select;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _isarray = _interopRequireDefault(require("./isarray"));

var _reduce = _interopRequireDefault(require("./reduce"));

// Copyright 2015-2018 FormBucket LLC
// SELECT fields from o
function select(fields, o) {
  // non-json
  if (!o || "object" != (0, _typeof2.default)(o)) return; // check for fields

  if (!fields) return; // split

  if ("string" == typeof fields) fields = fields.split(/ *, */); // fields array

  if ((0, _isarray.default)(o)) {
    return o.map(function (obj) {
      return (0, _reduce.default)(fields, function (ret, key) {
        ret[key] = obj[key];
        return ret;
      }, {});
    });
    return;
  } // fields o


  return (0, _reduce.default)(fields, function (ret, key) {
    ret[key] = o[key];
    return ret;
  }, {});
}