"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/alert/style/css");

var _alert = _interopRequireDefault(require("maycur-antd/lib/alert"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _mkSelect = _interopRequireDefault(require("../../Process/mkSelect"));

var _departmentPicker = _interopRequireDefault(require("../../Process/departmentPicker"));

var C = _interopRequireWildcard(require("../constants"));

var _constants2 = _interopRequireDefault(require("../../utils/constants"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var CoverUser = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(CoverUser, _Component);

  var _super = _createSuper(CoverUser);

  function CoverUser(props) {
    var _this;

    (0, _classCallCheck2.default)(this, CoverUser);
    _this = _super.call(this, props);

    _this.onDepartmentChange = function (value) {
      _this.props.handleTempChange(value, 'code');
    };

    _this.t = _mkTranslate.default.getLocalNs('MK_ConditionSetting', (0, _assertThisInitialized2.default)(_this));
    return _this;
  }

  (0, _createClass2.default)(CoverUser, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          selectedNode = _this$props.selectedNode,
          handleOpChange = _this$props.handleOpChange,
          fieldConfig = _this$props.fieldConfig,
          ModalManager = _this$props.ModalManager,
          apis = _this$props.apis,
          initData = _this$props.initData;

      var _ref = fieldConfig || {},
          opTypes = _ref.opTypes;

      console.log('this.props', this.props);
      return /*#__PURE__*/_react.default.createElement("div", null, selectedNode.field === 'COVER_USER_CODE_INCLUDE_ALLOCATIONS' && /*#__PURE__*/_react.default.createElement(_alert.default, {
        type: "info",
        message: this.t('EgAllocates'),
        banner: true
      }), selectedNode.valueFrom === 'CUSTOM' && /*#__PURE__*/_react.default.createElement("div", {
        className: "popover-selected-item-wrap"
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "label-obj"
      }, this.t('object')), /*#__PURE__*/_react.default.createElement(_departmentPicker.default, {
        scope: _constants2.default.DEPARTMENT_PICKER.SCOPE_STAFF,
        isShowUserGroup: true,
        onChange: this.onDepartmentChange,
        value: selectedNode.temp && selectedNode.temp.value1,
        ModalManager: ModalManager,
        apis: apis,
        initData: initData
      })));
    }
  }]);
  return CoverUser;
}(_react.Component);

CoverUser.defaultProps = {
  fieldConfig: {
    opTypes: [{
      name: C.WORD_MAP[C.IN],
      value: C.IN
    }, {
      name: C.WORD_MAP[C.NOT_IN],
      value: C.NOT_IN
    }]
  }
};
var _default = CoverUser;
exports.default = _default;