### 自定义标签下拉框

## 何时使用

自定义下拉框选中内容，自定义选中内容的颜色标签。

## API

自定义标签下拉框的属性说明如下：

| 参数 | 说明 | 类型 | 默认值 |
| --- | --- | --- | --- |
| options     | 数据化配置选项内容 | { label, value, color, default }[]   | - |
| placeholder | 选择框默认文本    ｜ string                               | - |
| value       | 指定当前选中的条目 | string[] \| number[] \| LabeledValue[] | - |
| onChange    | 选中 option，或 input 的 value 变化时，调用此函数 |  function (value, option: Option) | - |

Option Props

| 参数 | 说明 | 类型 | 默认值 |
| --- | --- | --- | --- |
| label | 选中该 Option 后，Select 的 label | string | - |
| value | 默认根据此属性值进行筛选 | string \| number | - |
| color | label 圆点颜色设置     | string | - |
| default | 是否为系统预计       | boolean | - | 



