"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/list/style/css");

var _list = _interopRequireDefault(require("maycur-antd/lib/list"));

require("maycur-antd/lib/message/style/css");

var _message2 = _interopRequireDefault(require("maycur-antd/lib/message"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _Empty = _interopRequireDefault(require("../../Empty"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _constants = _interopRequireDefault(require("../../utils/constants"));

var _Loader = _interopRequireDefault(require("../../Loader"));

var _lodash = _interopRequireDefault(require("lodash"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;
var DEPARTMENT_PICKER = _constants.default.DEPARTMENT_PICKER;

var DepartmentList = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(DepartmentList, _Component);

  var _super = _createSuper(DepartmentList);

  function DepartmentList(props) {
    var _this;

    (0, _classCallCheck2.default)(this, DepartmentList);
    _this = _super.call(this, props);

    _this.localeProcess = function (ns, key) {
      _mkTranslate.default.getNameSpace(ns).then(function (t) {
        _this.setState((0, _defineProperty2.default)({}, key, t));
      });
    };

    _this.preventCheckAllCondition = function () {
      var _this$props = _this.props,
          maxSelectLength = _this$props.maxSelectLength,
          scope = _this$props.scope;
      var _this$state = _this.state,
          sourceList = _this$state.sourceList,
          selectList = _this$state.selectList; // 根据要选择的类型取出当前列表下所有该类型的数据

      if (scope === 'DEPARTMENT' || scope === 'STAFF') {
        sourceList = _lodash.default.filter(sourceList, {
          type: scope
        });
      } // sourceList = _.filter(sourceList, { type: DEPARTMENT_PICKER.DEPARTMENT });


      var common = _lodash.default.intersectionWith(sourceList, selectList, _utils.default.bizEquals);

      return sourceList.length > common.length + (maxSelectLength - selectList.length) && maxSelectLength > 0;
    };

    _this.toggleAll = function () {
      var _this$props2 = _this.props,
          scope = _this$props2.scope,
          includeChildDept = _this$props2.includeChildDept;
      var _this$state2 = _this.state,
          sourceList = _this$state2.sourceList,
          allSelected = _this$state2.allSelected;

      var _sourceList = _lodash.default.map(sourceList, function (item) {
        return _objectSpread(_objectSpread({}, item), {}, {
          includeChildDept: includeChildDept
        });
      });

      if (scope === DEPARTMENT_PICKER.SCOPE_STAFF) {
        _sourceList = _lodash.default.filter(_sourceList, {
          type: DEPARTMENT_PICKER.STAFF
        });
      }

      if (_this.preventCheckAllCondition()) {
        return;
      }

      _this.setState({
        selectList: _sourceList,
        allSelected: !allSelected
      });

      _this.output(_sourceList, false);
    };

    _this.toggleItem = function (e, item) {
      if (item.disableSelected) return;
      var _this$props3 = _this.props,
          scope = _this$props3.scope,
          maxSelectLength = _this$props3.maxSelectLength;
      var _this$state3 = _this.state,
          selectList = _this$state3.selectList,
          t = _this$state3.t; // if (scope === DEPARTMENT_PICKER.SCOPE_STAFF &&
      //     item.type === DEPARTMENT_PICKER.DEPARTMENT) {
      //     e.stopPropagation();
      //     return;
      // }

      if (scope === DEPARTMENT_PICKER.SCOPE_STAFF && item.type === DEPARTMENT_PICKER.DEPARTMENT) {
        _this.drillDown(item);

        return;
      }
      /** 单选 */


      if (!maxSelectLength || maxSelectLength === 1) {
        selectList = [item];
      } else {
        var idx = _lodash.default.findIndex(selectList, {
          code: item.code
        });

        if (idx !== -1) {
          selectList.splice(idx, 1);
        } else {
          if (selectList.length < maxSelectLength || maxSelectLength <= 0) {
            selectList.push(item);
          } else {
            _message2.default.warning(t('departmentList.warningText', {
              n: maxSelectLength
            }));
          }
        }
      }

      _this.setState({
        selectList: selectList
      });

      _this.output(selectList, true);

      setTimeout(_this.checkAllFlag);
    };

    _this.checkAllFlag = function () {
      var scope = _this.props.scope;
      var _this$state4 = _this.state,
          sourceList = _this$state4.sourceList,
          selectList = _this$state4.selectList;
      var targetList;

      if (scope === DEPARTMENT_PICKER.SCOPE_STAFF) {
        targetList = _lodash.default.filter(sourceList, {
          type: DEPARTMENT_PICKER.STAFF
        });
      } else {
        targetList = sourceList;
      }

      var allSelected = targetList.length && !_lodash.default.find(targetList, function (dep) {
        return !_lodash.default.find(selectList, {
          code: dep.code
        });
      });

      _this.setState({
        allSelected: allSelected
      });
    };

    _this.drillDown = function (item) {
      var onDrillDown = _this.props.onDrillDown;

      if (typeof onDrillDown === 'function') {
        onDrillDown(item);
      }
    };

    _this.output = function (selectList, itemSelected) {
      var onOutput = _this.props.onOutput;
      var _this$state5 = _this.state,
          sourceList = _this$state5.sourceList,
          allSelected = _this$state5.allSelected;
      var result = {
        added: selectList,
        removed: _lodash.default.differenceWith(sourceList, selectList, function (o1, o2) {
          return o1.code === o2.code;
        }),
        allSelected: allSelected,
        itemSelected: itemSelected
      };

      if (typeof onOutput === 'function') {
        onOutput(result);
      }
    };

    _this.state = {
      sourceList: props.sourceList || [],
      selectList: props.selectList || [],
      allSelected: false,
      t: _mkTranslate.default.noop(),
      gt: _mkTranslate.default.noop()
    };

    _this.localeProcess('MK_DepartmentSelectionModal', 't');

    _this.localeProcess('MK_Global', 'gt');

    return _this;
  }

  (0, _createClass2.default)(DepartmentList, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var sourceList = nextProps.sourceList,
          selectList = nextProps.selectList;

      if (sourceList) {
        this.setState({
          sourceList: sourceList
        });
      }

      if (selectList) {
        this.setState({
          selectList: selectList
        });
      }

      setTimeout(this.checkAllFlag);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.checkAllFlag();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          canDrillDown = _this$props4.canDrillDown,
          loading = _this$props4.loading,
          scope = _this$props4.scope,
          maxSelectLength = _this$props4.maxSelectLength,
          renderAddition = _this$props4.renderAddition,
          includeChildDept = _this$props4.includeChildDept;
      var _this$state6 = this.state,
          sourceList = _this$state6.sourceList,
          selectList = _this$state6.selectList,
          allSelected = _this$state6.allSelected,
          className = _this$state6.className,
          gt = _this$state6.gt,
          t = _this$state6.t;
      var containerClass = (0, _classnames.default)("".concat(prefix, "-department-picker-list"), className);
      var selectClass = (0, _classnames.default)('select-all-btn', {
        'disabled': this.preventCheckAllCondition()
      });
      var allSelectedClass = (0, _classnames.default)({
        'selected': allSelected
      });
      return /*#__PURE__*/_react.default.createElement("div", {
        className: containerClass
      }, Number(maxSelectLength) === 1 ? null : /*#__PURE__*/_react.default.createElement("div", {
        className: 'opt-bar'
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: selectClass,
        onClick: this.toggleAll
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: allSelectedClass + " fm fm-check"
      }), /*#__PURE__*/_react.default.createElement("span", null, allSelected ? gt('MK_Global:selectInvert') : gt('MK_Global:selectAll')))), sourceList && sourceList.length > 0 ? /*#__PURE__*/_react.default.createElement(_list.default, {
        size: "small",
        loading: loading,
        dataSource: sourceList,
        renderItem: function renderItem(item) {
          var selected = _lodash.default.findIndex(selectList, {
            code: item.code
          }) !== -1;
          var fullName;

          if (item.fullName && typeof item.fullName === 'string') {
            if (item.fullName.indexOf(',') > -1) {
              fullName = item.fullName.split(',').join('/');
            } else if (item.fullName.indexOf('\\') > -1) {
              fullName = item.fullName.split('\\').join('/');
            } else {
              fullName = item.fullName;
            }
          } else {
            if (Array.isArray(item.fullName)) {
              fullName = item.fullName.join('/');
            }
          }

          var itemClass = (0, _classnames.default)({
            selected: selected,
            notick: scope === DEPARTMENT_PICKER.SCOPE_STAFF && item.type === DEPARTMENT_PICKER.DEPARTMENT
          }); // NOTE: 承担部门 && 不可选且无下级时标题置灰

          var nameClass = (0, _classnames.default)({
            'name-wrapper': item.disableSelected && !(item.type === DEPARTMENT_PICKER.DEPARTMENT && item.hasChildren && (item.hasDepartments && scope === DEPARTMENT_PICKER.DEPARTMENT || scope !== DEPARTMENT_PICKER.DEPARTMENT) && canDrillDown)
          });
          return (// 如果是职工并且是根节点的话,不渲染
            scope === DEPARTMENT_PICKER.SCOPE_STAFF && item.root ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null) : /*#__PURE__*/_react.default.createElement(_list.default.Item, {
              className: itemClass,
              key: item.code,
              onClick: function onClick(e) {
                var _item = _objectSpread(_objectSpread({}, item), {}, {
                  includeChildDept: includeChildDept
                });

                _this2.toggleItem(e, _item);
              }
            }, /*#__PURE__*/_react.default.createElement("div", {
              className: "item-content ".concat(item.root ? 'item-root' : '')
            }, item.disableSelected ? /*#__PURE__*/_react.default.createElement("span", {
              className: "fm fm-radio disable"
            }) : Number(maxSelectLength) === 1 ? selected ? /*#__PURE__*/_react.default.createElement("span", {
              className: "fm fm-circle-check-o"
            }) : /*#__PURE__*/_react.default.createElement("span", {
              className: "fm fm-radio"
            }) : /*#__PURE__*/_react.default.createElement("span", {
              className: "fm fm-check"
            }), item.type === DEPARTMENT_PICKER.STAFF ? /*#__PURE__*/_react.default.createElement("span", {
              className: "fm fm-employee"
            }) : /*#__PURE__*/_react.default.createElement("span", {
              className: "fm fm-cube"
            }), /*#__PURE__*/_react.default.createElement("div", {
              className: nameClass,
              style: {
                overflow: 'hidden'
              }
            }, /*#__PURE__*/_react.default.createElement("span", {
              className: "name"
            }, item.name, renderAddition && renderAddition(item)), fullName ? /*#__PURE__*/_react.default.createElement("div", {
              className: "fullname"
            }, fullName) : null), item.userEmployeeId && /*#__PURE__*/_react.default.createElement("span", {
              className: "user-info"
            }, item.userEmployeeId)), item.type === DEPARTMENT_PICKER.DEPARTMENT && item.hasChildren && (item.hasDepartments && scope === DEPARTMENT_PICKER.DEPARTMENT || scope !== DEPARTMENT_PICKER.DEPARTMENT) && canDrillDown ? /*#__PURE__*/_react.default.createElement("span", {
              className: 'fm fm-organization',
              onClick: function onClick(e) {
                e.stopPropagation();

                _this2.drillDown(item);
              }
            }, t('departmentList.subordinate')) : null)
          );
        }
      }) : loading ? /*#__PURE__*/_react.default.createElement(_Loader.default, {
        active: loading,
        embed: true
      }) : /*#__PURE__*/_react.default.createElement(_Empty.default, null));
    }
  }]);
  return DepartmentList;
}(_react.Component);

DepartmentList.defaultProps = {
  canDrillDown: true
};
var _default = DepartmentList;
exports.default = _default;