"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/list/style/css");

var _list = _interopRequireDefault(require("maycur-antd/lib/list"));

require("maycur-antd/lib/tag/style/css");

var _tag = _interopRequireDefault(require("maycur-antd/lib/tag"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/collapse/style/css");

var _collapse = _interopRequireDefault(require("maycur-antd/lib/collapse"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Panel = _collapse.default.Panel;

var ExpenseTypeList = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(ExpenseTypeList, _Component);

  var _super = _createSuper(ExpenseTypeList);

  function ExpenseTypeList(props) {
    var _this;

    (0, _classCallCheck2.default)(this, ExpenseTypeList);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_ExpenseTypeSelectionModal').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.state = {
      sourceList: props.sourceList || [],
      selectList: props.selectList || [],
      allSelected: false,
      allExpanded: true,
      t: _mkTranslate.default.noop()
    };
    _this.toggleAll = _this.toggleAll.bind((0, _assertThisInitialized2.default)(_this));
    _this.toggleItem = _this.toggleItem.bind((0, _assertThisInitialized2.default)(_this));
    _this.checkAllFlag = _this.checkAllFlag.bind((0, _assertThisInitialized2.default)(_this));
    _this.output = _this.output.bind((0, _assertThisInitialized2.default)(_this));
    _this.preCheck = _this.preCheck.bind((0, _assertThisInitialized2.default)(_this));
    _this.addAllFor = _this.addAllFor.bind((0, _assertThisInitialized2.default)(_this));

    _this.localeProcess();

    return _this;
  }

  (0, _createClass2.default)(ExpenseTypeList, [{
    key: "toggleAll",
    value: function toggleAll() {
      var _this$state = this.state,
          sourceList = _this$state.sourceList,
          allSelected = _this$state.allSelected;
      var selectList;

      if (allSelected) {
        selectList = [];
      } else {
        selectList = _lodash.default.flatten(_lodash.default.map(sourceList, function (group) {
          return group.data || [];
        }));
      }

      if (this.preCheck(selectList)) {
        this.setState({
          selectList: selectList,
          allSelected: !allSelected
        });
        this.output(selectList);
      }
    }
  }, {
    key: "toggleItem",
    value: function toggleItem(item) {
      if (!item.enabled || this.isDisabled(item)) return;

      var selectList = _lodash.default.clone(this.state.selectList);

      var idx = _lodash.default.findIndex(selectList, {
        expenseTypeCode: item.expenseTypeCode
      });

      if (idx !== -1) {
        selectList.splice(idx, 1);
      } else {
        selectList.push(item);
      }

      if (this.preCheck(selectList)) {
        this.setState({
          selectList: selectList
        });
        this.output(selectList);
        setTimeout(this.checkAllFlag);
      }
    }
  }, {
    key: "checkAllFlag",
    value: function checkAllFlag() {
      var _this$state2 = this.state,
          sourceList = _this$state2.sourceList,
          selectList = _this$state2.selectList,
          allSelected;
      sourceList = _lodash.default.flatten(_lodash.default.map(sourceList, function (group) {
        return group.data || [];
      }));
      allSelected = sourceList.length && !_lodash.default.find(sourceList, function (item) {
        return !_lodash.default.find(selectList, {
          expenseTypeCode: item.expenseTypeCode
        });
      });
      this.setState({
        allSelected: allSelected
      });
    }
  }, {
    key: "addAllFor",
    value: function addAllFor(group) {
      var targetList = _lodash.default.flatten(group.data || []),
          notSelect;

      var selectList = this.state.selectList;
      notSelect = _lodash.default.filter(group.data || [], function (item) {
        return !_lodash.default.find(selectList, function (o) {
          return o.expenseTypeCode === item.expenseTypeCode;
        });
      });

      if (notSelect.length) {
        selectList = _lodash.default.unionWith(selectList, targetList, function (o1, o2) {
          return o1.expenseTypeCode === o2.expenseTypeCode;
        });
      } else {
        selectList = _lodash.default.differenceWith(selectList, targetList, function (o1, o2) {
          return o1.expenseTypeCode === o2.expenseTypeCode;
        });
      }

      if (this.preCheck(selectList)) {
        this.setState({
          selectList: selectList
        });
        this.output(selectList);
        setTimeout(this.checkAllFlag);
      }
    }
  }, {
    key: "output",
    value: function output(selectList) {
      var onOutput = this.props.onOutput;

      if (typeof onOutput === 'function') {
        onOutput(selectList);
      }
    }
  }, {
    key: "preCheck",
    value: function preCheck(selectList) {
      var onPreCheck = this.props.onPreCheck;

      if (typeof onPreCheck === 'function') {
        return onPreCheck(selectList);
      } else {
        return true;
      }
    }
  }, {
    key: "isDisabled",
    value: function isDisabled(item) {
      var disabledValues = this.props.disabledValues;
      return !_lodash.default.isEmpty(disabledValues) && disabledValues.includes(item.expenseTypeCode);
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var sourceList = nextProps.sourceList,
          selectList = nextProps.selectList;

      if (sourceList) {
        this.setState({
          sourceList: sourceList
        });
      }

      if (selectList) {
        this.setState({
          selectList: selectList
        });
      }

      setTimeout(this.checkAllFlag);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.checkAllFlag();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state3 = this.state,
          sourceList = _this$state3.sourceList,
          selectList = _this$state3.selectList,
          allSelected = _this$state3.allSelected,
          className = _this$state3.className,
          t = _this$state3.t;
      var loading = this.props.loading;
      var containerClass = (0, _classnames.default)('expense-type-list', className);
      var allSelectedClass = (0, _classnames.default)({
        selected: allSelected
      });
      return /*#__PURE__*/_react.default.createElement("div", {
        className: containerClass
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'opt-bar'
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'select-all-btn',
        onClick: this.toggleAll
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: allSelectedClass + ' fm fm-check'
      }), /*#__PURE__*/_react.default.createElement("span", null, allSelected ? t('selectInvert') : t('selectAll'))), /*#__PURE__*/_react.default.createElement("span", {
        className: 'flex-1'
      })), /*#__PURE__*/_react.default.createElement(_list.default, {
        size: "small",
        loading: loading,
        dataSource: sourceList,
        renderItem: function renderItem(group) {
          var children = group.data || [];

          var selectChildren = _lodash.default.filter(children, function (item) {
            return _lodash.default.find(selectList, function (o) {
              return o.expenseTypeCode === item.expenseTypeCode;
            });
          }),
              allSelect = false;

          if (selectChildren.length && selectChildren.length === children.length) {
            allSelect = true;
          }

          return /*#__PURE__*/_react.default.createElement(_collapse.default, {
            defaultActiveKey: group.expenseTypeCode,
            key: group.expenseTypeCode,
            expandIconPosition: "right"
          }, /*#__PURE__*/_react.default.createElement(Panel, {
            key: group.expenseTypeCode,
            header: /*#__PURE__*/_react.default.createElement("div", {
              className: 'group-header'
            }, /*#__PURE__*/_react.default.createElement("span", {
              className: 'fm fm-check' + (allSelect ? ' selected' : ''),
              onClick: function onClick(e) {
                e.stopPropagation();

                _this2.addAllFor(group);
              }
            }), /*#__PURE__*/_react.default.createElement("span", {
              className: 'label'
            }, group.expenseTypeName)),
            className: 'group'
          }, group.data.map(function (item) {
            var selected = _lodash.default.findIndex(selectList, {
              expenseTypeCode: item.expenseTypeCode
            }) !== -1;
            var itemClass = (0, _classnames.default)({
              selected: selected,
              disabled: !item.enabled || _this2.isDisabled(item)
            });
            return /*#__PURE__*/_react.default.createElement(_list.default.Item, {
              className: itemClass,
              key: item.expenseTypeCode,
              onClick: function onClick() {
                _this2.toggleItem(item);
              }
            }, /*#__PURE__*/_react.default.createElement("span", {
              className: 'fm fm-check'
            }), /*#__PURE__*/_react.default.createElement("span", {
              className: 'item-name'
            }, /*#__PURE__*/_react.default.createElement("span", {
              className: 'fm fm-feetype-' + (item.iconCode || 'empty')
            }), /*#__PURE__*/_react.default.createElement("span", null, item.expenseTypeName)), _this2.isDisabled(item) && /*#__PURE__*/_react.default.createElement(_tag.default, {
              style: {
                marginLeft: 5
              }
            }, "\u5DF2\u914D\u7F6E\u89C4\u5219"));
          })));
        }
      }));
    }
  }]);
  return ExpenseTypeList;
}(_react.Component);

var _default = ExpenseTypeList;
exports.default = _default;