"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _FormChef = _interopRequireDefault(require("../FormChef"));

var _FormFields = _interopRequireDefault(require("../../FormFields"));

var _FormFood = _interopRequireDefault(require("../../WebFormFood/FormFood"));

var _FormDish = _interopRequireDefault(require("../../FormDish/FormDish"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var InputField = _FormFields.default.InputField,
    MoneyField = _FormFields.default.MoneyField,
    NumberField = _FormFields.default.NumberField;
var fieldMaps = {
  NumberField: NumberField,
  SingleTextInput: InputField,
  AmountInput: MoneyField
};

var DemoFormChef = function DemoFormChef(option) {
  return function (WrappedComponent) {
    var FieldFood = (0, _FormDish.default)(_FormFood.default, {
      fieldMaps: fieldMaps,
      specialFields: ['InvoiceInput', 'AllocationInput', 'ReceiptCrossInput', 'ExpenseListInput', 'DescText', 'ApplicationExpenseListInput', 'TableInput', 'AccountInput'],
      complexFields: ['AttachInput', 'ApplicationDetailListInput']
    });
    return (0, _FormChef.default)(_objectSpread(_objectSpread({}, option), {}, {
      FormDish: FieldFood
    }))(WrappedComponent);
  };
};

var _default = DemoFormChef;
exports.default = _default;