"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/modal/style/css");

var _modal = _interopRequireDefault(require("maycur-antd/lib/modal"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

require("maycur-antd/lib/tabs/style/css");

var _tabs = _interopRequireDefault(require("maycur-antd/lib/tabs"));

require("maycur-antd/lib/button/style/css");

var _button = _interopRequireDefault(require("maycur-antd/lib/button"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

require("maycur-antd/lib/tooltip/style/css");

var _tooltip = _interopRequireDefault(require("maycur-antd/lib/tooltip"));

require("maycur-antd/lib/radio/style/css");

var _radio = _interopRequireDefault(require("maycur-antd/lib/radio"));

require("maycur-antd/lib/checkbox/style/css");

var _checkbox = _interopRequireDefault(require("maycur-antd/lib/checkbox"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/input/style/css");

var _input2 = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _Loader = _interopRequireDefault(require("../../Loader"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _i18next = _interopRequireDefault(require("i18next"));

var _reactI18next = require("react-i18next");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;
var Search = _input2.default.Search;

var StuffSelectionModal = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(StuffSelectionModal, _Component);

  var _super = _createSuper(StuffSelectionModal);

  function StuffSelectionModal(_props) {
    var _this;

    (0, _classCallCheck2.default)(this, StuffSelectionModal);
    _this = _super.call(this, _props);

    _this.filterDataSource = function (dataSource) {
      var _values = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

      var active = arguments.length > 2 ? arguments[2] : undefined;

      if (dataSource instanceof Array) {
        return _this.freshDataSource(dataSource, _values).dataSource;
      } else if (dataSource instanceof Object) {
        // 如果数据来源是一个对象: { 0: { title: '', data: [] }, ...}
        // 取第${active}个dataSource,0开始
        var _data = dataSource[active] ? dataSource[active].data : [];

        return _this.freshDataSource(_data, _values).dataSource;
      }
    };

    _this.filterOutput = function (dataSource) {
      var values = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

      if (dataSource instanceof Array) {
        return _this.freshDataSource(dataSource, values).output;
      } else if (dataSource instanceof Object) {
        // 如果数据来源是一个对象: { 0: { title: '', data: [] }, ...}
        var _data = [];
        Object.keys(dataSource).forEach(function (key) {
          _data = _data.concat(dataSource[key].data);
        });
        return _this.freshDataSource(_data, values).output;
      }
    };

    _this.freshDataSource = function (arr, values) {
      var _output = [],
          allChecked = true;

      if (arr.length > 0) {
        _lodash.default.forEach(arr, function (data) {
          if (!data.disabled) {
            if (_this.isMatched(data, values)) {
              data['checked'] = true;

              _output.push(data);
            } else {
              allChecked = false;
              data['checked'] = false;
            }
          }
        });
      }

      if (values && values.length > 0) {
        _lodash.default.forEach(values, function (value) {
          if (!_this.isMatched(value, _output)) {
            _output.push(value);
          }
        });
      } else allChecked = false;

      _this.setState({
        allChecked: allChecked
      });

      return {
        dataSource: arr,
        output: _output
      };
    };

    _this.filterTabs = function (props) {
      _this.setState({
        dataSource: props.dataSource
      });

      if (props.dataSource instanceof Array) {
        return [{
          title: props.tabname ? props.tabname : 'tabname'
        }];
      } else if (props.dataSource instanceof Object) {
        var _array = [];

        _lodash.default.forEach(props.dataSource, function (value, key) {
          _array.push({
            title: value.title,
            category: value.category
          });

          if (Number(key) === 0) {
            _this.setState({
              category: value.category
            });
          }
        });

        return _array;
      } else {
        return [{
          title: props.tabname ? props.tabname : 'tabname'
        }];
      }
    };

    _this.onTabChange = function (key) {
      _this.setState({
        active: key,
        category: _this.state.tabs[key].category,
        input: _this.filterDataSource(_this.state.dataSource, _this.state.output, key)
      });
    };

    _this.isMatched = function (target, array) {
      var dataIndex = _this.props.dataIndex;

      if (array && array.length > 0) {
        var key = target[dataIndex];
        return array.some(function (_ref) {
          var _key = _ref[dataIndex];
          return key === _key;
        });
      } else return false;
    };

    _this.onSearch = function (e) {
      var onSearch = _this.props.onSearch;

      if (typeof onSearch === 'function') {
        try {
          if (e) {
            _this.setState({
              isSearching: true,
              loading: _objectSpread(_objectSpread({}, _this.state.loading), {}, {
                left: true
              })
            });

            onSearch(e, _this.state.category).then(function (_ref2) {
              var dataSource = _ref2.dataSource,
                  total = _ref2.total;

              _this.setState({
                input: _this.filterDataSource(dataSource, _this.state.output, 0),
                loading: _objectSpread(_objectSpread({}, _this.state.loading), {}, {
                  left: false
                })
              });
            }).catch(function () {
              _this.setState({
                loading: _objectSpread(_objectSpread({}, _this.state.loading), {}, {
                  left: false
                })
              });
            });
          } else {
            if (_this.clonedInput) {
              _this.setState({
                input: _this.clonedInput,
                isSearching: false
              });
            }
          }
        } catch (error) {
          // eslint-disable-next-line no-console
          console.log(error);
        }
      } else {
        // eslint-disable-next-line no-console
        console.warn('picker onSearch function is not defined');
      }
    };

    _this.onChange = function (item, e) {
      var _this$props = _this.props,
          dataIndex = _this$props.dataIndex,
          multiply = _this$props.multiply;
      var output = _this.state.output;
      item['checked'] = e.target.checked;

      if (e.target.checked) {
        if (!multiply && output.length > 0) {
          // message.warn('只可选择一项');
          output = [];
          item.checked = null;
          delete item.checked;
          output.push(item);
        } else {
          item.checked = null;
          delete item.checked;
          output.push(item);
        }

        _this.setState({
          output: output
        }, function () {
          _this.filterDataSource(_this.state.input, _this.state.output, _this.state.active);
        });
      } else {
        _this.setState({
          isSelectAll: false,
          output: _lodash.default.differenceBy(output, [item], dataIndex)
        }, function () {
          _this.filterDataSource(_this.state.input, _this.state.output, _this.state.active);
        });
      }
    };

    _this.allSelected = function (isAll, clearAllTab) {
      var _this$state = _this.state,
          input = _this$state.input,
          output = _this$state.output;

      if (isAll) {
        // 左边框中未选择的过滤出来
        var selected = _lodash.default.filter(input, function (item) {
          return !item.checked && !item.disabled;
        });

        _lodash.default.map(selected, function (item) {
          item.checked = true;
          return item;
        });

        var newoutput = output.concat(selected);

        _this.setState({
          output: newoutput,
          allChecked: true
        });
      } else {
        var _output = [],
            filterKey = [];
        var dataIndex = _this.props.dataIndex;

        _lodash.default.map(input, function (item) {
          item.checked = false;
          filterKey.push(item[dataIndex]);
        });

        if (!clearAllTab) {
          _output = output.filter(function (_ref3) {
            var key = _ref3[dataIndex];
            return !filterKey.includes(key);
          });
        }

        _this.setState({
          output: _output,
          allChecked: false
        });
      }
    };

    _this.onSelectAll = function (e) {
      _this.allSelected(e.target.checked);
    };

    _this.clearBasket = function () {
      _this.allSelected(false, true);
    };

    _this.handleOk = function (e) {
      _this.props.promise.resolve(_this.state.output);
    };

    _this.onClose = function (item, index, e) {
      var dataIndex = _this.props.dataIndex;
      var _this$state2 = _this.state,
          input = _this$state2.input,
          output = _this$state2.output;

      var newinput = _lodash.default.cloneDeep(input);

      var newoutput = _lodash.default.cloneDeep(output);

      var ii = _lodash.default.findIndex(input, function (o) {
        return o[dataIndex] === item[dataIndex];
      });

      var oi = _lodash.default.findIndex(output, function (o) {
        return o[dataIndex] === item[dataIndex];
      });

      if (ii > -1) {
        newinput.splice(ii, 1, _objectSpread(_objectSpread({}, item), {}, {
          checked: false
        }));

        _this.setState({
          allChecked: false
        });
      }

      if (oi > -1) {
        newoutput.splice(oi, 1);
      }

      _this.setState({
        input: newinput,
        output: newoutput
      });
    };

    _this.renderShelf = function () {
      var _this$props2 = _this.props,
          renderLeftListItem = _this$props2.renderLeftListItem,
          multiply = _this$props2.multiply,
          t = _this$props2.t;
      var input = _this.state.input;
      var SelectBox = multiply ? _checkbox.default : _radio.default;
      return input && input.length > 0 ? input.map(function (item, index) {
        return /*#__PURE__*/_react.default.createElement("div", {
          className: "stuff-box",
          key: index
        }, /*#__PURE__*/_react.default.createElement(SelectBox, {
          onChange: _this.onChange.bind((0, _assertThisInitialized2.default)(_this), item),
          checked: item.checked,
          disabled: item.disabled,
          style: {
            display: 'flex',
            alignItems: 'center'
          }
        }, renderLeftListItem ? renderLeftListItem(item, index) : /*#__PURE__*/_react.default.createElement("div", {
          className: "left-item",
          style: {
            padding: multiply ? '6px 6px' : '2px 6px'
          },
          key: index
        }, /*#__PURE__*/_react.default.createElement("div", {
          className: "name-wrapper"
        }, /*#__PURE__*/_react.default.createElement("span", {
          className: "fm fm-paper"
        }), /*#__PURE__*/_react.default.createElement(_tooltip.default, {
          placement: "top",
          title: item.name
        }, /*#__PURE__*/_react.default.createElement("span", {
          className: "name",
          style: {
            width: 'initial'
          }
        }, /*#__PURE__*/_react.default.createElement("b", null, item.name))), item.tagName ? /*#__PURE__*/_react.default.createElement("div", {
          className: "tag-item"
        }, item.tagName) : null))));
      }) : /*#__PURE__*/_react.default.createElement("div", {
        className: "no-data"
      }, t('notData'));
    };

    _this.renderBasket = function () {
      var output = _this.state.output;
      var renderRightListItem = _this.props.renderRightListItem;
      return output && output.length > 0 ? output.map(function (item, index) {
        return renderRightListItem ? renderRightListItem(item, index, _this.onClose) : /*#__PURE__*/_react.default.createElement("div", {
          className: "right-item",
          key: index
        }, /*#__PURE__*/_react.default.createElement("div", {
          className: "name-wrapper"
        }, /*#__PURE__*/_react.default.createElement("span", {
          className: "fm fm-paper"
        }), /*#__PURE__*/_react.default.createElement(_tooltip.default, {
          placement: "top",
          title: item.name
        }, /*#__PURE__*/_react.default.createElement("span", {
          className: "name"
        }, /*#__PURE__*/_react.default.createElement("b", null, item.name)))), /*#__PURE__*/_react.default.createElement("div", {
          className: "delete-btn",
          onClick: _this.onClose.bind((0, _assertThisInitialized2.default)(_this), item, index)
        }, /*#__PURE__*/_react.default.createElement("span", {
          className: "fm fm-trash"
        })));
      }) : /*#__PURE__*/_react.default.createElement("div", {
        className: "no-data"
      }, _this.props.t('notData'));
    };

    _this.loadMore = function () {
      var current = _this.state.current;

      _this.setState({
        current: current + 1
      }, function () {
        _this.setState({
          loading: _objectSpread(_objectSpread({}, _this.state.loading), {}, {
            more: true
          })
        });

        _this.loadDataSource(true).then(function () {
          _this.setState({
            loading: _objectSpread(_objectSpread({}, _this.state.loading), {}, {
              more: false
            })
          });
        }).catch(function () {
          _this.setState({
            loading: _objectSpread(_objectSpread({}, _this.state.loading), {}, {
              more: false
            })
          });
        });
      });
    };

    _this.fetchDataSource = function (fixoutput, refresh) {
      _this.setState({
        loading: _objectSpread(_objectSpread({}, _this.state.loading), {}, {
          left: true
        })
      });

      _this.loadDataSource(fixoutput, refresh);
    };

    _this.loadDataSource = function (fixoutput, refresh) {
      return new Promise(function (resolve, reject) {
        var dataSourceSync = _this.props.dataSourceSync;
        var _this$state3 = _this.state,
            current = _this$state3.current,
            pageSize = _this$state3.pageSize,
            input = _this$state3.input;

        if (typeof dataSourceSync === 'function') {
          dataSourceSync({
            current: current,
            pageSize: pageSize
          }).then(function (_ref4) {
            var dataSource = _ref4.dataSource,
                total = _ref4.total;

            _this.setState(function (state, props) {
              var _output = fixoutput ? state.output : _this.filterOutput(dataSource, props.value);

              var _input = _this.filterDataSource(dataSource, _output, state.active);

              _this.clonedInput = refresh ? _input : [].concat((0, _toConsumableArray2.default)(input), (0, _toConsumableArray2.default)(_input));
              return {
                input: _lodash.default.cloneDeep(_this.clonedInput),
                output: _output,
                total: total,
                tabs: _this.filterTabs({
                  dataSource: dataSource,
                  tabname: props.tabname
                }),
                loading: _objectSpread(_objectSpread({}, state.loading), {}, {
                  left: false
                })
              };
            });

            resolve();
          }).catch(function () {
            _this.setState({
              loading: _objectSpread(_objectSpread({}, _this.state.loading), {}, {
                left: false
              }),
              noMore: true
            });

            reject();
          });
        }
      });
    };

    _this.searchCall = function () {
      if (typeof _this.props.dataSourceSync === 'function') {
        _this.fetchDataSource(true, true);
      } else {
        _this.setState({
          input: _this.filterDataSource(_this.props.dataSource, _this.state.output, _this.state.active),
          tabs: _this.filterTabs(_this.props)
        });
      }
    };

    _this.init = function () {
      if (typeof _this.props.dataSourceSync === 'function') {
        _this.fetchDataSource(false, true);
      } else {
        var _input = _this.filterDataSource(_this.props.dataSource, _this.props.value, 0);

        _this.clonedInput = _input;

        _this.setState({
          input: _lodash.default.cloneDeep(_input),
          output: _this.filterOutput(_this.props.dataSource, _this.props.value),
          tabs: _this.filterTabs(_this.props)
        });
      }
    };

    _this.state = {
      dataSource: _props.dataSource,
      input: [],
      output: [],
      tabs: [{
        title: _props.tabname ? _props.tabname : 'tabname'
      }],
      allChecked: false,
      active: '0',
      current: 1,
      category: '',
      isSearching: false,
      pageSize: _props.pageSize ? _props.pageSize : 50,
      total: 0,
      loading: {
        left: false,
        right: false,
        more: false
      },
      noMore: false
    };
    return _this;
  }

  (0, _createClass2.default)(StuffSelectionModal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (typeof this.props.onRef === 'function') {
        this.props.onRef(this);
      }

      this.init();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          title = _this$props3.title,
          isShowSearch = _this$props3.isShowSearch,
          multiply = _this$props3.multiply,
          searchPlaceholder = _this$props3.searchPlaceholder,
          selectedDesc = _this$props3.selectedDesc,
          loadMore = _this$props3.loadMore,
          promise = _this$props3.promise,
          renderExtraOfFooter = _this$props3.renderExtraOfFooter,
          t = _this$props3.t;
      var _this$state4 = this.state,
          input = _this$state4.input,
          output = _this$state4.output,
          tabs = _this$state4.tabs,
          allChecked = _this$state4.allChecked,
          loading = _this$state4.loading,
          noMore = _this$state4.noMore,
          active = _this$state4.active,
          isSearching = _this$state4.isSearching,
          current = _this$state4.current,
          pageSize = _this$state4.pageSize,
          total = _this$state4.total;
      return /*#__PURE__*/_react.default.createElement(_modal.default, (0, _extends2.default)({}, this.props, {
        width: 800,
        visible: true,
        centered: true,
        bodyStyle: {
          padding: '0 15px'
        },
        cancelButtonProps: {
          type: 'info',
          size: 'large'
        },
        footer: /*#__PURE__*/_react.default.createElement("div", {
          className: "".concat(prefix, "-stuff-selection-custom-modal-footer")
        }, /*#__PURE__*/_react.default.createElement("div", null, typeof renderExtraOfFooter === 'function' ? renderExtraOfFooter() : null), /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_button.default, {
          onClick: function onClick(e) {
            return promise.reject();
          }
        }, t('cancel')), /*#__PURE__*/_react.default.createElement(_button.default, {
          type: "primary",
          onClick: this.handleOk
        }, t('ok'))))
      }), /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-stuff-selection-modal-body")
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "selection-box"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "selection-box-title"
      }, Array.isArray(tabs) && tabs.length > 0 ? /*#__PURE__*/_react.default.createElement(_tabs.default, {
        defaultActiveKey: "0",
        activeKey: active,
        onChange: this.onTabChange
      }, _lodash.default.map(tabs, function (tab, index) {
        return /*#__PURE__*/_react.default.createElement(_tabs.default.TabPane, {
          tab: tab.title,
          key: index
        });
      })) : null), /*#__PURE__*/_react.default.createElement("div", {
        className: "selection-box-body"
      }, isShowSearch ? /*#__PURE__*/_react.default.createElement(Search, {
        placeholder: searchPlaceholder || '请输入科目名称',
        onSearch: this.onSearch,
        type: "grey"
      }) : null, input && output && multiply ? /*#__PURE__*/_react.default.createElement("div", {
        className: "checkall-box"
      }, /*#__PURE__*/_react.default.createElement(_checkbox.default, {
        onChange: this.onSelectAll,
        checked: allChecked
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "checkall-text"
      }, t('allSelect')))) : null, /*#__PURE__*/_react.default.createElement("div", {
        className: 'selection-content ' + (isShowSearch && multiply ? 'selection-smaller-content' : null)
      }, /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, loading.left ? /*#__PURE__*/_react.default.createElement(_Loader.default, {
        active: true,
        mask: true
      }) : this.renderShelf(), /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, loadMore && !isSearching ? /*#__PURE__*/_react.default.createElement("div", {
        className: "load-more-wrapper"
      }, noMore ? /*#__PURE__*/_react.default.createElement("div", null, "\u5230\u5E95\u4E86") : current * pageSize < total ? /*#__PURE__*/_react.default.createElement("div", {
        className: "load-more-btn",
        onClick: this.loadMore
      }, /*#__PURE__*/_react.default.createElement(_Loader.default, {
        active: loading.more,
        embed: true,
        size: 16
      }), /*#__PURE__*/_react.default.createElement("span", null, t('loadMore'))) : null) : null))))), /*#__PURE__*/_react.default.createElement("div", {
        className: "middle-icon-box"
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "fm fm-angle-right"
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: "selection-box"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "selection-box-title basket-box"
      }, /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("span", {
        className: "basket-title"
      }, t('selected')), /*#__PURE__*/_react.default.createElement("span", {
        className: "number"
      }, output && output.length > 0 ? output.length : null), /*#__PURE__*/_react.default.createElement("span", null, _i18next.default.language === 'en' ? '' : selectedDesc || title)), /*#__PURE__*/_react.default.createElement("span", {
        className: "basket-clear",
        onClick: this.clearBasket
      }, t('clear'))), /*#__PURE__*/_react.default.createElement("div", {
        className: "selection-box-right-body"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "selection-content"
      }, this.renderBasket())))));
    }
  }]);
  return StuffSelectionModal;
}(_react.Component);

var _default = (0, _reactI18next.withTranslation)('MK_StuffSelectionModal')(StuffSelectionModal);

exports.default = _default;