"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;

var OptGroup = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(OptGroup, _Component);

  var _super = _createSuper(OptGroup);

  function OptGroup(props) {
    (0, _classCallCheck2.default)(this, OptGroup);
    return _super.call(this, props);
  }

  (0, _createClass2.default)(OptGroup, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          select__value = _this$props.select__value,
          label = _this$props.label,
          getTargetTop = _this$props.getTargetTop,
          onChange = _this$props.onChange,
          docId = _this$props.docId;
      var groupClass = (0, _classnames.default)("".concat(prefix, "-opt-group"), (0, _defineProperty2.default)({}, className, className)); //如果是费用类型的title统一类名，方便获取；

      var isExpenseTitle = docId ? 'expense-title' : '';
      return /*#__PURE__*/_react.default.createElement("div", {
        className: groupClass
      }, label && /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-opt-title ").concat((0, _typeof2.default)(label) !== 'object' ? "".concat(prefix, "-opt-txt") : "".concat(prefix, "-opt-node"), " ").concat(isExpenseTitle),
        id: docId
      }, label), /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-opt-content")
      }, _react.default.Children.map(children, function (o) {
        return /*#__PURE__*/_react.default.isValidElement(o) ? /*#__PURE__*/_react.default.cloneElement(o, {
          select__value: select__value,
          getTargetTop: getTargetTop,
          onChange: onChange
        }) : null;
      })));
    }
  }]);
  return OptGroup;
}(_react.Component);

var _default = OptGroup;
exports.default = _default;