"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/button/style/css");

var _button = _interopRequireDefault(require("maycur-antd/lib/button"));

require("maycur-antd/lib/popover/style/css");

var _popover = _interopRequireDefault(require("maycur-antd/lib/popover"));

require("maycur-antd/lib/checkbox/style/css");

var _checkbox = _interopRequireDefault(require("maycur-antd/lib/checkbox"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _DepartmentTransfer = _interopRequireDefault(require("../../../DepartmentSelectionModal/DepartmentTransfer"));

var _utils = _interopRequireDefault(require("../../../utils/utils"));

var _i18next = _interopRequireDefault(require("i18next"));

var _excluded = ["confirm", "promise", "columnModify", "setSelectedKeys"],
    _excluded2 = ["confirm", "promise", "columnModify"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;

var DepartmentPickerDropdown = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(DepartmentPickerDropdown, _Component);

  var _super = _createSuper(DepartmentPickerDropdown);

  function DepartmentPickerDropdown(props) {
    var _this;

    (0, _classCallCheck2.default)(this, DepartmentPickerDropdown);
    _this = _super.call(this, props);

    _this.onChange = function (selectList) {
      _this.setState({
        currentSelected: selectList
      });

      _this.props.setSelectedKeys(selectList);
    };

    _this.onOk = function () {
      var _this$props = _this.props,
          confirm = _this$props.confirm,
          promise = _this$props.promise,
          columnModify = _this$props.columnModify,
          setSelectedKeys = _this$props.setSelectedKeys,
          col = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
      var _this$state = _this.state,
          currentSelected = _this$state.currentSelected,
          includeChildDept = _this$state.includeChildDept;
      _this.selectList = _lodash.default.map(currentSelected, function (item) {
        return _objectSpread(_objectSpread({}, item), {}, {
          includeChildDept: includeChildDept
        });
      });

      if (promise) {
        promise.resolve(_this.selectList);
      } else {
        var selectedNames = _this.selectList.map(function (item) {
          return item.name;
        });

        var colCopy = _lodash.default.cloneDeep(col);

        colCopy.key = colCopy.dataIndex;

        if (colCopy) {
          columnModify(colCopy, {
            key: 'selectedList',
            value: selectedNames
          }, true);
        }

        setSelectedKeys(_this.selectList);
        confirm();
      }
    };

    _this.onCancel = function () {
      var _this$props2 = _this.props,
          promise = _this$props2.promise,
          cancel = _this$props2.cancel;

      if (promise) {
        promise.resolve();
      } else {
        /*NOTE 这里不使用confirm了。扩展了cancel方法处理取消操作 confirm会和确定同效果使取消按钮无意义*/
        // confirm();
        // 取确定时已选的数据赋值处理选了新数据点取消的操作
        _this.setState({
          currentSelected: _this.selectList
        });

        cancel();
      }
    };

    _this.includeChildrenChecked = function (e) {
      var checked = e.target.checked;

      _this.setState({
        includeChildDept: checked
      }); // 是否包含子部门

    };

    _this.showIncludeDisableDeptChecked = function (e) {
      var checked = e.target.checked;

      _this.setState({
        includeDisableDept: checked
      }, function () {
        if (_this.deptRef) {
          _this.deptRef.showIncludeDisableDeptRefresh();
        }
      });
    };

    _this.state = {
      includeChildDept: false,
      includeDisableDept: false,
      currentSelected: [] // 最新选择的数据，取消时更新为 this.selectList

    };
    _this.selectList = []; // 旧的数据，确定时更新为 this.state.currentSelected

    return _this;
  }

  (0, _createClass2.default)(DepartmentPickerDropdown, [{
    key: "setCurrentSelected",
    value: function setCurrentSelected(selectedKeys, isInit) {
      var currentSelected = [];
      var includeChildDept = false;

      _lodash.default.each(selectedKeys, function (key) {
        if (typeof key === 'string') {
          currentSelected.push({
            code: key
          });
        } else {
          currentSelected.push(key);
          includeChildDept = key && key.includeChildDept || false;
        }
      });

      if (isInit) {
        this.selectList = currentSelected;
      }

      this.setState({
        currentSelected: currentSelected,
        includeChildDept: includeChildDept
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.setCurrentSelected(this.props.selectedKeys, true);
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var _this$state2 = this.state,
          currentSelected = _this$state2.currentSelected,
          includeChildDept = _this$state2.includeChildDept;
      var confirm = nextProps.confirm,
          promise = nextProps.promise,
          columnModify = nextProps.columnModify,
          col = (0, _objectWithoutProperties2.default)(nextProps, _excluded2);

      if (nextProps.selectedKeys !== this.props.selectedKeys) {
        this.setCurrentSelected(nextProps.selectedKeys);
      }

      if (nextProps.clickedInBlank) {
        this.selectList = _lodash.default.map(currentSelected, function (item) {
          return _objectSpread(_objectSpread({}, item), {}, {
            includeChildDept: includeChildDept
          });
        });
        var selectedNames = this.selectList.map(function (item) {
          return item.name;
        });

        var colCopy = _lodash.default.cloneDeep(col);

        colCopy.key = colCopy.dataIndex;

        if (colCopy) {
          columnModify(colCopy, {
            key: 'selectedList',
            value: selectedNames
          }, true);
        }

        nextProps.resetClickedInBlank();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state3 = this.state,
          currentSelected = _this$state3.currentSelected,
          includeChildDept = _this$state3.includeChildDept,
          includeDisableDept = _this$state3.includeDisableDept;
      var _this$props3 = this.props,
          filterOption = _this$props3.filterOption,
          hideHelp = _this$props3.hideHelp,
          showIncludeDisableDept = _this$props3.showIncludeDisableDept;
      var maxSelectLength = filterOption.maxSelectLength,
          includeChildren = filterOption.includeChildren;
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-department-picker-filter-dropdown")
      }, /*#__PURE__*/_react.default.createElement(_DepartmentTransfer.default, (0, _extends2.default)({
        scope: "DEPARTMENT",
        isShowUserGroup: false,
        onChange: this.onChange,
        selectList: (0, _toConsumableArray2.default)(currentSelected),
        includeChildDept: includeChildDept
      }, this.props, {
        maxSelectLength: maxSelectLength || 1,
        includeDisableDept: includeDisableDept,
        ref: function ref(_ref) {
          return _this2.deptRef = _ref;
        }
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: 'footer'
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'help'
      }, showIncludeDisableDept && /*#__PURE__*/_react.default.createElement("p", null, /*#__PURE__*/_react.default.createElement(_checkbox.default, {
        style: {
          color: '#999'
        },
        checked: includeDisableDept,
        onChange: this.showIncludeDisableDeptChecked
      }, _i18next.default.t('MK_Global:showDepartmentsBlocked'))), includeChildren && /*#__PURE__*/_react.default.createElement("p", null, /*#__PURE__*/_react.default.createElement(_checkbox.default, {
        style: {
          color: '#999'
        },
        checked: includeChildDept,
        onChange: this.includeChildrenChecked
      }, _i18next.default.t('MK_Global:departmentSpan'), /*#__PURE__*/_react.default.createElement(_popover.default, {
        placement: "right",
        content: /*#__PURE__*/_react.default.createElement("div", {
          className: "".concat(prefix, "-popover")
        }, _i18next.default.t('MK_Global:departmentPopover'))
      }, /*#__PURE__*/_react.default.createElement("span", {
        style: {
          marginLeft: '5px'
        },
        className: "fm fm-question"
      })))), !hideHelp && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, _i18next.default.t('MK_Global:helpText'), /*#__PURE__*/_react.default.createElement("a", {
        href: "https://www.yuque.com/ruanruan-eydfh/yb01tu/adugpa",
        rel: "noopener noreferrer",
        target: "_blank"
      }, _i18next.default.t('MK_Global:help')))), /*#__PURE__*/_react.default.createElement("div", {
        className: 'btn'
      }, /*#__PURE__*/_react.default.createElement(_button.default, {
        key: "back",
        type: "info",
        size: "large",
        onClick: this.onCancel
      }, _i18next.default.t('MK_Global:cancel')), /*#__PURE__*/_react.default.createElement(_button.default, {
        key: "submit",
        type: "primary",
        size: "large",
        onClick: this.onOk
      }, _i18next.default.t('MK_Global:ok')))));
    }
  }]);
  return DepartmentPickerDropdown;
}(_react.Component);

var _default = DepartmentPickerDropdown;
exports.default = _default;