"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/tag/style/css");

var _tag = _interopRequireDefault(require("maycur-antd/lib/tag"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/modal/style/css");

var _modal = _interopRequireDefault(require("maycur-antd/lib/modal"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _FilterDropDown = require("../../FilterDropDown");

var _lodash = _interopRequireDefault(require("lodash"));

var _i18next = _interopRequireDefault(require("i18next"));

var _mkTranslate = _interopRequireDefault(require("../../../utils/mkTranslate"));

var _reactI18next = require("react-i18next");

var _excluded = ["width"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var BudgetSubjectModal = function BudgetSubjectModal(props) {
  var width = props.width,
      restProps = (0, _objectWithoutProperties2.default)(props, _excluded);
  return /*#__PURE__*/_react.default.createElement(_modal.default, (0, _extends2.default)({}, restProps, {
    footer: null,
    visible: true,
    wrapClassName: 'department-modal-wrapper'
  }), /*#__PURE__*/_react.default.createElement(_FilterDropDown.BudgetSubjectFilter, props));
};

var BudgetSubjectPicker = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(BudgetSubjectPicker, _Component);

  var _super = _createSuper(BudgetSubjectPicker);

  function BudgetSubjectPicker(props) {
    var _this;

    (0, _classCallCheck2.default)(this, BudgetSubjectPicker);
    _this = _super.call(this, props);

    _this.renderValueText = function (value) {
      return value.map(function (item) {
        return item.name;
      }).join('、');
    };

    _this.onClick = function () {
      var _this$props = _this.props,
          disabled = _this$props.disabled,
          maxLength = _this$props.maxLength,
          ModalManager = _this$props.ModalManager,
          dataSourceSync = _this$props.dataSourceSync,
          fetchChildren = _this$props.fetchChildren,
          search = _this$props.search,
          setSelectedKeys = _this$props.setSelectedKeys,
          confirm = _this$props.confirm;

      if (disabled) {
        return;
      }

      ModalManager.open({
        component: BudgetSubjectModal,
        componentProps: _objectSpread(_objectSpread({}, _this.props), {}, {
          title: _this.t('BudgetAccount'),
          selectedKeys: _this.state.value,
          maxLength: maxLength,
          dataSourceSync: dataSourceSync,
          fetchChildren: fetchChildren,
          search: search,
          confirm: confirm
        })
      }).then(function (data) {
        if (typeof setSelectedKeys === 'function' && data) {
          var _data = _lodash.default.map(data, function (item) {
            return _lodash.default.pick(item, ['code', 'name', 'heirCode', 'bizCode']);
          });

          _this.setState({
            value: _data
          });

          setSelectedKeys(_data);
          confirm();
        }
      }).catch(function () {});
    };

    _this.renderTags = function (value, account) {
      var _this$props2 = _this.props,
          renderTagItem = _this$props2.renderTagItem,
          emptyText = _this$props2.emptyText,
          maxTagLength = _this$props2.maxTagLength,
          style = _this$props2.style;
      var hasValue = _lodash.default.isArray(value) && value.length > 0;
      return /*#__PURE__*/_react.default.createElement("div", {
        className: hasValue ? 'tags-wrapper' : 'container',
        style: style,
        onClick: _this.onClick
      }, hasValue ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
        style: {
          display: 'inline-flex',
          alignItems: 'flex-end',
          flexWrap: 'wrap'
        }
      }, value.map(function (item, index) {
        return /*#__PURE__*/_react.default.createElement(_tag.default, {
          style: {
            marginTop: 4
          },
          key: index
        }, renderTagItem ? renderTagItem(item, index) : item.name);
      })), account > maxTagLength ? /*#__PURE__*/_react.default.createElement("span", {
        className: "more-stuff"
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "more-stuff-symbol"
      }, "..."), /*#__PURE__*/_react.default.createElement("span", {
        style: {
          marginLeft: 2,
          marginTop: 5
        }
      }, "\u5171", value ? /*#__PURE__*/_react.default.createElement("span", {
        className: "number"
      }, account) : null, "\u9879")) : null) : /*#__PURE__*/_react.default.createElement("span", {
        className: "empty"
      }, emptyText ? emptyText : _i18next.default.t('common:未选择')));
    };

    _this.renderValue = function (value) {
      return _lodash.default.take(value, 5).map(function (item) {
        return /*#__PURE__*/_react.default.createElement(_tag.default, {
          className: 'budgetment-name',
          key: item.code
        }, /*#__PURE__*/_react.default.createElement("span", {
          className: 'fm fm-cube'
        }), item.name);
      });
    };

    _this.t = _mkTranslate.default.getLocalNs('Budget', (0, _assertThisInitialized2.default)(_this));
    _this.state = {
      value: props.selectedKeys && props.selectedKeys.budgetSubjectCodes
    };
    return _this;
  }

  (0, _createClass2.default)(BudgetSubjectPicker, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          style = _this$props3.style,
          emptyText = _this$props3.emptyText,
          disabled = _this$props3.disabled;
      var value = this.state.value;
      return /*#__PURE__*/_react.default.createElement("div", {
        className: 'budgetment-filter-container ' + (disabled ? 'disabled' : ''),
        style: style,
        onClick: this.onClick
      }, _lodash.default.isArray(value) && value.length > 0 ? this.renderValue(value) : /*#__PURE__*/_react.default.createElement("span", {
        className: 'empty'
      }, emptyText ? emptyText : _i18next.default.t('common:未选择')), value && value.length > 5 ? /*#__PURE__*/_react.default.createElement("span", {
        className: 'department-stats'
      }, /*#__PURE__*/_react.default.createElement(_reactI18next.Trans, {
        i18n: _i18next.default,
        i18nKey: "departmentPicker.stats",
        ns: "MK_Table",
        values: {
          n: value.length
        },
        components: [/*#__PURE__*/_react.default.createElement("span", null), /*#__PURE__*/_react.default.createElement("span", {
          className: "strong"
        })],
        children: "\u5171 <span className={'strong'}>{{n}}</span> \u9879"
      })) : null, /*#__PURE__*/_react.default.createElement("span", {
        className: 'fm fm-more2'
      }));
    }
  }]);
  return BudgetSubjectPicker;
}(_react.Component);

var _default = BudgetSubjectPicker;
exports.default = _default;