"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/tooltip/style/css");

var _tooltip = _interopRequireDefault(require("maycur-antd/lib/tooltip"));

require("maycur-antd/lib/message/style/css");

var _message2 = _interopRequireDefault(require("maycur-antd/lib/message"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = _interopRequireDefault(require("../../../utils/utils"));

var _constants = _interopRequireDefault(require("../../../utils/constants"));

var _components = require("./components");

var _lodash = _interopRequireDefault(require("lodash"));

var _mkTranslate = _interopRequireDefault(require("../../../utils/mkTranslate"));

var _excluded = ["scope", "isShowUserGroup", "maxSelectLength", "disabled", "code", "property", "isSelectCategory", "dataSourceSync", "fetchSearchList", "ModalManager", "setSelectedKeys", "confirm"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var OPTION_PICKER = _constants.default.OPTION_PICKER;
var prefix = _utils.default.prefixCls;

var OptionInput = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(OptionInput, _Component);

  var _super = _createSuper(OptionInput);

  function OptionInput(props) {
    var _props$selectedKeys;

    var _this;

    (0, _classCallCheck2.default)(this, OptionInput);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_OptionInput').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.renderOptions = function (value, maxShowLength) {
      return _lodash.default.take(value, maxShowLength).map(function (item) {
        return item.name;
      }).join('、');
    };

    _this.state = {
      // rc-form组件契约：接受value属性成为受控组件
      value: ((_props$selectedKeys = props.selectedKeys) === null || _props$selectedKeys === void 0 ? void 0 : _props$selectedKeys.sharedFieldValues[props.dataIndex]) || [],
      t: _mkTranslate.default.noop()
    };
    _this.onChange = _this.onChange.bind((0, _assertThisInitialized2.default)(_this));
    _this.openModal = _this.openModal.bind((0, _assertThisInitialized2.default)(_this));
    _this.convertFromValue = _this.convertFromValue.bind((0, _assertThisInitialized2.default)(_this));
    _this.convertToValue = _this.convertToValue.bind((0, _assertThisInitialized2.default)(_this));
    _this.isExternal = props.group && props.group[0] && props.group[0].fromExternal;

    _this.localeProcess();

    return _this;
  }

  (0, _createClass2.default)(OptionInput, [{
    key: "onChange",
    value: // rc-form组件契约：注册onChange事件为form提供值变化感知
    function onChange(value) {
      var onChange = this.props.onChange;

      if (typeof onChange === 'function') {
        onChange(value);
      }
    } // rc-form组件契约：接受value属性成为受控组件

  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var value = nextProps.value,
          group = nextProps.group,
          code = nextProps.code;

      if (code !== this.props.code) {
        //是否是外部档案
        this.isExternal = group && group[0] && group[0].fromExternal;
      }

      if (_lodash.default.isEqual(value, this.props.value)) {
        return;
      } else {
        this.setState({
          value: value
        });
      }
    }
  }, {
    key: "convertFromValue",
    value: function convertFromValue(value) {
      var _this2 = this;

      value = value || [];
      return _lodash.default.map(value, function (item) {
        if (_this2.isExternal) {
          return {
            code: item.bizCode,
            _code: item.code,
            name: item.name,
            type: item.type,
            userEmployeeId: item.userEmployeeId
          };
        } else {
          return {
            code: item.code,
            name: item.name,
            type: item.type,
            userEmployeeId: item.userEmployeeId
          };
        }
      });
    }
  }, {
    key: "convertToValue",
    value: function convertToValue(selectList) {
      var _this3 = this;

      selectList = selectList || [];
      return _lodash.default.map(selectList, function (item) {
        if (_this3.isExternal) {
          return {
            code: item._code || item.code,
            bizCode: item.code,
            name: item.name,
            type: item.type,
            userEmployeeId: item.userEmployeeId
          };
        } else {
          return {
            code: item.code,
            name: item.name,
            type: item.type,
            userEmployeeId: item.userEmployeeId
          };
        }
      });
    }
  }, {
    key: "openModal",
    value: function openModal(e) {
      var _this4 = this;

      e.stopPropagation();
      var value = this.state.value;
      var _this$props = this.props,
          scope = _this$props.scope,
          isShowUserGroup = _this$props.isShowUserGroup,
          maxSelectLength = _this$props.maxSelectLength,
          disabled = _this$props.disabled,
          code = _this$props.code,
          property = _this$props.property,
          isSelectCategory = _this$props.isSelectCategory,
          dataSourceSync = _this$props.dataSourceSync,
          fetchSearchList = _this$props.fetchSearchList,
          ModalManager = _this$props.ModalManager,
          setSelectedKeys = _this$props.setSelectedKeys,
          confirm = _this$props.confirm,
          restProps = (0, _objectWithoutProperties2.default)(_this$props, _excluded);

      if (disabled) {
        return;
      }

      if (code) {
        ModalManager.open({
          component: _components.OptionSelectionModal,
          componentProps: _objectSpread(_objectSpread({}, restProps), {}, {
            selectList: this.convertFromValue(value),
            scope: scope,
            isShowUserGroup: isShowUserGroup,
            maxSelectLength: maxSelectLength,
            code: property.dataSource,
            isSelectCategory: isSelectCategory,
            dataSourceSync: dataSourceSync,
            fetchSearchList: fetchSearchList
          })
        }).then(function (selectList) {
          var _value = _this4.convertToValue(selectList);

          _this4.setState({
            value: _value
          });

          setSelectedKeys(_value);
          confirm();
        }, _utils.default.noop);
      } else {
        _message2.default.warning('请先选择自定义档案');
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          value = _this$state.value,
          t = _this$state.t;
      var _this$props2 = this.props,
          className = _this$props2.className,
          maxShowLength = _this$props2.maxShowLength,
          scope = _this$props2.scope,
          emptyText = _this$props2.emptyText,
          disabled = _this$props2.disabled,
          style = _this$props2.style;
      var containerClass = (0, _classnames.default)("".concat(prefix, "-option-input-container"), className, {
        disabled: disabled
      });
      var defaultEmptyText;

      if (!emptyText) {
        switch (scope) {
          case OPTION_PICKER.SCOPE_CATEGORY:
            defaultEmptyText = t('未选择分类');
            break;

          case OPTION_PICKER.SCOPE_ITEM:
            defaultEmptyText = t('未选择选项');
            break;

          default:
            defaultEmptyText = t('未选择选项');
            break;
        }
      }

      return /*#__PURE__*/_react.default.createElement("div", {
        className: containerClass,
        onClick: this.openModal,
        style: style
      }, value && value.length ? /*#__PURE__*/_react.default.createElement(_tooltip.default, {
        title: this.renderOptions(value, maxShowLength)
      }, this.renderOptions(value, maxShowLength)) : /*#__PURE__*/_react.default.createElement("span", {
        className: 'empty'
      }, emptyText || defaultEmptyText));
    }
  }]);
  return OptionInput;
}(_react.Component);

OptionInput.defaultProps = {
  maxShowLength: 6,
  maxSelectLength: -1,
  scope: OPTION_PICKER.SCOPE_ALL
};
var _default = OptionInput;
exports.default = _default;