"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/popover/style/css");

var _popover = _interopRequireDefault(require("maycur-antd/lib/popover"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/modal/style/css");

var _modal = _interopRequireDefault(require("maycur-antd/lib/modal"));

var _react = _interopRequireWildcard(require("react"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefixCls = _utils.default.prefixCls;
var confirm = _modal.default.confirm;

var PageHeaderBar = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(PageHeaderBar, _Component);

  var _super = _createSuper(PageHeaderBar);

  function PageHeaderBar(props) {
    var _this;

    (0, _classCallCheck2.default)(this, PageHeaderBar);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_PageHeaderBar').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.back = function () {
      var t = _this.state.t;
      var _this$props = _this.props,
          showConfirm = _this$props.showConfirm,
          confirmText = _this$props.confirmText;

      if (showConfirm) {
        confirm({
          title: confirmText || t('confirm'),
          content: t('tips'),
          okText: t('MK_Global:ok'),
          cancelText: t('MK_Global:cancel'),
          onOk: function onOk() {
            window.history.go(-1);
          },
          onCancel: function onCancel() {
            console.log('Cancel');
          }
        });
      } else {
        window.history.go(-1);
      }
    };

    _this.close = function () {
      var closeCallBack = _this.props.closeCallBack;

      if (typeof closeCallBack === 'function') {
        closeCallBack();
      }
    };

    _this.state = {
      t: _mkTranslate.default.noop()
    };

    _this.localeProcess();

    return _this;
  }

  (0, _createClass2.default)(PageHeaderBar, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          title = _this$props2.title,
          pageDescription = _this$props2.pageDescription,
          withGoBack = _this$props2.withGoBack,
          withClose = _this$props2.withClose,
          onGoBack = _this$props2.onGoBack,
          children = _this$props2.children,
          customNode = _this$props2.customNode;
      var t = this.state.t;
      var basicCls = "".concat(prefixCls, "-pageheader-bar");

      var popContent = /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(basicCls, "_content")
      }, pageDescription);

      return /*#__PURE__*/_react.default.createElement("div", {
        className: basicCls
      }, withGoBack ? /*#__PURE__*/_react.default.createElement("span", {
        className: "".concat(basicCls, "_back mkbs-fm mkbs-fm-arrow-left"),
        onClick: onGoBack || this.back
      }) : null, /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(basicCls, "_title")
      }, title, customNode), pageDescription ? /*#__PURE__*/_react.default.createElement(_popover.default, {
        autoAdjustOverflow: true,
        content: popContent,
        placement: "bottomRight"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(basicCls, "_help")
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "mkbs-fm mkbs-fm-description-o ".concat(basicCls, "_help_icon")
      }), t('help'))) : null, children, withClose ? /*#__PURE__*/_react.default.createElement("span", {
        className: "".concat(basicCls, "_close mkbs-fm mkbs-fm-close"),
        onClick: this.close
      }) : null);
    }
  }]);
  return PageHeaderBar;
}(_react.Component);

PageHeaderBar.defaultProps = {
  withGoBack: true,
  withClose: false
};
var _default = PageHeaderBar;
exports.default = _default;