"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

require("maycur-antd/lib/switch/style/css");

var _switch = _interopRequireDefault(require("maycur-antd/lib/switch"));

require("maycur-antd/lib/checkbox/style/css");

var _checkbox = _interopRequireDefault(require("maycur-antd/lib/checkbox"));

require("maycur-antd/lib/alert/style/css");

var _alert = _interopRequireDefault(require("maycur-antd/lib/alert"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

require("maycur-antd/lib/popover/style/css");

var _popover = _interopRequireDefault(require("maycur-antd/lib/popover"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/select/style/css");

var _select = _interopRequireDefault(require("maycur-antd/lib/select"));

require("maycur-antd/lib/radio/style/css");

var _radio = _interopRequireDefault(require("maycur-antd/lib/radio"));

require("maycur-antd/lib/form/style/css");

var _form = _interopRequireDefault(require("maycur-antd/lib/form"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _CityInput = _interopRequireDefault(require("./CityInput"));

var _BankInput = _interopRequireDefault(require("./BankInput"));

var _CountryInput = _interopRequireDefault(require("./CountryInput"));

var _BankBranchInput = _interopRequireDefault(require("./BankBranchInput"));

var _CertificateInput = _interopRequireDefault(require("./CertificateInput"));

var _CurrencySelector = _interopRequireDefault(require("../CurrencySelector"));

var _CurrencyFlag = _interopRequireDefault(require("../CurrencyFlag"));

var _LegalEntityPicker = _interopRequireDefault(require("../LegalEntityPicker"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;
var FormItem = _form.default.Item;
var RadioGroup = _radio.default.Group;
var Option = _select.default.Option;

var EditPaymentForm = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(EditPaymentForm, _Component);

  var _super = _createSuper(EditPaymentForm);

  function EditPaymentForm(props) {
    var _this;

    (0, _classCallCheck2.default)(this, EditPaymentForm);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_PaymentAccountModal').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.fetchCountryForm = function (country) {
      var fetchItemList = _this.props.fetchItemList;

      if (country === 'BURKINA-FASO') {
        country = 'BURKINA_FASO';
      }

      if (country === 'CAPE-VERDE') {
        country = 'CAPE_VERDE';
      }

      fetchItemList(country).then(function (res) {
        _this.setState({
          countryForm: res
        });
      }, function (err) {});
    };

    _this.showBranchNoChange = function (value) {
      _this.setState({
        showBranchNo: value
      });
    };

    _this.renderLabel = function (label, content) {
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("span", {
        style: {
          marginRight: 5
        }
      }, label), /*#__PURE__*/_react.default.createElement(_popover.default, {
        placement: "top",
        content: content
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "fm fm-question",
        onClick: function onClick(e) {
          e.preventDefault();
          e.stopPropagation();
        }
      })));
    };

    _this.state = {
      showBranchNo: false,
      t: _mkTranslate.default.noop(),
      isAutowatch: true,
      countryForm: [],
      shouldLimitEntity: props.data && Array.isArray(props.data.legalEntityAuthzs) && props.data.legalEntityAuthzs.length > 0
    };
    _this.validate = _this.validate.bind((0, _assertThisInitialized2.default)(_this));
    _this.handleSubmit = _this.handleSubmit.bind((0, _assertThisInitialized2.default)(_this));
    _this.onChangeBank = _this.onChangeBank.bind((0, _assertThisInitialized2.default)(_this));
    _this.onChangeBankCountry = _this.onChangeBankCountry.bind((0, _assertThisInitialized2.default)(_this));
    _this.onChangeBankBranch = _this.onChangeBankBranch.bind((0, _assertThisInitialized2.default)(_this));
    _this.onBulrchange = _this.onBulrchange.bind((0, _assertThisInitialized2.default)(_this));

    _this.localeProcess();

    _this.lang = localStorage.getItem('lang');
    return _this;
  }

  (0, _createClass2.default)(EditPaymentForm, [{
    key: "handleSubmit",
    value: function handleSubmit() {
      var _this$props = this.props,
          form = _this$props.form,
          onErrors = _this$props.onErrors,
          onSubmit = _this$props.onSubmit;
      form.validateFields(null, {
        force: true
      }, function (errs, values) {
        if (errs) {
          if (typeof onErrors === 'function') {
            onErrors(errs);
          }
        } else {
          if (typeof onSubmit === 'function') {
            var _values = _lodash.default.cloneDeep(values);

            if (values.bankAcctNumber) {
              _values.bankAcctNumber = values.bankAcctNumber.replace(/\s+/g, '');
            }

            onSubmit(_values);
          }
        }
      });
    }
  }, {
    key: "validate",
    value: function validate() {
      var form = this.props.form;
      var t = this.state.t;
      return new Promise(function (resolve, reject) {
        form.validateFields(function (errs, values) {
          if (errs) {
            reject(t('editPaymentForm.errMsg'));
          } else {
            resolve(values);
          }
        });
      });
    }
  }, {
    key: "onChangeBank",
    value: function onChangeBank(value, option) {
      this.setState({
        isAutowatch: false
      });
      var data = option.props.data;
      var onChangeBank = this.props.onChangeBank;

      if (typeof onChangeBank === 'function') {
        onChangeBank(data);
      }
    }
  }, {
    key: "onChangeBankCountry",
    value: function onChangeBankCountry(value, option) {
      this.setState({
        isAutowatch: false
      });
      var data = option.props.data;
      var _this$props2 = this.props,
          accountType = _this$props2.accountType,
          onChangeBankCountry = _this$props2.onChangeBankCountry;

      if (data && data.country !== "CHINA" && accountType && accountType === 'PERSONAL') {
        this.fetchCountryForm(data.country);
      }

      if (typeof onChangeBankCountry === 'function') {
        onChangeBankCountry(data);
      }
    }
  }, {
    key: "onBulrchange",
    value: function onBulrchange(e) {
      var isAutowatch = this.state.isAutowatch;
      var _this$props3 = this.props,
          form = _this$props3.form,
          getBankname = _this$props3.getBankname,
          onChangeBank = _this$props3.onChangeBank;

      if (isAutowatch && e.target.value) {
        if (typeof getBankname === 'function') {
          getBankname(e.target.value).then(function (res) {
            var data = {
              code: res.bankCode,
              name: res.bankName
            };

            if (typeof onChangeBank === 'function') {
              onChangeBank(data);
            }

            form.setFieldsValue({
              bankCode: res.bankCode
            });
          });
        }
      }
    }
  }, {
    key: "onChangeBankBranch",
    value: function onChangeBankBranch(value, option) {
      var _option$props = option.props,
          data = _option$props.data,
          showBranchNo = _option$props.showBranchNo;
      var onChangeBankBranch = this.props.onChangeBankBranch;
      this.setState({
        showBranchNo: showBranchNo
      });

      if (typeof onChangeBankBranch === 'function') {
        onChangeBankBranch(data);
      }
    }
  }, {
    key: "filterRadioOptions",
    value: function filterRadioOptions() {
      var paymentTypes = this.props.paymentTypes;
      var t = this.state.t;
      var radioOptions = [{
        label: t('MK_PaymentAccountModal:editPaymentForm.bank'),
        value: 'BANK'
      }, {
        label: t('MK_PaymentAccountModal:editPaymentForm.alipay'),
        value: 'ALIPAY'
      }, {
        label: t('MK_PaymentAccountModal:editPaymentForm.cash'),
        value: 'CASH'
      }, {
        label: t('MK_PaymentAccountModal:editPaymentForm.other'),
        value: 'OTHER'
      }];
      if (!paymentTypes.length) return radioOptions;
      return radioOptions.filter(function (item) {
        return paymentTypes.includes(item.value);
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props4 = this.props,
          accountType = _this$props4.accountType,
          data = _this$props4.data;

      if (accountType && accountType === 'PERSONAL') {
        this.fetchCountryForm(data.bankCountry);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props5 = this.props,
          data = _this$props5.data,
          _this$props5$form = _this$props5.form,
          getFieldDecorator = _this$props5$form.getFieldDecorator,
          setFieldsValue = _this$props5$form.setFieldsValue,
          isCompany = _this$props5.isCompany,
          _this$props5$isAutoma = _this$props5.isAutomatic,
          isAutomatic = _this$props5$isAutoma === void 0 ? true : _this$props5$isAutoma,
          currencyLabel = _this$props5.currencyLabel,
          showActive = _this$props5.showActive,
          cities = _this$props5.cities,
          banks = _this$props5.banks,
          countryList = _this$props5.countryList,
          currencys = _this$props5.currencys,
          canAddBranch = _this$props5.canAddBranch,
          fetchCities = _this$props5.fetchCities,
          fetchBanks = _this$props5.fetchBanks,
          fetchCountryList = _this$props5.fetchCountryList,
          autoRequired = _this$props5.autoRequired,
          fetchBankBranches = _this$props5.fetchBankBranches,
          fetchCertificationTypes = _this$props5.fetchCertificationTypes,
          extra = _this$props5.extra,
          withCurrency = _this$props5.withCurrency,
          fetchEntities = _this$props5.fetchEntities,
          modalManager = _this$props5.modalManager,
          accountType = _this$props5.accountType,
          chooseCurrency = _this$props5.chooseCurrency,
          _this$props5$codeAndR = _this$props5.codeAndRange,
          codeAndRange = _this$props5$codeAndR === void 0 ? ['CODE', 'RANGE'] : _this$props5$codeAndR;
      var currency = data.acceptCcyDetail;
      var _this$state = this.state,
          showBranchNo = _this$state.showBranchNo,
          t = _this$state.t,
          defaultValues = _this$state.defaultValues,
          shouldLimitEntity = _this$state.shouldLimitEntity,
          countryForm = _this$state.countryForm; // let accountType = false;

      var radios = this.filterRadioOptions();
      return /*#__PURE__*/_react.default.createElement(_form.default, {
        onSubmit: this.handleSubmit,
        className: "".concat(prefix, "-edit-payment-form")
      }, extra, /*#__PURE__*/_react.default.createElement(FormItem, {
        label: t('editPaymentForm.paymentType')
      }, getFieldDecorator('paymentType', {
        rules: [{
          required: true,
          message: t('editPaymentForm.paymentTypeMsg')
        }]
      })( /*#__PURE__*/_react.default.createElement(RadioGroup, {
        options: radios
      }))), data.paymentType === 'OTHER' ? /*#__PURE__*/_react.default.createElement("div", {
        className: "other-section"
      }, /*#__PURE__*/_react.default.createElement(FormItem, {
        label: t('editPaymentForm.bankAcctNameOther')
      }, getFieldDecorator('bankAcctName', {
        rules: [{
          required: true,
          message: t('editPaymentForm.bankAcctNameOtherMsg')
        }, {
          max: 150,
          message: t('editPaymentForm.bankAcctNameMax')
        }]
      })( /*#__PURE__*/_react.default.createElement(_input.default, {
        placeholder: t('editPaymentForm.bankAcctNameOtherPlaceholder')
      }))), /*#__PURE__*/_react.default.createElement(FormItem, {
        label: t('editPaymentForm.bankAcctNumberOther')
      }, getFieldDecorator('bankAcctNumber', {
        getValueFromEvent: function getValueFromEvent(event) {
          return event.target.value.replace(/\s+/g, '');
        }
      })( /*#__PURE__*/_react.default.createElement(_input.default, {
        placeholder: t('editPaymentForm.bankAcctNumberOtherPlaceholder')
      })))) : null, data.paymentType === 'CASH' ? /*#__PURE__*/_react.default.createElement("div", {
        className: "cash-section"
      }, /*#__PURE__*/_react.default.createElement(FormItem, {
        label: t('editPaymentForm.cashAcctName')
      }, getFieldDecorator('bankAcctName', {
        rules: [{
          required: true,
          message: t('editPaymentForm.bankAcctNameMsg')
        }, {
          max: 150,
          message: t('editPaymentForm.bankAcctNameMax')
        }]
      })( /*#__PURE__*/_react.default.createElement(_input.default, {
        placeholder: t('editPaymentForm.cashAcctNamePlaceholder')
      })))) : null, data.paymentType === 'ALIPAY' ? /*#__PURE__*/_react.default.createElement("div", {
        className: "alipay-section"
      }, /*#__PURE__*/_react.default.createElement(FormItem, {
        label: t('editPaymentForm.bankAcctNameAli')
      }, getFieldDecorator('bankAcctName', {
        rules: [{
          required: true,
          message: t('editPaymentForm.bankAcctNameAliMsg')
        }, {
          max: 150,
          message: t('editPaymentForm.bankAcctNameMax')
        }]
      })( /*#__PURE__*/_react.default.createElement(_input.default, {
        placeholder: t('editPaymentForm.bankAcctNameAliPlaceholder')
      }))), /*#__PURE__*/_react.default.createElement(FormItem, {
        label: t('editPaymentForm.bankAcctNumberAli')
      }, getFieldDecorator('bankAcctNumber', {
        rules: [{
          required: true,
          message: t('editPaymentForm.bankAcctNumberAliMsg')
        }],
        getValueFromEvent: function getValueFromEvent(event) {
          return event.target.value.replace(/\s+/g, '');
        }
      })( /*#__PURE__*/_react.default.createElement(_input.default, {
        placeholder: t('editPaymentForm.bankAcctNumberAliPlaceholder')
      })))) : null, data.paymentType === 'BANK' ? /*#__PURE__*/_react.default.createElement("div", {
        className: "bank-section"
      }, /*#__PURE__*/_react.default.createElement(FormItem //国家
      , {
        label: t('editPaymentForm.country')
      }, getFieldDecorator('bankCountry', {
        rules: [{
          required: true,
          message: t('editPaymentForm.bankCodeMsg')
        }]
      })( /*#__PURE__*/_react.default.createElement(_CountryInput.default, {
        placeholder: t('editPaymentForm.bankAcctNamePlaceholder'),
        onChange: this.onChangeBankCountry,
        disabled: false,
        fetchCountryList: fetchCountryList,
        countryList: countryList,
        defaultValues: defaultValues
      }))), !(data.bankCountry && data.bankCountry !== "CHINA") ?
      /*#__PURE__*/
      //往来单位国内外判断显示字段
      _react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(FormItem //户名
      , {
        label: t('editPaymentForm.bankAcctName')
      }, getFieldDecorator('bankAcctName', {
        rules: [{
          required: true,
          message: t('editPaymentForm.bankAcctNameMsg')
        }, {
          max: 150,
          message: t('editPaymentForm.bankAcctNameMax')
        }]
      })( /*#__PURE__*/_react.default.createElement(_input.default, {
        placeholder: t('editPaymentForm.bankAcctNamePlaceholder')
      }))), /*#__PURE__*/_react.default.createElement(FormItem //账号
      , {
        label: t('editPaymentForm.bankAcctNumber')
      }, getFieldDecorator('bankAcctNumber', {
        rules: [{
          required: true,
          message: t('editPaymentForm.bankAcctNumberMsg')
        }],
        getValueFromEvent: function getValueFromEvent(event) {
          return event.target.value.replace(/\s+/g, '');
        }
      })( /*#__PURE__*/_react.default.createElement(_input.default, {
        onBlur: this.onBulrchange,
        placeholder: t('editPaymentForm.bankAcctNumberPlaceholder')
      }))), /*#__PURE__*/_react.default.createElement(FormItem //开户银行
      , {
        label: this.renderLabel(t('editPaymentForm.bankLabel'), /*#__PURE__*/_react.default.createElement("div", {
          style: {
            fontSize: 12,
            color: '#999'
          }
        }, /*#__PURE__*/_react.default.createElement("p", null, t('editPaymentForm.p1')), /*#__PURE__*/_react.default.createElement("p", null, t('editPaymentForm.p2'))))
      }, getFieldDecorator('bankCode', {
        rules: [{
          required: true,
          message: t('editPaymentForm.bankCodeMsg')
        }]
      })( /*#__PURE__*/_react.default.createElement(_BankInput.default, {
        placeholder: t('editPaymentForm.bankCodePlaceholder'),
        onChange: this.onChangeBank,
        banks: banks,
        area: data.bankCountry || "CHINA",
        fetchBanks: fetchBanks,
        defaultValues: defaultValues,
        needCountry: true
      }))), /*#__PURE__*/_react.default.createElement(FormItem //开户省市
      , {
        label: t('editPaymentForm.bankLocation')
      }, getFieldDecorator('bankLocation', {
        rules: [{
          required: autoRequired,
          message: t('editPaymentForm.bankLocationMsg')
        }]
      })( /*#__PURE__*/_react.default.createElement(_CityInput.default, {
        showAll: true,
        placeholder: t('editPaymentForm.bankLocationPlaceholder'),
        cities: cities,
        fetchCities: fetchCities
      }))), /*#__PURE__*/_react.default.createElement(FormItem // 分支行               
      , {
        label: t('editPaymentForm.bankBranchBizCode')
      }, getFieldDecorator('bankBranchBizCode', {
        rules: [{
          required: autoRequired,
          message: t('editPaymentForm.bankBranchBizCodeMsg')
        }],
        validateTrigger: 'falsy'
      })( /*#__PURE__*/_react.default.createElement(_BankBranchInput.default, {
        bankBranchName: data.bankBranchName,
        cityCode: data.bankLocation,
        bankCode: data.bankCode,
        fetchBankBranches: fetchBankBranches,
        onChange: this.onChangeBankBranch,
        showBranchNoChange: this.showBranchNoChange,
        showBranchNo: showBranchNo,
        canAddBranch: canAddBranch,
        placeholder: t('editPaymentForm.bankBranchBizCodePlaceholder')
      })))) : accountType && accountType === 'PERSONAL' ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, _lodash.default.map(countryForm, function (item, index) {
        if (item.field === 'bankCountry') return;

        if (item.field === 'bankAcctNumber') {
          return /*#__PURE__*/_react.default.createElement(FormItem //账号
          , {
            label: t('editPaymentForm.bankAcctNumber')
          }, getFieldDecorator('bankAcctNumber', {
            rules: [{
              required: true,
              message: t('editPaymentForm.bankAcctNumberMsg')
            }],
            getValueFromEvent: function getValueFromEvent(event) {
              return event.target.value.replace(/\s+/g, '');
            }
          })( /*#__PURE__*/_react.default.createElement(_input.default, {
            placeholder: t('editPaymentForm.bankAcctNumberPlaceholder')
          })));
        }

        if (item.field === 'bankCode') {
          return /*#__PURE__*/_react.default.createElement(FormItem //开户银行
          , {
            label: _this2.renderLabel(t('editPaymentForm.bankLabel'), /*#__PURE__*/_react.default.createElement("div", {
              style: {
                fontSize: 12,
                color: '#999'
              }
            }, /*#__PURE__*/_react.default.createElement("p", null, t('editPaymentForm.p1')), /*#__PURE__*/_react.default.createElement("p", null, t('editPaymentForm.p2'))))
          }, getFieldDecorator('bankCode', {
            rules: [{
              required: true,
              message: t('editPaymentForm.bankCodeMsg')
            }]
          })( /*#__PURE__*/_react.default.createElement(_BankInput.default, {
            placeholder: t('editPaymentForm.bankCodePlaceholder'),
            onChange: _this2.onChangeBank,
            banks: banks,
            area: data.bankCountry || "CHINA",
            fetchBanks: fetchBanks,
            defaultValues: defaultValues,
            needCountry: true
          })));
        }

        if (item.field === 'abroadPayeeType') {
          return /*#__PURE__*/_react.default.createElement(FormItem //收款人类型选项
          , {
            label: _this2.lang === 'zh' ? item.fieldNameZh : item.fieldNameEn
          }, getFieldDecorator(item.field, {
            rules: [{
              required: item.required,
              message: t('editPaymentForm.bankAcctNameMsg')
            }, {
              max: 150,
              message: t('editPaymentForm.bankAcctNameMax')
            }]
          })( /*#__PURE__*/_react.default.createElement(_select.default, {
            placeholder: _this2.lang === 'zh' ? item.placeholderZh : item.placeholderEn
          }, /*#__PURE__*/_react.default.createElement(Option, {
            value: "Corporate"
          }, "Corporate"), /*#__PURE__*/_react.default.createElement(Option, {
            value: "Individual"
          }, "Individual"), /*#__PURE__*/_react.default.createElement(Option, {
            value: "Government"
          }, "Government"))));
        }

        if (item.field === 'abroadPayeeAccountType') {
          return /*#__PURE__*/_react.default.createElement(FormItem //收款人账户类型选项
          , {
            label: _this2.lang === 'zh' ? item.fieldNameZh : item.fieldNameEn
          }, getFieldDecorator(item.field, {
            rules: [{
              required: item.required,
              message: t('editPaymentForm.bankAcctNameMsg')
            }, {
              max: 150,
              message: t('editPaymentForm.bankAcctNameMax')
            }]
          })( /*#__PURE__*/_react.default.createElement(_select.default, {
            placeholder: _this2.lang === 'zh' ? item.placeholderZh : item.placeholderEn
          }, /*#__PURE__*/_react.default.createElement(Option, {
            value: "Checking account"
          }, "Checking account"), /*#__PURE__*/_react.default.createElement(Option, {
            value: "Savings account"
          }, "Savings account"), /*#__PURE__*/_react.default.createElement(Option, {
            value: "Investment account"
          }, "Investment account"))));
        }

        return /*#__PURE__*/_react.default.createElement(FormItem, {
          label: _this2.lang === 'zh' ? item.fieldNameZh : item.fieldNameEn
        }, getFieldDecorator(item.field, {
          rules: [{
            required: item.required,
            message: t('editPaymentForm.bankAcctNameMsg')
          }, {
            max: 150,
            message: t('editPaymentForm.bankAcctNameMax')
          }]
        })( /*#__PURE__*/_react.default.createElement(_input.default, {
          placeholder: _this2.lang === 'zh' ? item.placeholderZh : item.placeholderEn
        })));
      })) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(FormItem //户名
      , {
        label: t('editPaymentForm.bankAcctName')
      }, getFieldDecorator('bankAcctName', {
        rules: [{
          required: true,
          message: t('editPaymentForm.bankAcctNameMsg')
        }, {
          max: 150,
          message: t('editPaymentForm.bankAcctNameMax')
        }]
      })( /*#__PURE__*/_react.default.createElement(_input.default, {
        placeholder: t('editPaymentForm.bankAcctNamePlaceholder')
      }))), /*#__PURE__*/_react.default.createElement(FormItem //账号
      , {
        label: t('editPaymentForm.bankAcctNumber')
      }, getFieldDecorator('bankAcctNumber', {
        rules: [{
          required: true,
          message: t('editPaymentForm.bankAcctNumberMsg')
        }],
        getValueFromEvent: function getValueFromEvent(event) {
          return event.target.value.replace(/\s+/g, '');
        }
      })( /*#__PURE__*/_react.default.createElement(_input.default, {
        onBlur: this.onBulrchange,
        placeholder: t('editPaymentForm.bankAcctNumberPlaceholder')
      }))), /*#__PURE__*/_react.default.createElement(FormItem //开户银行
      , {
        label: this.renderLabel(t('editPaymentForm.bankLabel'), /*#__PURE__*/_react.default.createElement("div", {
          style: {
            fontSize: 12,
            color: '#999'
          }
        }, /*#__PURE__*/_react.default.createElement("p", null, t('editPaymentForm.p1')), /*#__PURE__*/_react.default.createElement("p", null, t('editPaymentForm.p2'))))
      }, getFieldDecorator('bankCode', {
        rules: [{
          required: true,
          message: t('editPaymentForm.bankCodeMsg')
        }]
      })( /*#__PURE__*/_react.default.createElement(_BankInput.default, {
        placeholder: t('editPaymentForm.bankCodePlaceholder'),
        onChange: this.onChangeBank,
        banks: banks,
        area: data.bankCountry || "CHINA",
        fetchBanks: fetchBanks,
        defaultValues: defaultValues,
        needCountry: true
      }))), /*#__PURE__*/_react.default.createElement(FormItem //swiftCode
      , {
        label: t('editPaymentForm.swiftCode')
      }, getFieldDecorator('swiftCode', {
        rules: []
      })( /*#__PURE__*/_react.default.createElement(_input.default, {
        placeholder: t('editPaymentForm.swiftCodePlaceholder')
      }))), !isCompany && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(FormItem //海外收款人地址
      , {
        label: t('editPaymentForm.abroadPayeeAddress')
      }, getFieldDecorator('abroadPayeeAddress', {
        rules: []
      })( /*#__PURE__*/_react.default.createElement(_input.default, {
        placeholder: t('editPaymentForm.abroadPayeeAddressPlaceholder')
      }))), /*#__PURE__*/_react.default.createElement(FormItem //海外开户行地址
      , {
        label: t('editPaymentForm.abroadBankAddressPlaceholder')
      }, getFieldDecorator('abroadBankAddress', {
        rules: []
      })( /*#__PURE__*/_react.default.createElement(_input.default, {
        placeholder: t('editPaymentForm.abroadBankAddressPlaceholder')
      }))))), showBranchNo && /*#__PURE__*/_react.default.createElement(FormItem, {
        extra: /*#__PURE__*/_react.default.createElement(_alert.default, {
          message: /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("p", {
            style: {
              fontWeight: 700
            }
          }, t('editPaymentForm.bankQuery')), /*#__PURE__*/_react.default.createElement("p", null, t('editPaymentForm.bankMsg'), /*#__PURE__*/_react.default.createElement("a", {
            rel: "noopener noreferrer",
            target: "_blank",
            href: "https://www.hebbank.com/corporbank/otherBankQueryWeb.do"
          }, t('editPaymentForm.bank1')), "\u3001", /*#__PURE__*/_react.default.createElement("a", {
            rel: "noopener noreferrer",
            target: "_blank",
            href: "https://corbank.czbank.com/CORPORBANK/query_unionBank_index.jsp"
          }, t('editPaymentForm.bank2')), "\u3001", /*#__PURE__*/_react.default.createElement("a", {
            rel: "noopener noreferrer",
            target: "_blank",
            href: "https://ibsbjstar.ccb.com.cn/CCBIS/B2CMainPlat?SERVLET_NAME=B2CMainPlat&CCB_IBSVersion=V6&PT_STYLE=1&TXCODE=418105"
          }, t('editPaymentForm.bank3')), "\u3001", /*#__PURE__*/_react.default.createElement("a", {
            rel: "noopener noreferrer",
            target: "_blank",
            href: "http://www.zybank.com.cn/eportal/ui?pageId=364123"
          }, t('editPaymentForm.bank4')))),
          type: "info",
          showIcon: true
        }),
        label: t('editPaymentForm.bankBranchNo')
      }, getFieldDecorator('bankBranchNo', {
        rules: [{
          required: true,
          message: t('editPaymentForm.bankBranchNoMsg')
        }]
      })( /*#__PURE__*/_react.default.createElement(_input.default, {
        placeholder: t('editPaymentForm.bankBranchNoPlaceholder')
      })))) : null, data.paymentType === 'BANK' && isCompany && data.bankCode === 'cmbc' ? /*#__PURE__*/_react.default.createElement(FormItem, {
        label: t('editPaymentForm.agencyBizCode')
      }, getFieldDecorator('agencyBizCode', {
        rules: []
      })( /*#__PURE__*/_react.default.createElement(_input.default, {
        placeholder: t('editPaymentForm.agencyBizCodePlaceholder')
      }))) : !isCompany && data.bankCode === 'boc' ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(FormItem, {
        label: t('editPaymentForm.certType')
      }, getFieldDecorator('certificationTypeCode', {
        rules: [{// required: !certificateNoRequired, message: t('editPaymentForm.certTypeMsg')
        }, {
          max: 40,
          message: t('editPaymentForm.certTypeMax')
        }]
      })( /*#__PURE__*/_react.default.createElement(_CertificateInput.default, {
        fetchCertificationTypes: fetchCertificationTypes,
        placeholder: t('editPaymentForm.certTypePlaceholder')
      }))), /*#__PURE__*/_react.default.createElement(FormItem, {
        label: t('editPaymentForm.identification')
      }, getFieldDecorator('identification', {
        rules: [{// required: !certificateNoRequired, message: t('editPaymentForm.identificationMsg')
        }]
      })( /*#__PURE__*/_react.default.createElement(_input.default, {
        placeholder: t('editPaymentForm.identificationPlaceholder')
      })))) : null, isCompany && codeAndRange.includes('CODE') &&
      /*#__PURE__*/
      // 账户编码
      _react.default.createElement(FormItem, {
        label: t('editPaymentForm.accountBizCode')
      }, getFieldDecorator('accountBizCode', {
        rules: []
      })( /*#__PURE__*/_react.default.createElement(_input.default, {
        placeholder: t('editPaymentForm.accountBizCodePlaceholder')
      }))), !isCompany && /*#__PURE__*/_react.default.createElement(FormItem, {
        label: currencyLabel
      }, getFieldDecorator('acceptCcyDetail', {
        rules: [{
          required: true,
          message: "".concat(currencyLabel, "\u4E0D\u80FD\u4E3A\u7A7A")
        }]
      })( /*#__PURE__*/_react.default.createElement(_CurrencySelector.default, {
        data: currencys,
        disabled: chooseCurrency
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "form-currency-wrapper"
      }, _lodash.default.isEmpty(currency) ? /*#__PURE__*/_react.default.createElement("div", null, "\u8BF7\u9009\u62E9", currencyLabel) : /*#__PURE__*/_react.default.createElement("div", {
        className: "form-currency"
      }, /*#__PURE__*/_react.default.createElement(_CurrencyFlag.default, {
        flagInfo: {
          code: currency.code
        }
      }), /*#__PURE__*/_react.default.createElement("span", {
        style: {
          marginLeft: 4
        }
      }, currency.code, " - ", currency.name)))))), /*#__PURE__*/_react.default.createElement(FormItem //备注
      , {
        label: t('editPaymentForm.description')
      }, getFieldDecorator('remark', {
        rules: []
      })( /*#__PURE__*/_react.default.createElement(_input.default, {
        placeholder: t('editPaymentForm.descriptionPlaceholder')
      }))), isCompany && codeAndRange.includes('RANGE') ?
      /*#__PURE__*/
      // 适用范围
      _react.default.createElement(FormItem, {
        label: t('editPaymentForm.accountScope')
      }, /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_checkbox.default, {
        checked: shouldLimitEntity,
        onChange: function onChange(e) {
          _this2.setState({
            shouldLimitEntity: e.target.checked
          });

          if (!e.target.checked) {
            setFieldsValue({
              legalEntityAuthzs: null
            });
          }
        }
      }, t('editPaymentForm.shouldLimitEntity')), shouldLimitEntity ? /*#__PURE__*/_react.default.createElement("div", {
        style: {
          paddingBottom: 6
        }
      }, getFieldDecorator('legalEntityAuthzs', {
        rules: []
      })( /*#__PURE__*/_react.default.createElement(_LegalEntityPicker.default, {
        maxTagLength: 2,
        fetchEntities: fetchEntities,
        modalManager: modalManager
      }))) : null, /*#__PURE__*/_react.default.createElement("div", null, isAutomatic && data.paymentType === 'BANK' && getFieldDecorator('bankAutomaticEnable', {
        rules: []
      })( /*#__PURE__*/_react.default.createElement(_checkbox.default, {
        checked: data.bankAutomaticEnable
      }, this.renderLabel(t('editPaymentForm.bankAutomaticEnableMsg'), /*#__PURE__*/_react.default.createElement("div", {
        style: {
          maxWidth: 300
        }
      }, /*#__PURE__*/_react.default.createElement("p", null, t('editPaymentForm.bankAutomaticEnableTip'))))))))) : null, showActive && /*#__PURE__*/_react.default.createElement(FormItem, {
        label: t('editPaymentForm.active')
      }, getFieldDecorator('active', {
        valuePropName: 'checked'
      })( /*#__PURE__*/_react.default.createElement(_switch.default, null))), data.paymentType === 'BANK' && withCurrency ? /*#__PURE__*/_react.default.createElement(FormItem, {
        label: "\u8D26\u6237\u540D"
      }, getFieldDecorator('bankAcctName', {
        rules: [{
          required: true,
          message: '账户名不能为空'
        }, {
          max: 150,
          message: '最多输入150个字符'
        }]
      })( /*#__PURE__*/_react.default.createElement(_input.default, {
        placeholder: "\u94F6\u884C\u8D26\u6237\u540D\u79F0"
      }))) : null);
    }
  }]);
  return EditPaymentForm;
}(_react.Component);

var mapPropsToFields = function mapPropsToFields(props) {
  var data = props.data || {};
  var fields = props.fields || {};
  var extraName = props.extraName || {};
  return {
    paymentType: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['paymentType']), {}, {
      value: data.paymentType
    })),
    paymentCode: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['paymentCode']), {}, {
      value: data.paymentCode || undefined
    })),
    bankCode: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['bankCode']), {}, {
      value: data.bankCode || undefined
    })),
    bankAcctName: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['bankAcctName']), {}, {
      value: data.bankAcctName || extraName.name
    })),
    bankAcctNumber: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['bankAcctNumber']), {}, {
      value: data.bankAcctNumber || undefined
    })),
    bankLocation: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['bankLocation']), {}, {
      value: data.bankLocation || undefined
    })),
    bankBranchBizCode: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['bankBranchBizCode']), {}, {
      value: data.bankBranchBizCode || undefined
    })),
    bankBranchNo: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['bankBranchNo']), {}, {
      value: data.bankBranchNo || undefined
    })),
    accountBizCode: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['accountBizCode']), {}, {
      value: data.accountBizCode || undefined
    })),
    // description: Form.createFormField({
    //     ...fields['description'],
    //     value: data.description || undefined
    // }),
    remark: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['remark']), {}, {
      value: data.remark || undefined
    })),
    bankAutomaticEnable: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['bankAutomaticEnable']), {}, {
      value: data.bankAutomaticEnable || true
    })),
    active: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['active']), {}, {
      value: data.active
    })),
    agencyBizCode: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['agencyBizCode']), {}, {
      value: data.agencyBizCode
    })),
    certificationTypeCode: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['certificationTypeCode']), {}, {
      value: data.certificationTypeCode || undefined
    })),
    identification: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['identification']), {}, {
      value: data.identification || undefined
    })),
    acceptCcyDetail: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['acceptCcyDetail']), {}, {
      value: data.acceptCcyDetail || undefined
    })),
    swiftCode: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['swiftCode']), {}, {
      value: data.swiftCode || undefined
    })),
    abroadPayeeAddress: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['abroadPayeeAddress']), {}, {
      value: data.abroadPayeeAddress || undefined
    })),
    abroadBankAddress: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['abroadBankAddress']), {}, {
      value: data.abroadBankAddress || undefined
    })),
    bankCountry: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['bankCountry']), {}, {
      value: data.bankCountry || "CHINA"
    })),
    abroadPayeeType: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['abroadPayeeType']), {}, {
      value: data.abroadPayeeType || undefined
    })),
    payeeAccountType: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['payeeAccountType']), {}, {
      value: data.payeeAccountType || undefined
    })),
    iban: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['iban']), {}, {
      value: data.iban || undefined
    })),
    paymentTypeBizCode: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['paymentTypeBizCode']), {}, {
      value: data.paymentTypeBizCode || undefined
    })),
    edrpou: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['edrpou']), {}, {
      value: data.edrpou || undefined
    })),
    abroadBankBranchCode: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['abroadBankBranchCode']), {}, {
      value: data.abroadBankBranchCode || undefined
    })),
    dutyParagraph: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['dutyParagraph']), {}, {
      value: data.dutyParagraph || undefined
    })),
    paymentPurposeCode: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['paymentPurposeCode']), {}, {
      value: data.paymentPurposeCode || undefined
    })),
    businessStructureOfBeneficiaryCompany: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['businessStructureOfBeneficiaryCompany']), {}, {
      value: data.businessStructureOfBeneficiaryCompany || undefined
    })),
    abroadBankNumberbusinessStructureOfBeneficiaryCompany: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['businessStructureOfBeneficiaryCompany']), {}, {
      value: data.businessStructureOfBeneficiaryCompany || undefined
    })),
    abroadBankNumber: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['abroadBankNumber']), {}, {
      value: data.abroadBankNumber || undefined
    })),
    bsb: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['bsb']), {}, {
      value: data.bsb || undefined
    })),
    ifsc: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['ifsc']), {}, {
      value: data.ifsc || undefined
    })),
    dniPassport: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['dniPassport']), {}, {
      value: data.dniPassport || undefined
    })),
    cbu: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['cbu']), {}, {
      value: data.cbu || undefined
    })),
    cuit: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['cuit']), {}, {
      value: data.cuit || undefined
    })),
    branchTransitNumber: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['branchTransitNumber']), {}, {
      value: data.branchTransitNumber || undefined
    })),
    bankId: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['bankId']), {}, {
      value: data.bankId || undefined
    })),
    payeePhoneNumber: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['payeePhoneNumber']), {}, {
      value: data.payeePhoneNumber || undefined
    })),
    routingNumber: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['routingNumber']), {}, {
      value: data.routingNumber || undefined
    })),
    cci: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['cci']), {}, {
      value: data.cci || undefined
    })),
    rnn: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['rnn']), {}, {
      value: data.rnn || undefined
    })),
    payeeDutyParagraph: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['payeeDutyParagraph']), {}, {
      value: data.payeeDutyParagraph || undefined
    })),
    abroadPayeeAccountType: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['abroadPayeeAccountType']), {}, {
      value: data.abroadPayeeAccountType || undefined
    })),
    bankIdentificationNumber: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['bankIdentificationNumber']), {}, {
      value: data.bankIdentificationNumber || undefined
    })),
    abroadBankBranchNo: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['abroadBankBranchNo']), {}, {
      value: data.abroadBankBranchNo || undefined
    })),
    abroadBankBizCode: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['abroadBankBizCode']), {}, {
      value: data.abroadBankBizCode || undefined
    })),
    abroadBankCode: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['abroadBankCode']), {}, {
      value: data.abroadBankCode || undefined
    })),
    legalEntityAuthzs: _form.default.createFormField(_objectSpread(_objectSpread({}, fields['legalEntityAuthzs']), {}, {
      value: Array.isArray(data.legalEntityAuthzs) && data.legalEntityAuthzs.length > 0 ? data.legalEntityAuthzs.map(function (item) {
        return {
          code: item.authzCode,
          name: item.authzName,
          authzType: 'LEGAL_ENTITY'
        };
      }) : null
    }))
  };
};

var onFieldsChange = function onFieldsChange(props, changedFields) {
  var onChange = props.onChange;

  if (typeof onChange === 'function') {
    if (changedFields && changedFields['legalEntityAuthzs']) {
      var _v = changedFields['legalEntityAuthzs'].value;
      changedFields['legalEntityAuthzs'].value = Array.isArray(_v) && _v.length > 0 ? _v.map(function (item) {
        return {
          authzCode: item.code,
          authzName: item.name,
          authzType: 'LEGAL_ENTITY'
        };
      }) : null;
    }

    onChange(changedFields);
  }
};

var _default = _form.default.create({
  mapPropsToFields: mapPropsToFields,
  onFieldsChange: onFieldsChange
})(EditPaymentForm);

exports.default = _default;