"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/popover/style/css");

var _popover = _interopRequireDefault(require("maycur-antd/lib/popover"));

require("maycur-antd/lib/spin/style/css");

var _spin = _interopRequireDefault(require("maycur-antd/lib/spin"));

require("maycur-antd/lib/icon/style/css");

var _icon = _interopRequireDefault(require("maycur-antd/lib/icon"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _treeView = _interopRequireDefault(require("./treeView"));

var _lodash = _interopRequireDefault(require("lodash"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var PopSelector = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(PopSelector, _Component);

  var _super = _createSuper(PopSelector);

  function PopSelector(props) {
    var _this;

    (0, _classCallCheck2.default)(this, PopSelector);
    _this = _super.call(this, props);

    _this.parentTemplate = function (node) {
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("i", {
        className: "'icon-down' ".concat(node.active ? 'open' : '')
      }), /*#__PURE__*/_react.default.createElement("span", {
        className: "node parent-node"
      }, " ", node[_this.name], " "));
    };

    _this.childrenTemplate = function (node) {
      /* const name = node[this.name];
      const abbrName = utils.getAbbrName(name);
      const color = utils.getAvatarClass(name);
      return (
          <React.Fragment>
              <span className={`avatar ${color}`}>{abbrName}</span>
              <span id={node[this.code]} className='node child-node'>
                  {node[this.name]}
                  {node.account && (<span> - {node.account}</span>)}
              </span>
          </React.Fragment>
      ) */
    };

    _this.searchPop = function () {
      var value = _this.refs.filterInput.value;
      var _this$props = _this.props,
          searchApi = _this$props.searchApi,
          localSearch = _this$props.localSearch,
          searchField = _this$props.searchField;

      if (localSearch) {
        _this.treeData = _lodash.default.filter(_this.sourchTreeData, function (item) {
          return item[searchField].indexOf(value) !== -1;
        });

        _this.setState({
          filter: value
        });
      } else {
        if (!_lodash.default.isEmpty(value)) {
          searchApi(value).then(function (resp) {
            if (resp.code === 'ACK') {
              _this.treeData = resp.data;
            }

            _this.setState({
              filter: value,
              isSearching: true
            });
          });
        } else {
          _this.treeData = _this.props.treeData;

          _this.setState({
            filter: value,
            isSearching: false
          });
        }
      }
    };

    _this.debounceSearch = _lodash.default.debounce(function (value) {
      _this.searchPop(value);
    }, 500);

    _this.handleSearch = function () {
      _this.debounceSearch();
    };

    _this.loadMore = function () {
      var _this$props2 = _this.props,
          loadMore = _this$props2.loadMore,
          _this$props2$pageSize = _this$props2.pageSize,
          pageSize = _this$props2$pageSize === void 0 ? 50 : _this$props2$pageSize;
      var current = _this.state.current;

      _this.setState({
        current: current + 1,
        loading: true
      }, function () {
        loadMore && loadMore({
          current: current + 1,
          pageSize: pageSize
        }).then(function (value) {
          _this.treeData = value;

          _this.setState({
            loading: false
          });
        }, function () {
          _this.setState({
            loading: false,
            noMore: true
          });
        });
      });
    };

    _this.onVisibleChange = function (b) {
      if (!b) {
        _this.treeData = _this.props.treeData;
        _this.refs.filterInput.value = '';

        _this.setState({
          filter: ''
        });
      }

      _this.props.onVisibleChange();
    };

    _this.state = {
      filter: '',
      isSearching: false,
      current: 1,
      noMore: false,
      loading: false
    }; //本地搜索的时候使用

    _this.sourchTreeData = _this.props.treeData;
    _this.treeData = _this.props.treeData;
    _this.code = props.code;
    _this.name = props.name;
    _this.t = _mkTranslate.default.getLocalNs('MK_ConditionSetting', (0, _assertThisInitialized2.default)(_this));
    return _this;
  }

  (0, _createClass2.default)(PopSelector, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          defaultChecked = _this$props3.defaultChecked,
          onCheckItem = _this$props3.onCheckItem,
          visible = _this$props3.visible,
          children = _this$props3.children,
          parentTemplate = _this$props3.parentTemplate,
          childrenTemplate = _this$props3.childrenTemplate,
          code = _this$props3.code,
          name = _this$props3.name,
          placeholder = _this$props3.placeholder,
          maxSelectLength = _this$props3.maxSelectLength,
          loadMore = _this$props3.loadMore,
          total = _this$props3.total;
      var _this$state = this.state,
          isSearching = _this$state.isSearching,
          noMore = _this$state.noMore,
          loading = _this$state.loading;

      var popoverCnt = /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("div", {
        className: "search-input-wrap"
      }, /*#__PURE__*/_react.default.createElement("input", {
        className: "search-input",
        onKeyDown: this.handleSearch,
        ref: "filterInput",
        placeholder: placeholder
      }), /*#__PURE__*/_react.default.createElement("i", {
        className: "fm fm-search2"
      })), /*#__PURE__*/_react.default.createElement(_treeView.default, {
        code: code,
        name: name,
        maxSelectLength: parseInt(maxSelectLength),
        treeData: this.treeData,
        defaultCheckedNodes: defaultChecked,
        onCheck: onCheckItem,
        parentTemplate: parentTemplate || this.parentTemplate,
        childrenTemplate: childrenTemplate || this.childrenTemplate
      }), loadMore && !isSearching ? /*#__PURE__*/_react.default.createElement("div", {
        className: "load-more-wrapper"
      }, noMore || total === this.treeData.length ? /*#__PURE__*/_react.default.createElement("div", null, this.t('noMoreData')) : /*#__PURE__*/_react.default.createElement("div", {
        className: "load-more-btn",
        onClick: this.loadMore
      }, loading && /*#__PURE__*/_react.default.createElement(_spin.default, {
        indicator: /*#__PURE__*/_react.default.createElement(_icon.default, {
          type: "loading",
          style: {
            fontSize: 12
          },
          spin: true
        })
      }), /*#__PURE__*/_react.default.createElement("span", null, this.t('More')))) : null);

      return /*#__PURE__*/_react.default.createElement(_popover.default, {
        content: popoverCnt,
        trigger: "click",
        placement: "rightTop",
        overlayClassName: "mk-select-popover",
        visible: visible,
        onVisibleChange: this.onVisibleChange
      }, children);
    }
  }]);
  return PopSelector;
}(_react.Component);

var _default = PopSelector;
exports.default = _default;
PopSelector.defaultProps = {
  maxSelectLength: -1
};