"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/popover/style/css");

var _popover = _interopRequireDefault(require("maycur-antd/lib/popover"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

require("maycur-antd/lib/button/style/css");

var _button = _interopRequireDefault(require("maycur-antd/lib/button"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _TranslateHook = _interopRequireDefault(require("../../hooks/TranslateHook"));

var _reactOnclickoutside = _interopRequireDefault(require("react-onclickoutside"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var prefix = _utils.default.prefixCls;

function SensitiveWordsForm(props) {
  var _useState = (0, _react.useState)(),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      content = _useState2[0],
      setContent = _useState2[1];

  var setVisible = props.setVisible,
      onChange = props.onChange;

  var save = function save() {
    onChange(content);
    setVisible(false);
  };
  /*
  {
           handleClickOutside: () => {
              setVisible(false)
          }
      }
  */


  return /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-sensitive-word-form")
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "header"
  }, "\u6DFB\u52A0\u6587\u672C"), /*#__PURE__*/_react.default.createElement("div", {
    className: "body"
  }, /*#__PURE__*/_react.default.createElement(_input.default.TextArea, {
    value: content,
    onChange: function onChange(e) {
      setContent(e.target.value);
    },
    maxLength: 100,
    placeholder: "\u8BF7\u8F93\u5165\u6587\u672C"
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "footer"
  }, /*#__PURE__*/_react.default.createElement(_button.default, {
    type: "primary",
    onClick: save
  }, "\u4FDD\u5B58")));
}

function SensitiveWordsSetting(props) {
  var value = props.value,
      onChange = props.onChange;

  var _useState3 = (0, _react.useState)(value || []),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      wordList = _useState4[0],
      setWordList = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
      visible = _useState6[0],
      setVisible = _useState6[1];

  var t = (0, _TranslateHook.default)('MK_ConditionSetting');
  (0, _react.useEffect)(function () {
    setWordList(value || []);
  }, [value]);

  var togglePopover = function togglePopover() {
    setVisible(function (current) {
      return !current;
    });
  };

  var onFormChange = function onFormChange(value) {
    var _wordList = [].concat((0, _toConsumableArray2.default)(wordList), [value]);

    setWordList(_wordList);
    onChange(_wordList);
  };

  var deleteWord = function deleteWord(index) {
    var _wordList = wordList === null || wordList === void 0 ? void 0 : wordList.filter(function (t, i) {
      return i !== index;
    });

    setWordList(_wordList);
    onChange(_wordList);
  };

  console.log('wordList', wordList);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-sensitive-word")
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: "label-obj"
  }, t('object')), /*#__PURE__*/_react.default.createElement(_popover.default, {
    placement: "right",
    overlayClassName: "".concat(prefix, "-sensitive-word-popover"),
    visible: visible,
    content: visible && /*#__PURE__*/_react.default.createElement(SensitiveWordsForm, {
      setVisible: setVisible,
      onChange: onFormChange
    }),
    trigger: "click"
  }, /*#__PURE__*/_react.default.createElement("button", {
    onClick: togglePopover,
    className: "rect-add-btn"
  }, /*#__PURE__*/_react.default.createElement("i", {
    className: "fm fm-plus"
  }))), wordList === null || wordList === void 0 ? void 0 : wordList.map(function (d, index) {
    return /*#__PURE__*/_react.default.createElement("a", {
      key: d.code,
      className: "popover-selected-item-rect"
    }, d, /*#__PURE__*/_react.default.createElement("span", {
      className: "close-icon-wrap",
      onClick: function onClick(e) {
        deleteWord(index);
      }
    }, /*#__PURE__*/_react.default.createElement("i", {
      className: "fm fm-cross"
    })));
  }));
}

var _default = SensitiveWordsSetting;
exports.default = _default;