"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = defer;

/**
* Waits until next repaint to execute a fn
* @param {Function} fn
*/
function defer(fn) {
  window.requestAnimationFrame(function () {
    setTimeout(fn, 0);
  });
}