"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = modifyClassList;

/**
* Modifies elements' class lists
* @param {Element[]} els - Array of elements
* @param {Function} callback
*/
function modifyClassList(els, callback) {
  els.forEach(function (el) {
    if (!el) return;
    callback(el.classList);
  });
}