"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = triggerReflow;

/**
* Triggers a document repaint or reflow for CSS transition
* @param {Element} tooltip
* @param {Element} circle
*/
function triggerReflow(tooltip, circle) {
  // Safari needs the specific 'transform' property to be accessed
  if (circle) {
    window.getComputedStyle(circle);
  } else {
    window.getComputedStyle(tooltip);
  }
}