### 多语言国际化文本框

## 何时使用

表单设计器和设置页面的提示名称和提示文字等，需要支持多语言国际化。

## API

TransInput

| 参数 | 说明 | 类型 | 默认值 |
| --- | --- | --- | --- |
| identifier | 标识data中需要多语言国际化的属性 ｜ string | - |
| data | 表单的内容 ｜ object | - |
| disabled | 是否为禁用，默认为false | boolean | false |
| placeholder | 输入框默认文字 ｜ string | - |
| maxLength | 内容最大长度 ｜ number | - |
| onFieldBlur | 失去焦点时的回调，用于`rc-form`的onValuesChange和onFieldsChange | function(data: object, changedFields: object) | - ｜ 
| onFieldsChange | 输入框内容发生变化时的回调，用于`rc-form`的onValuesChange和onFieldsChange | function(data: object, changedFields: object) | - |

TransInput.TransTextArea

| 参数 | 说明 | 类型 | 默认值 |
| --- | --- | --- | --- |
| autosize | 自适应内容高度，可设置为 `true | false` 或对象：`{ minRows: 2, maxRows: 6 }`
| identifier | 标识data中需要多语言国际化的属性 ｜ string | - |
| data | 表单的内容 ｜ object | - |
| disabled | 是否为禁用，默认为false | boolean | false |
| placeholder | 输入框默认文字 ｜ string | - |
| maxLength | 内容最大长度 ｜ number | - |
| onFieldBlur | 失去焦点时的回调，用于`rc-form`的onValuesChange和onFieldsChange | function(data: object, changedFields: object) | - ｜ 
| onFieldsChange | 输入框内容发生变化时的回调，用于`rc-form`的onValuesChange和onFieldsChange | function(data: object, changedFields: object) | - |