"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/alert/style/css");

var _alert = _interopRequireDefault(require("maycur-antd/lib/alert"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/input/style/css");

var _input2 = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _SelectableTree = _interopRequireDefault(require("./SelectableTree/SelectableTree"));

var _i18next = _interopRequireDefault(require("i18next"));

var _Loader = _interopRequireDefault(require("../Loader"));

var _lodash = _interopRequireDefault(require("lodash"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls; // const Loader = () => {
//     return <div style={{ display: 'flex', alignItems: 'center', justifyContent: 'center', height: '100%' }}>
//         <Spin />
//     </div>
// };

var Search = _input2.default.Search;

var TreeTransfer = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(TreeTransfer, _Component);

  var _super = _createSuper(TreeTransfer);

  function TreeTransfer(props) {
    var _this;

    (0, _classCallCheck2.default)(this, TreeTransfer);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_TreeTransfer').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.generateCheckedKeys = function (value) {
      if (_lodash.default.isArray(value) && value.length > 0) {
        return value.map(function (item) {
          return item.code;
        });
      } else {
        return [];
      }
    };

    _this.onChangeCheckedKeys = function (checkedKeys) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          maxLength = _this$props.maxLength; // 如果当前选中的数量大于maxLength限制的

      if (checkedKeys.length > maxLength) {
        checkedKeys.shift();
      }

      var _output = [];

      if (_lodash.default.isArray(checkedKeys) && checkedKeys.length > 0) {
        checkedKeys.forEach(function (checkedKey) {
          if (_this.map[checkedKey]) {
            var _data = _objectSpread({}, _this.map[checkedKey]);

            delete _data.ref;

            _output.push(_data);
          }
        });
      }

      if (typeof onChange === 'function') {
        onChange(_output);
      }
    };

    _this.buildMap = function (data) {
      var map = {};

      if (data instanceof Array && data.length > 0) {
        _lodash.default.forEach(data, function (item) {
          map[item.code] = item;
        });

        _this.map = _lodash.default.merge(_this.map, map);
      }
    };

    _this.deepBuildMap = function (item) {
      if (item instanceof Array && item.length > 0) {
        _this.buildMap(item);

        item.forEach(function (i) {
          if (i.children && i.children instanceof Array && i.children.length > 0) {
            _this.deepBuildMap(i.children);
          }
        });
      }
    };

    _this.refreshOutput = function (output) {
      var _output = [];

      if (output && output.length > 0) {
        output.forEach(function (item) {
          if (_this.map && _this.map[item.code]) {
            _output.push(_this.map[item.code]);
          } else {
            _output.push(item);
          }
        });
      }

      return _output;
    };

    _this.onClose = function (item, index, e) {
      var checkedKeys = _this.state.checkedKeys;

      var idx = _lodash.default.findIndex(checkedKeys, function (o) {
        return o === item.code;
      });

      checkedKeys.splice(idx, 1);

      _this.onChangeCheckedKeys(checkedKeys);
    };

    _this.onSearch = function (keyword) {
      var search = _this.props.search;

      if (keyword) {
        if (typeof search === 'function') {
          _this.setState({
            isSearching: true,
            searchingLoading: true
          });

          search(keyword).then(function (data) {
            _this.setState({
              searchResult: data,
              searchingLoading: false
            });

            _this.buildMap(data);
          }).catch(function (error) {
            _this.setState({
              searchingLoading: false
            });
          });
        }
      } else {
        _this.clearSearching();
      }
    };

    _this.onSearchKeywordChange = function (e) {
      _this.setState({
        keyword: e.target.value
      });
    };

    _this.clearSearching = function () {
      _this.setState({
        isSearching: false,
        searchResult: [],
        keyword: null
      });

      _this.initTree();
    };

    _this.clearBasket = function () {
      _this.onChangeCheckedKeys([]);
    };

    _this.renderTreeShelf = function () {
      var _this$props2 = _this.props,
          fetchChildren = _this$props2.fetchChildren,
          checkStrictly = _this$props2.checkStrictly,
          renderItemExtra = _this$props2.renderItemExtra,
          pageSize = _this$props2.pageSize,
          paging = _this$props2.paging,
          dataSourceSync = _this$props2.dataSourceSync,
          rootName = _this$props2.rootName;
      var _this$state = _this.state,
          input = _this$state.input,
          inputLoading = _this$state.inputLoading,
          checkedKeys = _this$state.checkedKeys;
      var showMore = input && input.length >= pageSize;
      var dataSourse = [{
        key: 'root',
        children: input,
        code: 'root',
        showMore: showMore,
        disableCheckbox: true,
        _type: 'root',
        name: rootName
      }];
      return !inputLoading ? input && input.length > 0 ? /*#__PURE__*/_react.default.createElement(_SelectableTree.default, {
        checkedKeys: checkedKeys,
        checkStrictly: checkStrictly,
        dataSourceSync: dataSourceSync,
        dataSource: paging ? dataSourse : input,
        onChange: _this.onChangeCheckedKeys,
        fetchChildren: fetchChildren,
        onBuildMap: _this.buildMap,
        renderItemExtra: renderItemExtra,
        pageSize: pageSize,
        paging: paging
      }) : /*#__PURE__*/_react.default.createElement("div", {
        className: 'no-data'
      }, _i18next.default.t('MK_Global:noData')) : /*#__PURE__*/_react.default.createElement(_Loader.default, {
        active: true,
        mask: true
      });
    };

    _this.renderSearchShelf = function () {
      var _this$state2 = _this.state,
          searchResult = _this$state2.searchResult,
          searchingLoading = _this$state2.searchingLoading,
          checkedKeys = _this$state2.checkedKeys,
          renderItemExtra = _this$state2.renderItemExtra;
      return !searchingLoading ? searchResult && searchResult.length > 0 ? /*#__PURE__*/_react.default.createElement(_SelectableTree.default, {
        checkedKeys: checkedKeys,
        dataSource: searchResult,
        onChange: _this.onChangeCheckedKeys,
        onBuildMap: _this.buildMap,
        renderItemExtra: renderItemExtra
      }) : /*#__PURE__*/_react.default.createElement("div", {
        className: 'no-data'
      }, _i18next.default.t('MK_Global:noResult')) : /*#__PURE__*/_react.default.createElement(_Loader.default, {
        active: true,
        mask: true
      });
    };

    _this.renderBasket = function () {
      var _this$state3 = _this.state,
          output = _this$state3.output,
          t = _this$state3.t;
      var _this$props3 = _this.props,
          renderRightListItem = _this$props3.renderRightListItem,
          maxLength = _this$props3.maxLength;
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, maxLength && /*#__PURE__*/_react.default.createElement(_alert.default, {
        type: "warning",
        message: t('maxLength', {
          n: maxLength
        })
      }), output && output.length > 0 ? output.map(function (item, index) {
        return renderRightListItem ? renderRightListItem(item, index, _this.onClose) : /*#__PURE__*/_react.default.createElement("div", {
          className: 'right-item',
          key: index
        }, /*#__PURE__*/_react.default.createElement("div", {
          className: 'name-wrapper'
        }, item._type === 'CATEGORY' ? /*#__PURE__*/_react.default.createElement("span", {
          className: "fm fm-folder-o"
        }) : /*#__PURE__*/_react.default.createElement("span", {
          className: "fm fm-paper"
        }), /*#__PURE__*/_react.default.createElement("span", {
          className: 'name'
        }, /*#__PURE__*/_react.default.createElement("b", null, item.name ? item.name : null))), /*#__PURE__*/_react.default.createElement("div", {
          className: 'delete-btn',
          onClick: _this.onClose.bind((0, _assertThisInitialized2.default)(_this), item, index)
        }, /*#__PURE__*/_react.default.createElement("span", {
          className: "fm fm-trash"
        })));
      }) : /*#__PURE__*/_react.default.createElement("div", {
        className: 'no-data'
      }, _i18next.default.t('MK_Global:noData')));
    };

    _this.initTree = function () {
      var dataSourceSync = _this.props.dataSourceSync;

      if (typeof dataSourceSync === 'function') {
        _this.setState({
          inputLoading: true
        });

        try {
          dataSourceSync().then(function (_input) {
            _this.setState({
              input: _input,
              inputLoading: false
            }, function () {
              _this.deepBuildMap(_this.state.input); // 刷新输出：主要解决有些时候值只有code时的显示问题


              _this.setState({
                output: _this.refreshOutput(_this.state.output)
              }, function () {
                _this.buildMap(_this.state.output);
              });
            });
          }).catch(function (error) {
            _this.setState({
              inputLoading: false
            });
          });
        } catch (error) {
          console.log(error);
        }
      } else {
        _this.setState({
          inputLoading: true
        });

        try {
          _this.deepBuildMap(_this.state.input);

          _this.setState({
            output: _this.refreshOutput(_this.state.output),
            inputLoading: false
          }, function () {
            _this.buildMap(_this.state.output);
          });
        } catch (error) {
          console.log(error);
        }
      }
    };

    _this.state = {
      input: props.dataSource ? props.dataSource : null,
      output: props.value ? props.value : [],
      checkedKeys: _this.generateCheckedKeys(props.value),
      isSearching: false,
      searchResult: [],
      inputLoading: false,
      searchingLoading: false,
      keyword: null,
      t: _mkTranslate.default.noop()
    };
    _this.map = {};

    _this.localeProcess();

    return _this;
  }

  (0, _createClass2.default)(TreeTransfer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.initTree();
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var _this2 = this;

      if (!_lodash.default.isEqual(this.props.value, nextProps.value)) {
        this.setState({
          output: nextProps.value,
          checkedKeys: this.generateCheckedKeys(nextProps.value)
        });
      }

      if (!_lodash.default.isEqual(this.props.dataSource, nextProps.dataSource)) {
        this.setState({
          input: nextProps.dataSource,
          output: []
        }, function () {
          _this2.initTree();
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
          title = _this$props4.title,
          placeholder = _this$props4.placeholder,
          hasSearch = _this$props4.hasSearch;
      var _this$state4 = this.state,
          output = _this$state4.output,
          isSearching = _this$state4.isSearching,
          keyword = _this$state4.keyword,
          t = _this$state4.t;
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-tree-transfer-body")
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'selection-box'
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'selection-box-title'
      }, title), /*#__PURE__*/_react.default.createElement("div", {
        className: 'selection-box-body'
      }, hasSearch ? /*#__PURE__*/_react.default.createElement("div", {
        className: "search-wrapper"
      }, /*#__PURE__*/_react.default.createElement(Search, {
        value: keyword,
        onChange: this.onSearchKeywordChange,
        onSearch: this.onSearch,
        placeholder: placeholder
      }), isSearching ? /*#__PURE__*/_react.default.createElement("div", {
        className: "clear-btn",
        onClick: this.clearSearching
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "fm fm-cross"
      })) : null) : null, /*#__PURE__*/_react.default.createElement("div", {
        className: "main-wrapper"
      }, isSearching ? this.renderSearchShelf() : this.renderTreeShelf()))), /*#__PURE__*/_react.default.createElement("div", {
        className: 'middle-icon-box'
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "fm fm-angle-right"
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: 'selection-box'
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'selection-box-title basket-box'
      }, /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("span", {
        className: 'basket-title'
      }, t('selection')), /*#__PURE__*/_react.default.createElement("span", {
        className: 'number'
      }, " ", output ? output.length : null)), /*#__PURE__*/_react.default.createElement("span", {
        className: 'basket-clear',
        onClick: this.clearBasket
      }, _i18next.default.t('MK_Global:clear'))), /*#__PURE__*/_react.default.createElement("div", {
        className: 'selection-box-body'
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "main-wrapper"
      }, this.renderBasket()))));
    }
  }]);
  return TreeTransfer;
}(_react.Component);

TreeTransfer.defaultProps = {
  hasSearch: true
};
var _default = TreeTransfer;
exports.default = _default;