"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/*
 * @Description: file content
 * @Author: RongWei
 * @Date: 2020-08-07 11:47:24
 * @LastEditors: Please set LastEditors
 * @LastEditTime: 2020-10-14 17:40:56
 */
var _default = {
  "budgetmentFilter": {
    "placeholder": "Please enter a budget organization name."
  },
  "budgetSubjectFilter": {
    "placeholder": "Enter a budget account to search"
  },
  "budgetUnitFilter": {
    "placeholder": "Enter a budget unit to search"
  },
  "tradingPartnerFilter": {
    "placeholder": "Enter a keyword and press Enter to search."
  },
  "optionFilter": {
    "placeholder": "Enter a keyword and press Enter to search."
  },
  "dateFilter": {
    "all": "All",
    "recentOne": "Last month",
    "recentThree": "Last Three Months",
    "startDate": "Start Date",
    "endDate": "End Date"
  },
  "numberRangeFilter": {
    "warn": "Please enter a valid range of values.",
    "min": "Min",
    "max": "Max"
  },
  "departmentPicker": {
    "empty": "No department selected.",
    "stats": "Total <1>{{n}}</1> items."
  },
  "rangeCalendar": {
    "recentOne": "Last month",
    "recentThree": "In the last three months."
  },
  "filterListPanel": {
    "add": "New custom filter.",
    "empty": "No custom filters are currently available.",
    "设为默认": "Set as Default",
    "取消默认": "Cancel the default",
    "默认筛选项": "Default Filter",
    "编辑": "Edit",
    "删除": "Delete"
  },
  "filterSettingPanel": {
    "content": "Please select the content to include.",
    "range": "Please enter a valid range of values.",
    "label": "Condition Name",
    "rule": "Please enter a condition name.",
    "message": "The condition name cannot exceed 10 characters.",
    "title": "Filter Criteria ({{n}})",
    "itemLabel": "Filter",
    "itemMessage": "Please select a filter",
    "customLabel": "Include content",
    "customMessage": "Please select the content to include.",
    "addBtn": "Add Filter Criteria"
  },
  "filterSettingModal": {
    "subTitle": "Are you sure you want to delete this custom filter? It cannot be recovered after deletion.",
    "popover": "Frequently used filters can be stored here on Maycur's system, so that you can have a quick filtering based on them both on your mobile phone and PC.",
    "edit": "Edit custom filter.",
    "add": "New Custom Filter.",
    "manage": "Manage Custom Filters"
  },
  "filterStateBar": {
    "empty": "No Title",
    "title": "Filter Criteria",
    "filterLabel": "Filter：",
    "setBtn": "Configuration",
    "totalCount": "Total <1>{{n}}</1> records.",
    "up": "Up",
    "down": "Down"
  },
  "mkTable": {
    "btn": "Column Header",
    "columnVisible": "Column Header",
    "tip": "Press “Shift” while rolling the mouse wheel forward/backward to pan to the right/left."
  }
};
exports.default = _default;