"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("babel-runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("babel-runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("babel-runtime/helpers/possibleConstructorReturn"));

var _inherits2 = _interopRequireDefault(require("babel-runtime/helpers/inherits"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _shallowequal = _interopRequireDefault(require("shallowequal"));

var ExpandIcon = function (_React$Component) {
  (0, _inherits2.default)(ExpandIcon, _React$Component);

  function ExpandIcon() {
    (0, _classCallCheck2.default)(this, ExpandIcon);
    return (0, _possibleConstructorReturn2.default)(this, (ExpandIcon.__proto__ || Object.getPrototypeOf(ExpandIcon)).apply(this, arguments));
  }

  (0, _createClass2.default)(ExpandIcon, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      return !(0, _shallowequal.default)(nextProps, this.props);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          expandable = _props.expandable,
          prefixCls = _props.prefixCls,
          onExpand = _props.onExpand,
          needIndentSpaced = _props.needIndentSpaced,
          expanded = _props.expanded,
          record = _props.record;

      if (expandable) {
        var expandClassName = expanded ? 'expanded' : 'collapsed';
        return /*#__PURE__*/_react.default.createElement('span', {
          className: prefixCls + '-expand-icon ' + prefixCls + '-' + expandClassName,
          onClick: function onClick(e) {
            return onExpand(record, e);
          }
        });
      } else if (needIndentSpaced) {
        return /*#__PURE__*/_react.default.createElement('span', {
          className: prefixCls + '-expand-icon ' + prefixCls + '-spaced'
        });
      }

      return null;
    }
  }]);
  return ExpandIcon;
}(_react.default.Component);

ExpandIcon.propTypes = {
  record: _propTypes.default.object,
  prefixCls: _propTypes.default.string,
  expandable: _propTypes.default.any,
  expanded: _propTypes.default.bool,
  needIndentSpaced: _propTypes.default.bool,
  onExpand: _propTypes.default.func
};
var _default = ExpandIcon;
exports.default = _default;