"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var localStore = {
  getItem: function getItem(key) {
    var value = window.localStorage.getItem(key);

    try {
      value = JSON.parse(value);
    } catch (e) {
      console.log(e);
    }

    return value;
  },
  setItem: function setItem(key, value) {
    value = typeof value === 'string' ? value : JSON.stringify(value);
    window.localStorage.setItem(key, value);
  },
  removeItem: function removeItem(key) {
    window.localStorage.removeItem(key);
  }
};
var _default = {
  localStore: localStore
};
exports.default = _default;