"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = overlap;

var _isobject = _interopRequireDefault(require("./isobject"));

var _error = _interopRequireDefault(require("./error"));

function overlap(a, b) {
  if (!(0, _isobject.default)(a)) return _error.default.na;
  if (!(0, _isobject.default)(b)) return _error.default.na;
  return a.left >= b.left && a.right <= b.right && a.top >= b.top && a.bottom <= b.bottom;
}