"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _i18next = _interopRequireDefault(require("i18next"));

var _reactI18next = require("react-i18next");

var _i18nextIntervalpluralPostprocessor = _interopRequireDefault(require("i18next-intervalplural-postprocessor"));

var _lang = _interopRequireDefault(require("../lang"));

/*
 * @Description: file content
 * @Author: RongWei
 * @Date: 2019-09-27 16:48:15
 * @LastEditors: RongWei
 * @LastEditTime: 2020-09-23 17:54:15
 */
_i18next.default.use(_i18nextIntervalpluralPostprocessor.default).use(_reactI18next.initReactI18next).init({
  ns: ['MK_Global', 'MK_PaymentAccountModal', 'MK_CityList', 'MK_Empty'],
  defaultNS: 'MK_Global',
  // 默认的命名空间
  resources: _lang.default,
  fallbackLng: {
    'zh-CN': ['zh'],
    'en-US': ['en']
  },
  load: 'languageOnly',
  interpolation: {
    escapeValue: false
  },
  debug: false,
  saveMissing: false,
  partialBundledLanguages: true,
  parseMissingKeyHandler: function parseMissingKeyHandler() {
    return '...';
  },
  react: {
    useSuspense: false
  }
});

var _default = _i18next.default;
exports.default = _default;